local g=GLOBAL
local TUNING = g.TUNING

local difficulty = GetModConfigData("difficulty")
TUNING.ZG_DIFFICULTY = difficulty
TUNING.ZG_DIFFICULTY_PERIOD = 1 / difficulty

----关于entityscript的安全隐患
local function EntityScriptFn(cmp)

	local function RemoveListener(t, event, inst, fn)
		if t then
			local listeners = t[event]
			if listeners then
				local listener_fns = listeners[inst]
				if listener_fns then
					g.RemoveByValue(listener_fns, fn)
					if g.next(listener_fns) == nil then
						listeners[inst] = nil
					end
				end
				if g.next(listeners) == nil then
					t[event] = nil
				end
			end
		end
	end
	
	function cmp:RemoveEventCallback(event, fn, source)
		if type(fn) == "function" then
			source = source or self
			RemoveListener(source.event_listeners, event, self, fn)
			RemoveListener(self.event_listening, event, source, fn)
		end
	end
	
	function cmp:GetPosition()
		return g.Point(self.Transform:GetWorldPosition())
	end
	
	function cmp:PushEvent(event, data)
		if self.event_listeners then
			local listeners = self.event_listeners[event]
			if listeners then
				local tocall = {}
				for entity, fns in pairs(listeners) do
					for i, fn in ipairs(fns) do
						table.insert(tocall, fn)
					end
				end
				for i, fn in ipairs(tocall) do
					if type(fn)=="function" then
						fn(self, data)
					end
				end
			end
		end
		if self.sg and
			self.sg:IsListeningForEvent(event) and
			g.SGManager:OnPushEvent(self.sg) then
			self.sg:PushEvent(event, data)
		end
		if self.brain then
			self.brain:PushEvent(event, data)
		end
	end
	
end
AddGlobalClassPostConstruct("entityscript","EntityScript",EntityScriptFn)

--修复官方的重大bug--
local renames =
{
    feather = "feather_crow",
}
g.SpawnPrefab=function(name, skin, skin_id, creator)
	if type(name)=="string" then
		name = string.sub(name, string.find(name, "[^/]*$"))
		name = renames[name] or name
		local guid = g.TheSim:SpawnPrefab(name, skin, skin_id, creator)
		return g.Ents[guid]
	else
		return nil
	end
end

g.SpawnSaveRecord=function(saved, newents)
    --print(string.format("~~~~~~~~~~~~~~~~~~~~~SpawnSaveRecord [%s, %s, %s]", tostring(saved.id), tostring(saved.prefab), tostring(saved.data)))
    local inst = g.SpawnPrefab(saved.prefab, saved.skinname, saved.skin_id)
    if inst then
        inst.Transform:SetPosition(saved.x or 0, saved.y or 0, saved.z or 0)
        if not inst.entity:IsValid() then
            --print(string.format("SpawnSaveRecord [%s, %s] FAILED - entity invalid", tostring(saved.id), saved.prefab))
            return nil
        end
        if newents then
            --this is kind of weird, but we can't use non-saved ids because they might collide
            if saved.id  then
                newents[saved.id] = {entity=inst, data=saved.data} 
            else
                newents[inst] = {entity=inst, data=saved.data} 
            end
        end
        -- Attach scenario. This is a special component that's added based on save data, not prefab setup.
        if saved.scenario or (saved.data and saved.data.scenariorunner) then
            if inst.components.scenariorunner == nil then
                inst:AddComponent("scenariorunner")
            end
            if saved.scenario then
                inst.components.scenariorunner:SetScript(saved.scenario)
            end
        end
        inst:SetPersistData(saved.data, newents)
    else
        --print(string.format("SpawnSaveRecord [%s, %s] FAILED", tostring(saved.id), saved.prefab))
		return nil 		--return nil 不就行了! Klei哪那么多废print呢！
    end
    return inst
end

---------------------


----语言描述
g.require "stringsC"
--常用函数移植过来的
g.require "zg_lib"
----玩家需要关闭五格装备栏
modimport("scripts/zg_rpg_inventory.lua")
----智能敌对定义元素属性 分别是 火, 冰, 电, 暗, 光, 土, 木, 物理伤害有普通,子弹等
modimport("scripts/zg_dmg_calc.lua")
----难度显示
modimport("scripts/zg_display_coordinates.lua")
----配方
modimport("scripts/ZG_recipes.lua")
----状态图改进
modimport("scripts/zg_sgwilson.lua")
modimport("scripts/zg_sgwilson_client.lua")
----新的action
modimport("scripts/zg_rpg_action.lua")

PrefabFiles = 
{

----新世代智能敌对-------------------------------------------------------------------------

	--工程师
	"zg_ch0_engineer","zg_ut_false","q4banshou",
	
	--大剑豪boss
	"zg_ch3_mihawk", "zg_fx_mihawkzj", "zg_fx_mihawkhsqj", "zg_fx_mihawksmoke", "q5moonstep", "zg_fx_mihawksymbol",
	"zg_fx_mihawkball","zg_fx_mihawkjq",

	--2048
	--"lovers_2048",
	--初等人形兵器，中等人形兵器，高等人形兵器ddd
	"zg_manshape_primary",
	--抛射物
	"zg_fx_projectile",
	--鬼魂
	"zg_mo_ghost",
	
	--特效
	"zg_fx_blood","zg_fx_impact","zg_fx_dizzy","zg_fx_smoke",
		--灵气
		"zg_reiki_liliang",
	
	--随从召唤物,
	"zg_mo1_bishop","zg_mo1_beaver","zg_mo1_shadowwaxwell",
	--非随从召唤物
	"zg_mo_tentaclearm","zg_mo_holespider",
	--非生物召唤物
	"zg_fx_balloon", "zg_fx_spiderhole2","zg_fx_spider2","zg_fx_holeio",
	
	--普通单手格斗武器
	"z_melees",
	--弓箭类
	"z_bows",
	--长矛类
	"z_spears",
	--喷火枪
	"z_firegun","zg_fx_firegunfire",
	
	--护甲类
	"z_ar_bone","z_ar_bone2",
	--头盔类
	"z_arh_bone",
	
	--骷髅
	"zg_mo_skel2",
---------------------------------------------------------------------------------
	----头颅或文字
	"bz_playerhead", "bz_playerhead1", "zg_fx_dmgid", 
	"q5word",
	----特效
	"zg_fx_flashgun", "zg_fx_truefire", "zg_fx_wolfwarning", 
	"zg_fx_zorotornado", "zg_fx_zoromoon",
	"zg_fx_gunfire", "zg_fx_axe",
	"zg_fx_bullet", "zg_fx_axewarning", "zg_fx_redalert", "zg_fx_paracute", "zg_fx_spider", "zg_fx_goblinwarning", "zg_fx_flashgun2", "zg_fx_flashgun2_0",
	"zg_fx_manshape", "zg_fx_bullet_enemy",
	"zg_fx_sanjifx",
	"zg_fx_luffyarm", "zg_fx_luffyhand_jgq",
	"zg_fx_arrow_yellow", "zg_fx_arrow_yellow2", "zg_fx_arrow_yellow_ring",
	"zg_fx_appear_onepiece", "zg_fx_manshape1",
	"zg_fx_upgrade_soldier",
	"q5batproj","q5batline","q5batlinearm","q5butterflyproj",
	----威尔逊
	"zg_ch_wilson", "zg_mo_bunny", "zg_mo_perd", 
	----薇洛
	"zg_ch_willow", "zg_mo_firegirl",
	----沃尔夫冈
	"zg_ch_wolfgang",
	----温蒂
	"zg_ch_wendy", "zg_mo_abigail",
	----机器人
	"zg_ch_wx78",
	----巫婆
	"zg_ch_wicker", "zg_mo_icearcher",
	----伐木工
	"zg_ch_woodie", "zg_mo_beaver", "zg_mo_evergreen",
	----小丑
	"zg_ch_wes", "zg_it_balloon",
	----麦斯威尔
	"zg_ch_waxwell", "zg_mo_shadow",
	----女武神
	"zg_ch_wigfrid",
	----蜘蛛人
	"zg_ch_webber", "zg_mo_spider",
	----索隆
	"zg_ch1_zoro",
	----路飞
	"zg_ch1_luffy",
	----山治
	"zg_ch1_sanji",
	----巴基
	"zg_ch1_buggy", 
	-----------------------------------------------------新增怪物
	"zg_mo_wolf", 
	"zg_mo_skel", "zg_mo_skelarcher", "zg_mo_stygiandoll",
	"zg_cr_icepig", "zg_mo_greenspider", 
	-----------------------------------------------------变异体
	--"zg_mo_butterfly", "zg_mo_butterfly0", 
	"zg_mo_frog", "zg_mo_frog0", "zg_mo_hound", "zg_mo_tentacle",
	"zg_mo_frog1",
	"q1bat","q1bat2","q1bat3",
	"q1butterfly","q1butterfly2",
	-----------------------------------------------------新增敌人
	"zg_ch0_sweeper", "zg_ch0_soldier", "zg_mo_goblin_grunt", "zg_mo_goblin_robot",
	-----------------------------------------------------新增设施
	"zg_ut_wormhole", "zg_ut_icepig_house", "darkgravestone", 
	-----------------------------------------------------新增道具
	--武器
	"zg_weapon_mace", "zg_weapon_longsword", "zg_weapon_shortsword", "zg_weapon_gaintsword", "zg_weapon_axe", 
	"zg_weapon_mordensword",
	"zg_ele_dark_spear",
	--枪械
	"zg_weapon_shotgun", "zg_weapon_minigun", "zg_weapon_ak47", "zg_weapon_m4", "zg_weapon_lightninggun",
	--防具
	"zg_armor_umbrella",
	--物品
	"zg_it_livingbone", "zg_it_shotgunbullet", "zg_it_minigunbullet", "zg_it_ak47bullet", "zg_it_icepigskin",
	--三代预告
	"zg_groundcreep", "zg_fx_web", "zg_steelsilk","zg_steelmonstermeat",
	--盾牌
	"zg_shield_lion", "zg_shield_wood", "zg_shield_armored",
	--护符
	"zg_amulet",
}

Assets = 
{

	--建筑物
	Asset('SOUNDPACKAGE', "sound/zg_building.fev"),
	Asset("SOUND", "sound/zg_building.fsb"),
---------------------------------------------------------------
	--动态材质
	Asset("DYNAMIC_ANIM", "anim/dynamic/wilson_survivor.zip"),
	Asset("DYNAMIC_ANIM", "anim/dynamic/wx78_survivor.zip"),
	Asset("DYNAMIC_ANIM", "anim/dynamic/woodie_survivor.zip"),
	Asset("DYNAMIC_ANIM", "anim/dynamic/wolfgang_mighty_survivor.zip"),
	Asset("DYNAMIC_ANIM", "anim/dynamic/willow_survivor.zip"),
	Asset("DYNAMIC_ANIM", "anim/dynamic/wickerbottom_survivor.zip"),
	Asset("DYNAMIC_ANIM", "anim/dynamic/wes_survivor.zip"),
	Asset("DYNAMIC_ANIM", "anim/dynamic/wendy_survivor.zip"),
	Asset("DYNAMIC_ANIM", "anim/dynamic/webber_survivor.zip"),
	Asset("DYNAMIC_ANIM", "anim/dynamic/waxwell_survivor.zip"),
	Asset("DYNAMIC_ANIM", "anim/dynamic/wathgrithr_survivor.zip"),
---------------------------------------------------------------
	--召唤类
	Asset('SOUNDPACKAGE', "sound/zg_summon.fev"),
	Asset("SOUND", "sound/zg_summon.fsb"),
	--蜘蛛类
	Asset("SOUNDPACKAGE", "sound/zg_spider.fev"),
	Asset("SOUND", "sound/zg_spider.fsb"),
	--洞穴类
	Asset("SOUNDPACKAGE", "sound/zg_hole.fev"),
	Asset("SOUND", "sound/zg_hole.fsb"),
	--射箭动画+弓箭音效
	Asset("ANIM","anim/zg_bow_attack.zip"),
	--骷髅类
	Asset("SOUNDPACKAGE", "sound/zg_skel.fev"),
	Asset("SOUND", "sound/zg_skel.fsb"),

	--盾牌------
	Asset("ANIM", "anim/zg_shield_lion.zip"),
	Asset("ATLAS", "images/zg_shield_lion.xml"),	--模型盾
	Asset("ANIM", "anim/zg_shield_wood.zip"),
	Asset("ATLAS", "images/zg_shield_wood.xml"),	--木圆盾
	Asset("ANIM", "anim/zg_shield_armored.zip"),
	Asset("ATLAS", "images/zg_shield_armored.xml"),		--武装盾
	--玩家动作---------
	Asset("ANIM", "anim/zg_player_attacks.zip"),	--持盾攻击, 不要改变原来的动作
	Asset("ANIM", "anim/zg_player_runs.zip"),		--持盾跑步
	Asset("ANIM", "anim/zg_player_idles.zip"),		--持盾静止
	--黑电
	Asset("ANIM", "anim/zg_fx_blacklightning.zip"),
	--黑色头颅
	Asset("ANIM", "anim/zg_fx_soulspear.zip"),
	--HUD
	Asset("SOUNDPACKAGE", "sound/zg_hud.fev"),
	Asset("SOUND", "sound/zg_hud.fsb"),
	Asset("ATLAS", "images/zg_backpack.xml"),
	Asset("ATLAS", "images/zg_hand1.xml"),
	Asset("ATLAS", "images/zg_hand2.xml"),
	Asset("ATLAS", "images/zg_neck.xml"),
	Asset("ATLAS", "images/zg_ring1.xml"),
	Asset("ATLAS", "images/zg_ring2.xml"),
	--童子军升级特效
	Asset("ANIM", "anim/zg_fx_upgrade_soldier.zip"),
	--海贼王过场音乐
	Asset("ANIM", "anim/zg_fx_manshape1.zip"),
	Asset("SOUNDPACKAGE", "sound/zg_appear_onepiece.fev"),
	Asset("SOUND", "sound/zg_appear_onepiece.fsb"),
	--烦恼风
	Asset("ANIM", "anim/zg_fx_zorotornado.zip"),
	--新月
	Asset("ANIM", "anim/zg_fx_zoromoon.zip"),
	--坎普斯
	Asset("ANIM", "anim/zg_krampus_build.zip"),	
	--BGM海军
	Asset("SOUNDPACKAGE", "sound/zg_bgm_marine.fev"),
	Asset("SOUND", "sound/zg_bgm_marine.fsb"),
	--鱼人
	Asset("SOUNDPACKAGE", "sound/zg_sfx_merm.fev"),
	Asset("SOUND", "sound/zg_sfx_merm.fsb"),
	Asset("ANIM", "anim/zg_merm_build.zip"),
	Asset("ANIM", "anim/zg_pig_attacks.zip"),	--攻击动画
	Asset("ANIM", "anim/zg_merm_sword_swap.zip"),  --鱼人剑 手持
	Asset("ANIM", "anim/zg_pig_basic.zip"),  --静止,走,跑,wai鱼
	--海军帽子
	Asset("ANIM", "anim/zg_hat_marine.zip"),
	--巴基以及身体部件
	Asset("ANIM", "anim/zg_buggy.zip"),
	Asset("ANIM", "anim/zg_buggy_hand.zip"),
	Asset("ANIM", "anim/zg_buggy_body.zip"),
	Asset("ANIM", "anim/zg_buggy_head.zip"),
	Asset("ANIM", "anim/zg_buggy2.zip"),
	Asset("ANIM", "anim/zg_head_buggy.zip"),
	Asset( "ATLAS", "images/zg_head_buggy.xml" ),
	Asset("SOUNDPACKAGE", "sound/zg_voice_buggy.fev"),
	Asset("SOUND", "sound/zg_voice_buggy.fsb"),
	--打击音效
	Asset("SOUNDPACKAGE", "sound/zg_sfx_hit.fev"),
	Asset("SOUND", "sound/zg_sfx_hit.fsb"),
	--bossBGM
	Asset("SOUNDPACKAGE", "sound/zg_epic_ch1.fev"),
	Asset("SOUND", "sound/zg_epic_ch1.fsb"),
	--巨熊+肉肉果实
	Asset("SOUNDPACKAGE", "sound/zg_sfx_bearger.fev"),
	Asset("SOUND", "sound/zg_sfx_bearger.fsb"),
	--巨鹿+激光炮
	Asset("SOUNDPACKAGE", "sound/zg_laser.fev"),
	Asset("SOUND", "sound/zg_laser.fsb"),
	Asset("ANIM", "anim/zg_deerclops_build.zip"),
	Asset("ANIM", "anim/zg_deerclops_actions.zip"),
	Asset("ANIM", "anim/zg_laserring.zip"),
	Asset("ANIM", "anim/zg_laserstar.zip"),
	Asset("ANIM", "anim/zg_laserfx.zip"),
	Asset("ANIM", "anim/zg_snowflower.zip"),
	--钢蜘蛛
	Asset("ANIM", "anim/zg_spider_steel_build.zip"),
	Asset("ANIM", "anim/zg_steelsilk.zip"),
	Asset("ATLAS", "images/zg_steelsilk.xml"),
	Asset("ANIM", "anim/zg_steelmonstermeat.zip"),
	Asset("ATLAS", "images/zg_steelmonstermeat.xml"),
	--场面BGM
	Asset("SOUNDPACKAGE", "sound/zg_bgm_creature.fev"),
    Asset("SOUND", "sound/zg_bgm_creature.fsb"),
	--召唤技能
	Asset("SOUNDPACKAGE", "sound/zg_mo_summon.fev"),
    Asset("SOUND", "sound/zg_mo_summon.fsb"),
	Asset("SOUNDPACKAGE", "sound/zg_ut_adventure.fev"),
    Asset("SOUND", "sound/zg_ut_adventure.fsb"),
	--威尔逊
	Asset("SOUNDPACKAGE", "sound/zg_ch_wilson.fev"),
    Asset("SOUND", "sound/zg_ch_wilson.fsb"),
	--薇洛
	Asset("SOUNDPACKAGE", "sound/zg_ch_willow.fev"),
    Asset("SOUND", "sound/zg_ch_willow.fsb"),
	--大力士
	Asset("SOUNDPACKAGE", "sound/zg_ch_wolfgang.fev"),
    Asset("SOUND", "sound/zg_ch_wolfgang.fsb"),
	--机器人
	Asset("SOUNDPACKAGE", "sound/zg_ch_wx78.fev"),
    Asset("SOUND", "sound/zg_ch_wx78.fsb"),
	--巫婆
	Asset("SOUNDPACKAGE", "sound/zg_ch_wicker.fev"),
    Asset("SOUND", "sound/zg_ch_wicker.fsb"),
	--伐木工
	Asset("SOUNDPACKAGE", "sound/zg_mo_evergreen.fev"),
    Asset("SOUND", "sound/zg_mo_evergreen.fsb"),
	--小丑
	Asset("SOUNDPACKAGE", "sound/zg_ch_wes.fev"),
    Asset("SOUND", "sound/zg_ch_wes.fsb"),
	--女武神
	Asset("SOUNDPACKAGE", "sound/zg_ch_wigfrid.fev"),
    Asset("SOUND", "sound/zg_ch_wigfrid.fsb"),
	--蜘蛛人
	Asset("SOUNDPACKAGE", "sound/zg_ch_webber.fev"),
    Asset("SOUND", "sound/zg_ch_webber.fsb"),
	--怪物扩展
	Asset("SOUNDPACKAGE", "sound/zg_mo_mobs0.fev"),
    Asset("SOUND", "sound/zg_mo_mobs0.fsb"),
	--蝴蝶
	Asset("SOUNDPACKAGE", "sound/zg_cr_butterfly.fev"),
    Asset("SOUND", "sound/zg_cr_butterfly.fsb"),
	--触手
	Asset("SOUNDPACKAGE", "sound/zg_cr_tentacle.fev"),
    Asset("SOUND", "sound/zg_cr_tentacle.fsb"),
	--青蛙
	Asset("SOUNDPACKAGE", "sound/zg_cr_frog.fev"),
    Asset("SOUND", "sound/zg_cr_frog.fsb"),
	--猎犬
	Asset("SOUNDPACKAGE", "sound/zg_cr_hound.fev"),
    Asset("SOUND", "sound/zg_cr_hound.fsb"),
	--狼
	Asset("SOUNDPACKAGE", "sound/zg_mo_wolf.fev"),
    Asset("SOUND", "sound/zg_mo_wolf.fsb"),
	--骷髅
	Asset("SOUNDPACKAGE", "sound/zg_mo_skel.fev"),
    Asset("SOUND", "sound/zg_mo_skel.fsb"),
	--冥河娃娃
	Asset("SOUNDPACKAGE", "sound/zg_mo_stygiandoll.fev"),
    Asset("SOUND", "sound/zg_mo_stygiandoll.fsb"),
	----索隆
	Asset("SOUNDPACKAGE", "sound/zg_ch1_zoro.fev"),
    Asset("SOUND", "sound/zg_ch1_zoro.fsb"),
	----艾斯
	--Asset("SOUNDPACKAGE", "sound/zg_ch1_ace.fev"),
    --Asset("SOUND", "sound/zg_ch1_ace.fsb"),
	----路飞
	Asset("SOUNDPACKAGE", "sound/zg_ch1_luffy.fev"),
    Asset("SOUND", "sound/zg_ch1_luffy.fsb"),
	----特拉男
	Asset("SOUNDPACKAGE", "sound/zg_ch1_law.fev"),
    Asset("SOUND", "sound/zg_ch1_law.fsb"),
	----山治
	Asset("SOUNDPACKAGE", "sound/zg_ch1_sanji.fev"),
    Asset("SOUND", "sound/zg_ch1_sanji.fsb"),
	----皮弗娄牛
	Asset("SOUNDPACKAGE", "sound/zg_cr_beefalo.fev"),
    Asset("SOUND", "sound/zg_cr_beefalo.fsb"),
	----斧头帮
	Asset("SOUNDPACKAGE", "sound/zg_ch0_sweeper.fev"),
    Asset("SOUND", "sound/zg_ch0_sweeper.fsb"),
	Asset("SOUNDPACKAGE", "sound/zg_fx_axewarning.fev"),
    Asset("SOUND", "sound/zg_fx_axewarning.fsb"),
	----shotgun
	Asset("SOUNDPACKAGE", "sound/zg_weapon_shotgun.fev"),
    Asset("SOUND", "sound/zg_weapon_shotgun.fsb"),
	----minigun
	Asset("SOUNDPACKAGE", "sound/zg_we_mini.fev"),
    Asset("SOUND", "sound/zg_we_mini.fsb"),
	----ak47
	Asset("SOUNDPACKAGE", "sound/zg_weapon_ak47.fev"),
    Asset("SOUND", "sound/zg_weapon_ak47.fsb"),
	----m4
	Asset("SOUNDPACKAGE", "sound/zg_weapon_m4.fev"),
    Asset("SOUND", "sound/zg_weapon_m4.fsb"),
	----童子军大兵
	Asset("SOUNDPACKAGE", "sound/zg_ch0_soldier.fev"),
    Asset("SOUND", "sound/zg_ch0_soldier.fsb"),
	----防空警报
	Asset("SOUNDPACKAGE", "sound/zg_fx_redalert.fev"),
    Asset("SOUND", "sound/zg_fx_redalert.fsb"),
	----冰猪
	Asset("SOUNDPACKAGE", "sound/zg_cr_icepig.fev"),
    Asset("SOUND", "sound/zg_cr_icepig.fsb"),
	----真正的虫洞
	Asset("SOUNDPACKAGE", "sound/zg_ut_wormhole.fev"),
    Asset("SOUND", "sound/zg_ut_wormhole.fsb"),
	----腐败蜘蛛
	Asset("SOUNDPACKAGE", "sound/zg_mo_greenspider.fev"),
    Asset("SOUND", "sound/zg_mo_greenspider.fsb"),
	----猪猪BGM
	Asset("SOUNDPACKAGE", "sound/zg_bgm_pigmusic.fev"),
    Asset("SOUND", "sound/zg_bgm_pigmusic.fsb"),
	----丑猴王
	Asset("SOUNDPACKAGE", "sound/zg_ch2_wukong.fev"),
    Asset("SOUND", "sound/zg_ch2_wukong.fsb"),
	----羊
	Asset("SOUNDPACKAGE", "sound/zg_bgm_goat.fev"),
    Asset("SOUND", "sound/zg_bgm_goat.fsb"),
	----牛
	Asset("SOUNDPACKAGE", "sound/zg_bgm_ox.fev"),
    Asset("SOUND", "sound/zg_bgm_ox.fsb"),
	----滑板鞋
	Asset("SOUNDPACKAGE", "sound/zg_bgm_shoe.fev"),
    Asset("SOUND", "sound/zg_bgm_shoe.fsb"),
	----任务更新
	Asset("SOUNDPACKAGE", "sound/zg_bgm_taskcontinue.fev"),
    Asset("SOUND", "sound/zg_bgm_taskcontinue.fsb"),
	----物品掉落声音
	Asset("SOUNDPACKAGE", "sound/zg_sound_inv.fev"),
    Asset("SOUND", "sound/zg_sound_inv.fsb"),
	----哥布林
	Asset("SOUNDPACKAGE", "sound/zg_mo_goblin.fev"),
    Asset("SOUND", "sound/zg_mo_goblin.fsb"),
	----玩家声音
	--攻击
	Asset("SOUNDPACKAGE", "sound/zg_sfx_missattack.fev"),
    Asset("SOUND", "sound/zg_sfx_missattack.fsb"),
	--女武神
	Asset("SOUNDPACKAGE", "sound/zg_player_wigfid.fev"),
    Asset("SOUND", "sound/zg_player_wigfid.fsb"),
	--薇洛
	Asset("SOUNDPACKAGE", "sound/zg_player_willow.fev"),
    Asset("SOUND", "sound/zg_player_willow.fsb"),
	--温蒂
	Asset("SOUNDPACKAGE", "sound/zg_player_wendy.fev"),
    Asset("SOUND", "sound/zg_player_wendy.fsb"),
	--大力士
	Asset("SOUNDPACKAGE", "sound/zg_player_wolfgang.fev"),
    Asset("SOUND", "sound/zg_player_wolfgang.fsb"),
	--老奶奶
	Asset("SOUNDPACKAGE", "sound/zg_player_wickerbottom.fev"),
    Asset("SOUND", "sound/zg_player_wickerbottom.fsb"),
	--科学家
	Asset("SOUNDPACKAGE", "sound/zg_player_wilson.fev"),
    Asset("SOUND", "sound/zg_player_wilson.fsb"),
	--伐木工
	Asset("SOUNDPACKAGE", "sound/zg_player_woodie.fev"),
    Asset("SOUND", "sound/zg_player_woodie.fsb"),
	--复活
	Asset("SOUNDPACKAGE", "sound/zg_player_resurrect.fev"),
    Asset("SOUND", "sound/zg_player_resurrect.fsb"),
	--重制版的智能怪物1
	Asset("SOUNDPACKAGE", "sound/wiliya_monster.fev"),
    Asset("SOUND", "sound/wiliya_monster.fsb"),
	Asset("SOUNDPACKAGE", "sound/zg_drop.fev"),
    Asset("SOUND", "sound/zg_drop.fsb"),
	--弓箭音效
	Asset("SOUNDPACKAGE", "sound/zg_bow.fev"),
	Asset("SOUND", "sound/zg_bow.fsb"),
	--格斗武器音效
	Asset("SOUNDPACKAGE", "sound/zg_melee.fev"),
	Asset("SOUND", "sound/zg_melee.fsb"),
}
----BGM
RemapSoundEvent( "dontstarve/zg_bgm_creature/onepiece", "zg_bgm_creature/zg_bgm_creature/onepiece" )
RemapSoundEvent( "dontstarve/zg_bgm_creature/axe", "zg_bgm_creature/zg_bgm_creature/axe2" )
RemapSoundEvent( "dontstarve/zg_bgm_creature/ds", "zg_bgm_creature/zg_bgm_creature/ds" )
--召唤
RemapSoundEvent( "dontstarve/zg/spell/summon01", "zg_mo_summon/zg_mo_summon/summon01" )
RemapSoundEvent( "dontstarve/zg/spell/summon02", "zg_mo_summon/zg_mo_summon/summon02" )
--威尔逊
RemapSoundEvent( "dontstarve/zg/wilson/call", "zg_ch_wilson/zg_ch_wilson/call" )
RemapSoundEvent( "dontstarve/zg/wilson/hit", "zg_ch_wilson/zg_ch_wilson/hit" )
RemapSoundEvent( "dontstarve/zg/wilson/die", "zg_ch_wilson/zg_ch_wilson/die" )
--薇洛
RemapSoundEvent( "dontstarve/zg/willow/call", "zg_ch_willow/zg_ch_willow/call" )
RemapSoundEvent( "dontstarve/zg/willow/hit", "zg_ch_willow/zg_ch_willow/hit" )
RemapSoundEvent( "dontstarve/zg/willow/die", "zg_ch_willow/zg_ch_willow/die" )
RemapSoundEvent( "dontstarve/zg/willow/pound", "zg_ch_willow/zg_ch_willow/pound" )
RemapSoundEvent( "dontstarve/zg/willow/fireatk", "zg_ch_willow/zg_ch_willow/fireatk" )
--大力士
RemapSoundEvent( "dontstarve/zg/wolfgang/call", "zg_ch_wolfgang/zg_ch_wolfgang/call" )
RemapSoundEvent( "dontstarve/zg/wolfgang/hit", "zg_ch_wolfgang/zg_ch_wolfgang/hit" )
RemapSoundEvent( "dontstarve/zg/wolfgang/die", "zg_ch_wolfgang/zg_ch_wolfgang/die" )
RemapSoundEvent( "dontstarve/zg/wolfgang/flash", "zg_ch_wolfgang/zg_ch_wolfgang/flash" )
--温蒂
RemapSoundEvent( "dontstarve/zg/wendy/call", "zg_ch_wendy/zg_ch_wendy/call" )
RemapSoundEvent( "dontstarve/zg/wendy/hit", "zg_ch_wendy/zg_ch_wendy/hit" )
RemapSoundEvent( "dontstarve/zg/wendy/die", "zg_ch_wendy/zg_ch_wendy/die" )
RemapSoundEvent( "dontstarve/zg/wendy/atk", "zg_ch_wendy/zg_ch_wendy/atk" )
--机器人
RemapSoundEvent( "dontstarve/zg/wx78/call", "zg_ch_wx78/zg_ch_wx78/call" )
RemapSoundEvent( "dontstarve/zg/wx78/hit", "zg_ch_wx78/zg_ch_wx78/hit" )
RemapSoundEvent( "dontstarve/zg/wx78/die", "zg_ch_wx78/zg_ch_wx78/die" )
RemapSoundEvent( "dontstarve/zg/wx78/atk", "zg_ch_wx78/zg_ch_wx78/atk" )
RemapSoundEvent( "dontstarve/zg/wx78/tp", "zg_ch_wx78/zg_ch_wx78/tp" )
--巫婆
RemapSoundEvent( "dontstarve/zg/wicker/call", "zg_ch_wicker/zg_ch_wicker/call" )
RemapSoundEvent( "dontstarve/zg/wicker/hit", "zg_ch_wicker/zg_ch_wicker/hit" )
RemapSoundEvent( "dontstarve/zg/wicker/die", "zg_ch_wicker/zg_ch_wicker/die" )
RemapSoundEvent( "dontstarve/zg/wicker/ice", "zg_ch_wicker/zg_ch_wicker/ice" )
RemapSoundEvent( "dontstarve/zg/wicker/shoot", "zg_ch_wicker/zg_ch_wicker/shoot" )
RemapSoundEvent( "dontstarve/zg/wicker/call2", "zg_ch_wicker/zg_ch_wicker/call2" )
--伐木工
RemapSoundEvent( "dontstarve/zg/zg_mo_evergreen/explode", "zg_mo_evergreen/zg_mo_evergreen/explode" )
--维斯
RemapSoundEvent( "dontstarve/zg/wes/call", "zg_ch_wes/zg_ch_wes/call" )
RemapSoundEvent( "dontstarve/zg/wes/hit", "zg_ch_wes/zg_ch_wes/hit" )
RemapSoundEvent( "dontstarve/zg/wes/die", "zg_ch_wes/zg_ch_wes/die" )
--女武神
RemapSoundEvent( "dontstarve/zg/wigfrid/call", "zg_ch_wigfrid/zg_ch_wigfrid/call" )
RemapSoundEvent( "dontstarve/zg/wigfrid/hit", "zg_ch_wigfrid/zg_ch_wigfrid/hit" )
--蜘蛛人
RemapSoundEvent( "dontstarve/zg/webber/call", "zg_ch_webber/zg_ch_webber/call" )
RemapSoundEvent( "dontstarve/zg/webber/hit", "zg_ch_webber/zg_ch_webber/hit" )
RemapSoundEvent( "dontstarve/zg/webber/die", "zg_ch_webber/zg_ch_webber/die" )
--怪物扩展
RemapSoundEvent( "dontstarve/zg/mobs0/firegirl", "zg_mo_mobs0/firegirl/hit" )
RemapSoundEvent( "dontstarve/zg/mobs0/icearcher", "zg_mo_mobs0/icearcher/hit" )
RemapSoundEvent( "dontstarve/zg/mobs0/beaver", "zg_mo_mobs0/beaver/hit" )
--蝴蝶
RemapSoundEvent( "dontstarve/zg/cr_butterfly/call", "zg_cr_butterfly/zg_cr_butterfly/call" )
RemapSoundEvent( "dontstarve/zg/cr_butterfly/hit", "zg_cr_butterfly/zg_cr_butterfly/hit" )
RemapSoundEvent( "dontstarve/zg/cr_butterfly/die", "zg_cr_butterfly/zg_cr_butterfly/die" )
RemapSoundEvent( "dontstarve/zg/cr_butterfly/atk0", "zg_cr_butterfly/zg_cr_butterfly/atk0" )
RemapSoundEvent( "dontstarve/zg/cr_butterfly/atk1", "zg_cr_butterfly/zg_cr_butterfly/atk1" )
--触手
RemapSoundEvent( "dontstarve/zg/cr_tentacle/call", "zg_cr_tentacle/zg_cr_tentacle/call" )
RemapSoundEvent( "dontstarve/zg/cr_tentacle/hit", "zg_cr_tentacle/zg_cr_tentacle/hit" )
RemapSoundEvent( "dontstarve/zg/cr_tentacle/die", "zg_cr_tentacle/zg_cr_tentacle/die" )
--青蛙
RemapSoundEvent( "dontstarve/zg/cr_frog/call", "zg_cr_frog/zg_cr_frog/call" )
RemapSoundEvent( "dontstarve/zg/cr_frog/hit", "zg_cr_frog/zg_cr_frog/hit" )
RemapSoundEvent( "dontstarve/zg/cr_frog/die", "zg_cr_frog/zg_cr_frog/die" )
RemapSoundEvent( "dontstarve/zg/cr_frog/atk0", "zg_cr_frog/zg_cr_frog/atk0" )
--猎犬
RemapSoundEvent( "dontstarve/zg/cr_hound/call", "zg_cr_hound/zg_cr_hound/call" )
RemapSoundEvent( "dontstarve/zg/cr_hound/hit", "zg_cr_hound/zg_cr_hound/hit" )
RemapSoundEvent( "dontstarve/zg/cr_hound/die", "zg_cr_hound/zg_cr_hound/die" )
RemapSoundEvent( "dontstarve/zg/cr_hound/atk", "zg_cr_hound/zg_cr_hound/atk" )
--狼
RemapSoundEvent( "dontstarve/zg/mo_wolf/call", "zg_mo_wolf/zg_mo_wolf/call" )
RemapSoundEvent( "dontstarve/zg/mo_wolf/hit", "zg_mo_wolf/zg_mo_wolf/hit" )
RemapSoundEvent( "dontstarve/zg/mo_wolf/die", "zg_mo_wolf/zg_mo_wolf/die" )
RemapSoundEvent( "dontstarve/zg/mo_wolf/howl", "zg_mo_wolf/zg_mo_wolf/howl" )
--骷髅
RemapSoundEvent( "dontstarve/zg/mo_skel/call", "zg_mo_skel/zg_mo_skel/call" )
RemapSoundEvent( "dontstarve/zg/mo_skel/hit", "zg_mo_skel/zg_mo_skel/hit" )
RemapSoundEvent( "dontstarve/zg/mo_skel/die", "zg_mo_skel/zg_mo_skel/die" )
--冥河娃娃
RemapSoundEvent( "dontstarve/zg/mo_stygiandoll/call", "zg_mo_stygiandoll/zg_mo_stygiandoll/call" )
RemapSoundEvent( "dontstarve/zg/mo_stygiandoll/hit", "zg_mo_stygiandoll/zg_mo_stygiandoll/hit" )
RemapSoundEvent( "dontstarve/zg/mo_stygiandoll/die", "zg_mo_stygiandoll/zg_mo_stygiandoll/die" )
--艾斯
--RemapSoundEvent( "dontstarve/zg/ch_ace/call", "zg_ch1_ace/zg_ch1_ace/call" )
--RemapSoundEvent( "dontstarve/zg/ch_ace/hit", "zg_ch1_ace/zg_ch1_ace/hit" )
--RemapSoundEvent( "dontstarve/zg/ch_ace/die", "zg_ch1_ace/zg_ch1_ace/die" )
--特拉男
RemapSoundEvent( "dontstarve/zg/ch_law/hit", "zg_ch1_law/zg_ch1_law/hit" )
RemapSoundEvent( "dontstarve/zg/ch_law/die", "zg_ch1_law/zg_ch1_law/die" )
RemapSoundEvent( "dontstarve/zg/ch_law/atk", "zg_ch1_law/zg_ch1_law/atk" )
--山治
RemapSoundEvent( "dontstarve/zg/ch_sanji/call", "zg_ch1_sanji/zg_ch1_sanji/call" )
RemapSoundEvent( "dontstarve/zg/ch_sanji/hit", "zg_ch1_sanji/zg_ch1_sanji/hit" )
RemapSoundEvent( "dontstarve/zg/ch_sanji/die", "zg_ch1_sanji/zg_ch1_sanji/die" )
RemapSoundEvent( "dontstarve/zg/ch_sanji/atk", "zg_ch1_sanji/zg_ch1_sanji/atk" )
RemapSoundEvent( "dontstarve/zg/ch_sanji/atk_leg", "zg_ch1_sanji/zg_ch1_sanji/atk_leg" )
--皮弗娄牛
RemapSoundEvent( "dontstarve/beefalo/curious", "zg_cr_beefalo/zg_cr_beefalo/call" )
RemapSoundEvent( "dontstarve/beefalo/yell", "zg_cr_beefalo/zg_cr_beefalo/die" )
RemapSoundEvent( "dontstarve/beefalo/angry", "zg_cr_beefalo/zg_cr_beefalo/hit" )
--斧头帮
RemapSoundEvent( "dontstarve/zg/ch0_sweeper/mini", "zg_ch0_sweeper/zg_ch0_sweeper/minigun" )
--斧头帮来临
RemapSoundEvent( "dontstarve/zg/fx_axewarning/warn", "zg_fx_axewarning/zg_fx_axewarning/warn" )
--shotgun
RemapSoundEvent( "dontstarve/zg/shotgun/nobullet", "zg_weapon_shotgun/zg_weapon_shotgun/nobullet" )
RemapSoundEvent( "dontstarve/zg/shotgun/cantfill", "zg_weapon_shotgun/zg_weapon_shotgun/cantfill" )
RemapSoundEvent( "dontstarve/zg/shotgun/putdown", "zg_weapon_shotgun/zg_weapon_shotgun/putdown" )
RemapSoundEvent( "dontstarve/zg/shotgun/fill", "zg_weapon_shotgun/zg_weapon_shotgun/fill" )
--minigun
RemapSoundEvent( "dontstarve/zg/minigun/atk", "zg_weapon_minigun/zg_weapon_minigun/atk" )
--ak47
RemapSoundEvent( "dontstarve/zg/ak47/atk", "zg_weapon_ak47/zg_weapon_ak47/atk" )
--m4
RemapSoundEvent( "dontstarve/zg/m4/atk", "zg_weapon_m4/zg_weapon_m4/atk" )
--童子军大兵
RemapSoundEvent( "dontstarve/zg/ch0_soldier/call", "zg_ch0_soldier/zg_ch0_soldier/call" )
RemapSoundEvent( "dontstarve/zg/ch0_soldier/atking", "zg_ch0_soldier/zg_ch0_soldier/atking" )
RemapSoundEvent( "dontstarve/zg/ch0_soldier/atk", "zg_ch0_soldier/zg_ch0_soldier/atk" )
RemapSoundEvent( "dontstarve/zg/ch0_soldier/hit", "zg_ch0_soldier/zg_ch0_soldier/hit" )
RemapSoundEvent( "dontstarve/zg/ch0_soldier/die", "zg_ch0_soldier/zg_ch0_soldier/die" )
--防空警报
RemapSoundEvent( "dontstarve/zg/fx_redalert/warn", "zg_fx_redalert/zg_fx_redalert/warn" )
--冷冻猪
RemapSoundEvent( "dontstarve/zg/cr_icepig/atk", "zg_cr_icepig/zg_cr_icepig/atk" )
RemapSoundEvent( "dontstarve/zg/cr_icepig/hit", "zg_cr_icepig/zg_cr_icepig/hit" )
RemapSoundEvent( "dontstarve/zg/cr_icepig/die", "zg_cr_icepig/zg_cr_icepig/die" )
--虫洞
RemapSoundEvent( "dontstarve/zg/ut_wormhole/open", "zg_ut_wormhole/zg_ut_wormhole/open" )
RemapSoundEvent( "dontstarve/zg/ut_wormhole/close", "zg_ut_wormhole/zg_ut_wormhole/close" )
--腐败蜘蛛
RemapSoundEvent( "dontstarve/zg/mo_greenspider/call", "zg_mo_greenspider/zg_mo_greenspider/call" )
RemapSoundEvent( "dontstarve/zg/mo_greenspider/atk", "zg_mo_greenspider/zg_mo_greenspider/atk" )
RemapSoundEvent( "dontstarve/zg/mo_greenspider/die", "zg_mo_greenspider/zg_mo_greenspider/die" )
--猪猪BGM
RemapSoundEvent( "dontstarve/zg/bgm_pigmusic/bgm_pigmusic", "zg_bgm_pigmusic/zg_bgm_pigmusic/zg_bgm_pigmusic" )
--羊BGM
RemapSoundEvent( "dontstarve/zg/bgm_goat/bgm_goat", "zg_bgm_goat/zg_bgm_goat/zg_bgm_goat" )
--滑板鞋
RemapSoundEvent( "dontstarve/zg/bgm_shoe/bgm_shoe", "zg_bgm_shoe/zg_bgm_shoe/zg_bgm_shoe" )
--任务更新
RemapSoundEvent( "dontstarve/zg/bgm_taskcontinue/bgm_taskcontinue", "zg_bgm_taskcontinue/zg_bgm_taskcontinue/zg_bgm_taskcontinue" )

-------------------------------------------------------------------------------------------------------------------------------------------------------------
--全局变量
local g=GLOBAL
g.require "wiliya_lib"
local TimeEvent = g.TimeEvent
local FRAMES = g.FRAMES
local EQUIPSLOTS = g.EQUIPSLOTS
local EventHandler = g.EventHandler
local SpawnPrefab = g.SpawnPrefab
local State = g.State
local DEGREES = g.DEGREES
local Vector3 = g.Vector3
local STRINGS = g.STRINGS
local ACTIONS = g.ACTIONS
local FOODTYPE = g.FOODTYPE
local GetTime = g.GetTime
local wy_spawn=g.wy_spawn
local tw_isonland=g.tw_isonland
local FindEntity=g.FindEntity

----计算人物平均天数
local function ZG_average_dag()
	local sum = 0
	for i,v in ipairs(GLOBAL.AllPlayers) do
		if v and v.components.age then
			sum = sum + v.components.age:GetAgeInDays()
		end
	end
	local average = 0
	if #GLOBAL.AllPlayers >= 1 then
		average = sum / #GLOBAL.AllPlayers
	end
	return average
end

----计算人数
local function ZG_num_player()
	local num = 1
	if #GLOBAL.AllPlayers >= 1 then
		num = #GLOBAL.AllPlayers
	end
	return num
end

-- ######## 更改生物性格 #################################################################
local crtab={	--不能攻击指定的生物
	frog={dist=5,},
	tentacle={dist=5,},
	--dragonfly={dist=20,},
	moose={dist=20,},
	minotaur={dist=20,},
	rocky={dist=5,},
	walrus={dist=10,},
}
for k,v in pairs(crtab) do
	if v then
		AddPrefabPostInit(k,function(inst)
			inst:AddTag("shadowboss")
			if g.TheWorld.ismastersim then
				g.q1retarget(inst,v.dist or 9)
				g.q1keeptarget(inst)
				g.q1attacked(inst)
			end
		end)
	end
end

--蛤蟆
AddPrefabPostInit("toadstool",function(inst)
	inst:AddTag("shadowboss")	--不能攻击指定的生物
	if g.TheWorld.ismastersim then
		
	end
end)
--蜂后
AddPrefabPostInit("beequeen",function(inst)
	inst:AddTag("shadowboss")	--不能攻击指定的生物
	if g.TheWorld.ismastersim then
		
	end
end)

-- ######## 玩家机制 #####################################################################
local function GetSpawnPoint(pt)
    local theta = math.random() * 2 * g.PI
    local radius = 12
	local offset = g.FindWalkableOffset(pt, theta, radius, 12, true)
	if offset then
		return pt+offset
	end
end

local function Zg_onbuilt_fn(inst, data)
	--这是 和平难度 之上的机制
	if difficulty>.21 then
		if math.random() < .001/ZG_num_player() then
			for k=1,4 do
				local man=g.SpawnPrefab("zg_ch0_engineer")
				man.Transform:SetPosition( GetSpawnPoint( inst:GetPosition() ):Get() )
				wy_spawn(man,"collapse_small")
				if inst.components.talker then
					inst.components.talker:Say("有人跟踪我们")
				end
			end
		end
	end
end

local function Zg_oneat_fn(inst, data)
	
	--这是 和平难度 之上的机制
	if difficulty>.21 then
		if math.random() < .002/ZG_num_player() and ZG_average_dag()>15 then
			for k=1,4 do
				--local man=wy_spawn(inst,"krampus",{math.random()*5-10,0,math.random()*5-10})
				local man=g.SpawnPrefab("krampus")
				man.Transform:SetPosition( GetSpawnPoint( inst:GetPosition() ):Get() )
				wy_spawn(man,"collapse_small")
				if inst.components.talker then
					inst.components.talker:Say("我被盯上了")
				end
			end
		end
	end

	--吃东西触发的话难度需要 练习 以上
	if difficulty>.26 then
		if math.random() < .0002/ZG_num_player() and ZG_average_dag()>20 then
			local man=wy_spawn(inst,"zg_ch_wolfgang",{math.random()*3-6,0,math.random()*3-6})
			wy_spawn(man,"collapse_small")
		end
		if math.random() < .00005/ZG_num_player() and ZG_average_dag()>25 then
			local man=wy_spawn(inst,"zg_cr_icepig0",{math.random()*3-6,0,math.random()*3-6})
			wy_spawn(man,"collapse_small")
		end
		if math.random() < .001/ZG_num_player() and ZG_average_dag()>15 then
			for k=1,4 do
				local man=wy_spawn(inst,"zg_mo_goblin_grunt",{math.random()*5-10,0,math.random()*5-10})
				wy_spawn(man,"collapse_small")
			end
			if math.random() < .25 then
				local man=wy_spawn(inst,"zg_mo_goblin_robot_lightning",{math.random()*5-10,0,math.random()*5-10})
				wy_spawn(man,"collapse_small")
			end
		end
		
		local day=ZG_average_dag()
		if math.random() < .001/ZG_num_player() and day>30 then
			local num=4
			if day<50 then
				num=4
			elseif day<70 then
				num=6
			elseif day<90 then
				num=8
			elseif day<110 then
				num=10
			else
				num=12
			end
			for k=1,num do
				local man=wy_spawn(inst,{
					zg_skel2_mer=1,
					zg_skel2_gru=.5,
					zg_skel2_arc=.2,
					zg_skel2_ass=.1,
					zg_skel2_gua=.05,
					zg_skel2_sol=.02,
				},{math.random()*3-6,0,math.random()*3-6})
				wy_spawn(man,"collapse_small")
			end
		end
	end
end

--奖励箱子列表
local zg_chest_bonus = {
	"chest_labyrinth_zg", "chest_labyrinth_zg", "chest_labyrinth_zg", "chest_labyrinth_zg", "chest_labyrinth_zg", 
	"chest_labyrinth_zg", "chest_labyrinth_zg", "chest_labyrinth_zg", "chest_labyrinth_zg", "chest_labyrinth_zg", 
	"chest_zg_mo_evergreen", 
}
local BossChestTab={
	zg_ch_wilson=1, 
	zg_ch_willow=1, 
	zg_ch_wendy=1, 
	zg_ch_wx78=1, 
	zg_ch_wicker=1, 
	zg_ch_woodie=1, 
	zg_ch_wes=1, 
	zg_ch_waxwell=1, 
	zg_ch_webber=1,
	zg_ch_wigfrid=2, 
	zg_ch1_zoro=2, 
	zg_ch1_sanji=2, 
	zg_ch1_buggy=2,
	zg_ch_wolfgang=3, 
	zg_ch1_luffy=3, 
	deerclops=3, 
	bearger=4,
	
	zg_ch2_wilson=4, 
	zg_ch2_willow=4, 
	zg_ch2_wendy=4, 
	zg_ch2_wx78=4, 
	zg_ch2_wickerbottom=6, 
	zg_ch2_woodie=4, 
	zg_ch2_wes=4, 
	zg_ch2_waxwell=4, 
	zg_ch2_webber=4,
	zg_ch2_wathgrithr=5, 
	zg_ch2_wolfgang_mighty=6,
	
	zg_ch3_mihawk=6,
}
local function Zg_OnKill(inst, victim)
	if victim and victim.Zg_OnKill==nil then
		if BossChestTab[victim.prefab] then
			--GLOBAL.TheNet:Announce(inst:GetDisplayName().." 击杀了 "..victim:GetDisplayName())
			inst.SoundEmitter:PlaySound("dontstarve/zg/bgm_taskcontinue/bgm_taskcontinue")
			inst.components.health:SetPercent(1)
			for k=1,BossChestTab[victim.prefab] do
				--pandoraschest
				local chest=wy_spawn(inst,"treasurechest",{math.random()*2-4,0,math.random()*2-4})
				chest:AddComponent("scenariorunner")
				chest.components.scenariorunner:SetScript( zg_chest_bonus[math.random(#zg_chest_bonus)] )
				chest.components.scenariorunner:Run()
				wy_spawn(chest,"statue_transition_2")
				wy_spawn(chest,"statue_transition")
			end
			victim.Zg_OnKill=true
		end
	end
end

AddPlayerPostInit(function(inst)
	if inst then
		if g.TheWorld.ismastersim then
			inst:AddComponent("zg_sizechange")		--玩家的体积改变buff
			--inst:AddComponent("zg_onlyofficial")    --防止被卡到海外回不来的尴尬
			
			inst:ListenForEvent("oneat", Zg_oneat_fn)	--吃食物机制
			inst:ListenForEvent("builditem", Zg_onbuilt_fn)	--建造
			inst:ListenForEvent("buildstructure", Zg_onbuilt_fn)	--建造
			
			inst:AddComponent("zg_stat_score")
			inst:ListenForEvent("zg_killed", function(inst, data)
				local victim = data.victim
				if victim and victim:HasTag("zg_stat_manshape") then
					if inst.components.zg_stat_score then
						inst.components.zg_stat_score:Add(10)
					end
					g.TheNet:Announce(inst:GetDisplayName().." 击杀了 "..victim:GetDisplayName())
					Zg_OnKill(inst,victim)
				end
				
			end)
			----女武神自带25%物理伤害吸收
			if inst.prefab == "wathgrithr" then
				inst["zg_inh_anti_physics"] = .25
				inst.components.health:SetAbsorptionAmount(0)
			end
			----伐木工木属性抗性上限+10%
			if inst.prefab == "woodie" then
				inst["zg_max_anti_wood"] = .85
				inst["zg_inh_anti_wood"] = .50
			end
			----老,少
			if inst.prefab == "wickerbottom" or inst.prefab == "webber" or inst.prefab == "wx78" then
				inst.components.locomotor.walkspeed= 4.5
				inst.components.locomotor.runspeed = 6.5
				----机器人闪电抗性上限+10%
				if inst.prefab == "wx78" then
					inst["zg_max_anti_electric"] = .85
					inst["zg_inh_anti_electric"] = .50
				end
			end
			----年轻
			if inst.prefab == "wilson" or inst.prefab == "willow" or inst.prefab == "wendy" then
				inst.components.locomotor.walkspeed= 5
				inst.components.locomotor.runspeed = 7
				----威尔逊
				if inst.prefab == "wilson" then
					inst.components.builder.science_bonus = 1
				end
				----薇洛的攻击系数不变, 火焰火焰抗性上限+10%
				if inst.prefab == "willow" then
					inst["zg_max_anti_fire"] = .85
					inst["zg_inh_anti_fire"] = .50
				end
				----温蒂暗属性抗性上限+10%
				if inst.prefab == "wendy" then
					inst["zg_max_anti_dark"] = .85
					inst["zg_inh_anti_dark"] = .50
				end
			end
			----最弱的跑的最快
			if inst.prefab == "wes"then
				inst.components.locomotor.walkspeed= 5.5
				inst.components.locomotor.runspeed = 7.5
			end
			
		end
	end
end)

-- ######## 世界机制 ###############################################################
AddPrefabPostInit("world", function(inst)			
	if g.TheWorld.ismastersim then
	
		if difficulty > .21 then
			--练习模式开始有的
			inst:AddComponent("zg_axeed")			--斧头帮袭击
			inst:AddComponent("zg_goblined")		--哥布林袭击
			inst:AddComponent("zg_wolfed")			--狼群袭击
		end
		if difficulty > .26 then
			--彩蛋
			inst:AddComponent("zg_superboss")	--超级boss
			inst:DoTaskInTime(0, function()
				inst.components.zg_superboss:TrySpawn()
			end)
			--战争开始才有的袭击
			inst:AddComponent("zg_redalerted")		--童子军袭击
			inst:AddComponent("zg_kramped")			--新的淘气值
			inst:AddComponent("zg_skeled")			--骷髅袭击
			inst:AddComponent("zg_man_boss")	--人形兵器
		end
		if difficulty > .51 then
			--地狱难度才有的袭击
			--inst:AddComponent("zg_man_boss")		
		end
		--记录死亡次数
		inst:AddComponent("zg_total_death")
		inst:ListenForEvent("entity_death", function(inst, data)
			if data and data.inst and data.inst:HasTag("player") then
				inst.components.zg_total_death:Add(1)
			end
		end)
	end
end)

-- ######## 物理体的重写 (为了让子弹可以打到) ##################################
local phystab={
	crow={},
	robin={},
	robin_winter={},
	butterfly={m=1,},
	bee={m=1,},
	killerbee={m=1,},
	bat={},
	mosquito={m=1,},
	tentacle={phy="OBSTACLES",},
	tentacle_pillar_arm={phy="OBSTACLES",r=.1,},
	dragonfly={r=1.4,m=500},
	q1butterfly={},
	q1butterfly2={},
}
for k,v in pairs(phystab) do
	if v~=nil then
		AddPrefabPostInit(k, function(inst)
			local phys=inst.Physics
			phys:SetMass(v.phy=="OBSTACLES" and 0 or v.m or 10) 
			phys:SetCapsule(v.r or .5, v.h or 2)
			phys:SetCollisionGroup(g.COLLISION[v.phy or "CHARACTERS"])
			phys:ClearCollisionMask()
			phys:CollidesWith(g.COLLISION.CHARACTERS)
			phys:CollidesWith(g.COLLISION.GROUND)
		end)
	end
end

-- ######## 不显示血量浮动数字 #######
local function remove_dmgid(inst)
	inst:AddTag("zg_no_dmgid")
end
AddPrefabPostInit("chester",remove_dmgid)
AddPrefabPostInit("eyeturret",remove_dmgid)
AddPrefabPostInit("hutch",remove_dmgid)

-- ######## 怪物变大机制 ########
--巨型化	$$$$$$$$
local tobigtable = {
	--被动生物
	"crow", "robin", "robin_winter", "rabbit", 
	--中立生物
	"beefalo", "koalefant_summer","koalefant_winter","catcoon","buzzard","penguin","lightninggoat","monkey","pigman",
	--普通敌对生物
	"merm","pigguard","tallbird","walrus","mosquito","krampus","crawlinghorror","terrorbeak",
	"spider_hider","spider_dropper","spider","spider_spitter","spider_warrior",
	--精英敌对生物
	"zg_spider_steel",
}
for k,v in pairs(tobigtable) do
	AddPrefabPostInit(v, function(inst)
		if g.TheWorld.ismastersim then
			inst:AddComponent("zg_mobbig")		--怪物变大		
			inst.components.zg_mobbig:DoCalc()	--入口函数
			----与变大机制配套的掉落物的机制
			function inst.components.lootdropper:DropLoot(pt)
				local prefabs = self:GenerateLoot()
				if not self.inst.components.fueled and self.inst.components.burnable and self.inst.components.burnable:IsBurning() then
					for k,v in pairs(prefabs) do
						local cookedAfter = v.."_cooked"
						local cookedBefore = "cooked"..v
						if g.PrefabExists(cookedAfter) then
							prefabs[k] = cookedAfter
						elseif g.PrefabExists(cookedBefore) then
							prefabs[k] = cookedBefore 
						else             
							prefabs[k] = "ash"               
						end
					end
				end
				for k,v in pairs(prefabs) do
					self:SpawnLootPrefab(v, pt)
					----多余的掉落物
					if inst.components.zg_mobbig and inst.components.zg_mobbig.loot and inst.components.zg_mobbig.loot >= 1 then
						for k = 1, inst.components.zg_mobbig.loot do
							self:SpawnLootPrefab(v, pt)
						end
					end
				end
			end
		end
	end)
end
modimport("scripts/zg_mob_mods/pigman_mod.lua")
modimport("scripts/zg_mob_mods/bunnyman_mod.lua")
	
-- ######## 智能敌对 变异机制 (代码重制) ########################################################################
--生物的变异(和平难度没有)	$$$$$$$$
local antitab_defaulttime=15 + math.random() * 30
local antitab={
	butterfly={change={q1butterfly=2,q1butterfly2=1},},
	bat={change={q1bat=2,q1bat2=1,q1bat3=1},chance=.75},
	frog={change={zg_mo_frog=2,zg_mo_frog0=1},},
	hound={change={zg_mo_hound=1},},
	firehound={change={zg_mo_firehound=1},sg="hound",},
	icehound={change={zg_mo_icehound=1},sg="hound",},
	tentacle={change={zg_mo_tentacle=1},time=30 + math.random() * 30,chance=.75},
}

--变异函数		prefname2可以是table
local function wy_variation(sgname,prefname,time,prefname2,fx,sfx)
	AddStategraphPostInit(sgname,function(sg)
		local state_idle=sg.states["idle"].onenter
		sg.states["idle"].onenter=function(inst)
			if inst and inst.prefab==prefname 
				and (inst.components.wiliya_monsteranti and inst.components.wiliya_monsteranti.anti==false) --没有抗体
				then
				
				local t = GetTime()
				if inst.nextvariationtime==nil then
					inst.nextvariationtime=t + time
				end
				if t > inst.nextvariationtime then
					if antitab[prefname] and (antitab[prefname].chance or .5)>math.random() then	--在变异几率
						--特效
						wy_spawn(inst,fx or "statue_transition",nil,nil,nil,nil,sfx or "dontstarve/characters/woodie/lucy_warn_"..math.random(3))
						--生成新物品
						wy_spawn(inst,prefname2)
						--对于生物,要触发死亡事件后干净地消除物体
						if inst.components.health then
							inst:AddTag("zg_no_dmgid")
							inst.components.health:Kill()
							if inst.components.lootdropper then
								inst.components.lootdropper.GenerateLoot = function() return {} end
							end
						--对于非生物,直接移除
						else
							inst:Remove()
						end
					else
						--逃过一劫然后有抗体了
						if inst.components.wiliya_monsteranti then
							inst.components.wiliya_monsteranti.anti=true
						end
						return state_idle(inst)
					end
				else
					return state_idle(inst)
				end
			else
				--没有变异的有抗体了
				if inst.components.wiliya_monsteranti then
					inst.components.wiliya_monsteranti.anti=true
				end
				return state_idle(inst)
			end
		end
	end)
end

for k,v in pairs(antitab) do
	if v then
		--抗体概念
		AddPrefabPostInit(k,function(inst)	
			if g.TheWorld.ismastersim then
				inst:AddComponent("wiliya_monsteranti")
			end
		end)
		--实施变异
		if difficulty > .21 then
			wy_variation(k, v.sg or k, v.time or antitab_defaulttime, v.change)
		end
		--月圆之夜变异体消失
		for kk,vv in pairs(v) do	
			if kk=="change" then	
				if type(vv)=="table" then
					for kkk,vvv in pairs(vv) do
						AddPrefabPostInit(kkk,function(inst)
							if g.TheWorld.ismastersim then
								local function OnIsFullmoon(inst, isfullmoon)
									if isfullmoon then
										--特效
										wy_spawn(inst,fx or "statue_transition",nil,nil,nil,nil,sfx or "dontstarve/characters/woodie/lucy_warn_"..math.random(3))
										--还原物品
										local obj=wy_spawn(inst,k)
										--获得抗体
										if obj.components.wiliya_monsteranti then
											obj.components.wiliya_monsteranti.anti=true
										end
										--对于生物,要触发死亡事件后干净地消除物体
										if inst.components.health then
											inst:AddTag("zg_no_dmgid")
											inst.components.health:Kill()
											if inst.components.lootdropper then
												inst.components.lootdropper.GenerateLoot = function() return {} end
											end
										--对于非生物,直接移除
										else
											inst:Remove()
										end
									end
								end
								inst:WatchWorldState("isfullmoon", OnIsFullmoon)
							end
						end)
					end
				end
			end
		end
	end
end

-- ######## 生物特殊的 BGM ###################################
--牛
local function beefalo_music(inst)
	inst:AddTag("zg_beefalo_music")
end
AddPrefabPostInit("beefalo", beefalo_music)
--猪
local function pigman_music(inst)
	inst:AddTag("zg_pig_music")
end
AddPrefabPostInit("pigman", pigman_music)
AddPrefabPostInit("pigguard", pigman_music)
AddPrefabPostInit("zg_cr_icepig", pigman_music)	
--羊
local function lightninggoat_music(inst)
	inst:AddTag("zg_goat_music")
end
AddPrefabPostInit("lightninggoat", lightninggoat_music)

-- ######## 物品的 掉落音效 ####################################
-- $$$$$$$$
local soundtab={
	["zg_drop/shield/wood"]={"zg_shield_wood", "zg_shield_lion"},
	["zg_drop/shield/steel"]={"zg_shield_armored",},
	["zg_drop/weapon/spear_l"]={"boards","boomerang",},
	["zg_drop/weapon/spear"]={"spear", "pitchfork",},
	["zg_drop/weapon/spear_m"]={"spear_wathgrithr","tentaclespike",
		--mod a
		"z_boneclaw",
	},
	["zg_drop/weapon/staff"]={"icestaff","firestaff","telestaff","greenstaff","yellowstaff","staff_tornado","diviningrod",},
	["zg_drop/weapon/staff_l"]={"nightstick","cane","brush","orangestaff",},
	["zg_drop/weapon/sword"]={"nightsword", "batbat",
		--mod
		"z_bonesword","zg_weapon_mace","zg_weapon_shortsword",
	},
	["zg_drop/weapon/sword_l"]={"razor",},
	["zg_drop/weapon/axe"]={"axe", "batbat","goldenaxe", "pickaxe", "goldenpickaxe","shovel","shovel","goldenshovel",
		--mod
		"zg_weapon_axe","zg_weapon_axe0",
	},
	["zg_drop/weapon/axe_h"]={"multitool_axe_pickaxe","ruins_bat","z_greenspear",
		--mod
		"z_cutaxe","zg_weapon_longsword","zg_weapon_gaintsword","zg_fx_mihawksymbol",
	},
	["zg_drop/weapon/hammer"]={"hammer",},
	["zg_drop/weapon/dart"]={"blowdart_sleep","blowdart_fire","blowdart_pipe","blowdart_yellow",},
	["zg_drop/weapon/bow"]={
		--mod
		"z_redbow","z_bonebow",
	},
	
	["zg_drop/item/amulet"]={"amulet", "blueamulet", "purpleamulet", "orangeamulet", "greenamulet", "yellowamulet",},
	["zg_drop/item/gem"]={"redgem", "bluegem", "purplegem", "orangegem", "greengem", "yellowgem",},
	["zg_drop/item/posion"]={"waterballoon",},
	["zg_drop/item/heart"]={"reviver","spidergland","spidereggsack","mosquitosack",},
	["zg_drop/item/squre"]={"krampus_sack","moonrockcrater","moonrocknugget",
		--mod
		"q4banshou",
	},
	["zg_drop/item/money"]={"goldnugget",},
	
	["zg_drop/armor/chain"]={"armordragonfly",},
	["zg_drop/armor/leather"]={"trunkvest_summer", "trunkvest_winter","beargervest","bedroll_furry","piggyback","icepack",},
	["zg_drop/armor/leather_l"]={"raincoat","hawaiianshirt","reflectivevest","bedroll_straw","backpack",},
	["zg_drop/armor/chain_l"]={"sweatervest","whip","steelwool",},
	["zg_drop/armor/slurple"]={"armorslurper",},
	["zg_drop/armor/wood"]={"armorgrass", "armorwood", },
	["zg_drop/armor/plate"]={"armor_sanity",
		--mod
		"z_ar_bone",
	},
	["zg_drop/armor/plate_h"]={"armorruins","armormarble",
		--mod
		"z_ar_bone2",
	},
	
	["zg_drop/hat/hat"]={"footballhat","beefalohat","rainhat","winterhat","catcoonhat","icehat","featherhat","bushhat","eyebrellahat","minerhat","molehat","beehat",
		"red_mushroomhat","green_mushroomhat","blue_mushroomhat",
	},
	["zg_drop/hat/hat_h"]={"wathgrithrhat","ruinshat",
		--mod
		"z_arh_bone",
	},
	
	["zg_drop/book/book"]={"book_birds", "book_gardening", "book_sleep", "book_brimstone", "book_tentacles", "waxwelljournal",},
	["zg_drop/book/paper"]={"blueprint","papyrus",
		--mod
		"q4loveletter",
	},	
	
	["zg_melee/gun/ground"]={"saddle_basic","saddle_war","saddle_race","compass","featherfan","featherpencil","nightmare_timepiece","hambat","lifeinjector",},
	
	["dontstarve/impacts/impact_stone_wall_dull"]={"thulecite_pieces","thulecite","rocks","cutstone","wall_ruins_item","wall_stone_item",
		"heatrock","wall_moonrock_item",
	},
}
for k,v in pairs(soundtab) do
	if type(v)=="table" then
		for kk,vv in pairs(v) do
			AddPrefabPostInit(vv,function(inst)
				if not inst.SoundEmitter then inst.entity:AddSoundEmitter()	end
				if g.TheWorld.ismastersim then
					inst:ListenForEvent("ondropped", function(inst) 
						inst:DoTaskInTime(.25,function() 
							inst.SoundEmitter:PlaySound(k)
						end)
					end)
				end
			end)
		end
	end
end

--######## 工作机制 ###################################
if difficulty >.21 then
	-- 工作相关的所有机制 $$$$$$$$
	local SpawnMobTab_defaulttab={q1bat=7,q1bat2=2,q1bat3=1}
	local SpawnMobTab_defaultoffset={math.random()*.5-1,0,math.random()*.5-1}
	local SpawnMobTab={
		rock1={},
		rock2={},
		rock_flintless={},
		rock_flintless_med={},
		rock_flintless_low={},
		rock_moon={},
		rock_petrified_tree={},
		rock_petrified_tree_med={},
		rock_petrified_tree_tall={},
		rock_petrified_tree_short={},
		rock_petrified_tree_old={},
		stalagmite_full={},
		stalagmite_med={},
		stalagmite_low={},
		stalagmite={},
		stalagmite_tall_full={},
		stalagmite_tall_med={},
		stalagmite_tall_low={},
		stalagmite_tall={},
		rock_ice={mob={zg_cr_icepig=10,zg_cr_icepig0=1},},
		cookpot={event="zg_oncook",mob={zg_ut_wormhole=1},offset={math.random()*5-10,0,math.random()*5-10},chance=.005},
	}
	for k,v in pairs(SpawnMobTab) do
		if v then
			AddPrefabPostInit(k,function(inst)
				if g.TheWorld.ismastersim then
					inst:ListenForEvent(v.event or "worked", function(inst,data)
						if math.random() < (v.chance or .02) then
							local mob=wy_spawn(inst, v.mob or SpawnMobTab_defaulttab, v.offset or SpawnMobTab_defaultoffset,nil,nil,nil,nil,function(guy)
								if guy.sg and guy.sg.sg and guy.sg.sg.taunt then guy.sg:GoToState("taunt") end
							end)
							wy_spawn(mob,"collapse_small")
						end
					end)
				end
			end)
		end
	end
	--插入熟饭事件的定义
	AddComponentPostInit("stewer",function(cmp)
		local old_StartCooking=cmp.StartCooking
		function cmp:StartCooking()
			if self.targettime == nil and self.inst.components.container ~= nil then
				self.inst:PushEvent("zg_oncook")
			end
			return old_StartCooking(self)
		end
	end)
end

-- ######## boss以及召唤兽的初始化 ###########################################
-- $$$$$$
local bosstab = {
	zg_ch_wilson={}, 
	zg_ch_willow={anti={fire=1,},}, 
	zg_ch_wolfgang={}, 
	zg_ch_wendy={anti={dark=1,},}, 
	zg_ch_wx78={anti={electric=1,},}, 
	zg_ch_wicker={anti={ice=1,},}, 
	zg_ch_woodie={anti={wood=1,},}, 
	zg_ch_wes={}, 
	zg_ch_webber={}, 
	zg_ch_waxwell={}, 
	zg_ch_wigfrid={},
	zg_ch1_zoro={}, 
	zg_ch1_luffy={anti={electric=1,fire=0,bullet=1},}, 
	zg_ch1_sanji={}, 
	zg_ch1_buggy={},
	
	zg_ch3_mihawk={ex=true,},
	
	deerclops={boss=true,anti={ice=1,},},
	bearger={boss=true,},
	dragonfly={boss=true,anti={fire=1,},},
	moose={boss=true,},
	minotaur={boss=true,},
	spiderqueen={boss=true,},
	leif={boss=true,},
	leif_sparse={boss=true,},
	
	zg_mo_bunny={summon=true,},
	zg_mo_perd={summon=true,},
	zg_mo_firegirl={summon=true,anti={fire=1,},},
	zg_mo_spider={summon=true,},
	zg_mo_icearcher={summon=true,anti={ice=1,},},
	zg_mo_abigail={summon=true,},
	zg_mo_beaver={summon=true,},
	zg_mo_shadow={summon=true,},
}
local stimulitab={
	"fire","ice","electric","stone","wood","dark","ray","bone","bullet","physics",
}
for k,v in pairs(bosstab) do
	if v then
		AddPrefabPostInit(k,function(inst)
			inst:AddTag("electricdamageimmune")
			inst:AddTag("hostile")
			if g.TheWorld.ismastersim then
				local day=g.TheWorld.state.cycles or 0
				if v.boss then
					--
				elseif v.summon then
					inst.components.health:SetMaxHealth( math.min(200+day*1, 400) )
					inst.components.health:StartRegen(0, 5)
					inst.components.locomotor.runspeed = math.min(5+day*.02, 9)
				elseif v.ex then
					inst.components.health:SetMaxHealth( math.min(1000+day*10, 3000) )
					inst.components.health:StartRegen(0, 5)
					inst.components.health:SetAbsorptionAmount(.8)
					inst:ListenForEvent("attacked",function(inst,data)
						local attacker = data.attacker
						if attacker and not attacker:HasTag("shadowboss") then
							inst.components.combat:SetTarget(attacker)
						end
					end)
				else
					inst:AddTag("zg_stat_manshape")
					inst.components.health:SetMaxHealth( math.min(400+day*4, 1200) )
					inst.components.locomotor.runspeed = math.min(5+day*.01, 7)
					inst.components.health:SetAbsorptionAmount(.8)
					inst:ListenForEvent("attacked",function(inst,data)
						local attacker = data.attacker
						if attacker and not attacker:HasTag("shadowboss") then
							inst.components.combat:SetTarget(attacker)
						end
					end)
				end
				--共有抗性
				for i, j in pairs(stimulitab) do
					if j == "bullet" then
						inst["zg_inh_anti_"..j] = .75
						inst["zg_max_anti_"..j] = 1
					else
						inst["zg_inh_anti_"..j] = math.min(day*.00125,.5)
						inst["zg_max_anti_"..j] = 1
					end
				end
				--独特抗性
				if type(v.anti)=="table" then
					for i,j in pairs(v.anti) do
						inst["zg_inh_anti_"..i]=j
					end
				end
				--不会被指定的攻击
				function inst.components.combat:CanBeAttacked(attacker)
					return attacker
						and not attacker:HasTag("shadowboss")
						and not attacker:HasTag("shadowcreature")
						--and not ( not inst:HasTag("zg_kaizaku") and attacker:HasTag("zg_marine") )
						and self.inst.replica.combat:CanBeAttacked(attacker)
				end
			end
		end)
	end
end

--完善设置移动速度
AddComponentPostInit("locomotor",function(cmp) 
	function cmp:zg_setspeed(a,b) 
		self.runspeed=a 
		self.walkspeed=b
	end
end)











	