--走位躲避在AI必须是个定值
require "behaviours/bh_runaway"
require "behaviours/bh_chaseandattack"

local br_manshape = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)

---------------------------------------------------------------------------

----	吃食物时
local function EatFoodAction(inst)
    local target = nil
	if not inst.components.eater then
		return
	end
    if inst.components.inventory then
        target = inst.components.inventory:FindItem(function(item) return inst.components.eater:CanEat(item) 
			and (item.components.edible and item.components.edible:GetHealth(inst)>=0 )
		end)
    end
    if not target then
        target = FindEntity(inst, inst.zg_findfood_dist, function(item) return inst.components.eater:CanEat(item) 
			and (item.components.edible and item.components.edible:GetHealth(inst)>=0 )
		end)
    end
    if target then
        local act = BufferedAction(inst, target, ACTIONS.EAT)
        act.validfn = function() return 
			not (target.components.inventoryitem and target.components.inventoryitem.owner and target.components.inventoryitem.owner ~= inst)
		end
        return act
    end
end

---------------------------------------------------------------------------

function br_manshape:OnStart()
    local root = PriorityNode(
    {	
		----够不着玩家就打墙
		WhileNode( function() 
			return not zg_canattacktarget(self.inst) end, 
			"AttackWall1",
			AttackWall(self.inst)),
			
		--对付玩家的追杀		
        WhileNode( function() 
			return 
				not self.inst.components.combat:InCooldown()
				
				--[[
				--就绪 是否追
				not self.inst.components.combat:InCooldown() and 
				--( zg_checktag(self.inst.components.combat.target, {"player"}, {"playerghost"}) 
				--	or zg_cansneak(self.inst)
				--) 
				true
				
				or 
				--冷却中 是否追
				( 	
					--对待玩家
					zg_checktag(self.inst.components.combat.target, {"player"}, {"playerghost"}) and 
						(	--对于自己走位无法躲那个玩家攻击 在冷却阶段也要追
							not zg_target_noexweapon(self.inst,self.inst.target_exdist)
							
							--or
							
							--玩家表面上在逃跑
							--zg_target_isescaping(self.inst)
						)
					
					or 
					--不是玩家,在相对完全范围去追
					not zg_checktag(self.inst.components.combat.target, {"player"}, {"playerghost"}) and zg_cansneak(self.inst)
				)]]
				
			end, 			
			"AttackMomentarily",
			Bh_ChaseAndAttack(self.inst, self.inst.zg_chase_time) ), 
		
		--走位
		WhileNode( function() 
			return self.inst.components.combat.target and self.inst.components.combat:InCooldown() end,
			"Dodge", Bh_RunAway(self.inst, function() 
				return self.inst.components.combat.target end,
			self.inst.zg_see_dist,self.inst.zg_stoprunaway_dist)),
		
		--[[
		--对付非玩家的追杀
		WhileNode( function() 
			--自己冷却好, 并且读取目标的攻击间隔
			return not self.inst.components.combat:InCooldown() and not zg_checktag(self.inst.components.combat.target, {"player"}, {"playerghost"})
				and zg_cansneak(self.inst)
			end, 				
			"AttackMomentarily1",
			ChaseAndAttack(self.inst, self.inst.zg_chase_time) ), 
		]]
		
		--[[
		--对付玩家的走位
		WhileNode( function() 
			--自己在冷却 且 会被打到才走位, 但是如果是跟踪的武器或者攻击距离过长的变态武器则不再走位
			return --zg_canbeattacked(self.inst) and 
				self.inst.components.combat.target and self.inst.components.combat:InCooldown() 
				--
				--and	(	self.inst.components.combat.target:HasTag("player") and zg_target_noexweapon(self.inst,self.inst.target_exdist)
				--	or true
				--)
			end, 
			"Dodge", RunAway(self.inst, function() 
				return self.inst.components.combat.target end,
			zg_startdogedist(self.inst,self.inst.zg_runaway_dist), zg_stopdogedist(self.inst,self.inst.zg_stoprunaway_dist) ) ),
			--3, 5) ),
		]]
		--[[
		--对付非玩家的走位
		WhileNode( function()
			--自己在冷却 且 会被打到才走位, 但是如果是跟踪的武器或者攻击距离过长的变态武器则不再走位
			return --zg_canbeattacked(self.inst) and 
				self.inst.components.combat.target and not self.inst.components.combat.target:HasTag("player")
				and self.inst.components.combat:InCooldown() 
			end, 
			"Dodge1", RunAway(self.inst, function() 
			return self.inst.components.combat.target end, self.inst.zg_runaway_dist, self.inst.zg_stoprunaway_dist) ),
		]]	
		AttackWall(self.inst),
		----吃食物
        DoAction(self.inst, EatFoodAction, "Eat Food"),
		
		----接近玩家基地
		
		----徘徊
        Wander(self.inst),
		
    }, self.inst.zg_ai_period)
    
    self.bt = BT(self.inst, root)

end

return br_manshape