local zg_ch0_engineer = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)

local repair_targets=
{
	cookpot=true,
	icebox=true,
	firepit=true,
	coldfirepit=true,
	firesuppressor=true,
	
	researchlab=true,
	researchlab2=true,
	researchlab4=true,
	researchlab3=true,
	
	--ancient_altar=true,
	--ancient_altar_broken=true,
	pighouse=true,
	rabbithouse=true,
	
	tent=true,
	siestahut=true,
	
	birdcage=true,
}

local function FindRepair(inst)
	local target = FindEntity(inst, 30, function(item) 
		return item 
			and type(item.prefab)=="string" 
			and repair_targets[item.prefab]==true
			and item.components.workable
			and item.components.workable.workleft>0 
			and item:IsOnValidGround()
	end)
    if target then
        local act = BufferedAction(inst, target, ACTIONS.ZG_ENGINEER)
		act.target_type=repair_targets[target.prefab] and "zg_utf_"..target.prefab
		return act
    end
	return nil
end

function zg_ch0_engineer:OnStart()
    local root =
        PriorityNode(
        {
			ChaseAndAttack(self.inst,4,8),
			
			--修理
			--DoAction(self.inst, function() return FindRepair(self.inst, ACTIONS.ZG_ENGINEER,nil,nil,5) end),
			DoAction(self.inst, function() return FindRepair(self.inst) end, "OccupyBase", true),
			
            Wander(self.inst),
        },.25)
     
    self.bt = BT(self.inst, root)   
end

return zg_ch0_engineer
