
local SEE_PLAYER_DIST = 5
local SEE_FOOD_DIST = 10
local MAX_WANDER_DIST = 15
local MAX_CHASE_TIME = 20
local MAX_CHASE_DIST = 25
local RUN_AWAY_DIST = 6
local STOP_RUN_AWAY_DIST = 8

local MIN_FOLLOW = 4
local MAX_FOLLOW = 11
local MED_FOLLOW = 6 


local Zg_mo_wolfbrain = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)

---------------------------------------------------------------------------
----	ʳʱ
local function EatFoodAction(inst)
    --if (inst.components.combat.target) then return end
    local target = nil
    if inst.components.inventory and inst.components.eater then
        target = inst.components.inventory:FindItem(function(item) return inst.components.eater:CanEat(item) end)
    end
    if not target then
        target = FindEntity(inst, 20, function(item) return inst.components.eater:CanEat(item) end)
    end
    if target then
        local act = BufferedAction(inst, target, ACTIONS.EAT)
        act.validfn = function() return not (target.components.inventoryitem and target.components.inventoryitem.owner and target.components.inventoryitem.owner ~= inst) end
        return act
    end
end
---------------------------------------------------------------------------

function Zg_mo_wolfbrain:OnStart()
    local root = PriorityNode(
    {	
		AttackWall(self.inst),
	
		ChaseAndAttack(self.inst, 10, 30),      
			
		----	
		Follow(self.inst, function() return self.inst.components.follower.leader end, MIN_FOLLOW, MED_FOLLOW, MAX_FOLLOW, true),
		
		----	ʳ
        DoAction(self.inst, EatFoodAction, "Eat Food"),
		
		----	ǻ
        Wander(self.inst),
		
    }, 1)
    
    self.bt = BT(self.inst, root)

end

return Zg_mo_wolfbrain