return Class(function(self, inst)
----------------------------------------------------
self.inst = inst
self.mCount = 5		--方阵的大小
self.space = 2 		--结点间距
self.victory_stage = 17 	--胜利的段数		7级为131072/8

--重新开始游戏
function self:Restart()
	for i=1,self.victory_stage do
		self["victory"..i]=false
	end
	self.fail=false
	for i=1,self.mCount do
		for j=1,self.mCount do
			self:SetNum(i,j,0)		--设置卡片数字 
		end
	end
	self:SetScore()
	--生成开始的数字
	self:AddRandomNum()
	self:AddRandomNum()
end

--生成按钮,计分板,卡片
function self:SpawnCards()
	--卡片
	for i=1,self.mCount do
		for j=1,self.mCount do
			if self.inst["card_"..i.."_"..j]==nil then
				self.inst["card_"..i.."_"..j]=SpawnPrefab("lovers_2048_card")
				local x,y,z=self.inst.Transform:GetWorldPosition()
				x= x + self.space * ( i - math.ceil(self.mCount/2) )
				z= z + self.space * ( j + 1 )
				self.inst["card_"..i.."_"..j].Transform:SetPosition(x,0,z)	--设置卡片位置 
				self:SetNum(i,j, self["card_"..i.."_"..j.."_num"] or 0 )		--载入卡片数字  
			end
		end
	end
	--计分板
	local x,y,z=self.inst.Transform:GetWorldPosition()
	if self.inst["card_score"]==nil then
		self.inst["card_score"]=SpawnPrefab("lovers_2048_card")
		self.inst["card_score"].Transform:SetPosition(x,0,z-2)
		self:SetScore()
	end
	--移动杆
	local dirtab=
	{
		left={x=-4,z=-2},
		right={x=-2,z=-2},
		up={x=-3,z=-1},
		down={x=-3,z=-3},
	}
	for k,v in pairs(dirtab) do
		if v and self.inst[k]==nil then
			self.inst[k]=SpawnPrefab("lovers_2048_dir")
			self.inst[k].Transform:SetPosition( x+(v.x or 0),0,z+(v.z or 0) )
			self.inst[k].dir=k
			self.inst[k].master=self.inst
		end
	end
	dirtab=nil
	if not self.isNotNew then
		self:Restart()
		self.isNotNew=true
	end
end

local ColorTab=
{
	q2={184, 87,  198},
	q4={255, 196, 45},
	q8={75,  75,  75},
	q16={128, 128, 128},
	q32={255, 255, 255},
	q64={149, 191, 242},
	q128={222, 222, 99},
	q256={59,  222, 99},
	q512={216, 60,  84},
	q1024={129, 168, 99},
	q2048={150, 206, 169},
	q4096={206, 145, 192},
	q8192={113, 125, 194},
	q16384={205, 191, 121},
	q32768={170, 85,  129},
	q65536={150, 201, 206},
	q131072={206, 150, 100},
	q262144={208, 120, 86},
	q524288={125, 81,  156},
	q1048576={205, 79,  57 },
	q2097152={255, 165, 79},
	q4194304={205, 150, 205},
	q8388608={205, 170, 125},
}

--卡片设置数字并显示
function self:SetNum(i,j,num)
	if self.inst["card_"..i.."_"..j]~=nil then
		self.inst["card_"..i.."_"..j].num=num
		
		--设置卡片的显示的,目前用数字标签代替,以后换成真正的卡片
		self.inst["card_"..i.."_"..j].Label:SetText(num)
		if num>0 then
			self.inst["card_"..i.."_"..j].Label:SetColour(unpack(ColorTab["q"..num] or {1,0,0}))
		else
			self.inst["card_"..i.."_"..j].Label:SetColour(1, 0, 0)
		end
	end
end

--获取卡片数字
function self:GetNum(i,j)
	return self.inst["card_"..i.."_"..j]
		and self.inst["card_"..i.."_"..j].num
		or 0
end

----获得分数
function self:GetScore(score)
	local score=score or 0
	for i=1,self.mCount do
		for j=1,self.mCount do
			local _score = self.inst["card_"..i.."_"..j] and self.inst["card_"..i.."_"..j].num or 0
			score=math.max(score,_score)
		end
	end
	return score
end

----设置分数
function self:SetScore(score)
	--获取分数
	local score=self:GetScore(score or 0)
	--设置分数
	if self.inst["card_score"]~=nil then
		self.inst["card_score"].num=score
		
		--设置卡片的显示的,目前用数字标签代替,以后换成真正的卡片
		self.inst["card_score"].Label:SetText("分数:"..score)
	end
end

----在空闲位置随机生成数字,2和4的概率是9:1
function self:AddRandomNum()
	local emptyPoints={}	--记录所有空位
	for i=1,self.mCount do
		for j=1,self.mCount do
			if self:GetNum(i,j)<=0 then
				table.insert(emptyPoints, {i=i,j=j})
			end
		end
	end
	local point=emptyPoints[math.random(#emptyPoints)]
	self:SetNum(point.i,point.j,math.random()<.9 and 2 or 4)
end


--失败触发的函数
function self:DoFail()
	if not self.fail then
		self.fail=true
		--惩罚
		print("failed")
	end
end

local VictoryTab={}
for k=1, self.victory_stage do
	table.insert( VictoryTab, 128*math.pow(2,k) )		--从256开始有奖励
end
local BonusTab=
{
	[1]={
		goldnugget=1,
		tallbirdegg=1,
		pigskin=.95,
	},
	[2]={
		batwing=.15,
		monstermeat=.1,
		monstermeat=.5,
		silk=.25,
		spidergland=.25,
		gears=1,
	},
	[3]={
		gears=1,
		purplegem=1,
		nightmarefuel=.6,
		nightmarefuel=.6,
		thulecite_pieces=.5,
	},
	[4]={
		gears=1,
		nightmarefuel=.6,
		thulecite_pieces=.5,
		monstermeat=.5,
		silk=.25,
		spidergland=.25,
	},
	[5]={
		monstermeat=1,
		monstermeat=1,
		monstermeat=1,
		monstermeat=1,
		wormlight=1,
		froglegs=1,
		meat=.75,
		pigskin=.25,
	},
	[6]={
		meat=1,
		meat=1,
		pigskin=1,
		nightmarefuel=1,
		nightmarefuel=1,
		nightmarefuel=.5,
		nightmarefuel=.5,
	},
	[7]={
		monstermeat=1,
		houndstooth=.125,
		monstermeat=1,
		houndstooth=1,
		redgem=.2,
		monstermeat=1,
		houndstooth=1,
		houndstooth=1,
		bluegem=.2,
		meat=1,
		blowdart_pipe=1,
		walrus_tusk=.5,
		walrushat=.25,
	},
	[8]={
		meat=1,
		blowdart_pipe=1,
		walrus_tusk=.5,
		walrushat=.25,
		fish=1,
		froglegs=1,
		mosquitosack=1,
		monstermeat=.5,
		silk=.25,
		spidergland=.25,
		monstermeat=.5,
		silk=.25,
		spidergland=.25,
		monstermeat=.5,
		silk=.25,
		spidergland=.25,
	},
	[9]={
		meat=1,
		meat=1,
		monstermeat=1,
		monstermeat=1,
		tentaclespike=.5,
		tentaclespots=.2,
		lightbulb=.8,
		tentaclespike=.5,
		tentaclespots=.4,
		rocks=.1,
		meat=1,
		meat=1,
		blowdart_pipe=1,
		walrus_tusk=.5,
		walrushat=.25,
		monstermeat=1,
		monstermeat=1,
		monstermeat=1,
		monstermeat=1,
		monstermeat=.5,
		monstermeat=.5,
		houndstooth=1,
		houndstooth=.5,
		houndstooth=.5,
	},
	[10]={
		honey=.167,
		stinger=.833,
		honey=.167,
		stinger=.833,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		beefalowool=1,
		beefalowool=1,
		beefalowool=1,
		horn=.33,
		meat=.75,
		manrabbit_tail=.25,
		carrot=1,
		carrot=1,
		monstermeat=1,
		beardhair=1,
		beardhair=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		trunk_summer=1,
	},
	[11]={
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		trunk_winter=1,
		monstermeat=1,
		charcoal=1,
		charcoal=1,
		krampus_sack=.01,
		meat=.75,
		pigskin=.25,
		rocks=1,
		rocks=1,
		meat=1,
		flint=1,
		flint=1,
		slurtlehat=.1,
		armorsnurtleshell=.75,
		meat=1,
		smallmeat=1,
	},
	[12]={
		charcoal=1,
		charcoal=1,
		krampus_sack=.1,
		smallmeat=1,
		cave_banana=1,
		nightmarefuel=.5,
		beardhair=1,
		cave_banana=1,
		nightmarefuel=.5,
		smallmeat=.33,
		drumstick=1,
		meat=1,
		coontail=.33,
		meat=1,
		meat=1,
		meat=1,
		lightninggoathorn=.33,
		meat=1,
		meat=1,
		meat=1,
		lightninggoathorn=.33,
		goatmilk=.25,
	},
	[13]={
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		minotaurhorn=1,
	},
	[14]={
		monstermeat=1,
		monstermeat=1,
		monstermeat=1,
		monstermeat=1,
		spidereggsack=1,
		spiderhat=1,
		silk=4,
		livinglog=1,
		livinglog=1,
		livinglog=1,
		livinglog=1,
		livinglog=1,
		livinglog=1,
		monstermeat=1,
	},
	[15]={
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		goose_feather=1,
		goose_feather=1,
		goose_feather=1,
		goose_feather=.5,
		goose_feather=.5,
		drumstick=1,
		drumstick=1,
		dragon_scales=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
	},
	[16]={
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		bearger_fur=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		deerclops_eyeball=1,
	},
	[17]={
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		minotaurhorn=1,
		monstermeat=1,
		monstermeat=1,
		monstermeat=1,
		monstermeat=1,
		spidereggsack=1,
		spiderhat=1,
		silk=4,
		livinglog=1,
		livinglog=1,
		livinglog=1,
		livinglog=1,
		livinglog=1,
		livinglog=1,
		monstermeat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		goose_feather=1,
		goose_feather=1,
		goose_feather=1,
		goose_feather=.5,
		goose_feather=.5,
		drumstick=1,
		drumstick=1,
		dragon_scales=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		bearger_fur=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		meat=1,
		deerclops_eyeball=1,
	},
}

--胜利触发的函数
function self:DoVictory(level)
	if not self["victory"..level] then
		self["victory"..level]=true
		--奖励
		for k,v in pairs(BonusTab[level]) do
			if v and math.random()< v then
				if self.inst.components.lootdropper then
					self.inst.components.lootdropper:SpawnLootPrefab(k, self.inst:GetPosition()+Vector3(-5,0,5))
				end
			end
		end
	end
end

----判断是否失败或胜利
function self:CheckComplete()
	--获取分数
	local score=self:GetScore()
	
	--判断胜利
	for k,v in pairs(VictoryTab) do
		if v and score >= v then
			self:DoVictory(k)
		end
	end
	
	--移动到不能合并的时候算输
	local notFailed
	for i=1,self.mCount do
		for j=1,self.mCount do
			if self:GetNum(i,j)<=0 
				or (i>1 and self:GetNum(i,j)==self:GetNum(i-1,j) )
				or (i<self.mCount and self:GetNum(i,j)==self:GetNum(i+1,j) )
				or (j>1 and self:GetNum(i,j)==self:GetNum(i,j-1) )
				or (j<self.mCount and self:GetNum(i,j)==self:GetNum(i,j+1) )
				then
				notFailed=true
				break
			end
		end
	end
	--失败的话
	if not notFailed then
		self:DoFail()
	end
end

---请求移动
function self:ApplyDir()
	print("apply dir")
	local master=self.inst.master
	if master and master.components.lovers_2048_cmp then
		print("has master")
		local dir=self.inst.dir
		print(dir)
		if dir=="left" then
			master.components.lovers_2048_cmp:ToLeft()
		elseif dir=="right" then
			master.components.lovers_2048_cmp:ToRight()
		elseif dir=="up" then
			master.components.lovers_2048_cmp:ToUp()
		elseif dir=="down" then
			master.components.lovers_2048_cmp:ToDown()
		end
	end
end

--向下移动
function self:ToDown()
	local mMerge=false
	for i=1,self.mCount do
		for j=1,self.mCount do
			for j1=j+1,self.mCount do
				if self:GetNum(i,j1)>0 then
					if self:GetNum(i,j)<=0 then		--移位
						self:SetNum(i,j,self:GetNum(i,j1))
						self:SetNum(i,j1,0)
						mMerge=true
						j=j-1
					elseif self:GetNum(i,j)==self:GetNum(i,j1) then		--合并
						self:SetNum(i,j,self:GetNum(i,j1)*2)
						--mergeAction(cardArrays[x][y]);
						self:SetNum(i,j1,0)
						self:SetScore(self:GetNum(i,j))
						mMerge=true
					end
					break
				end
			end
		end
	end	
	if mMerge then
		self:AddRandomNum()
		self:CheckComplete()
	end
end

--向上移动
function self:ToUp()
	local mMerge=false
	for i=1,self.mCount do
		for j=self.mCount,1,-1 do
			for j1=j-1,1,-1 do
				if self:GetNum(i,j1)>0 then
					if self:GetNum(i,j)<=0 then		--移位
						self:SetNum(i,j,self:GetNum(i,j1))
						self:SetNum(i,j1,0)
						mMerge=true
						j=j+1
					elseif self:GetNum(i,j)==self:GetNum(i,j1) then		--合并
						self:SetNum(i,j,self:GetNum(i,j1)*2)
						--mergeAction(cardArrays[x][y]);
						self:SetNum(i,j1,0)
						self:SetScore(self:GetNum(i,j))
						mMerge=true
					end
					break
				end
			end
		end
	end	
	if mMerge then
		self:AddRandomNum()
		self:CheckComplete()
	end
end

--向右移动
function self:ToRight()
	local mMerge=false
	for j=1,self.mCount do
		for i=self.mCount,1,-1 do
			for i1=i-1,1,-1 do
				if self:GetNum(i1,j)>0 then
					if self:GetNum(i,j)<=0 then		--移位
						self:SetNum(i,j,self:GetNum(i1,j))
						self:SetNum(i1,j,0)
						mMerge=true
						i=i+1
					elseif self:GetNum(i,j)==self:GetNum(i1,j) then		--合并
						self:SetNum(i,j,self:GetNum(i1,j)*2)
						--mergeAction(cardArrays[x][y]);
						self:SetNum(i1,j,0)
						self:SetScore(self:GetNum(i,j))
						mMerge=true
					end
					break
				end
			end
		end
	end	
	if mMerge then
		self:AddRandomNum()
		self:CheckComplete()
	end
end

--向左移动
function self:ToLeft()
	local mMerge=false
	for j=1,self.mCount do
		for i=1,self.mCount do
			for i1=i+1,self.mCount do
				if self:GetNum(i1,j)>0 then
					if self:GetNum(i,j)<=0 then		--移位
						self:SetNum(i,j,self:GetNum(i1,j))
						self:SetNum(i1,j,0)
						mMerge=true
						i=i-1
					elseif self:GetNum(i,j)==self:GetNum(i1,j) then		--合并
						self:SetNum(i,j,self:GetNum(i1,j)*2)
						--mergeAction(cardArrays[x][y]);
						self:SetNum(i1,j,0)
						self:SetScore(self:GetNum(i,j))
						mMerge=true
					end
					break
				end
			end
		end
	end	
	if mMerge then
		self:AddRandomNum()
		self:CheckComplete()
	end
end
----------------------------------
	
function self:OnSave()
	local data={}
	for i=1,self.mCount do
		for j=1,self.mCount do
			data["card_"..i.."_"..j.."_num"]=self.inst["card_"..i.."_"..j] and self.inst["card_"..i.."_"..j].num or 0
		end
	end
	data.isNotNew=self.isNotNew
	for i=1,self.victory_stage do
		data["victory"..i]=self["victory"..i]
	end
	data.fail=self.fail
	return data
end
	
function self:OnLoad(data)
	if data then
		for i=1,self.mCount do
			for j=1,self.mCount do
				self["card_"..i.."_"..j.."_num"]=data["card_"..i.."_"..j.."_num"] or 0
			end
		end 
		self.isNotNew=data.isNotNew
		for i=1,self.victory_stage do
			self["victory"..i]=data["victory"..i] or false
		end
		self.fail=data.fail
	end
end
	
----------------------------------------------------
end)
