local zg_man_boss=Class(function(self, inst)
	self.inst=inst
	self.zg_ch=true
	self.zg_ch1=true
	self.zg_ch2=true
	
	self.cycle=TheWorld.state.cycles or 0
	
	self.serialtab={
		zg_ch={
			pre="zg_fx_manshape",
			boss={"zg_ch_wilson","zg_ch_willow","zg_ch_wolfgang","zg_ch_wendy","zg_ch_wx78","zg_ch_wicker",
				"zg_ch_woodie","zg_ch_wes","zg_ch_waxwell","zg_ch_wigfrid","zg_ch_webber",
			},
			intro="人形兵器!!!",
		},
		zg_ch1={
			pre="zg_fx_manshape1",
			boss={"zg_ch1_luffy","zg_ch1_sanji","zg_ch1_zoro","zg_ch1_buggy",
			},
			intro="One Piece!!!",
		},
		zg_ch2={
			pre="zg_fx_manshape2",
			boss={"zg_ch2_wilson","zg_ch2_willow","zg_ch2_wolfgang_mighty","zg_ch2_wendy","zg_ch2_wx78","zg_ch2_wickerbottom",
				"zg_ch2_woodie","zg_ch2_wes","zg_ch2_waxwell","zg_ch2_wathgrithr","zg_ch2_webber",
			},
			intro="西瓜怪盗团!!!",
		},
	}

	self.inst:ListenForEvent("cycleschanged",function(inst,cycles)	--这是新的天数
		self.cycle=cycles
		self:TestBoss(8,"zg_ch")
		self:TestBoss(12,"zg_ch1")
		if TUNING.ZG_DIFFICULTY >.51 then
			self:TestBoss(16,"zg_ch2")
		end
	end)
end)

local function getran(tab)
	return tab[math.random(#tab)]
end

function zg_man_boss:PlayerNum()
	if type(AllPlayers)=="table" then
		return #AllPlayers
	end
	return 0
end

function zg_man_boss:BossNum()
	if self.cycle<30 then
		return math.ceil(self:PlayerNum()/2.5)
	elseif self.cycle<70 then
		return math.ceil(self:PlayerNum()/2)
	elseif self.cycle<100 then
		return math.ceil(self:PlayerNum()/1.5)
	elseif self.cycle<140 then
		return math.ceil(self:PlayerNum())
	elseif self.cycle<170 then
		return math.ceil(self:PlayerNum()*1.5)
	elseif self.cycle<210 then
		return math.ceil(self:PlayerNum()*2)
	else
		return math.ceil(self:PlayerNum()*2.5)
	end
end

function zg_man_boss:SpawnBoss(serial)
	local player=AllPlayers[math.random(#AllPlayers)]
	local pre=wy_spawn(player,self.serialtab[serial].pre,{math.random()*10-20,0,math.random()*10-20})
	pre.zg_boss=getran(self.serialtab[serial].boss)
end

function zg_man_boss:TestBoss(period,serial)
	local period=period or 8
	period=math.max(3,period)
	if self.cycle%period==period-2 and not self[serial] then
		self[serial]=true
	end
	if self.cycle%period==period-1 and self[serial] then
		self[serial]=false
		if self:BossNum()>0 then
			SpawnPrefab("lightning")
			TheNet:Announce(self.serialtab[serial].intro)
			for k=1,self:BossNum() do
				self:SpawnBoss(serial)
			end
		end
	end	
end

function zg_man_boss:OnSave()
	return {
		zg_ch=self.zg_ch,
		zg_ch1=self.zg_ch1,
		zg_ch2=self.zg_ch2,
	}
end

function zg_man_boss:OnLoad(data)
	if data then
		if data.zg_ch then self.zg_ch=data.zg_ch end
		if data.zg_ch1 then self.zg_ch1=data.zg_ch1 end
		if data.zg_ch2 then self.zg_ch2=data.zg_ch2 end
	end
end

return zg_man_boss