local Zg_sizechange = Class(function(self, inst)
	self.inst = inst
	
	self.i_size = nil	--玩家的原来大小
	self.t_size = nil	--玩家被改变后的大小
	
	self.i_range1 = nil	--玩家的原来手长
	self.t_range1 = nil	--玩家被改变后的手长
	self.i_range2 = nil	--玩家的原来手长
	self.t_range2 = nil	--玩家被改变后的手长
	
	self.time = nil
	self.timeleft = nil

	self.canchange = true 
end)

function Zg_sizechange:StartChange(sizemult, time)
	if self.canchange then
		
		--保存原来的数据
		self.i_size = self.inst.Transform:GetScale()
		self.i_range1 = self.inst.components.combat.attackrange
		self.i_range2 = self.inst.components.combat.hitrange
		
		--计算出目标数据
		self.t_size = sizemult * self.i_size
		self.t_range1 = sizemult * self.i_range1
		self.t_range2 = sizemult * self.i_range2
		
		--开关关闭
		self.canchange = false
		
		--开始计时
		self.time = time
		self.timeleft = time

		if self.timeleft > 0 then
			self.inst:StartUpdatingComponent(self)
		else
			self:EndChange()
		end
	
	end
end

function Zg_sizechange:OnUpdate(dt)
	self.timeleft = self.timeleft - dt
	
	--执行目标数据
	self.inst.Transform:SetScale(self.t_size, self.t_size, self.t_size)
	self.inst.components.combat.attackrange = self.t_range1
	self.inst.components.combat.hitrange = self.t_range2

	if self.timeleft <= 0 then
		self:EndChange()
	end
end

function Zg_sizechange:EndChange()
	
	--还原原来的数据
	self.inst.Transform:SetScale(self.i_size, self.i_size, self.i_size)
	self.inst.components.combat.attackrange = self.i_range1
	self.inst.components.combat.hitrange = self.i_range2
	
	--停止计时
	self.inst:StopUpdatingComponent(self)
	
	--开关打开
	self.canchange = true
	
end


--------------------------------------------------状态的保存和载入-----------------------------
function Zg_sizechange:OnSave()
    return
    {
		--开关保存
		canchange = self.canchange,
	
        --时间保存
        time = self.timeleft,
		
		--状态保存
		i_size = self.i_size,
		t_size = self.t_size,
		
		i_range1 = self.i_range1,
		t_range1 = self.t_range1,
		
		i_range2 = self.i_range2,
		t_range2 = self.t_range2,
    }
end
function Zg_sizechange:OnLoad(data)
    if data ~= nil then
		
		--开关载入
		self.canchange = data.canchange
		
		--时间载入
		if data.time ~= nil then
			self.timeleft = data.time
        end
		
		--状态载入
		if data.i_size ~= nil then
			self.i_size = data.i_size
        end
		if data.t_size ~= nil then
			self.t_size = data.t_size
        end
		
		if data.i_range1 ~= nil then
			self.i_range1 = data.i_range1
		end
		if data.t_range1 ~= nil then
			self.t_range1 = data.t_range1
		end
		
		if data.i_range2 ~= nil then
			self.i_range2 = data.i_range2
		end
		if data.t_range2 ~= nil then
			self.t_range2 = data.t_range2
		end
		
		--继续执行
		if not self.canchange and self.timeleft ~= nil and self.timeleft > 0 then
			self.inst:StartUpdatingComponent(self)
		end
		
    end
end
-----------------------------------------------------------------------------------------------

return Zg_sizechange