--V2C: TODO: ... u know what this needs.... - _-""

local assets =
{
	Asset("ANIM", "anim/bearger_build.zip"),
	Asset("ANIM", "anim/bearger_basic.zip"),
	Asset("ANIM", "anim/bearger_groggy_build.zip"),
	Asset("ANIM", "anim/bearger_actions.zip"),
	Asset("SOUND", "sound/bearger.fsb"),
}

local prefabs =
{
	"groundpound_fx",
	"groundpoundring_fx",
	"bearger_fur",
	"furtuft",
	"collapse_small",
}

local brain = require("brains/beargerbrain")

SetSharedLootTable( 'bearger',
{
	{'meat',			 1.00},
	{'meat',			 1.00},
	{'meat',			 1.00},
	{'meat',			 1.00},
	{'meat',			 1.00},
	{'meat',			 1.00},
	{'meat',			 1.00},
	{'meat',			 1.00},
	{'bearger_fur',		 1.00},
	{'meat',			 1.00},
	{'meat',			 1.00},
	{'meat',			 1.00},
	{'meat',			 1.00},
	{'meat',			 1.00},
	{'meat',			 1.00},
	{'meat',			 1.00},
	{'meat',			 1.00},
	{'bearger_fur',		 1.00},
})

local TARGET_DIST = 48

local function CalcSanityAura(inst, observer)
    return inst.components.combat.target ~= nil and -TUNING.SANITYAURA_HUGE or -TUNING.SANITYAURA_LARGE
end

local function SetGroundPounderSettings(inst, mode)
	if mode == "normal" then 
		inst.components.groundpounder.damageRings = 2
		inst.components.groundpounder.destructionRings = 2
		inst.components.groundpounder.numRings = 3
	--[[elseif mode == "hibernation" then 
		inst.components.groundpounder.damageRings = 3
		inst.components.groundpounder.destructionRings = 3
		inst.components.groundpounder.numRings = 4]]
	end
end

local function RetargetFn(inst)
	if inst.components.sleeper and inst.components.sleeper:IsAsleep() then return end	

	local attackingTarget = FindEntity(inst, TARGET_DIST, function(guy)
							        --return inst.components.combat:CanTarget(guy)
							        --       and (guy.components.combat.target == inst)
									
									return guy and guy:HasTag("player") and not guy:HasTag("playerghost")
				
								    end,
								    nil,
								    {"prey", "smallcreature", "shadowboss"}
								    )

	if attackingTarget then 
		--print(inst, "got target that is attacking", attackingTarget)
		inst.components.combat:SetTarget(attackingTarget)
		
		if math.random() < .1 then
			local pt=inst:GetPosition()
			local fx = SpawnPrefab("zg_collapse_small")
			if fx then
				fx.Transform:SetPosition(pt:Get())
				fx.Transform:SetScale(2,2,2)
			end
			--瞬移
			local pt2=attackingTarget:GetPosition()
			inst.Transform:SetPosition(pt2:Get())
			local fx = SpawnPrefab("zg_collapse_small")
			if fx then
				fx.Transform:SetPosition(pt2:Get())
				fx.Transform:SetScale(2,2,2)
			end
		end
		
		return attackingTarget               
	elseif inst.last_eat_time and (GetTime() - inst.last_eat_time) > TUNING.BEARGER_DISGRUNTLE_TIME then
		--print(inst, "looking for target with food")
		return FindEntity(inst, TARGET_DIST*5, function(guy)
			return inst.components.combat:CanTarget(guy) 
				and guy.components.inventory and (guy.components.inventory:FindItem(function(item) return item:HasTag("honeyed") end) ~= nil)
		end,
		nil,
		{ "prey", "smallcreature", "shadowboss", }
		)
	end

end

local function KeepTargetFn(inst, target)
	return inst.components.combat:CanTarget(target)
end

local function OnSave(inst, data)
	data.seenbase = inst.seenbase or nil-- from brain
	data.cangroundpound = inst.cangroundpound
	data.num_food_cherrypicked = inst.num_food_cherrypicked
	data.num_good_food_eaten = inst.num_good_food_eaten
	data.killedplayer = inst.killedplayer
	data.shouldgoaway = inst.shouldgoaway
end

local function OnLoad(inst, data)
	if data ~= nil then
		inst.seenbase = data.seenbase or nil-- for brain
		inst.cangroundpound = data.cangroundpound
		inst.num_food_cherrypicked = data.num_food_cherrypicked or 0
		inst.num_good_food_eaten = data.num_good_food_eaten or 0
		inst.killedplayer = data.killedplayer or false
		inst.shouldgoaway = data.shouldgoaway or false
	end
end

local function OnSeasonChange(inst, data)
	if TheWorld.state.season == "autumn" or TheWorld.state.season == "summer" then 
		SetGroundPounderSettings(inst, "normal")
		inst.components.health:SetAbsorptionAmount(0)
		inst:RemoveTag("hibernation")
	else
		--SetGroundPounderSettings(inst, "hibernation")
		inst:AddTag("hibernation")
	end
end

local function OnAttacked(inst, data)
	local invader = nil
	invader = FindEntity(inst, 4, function(guy)
        return guy:HasTag("player") and not guy:HasTag("playerghost")
    end)
	if invader then
		inst.components.combat:SetTarget(invader)
	elseif data.attacker and not data.attacker:HasTag("shadowboss") then
		inst.components.combat:SetTarget(data.attacker)
	end
end

local function OnDestroyOther(inst, other)
    if other:IsValid() and other.components.workable ~= nil and other.components.workable:CanBeWorked() then
        SpawnPrefab("collapse_small").Transform:SetPosition(other.Transform:GetWorldPosition())
        if other.components.lootdropper ~= nil then
            other.components.lootdropper:SetLoot({})
        end
        other.components.workable:Destroy(inst)
    end
end

local function OnCollide(inst, other)
    if other ~= nil and
        other:IsValid() and
        other.components.workable ~= nil and
        other.components.workable:CanBeWorked() and
        Vector3(inst.Physics:GetVelocity()):LengthSq() >= 1 then
        inst:DoTaskInTime(2 * FRAMES, OnDestroyOther, other)
    end
end

local function WorkEntities(inst)
    local pt = inst:GetPosition()
    local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, 5, nil, { "insect", "INLIMBO", "zg_marine" })
    local heading_angle = inst.Transform:GetRotation()
    local dir = Vector3(math.cos(heading_angle * DEGREES), 0, -math.sin(heading_angle * DEGREES))

    for i, v in ipairs(ents) do
        if v:IsValid() and v.components.workable ~= nil then
            local offset = (v:GetPosition() - pt):GetNormalized()
            if offset:Dot(dir) > .3 then
                v.components.workable:Destroy(inst)
            end
        end
    end
end

local function LaunchItem(inst, target, item)
    if item.Physics ~= nil then
        local x, y, z = item.Transform:GetWorldPosition()
        item.Physics:Teleport(x, .1, z)

        local vel = (target:GetPosition() - inst:GetPosition()):GetNormalized()
        local speed = 5 + math.random() * 2
        local angle = math.atan2(vel.z, vel.x) + (math.random() * 20 - 10) * DEGREES
        item.Physics:SetVel(math.cos(angle) * speed, 10, -math.sin(angle) * speed)
    end
end

local function OnGroundPound(inst)
	if math.random() < .2 then 
		inst.components.shedder:DoMultiShed(3, false) -- can't drop too many, or it'll be really easy to farm for thick furs
	end
end

local function OnHitOther(inst, data)
	local other = data.target
	
	if other and other.components.inventory and other:HasTag("player") then
		local item = other.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
		if item then
			other.components.inventory:DropItem(item)
			LaunchItem(inst, data.target, item)
		end
	end
	
	----肉球果实
	if other and inst.sg:HasStateTag("zg_meatball") then

		local invader = nil
		invader = FindEntity(inst, 30, function(guy)
			return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
		end)
		if invader and inst:GetPosition():Dist(other:GetPosition()) <= 5.5 then
			--把目标送走, 当附近有 非目标 的活着的玩家时
			
			local pt = other:GetPosition()
			local fx = SpawnPrefab("zg_collapse_small")
			if fx then
				fx.Transform:SetPosition(pt:Get())
				--fx.Transform:SetScale(2,2,2)
			end
			
			local function Zg_GetTPPos(other)
				local ground = TheWorld
				local centers = {}
				for i, node in ipairs(ground.topology.nodes) do
					if ground.Map:IsPassableAtPoint(node.x, 0, node.y) then
						table.insert(centers, {x = node.x, z = node.y})
					end
				end
				if #centers > 0 then
					local pos = centers[math.random(#centers)]
					return Point(pos.x, 0, pos.z)
				else
					return other:GetPosition()
				end
			end
			
			local pos = Zg_GetTPPos(other)		
			
			if not other:HasTag("player") then
				other.Transform:SetPosition(pos:Get())
			end
			
			other:DoTaskInTime(0, function()
				if other:HasTag("player") and other.components.health and not other.components.health:IsDead() then
				
					if math.random() <.25 then
						other:PushEvent("zg_buff_knockout")
					end
					
					if other.components.hunger then
						other.components.hunger:DoDelta(-100 * TUNING.ZG_DIFFICULTY)
					end
					if other.components.sanity then
						other.components.sanity:DoDelta(-100 * TUNING.ZG_DIFFICULTY)
					end
					
					local fx2 = SpawnPrefab("zg_collapse_ball")
					if fx2 then
						fx2.Transform:SetPosition(pos:Get())
					end
					
				end
			end)
			--other:DoTaskInTime(.5, function()
			--	if other.SoundEmitter then
			--		other.SoundEmitter:PlaySound("zg_sfx_bearger/zg_sfx_bearger/tp")
			--	end
			--end)
			
			--
		end
	end
	
end

local function ontimerdone(inst, data)

	if data.name == "meatball" then
		inst.canmeatball = true
	elseif data.name == "GroundPound" then
		inst.cangroundpound = true
	elseif data.name == "Yawn" and inst:HasTag("hibernation") then 
		inst.canyawn = true
	end
end

local function ShouldSleep(inst)
	-- don't fall asleep if we have a target, we were either chasing it, or it woke us up
	if inst.components.combat.target then
		return false
	end

	-- don't fall asleep while on fire
	if inst.components.health.takingfiredamage then 
		return false
	end

	if TheWorld.state.season == "winter" or TheWorld.state.season == "spring" then 
		inst.components.shedder:StopShedding()
		inst:AddTag("hibernation")
		inst:AddTag("asleep")
		inst.AnimState:SetBuild("bearger_groggy_build")
		--SetGroundPounderSettings(inst, "hibernation")
		--inst.components.health:SetAbsorptionAmount(.15)
		return true
	end
	
	return false
end

local function ShouldWake(inst)
	if TheWorld.state.season == "summer" or TheWorld.state.season == "autumn" then 
		
		inst.components.shedder:StartShedding(TUNING.BEARGER_SHED_INTERVAL)
		inst:RemoveTag("hibernation")
		inst:RemoveTag("asleep")
		inst.AnimState:SetBuild("bearger_build")
		--SetGroundPounderSettings(inst, "normal")
		--inst.components.health:SetAbsorptionAmount(0)
		return true
	else
		return false
	end
end

local function OnLostTarget(inst, data)
	--Remove the listening set up on "OnCombatTarget"
	if data.oldtarget and data.oldtarget.BEARGER_OnDropItemFn then
		inst:RemoveEventCallback("dropitem", data.oldtarget.BEARGER_OnDropItemFn, data.oldtarget)
	end
end

local function OnCombatTarget(inst, data)
	--Listen for dropping of items... if it's food, maybe forgive your target?
	if data.oldtarget then
		OnLostTarget(inst, data)
	end
	if data.target then
		inst.num_food_cherrypicked = TUNING.BEARGER_STOLEN_TARGETS_FOR_AGRO - 1
		inst.components.locomotor.walkspeed = TUNING.BEARGER_ANGRY_WALK_SPEED
		data.target.BEARGER_OnDropItemFn = function(target, info)
			if inst.components.eater:CanEat(info.item) then
				--print("Bearger saw dropped food, losing target")
				if info.item:HasTag("honeyed") or math.random() < 1 then
					inst.components.combat:SetTarget(nil)
				end
			end
		end
		inst:ListenForEvent("dropitem", data.target.BEARGER_OnDropItemFn, data.target)
	else
		inst.components.locomotor.walkspeed = TUNING.BEARGER_CALM_WALK_SPEED
	end
end

local function IsTargetValidForAreaAttack(inst, target)

	local pos = Vector3(inst.Transform:GetWorldPosition())
	local targetPos = Vector3(target.Transform:GetWorldPosition())

	local forwardAngle = inst.Transform:GetRotation()*DEGREES
	local forwardVector = Vector3(math.cos(forwardAngle), 0, math.sin(forwardAngle))

	return IsWithinAngle(pos, forwardVector, TUNING.BEARGER_ATTACK_CONE_WIDTH, targetPos)
end

local function SetStandState(inst, state)
	--"quad" or "bi" state
	inst.StandState = string.lower(state)
end

local function IsStandState(inst, state)
	return inst.StandState == string.lower(state)
end

local function OnKill(inst, data)
	if data and data.victim:HasTag("player") then
		inst.killedplayer = true
	end
end

local function OnDead(inst)
	TheWorld:PushEvent("beargerkilled", inst)
	inst.components.shedder:StopShedding()
end

local function OnRemove(inst)
	TheWorld:PushEvent("beargerremoved", inst)
end

local function OnPlayerAction(inst, player, data)
	if inst.components.sleeper and inst.components.sleeper:IsAsleep() then 
		return -- don't react to things when asleep
	end

	local playerAction = data.action
	local selfAction = inst:GetBufferedAction()

	if not playerAction or not selfAction then return end --You're not doing anything so whatever.

	if playerAction.target == selfAction.target then -- We got a problem bud.

		inst.num_food_cherrypicked = inst.num_food_cherrypicked + 1
		if inst.num_food_cherrypicked < TUNING.BEARGER_STOLEN_TARGETS_FOR_AGRO then
			inst.sg:GoToState("targetstolen")
		else
			inst.num_food_cherrypicked = TUNING.BEARGER_STOLEN_TARGETS_FOR_AGRO - 1
			inst.components.combat:SuggestTarget(player)
		end
	end
end

--[[ PLAYER TRACKING ]]


local function OnPlayerJoined(inst, player)
	for i, v in ipairs(inst._activeplayers) do
		if v == player then
			return
		end
	end

	inst:ListenForEvent("performaction", function(player, data) OnPlayerAction(inst, player, data) end, player)
	table.insert(inst._activeplayers, player)
end

local function OnPlayerLeft(inst, player)
	for i, v in ipairs(inst._activeplayers) do
		if v == player then
			table.remove(inst._activeplayers, i)
			return
		end
	end
end

--[[ END PLAYER TRACKING ]]

local function fn()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddDynamicShadow()
    inst.entity:AddNetwork()

	inst.Transform:SetFourFaced()
	inst.DynamicShadow:SetSize(6, 3.5)
	local s = 1
	inst.Transform:SetScale(s,s,s)

	MakeGiantCharacterPhysics(inst, 1000, 0.5)

	inst.AnimState:SetBank("bearger")
	inst.AnimState:SetBuild("bearger_build")
	inst.AnimState:PlayAnimation("idle_loop", true)

	------------------------------------------
	inst:AddTag("zg_epic_ch1")
	inst:AddTag("zg_marine")

	inst:AddTag("epic")
	inst:AddTag("monster")
	inst:AddTag("hostile")
	inst:AddTag("bearger")
	inst:AddTag("scarytoprey")
	inst:AddTag("largecreature")
	
	inst:AddTag("shadowboss")		--专属标签

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.Physics:SetCollisionCallback(OnCollide)

	------------------------------------------

	inst:AddComponent("sanityaura")
	inst.components.sanityaura.aurafn = CalcSanityAura

	------------------

	inst:AddComponent("health")
	inst.components.health:SetMaxHealth(8000)
	inst.components.health.destroytime = 5

	------------------

	inst:AddComponent("combat")
	inst.components.combat:SetDefaultDamage(200)
	--inst.components.combat.playerdamagepercent = .5
	inst.components.combat:SetRange(5.5, 5.5)
	inst.components.combat:SetAreaDamage(5.5, 0.8)
	inst.components.combat.hiteffectsymbol = "bearger_body"
	inst.components.combat:SetAttackPeriod(3)
	inst.components.combat:SetRetargetFunction(3, RetargetFn)
	inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	inst.components.combat:SetHurtSound("dontstarve_DLC001/creatures/bearger/hurt")
	
	function inst.components.combat:DoAreaAttack(target, range, weapon, validfn, stimuli)
		local hitcount = 0
		local x, y, z = target.Transform:GetWorldPosition()
		local ents = TheSim:FindEntities(x, y, z, range, { "_combat" }, {"shadowboss","zg_marine"})			----AOE伤害忽略队友
		for i, ent in ipairs(ents) do
			if ent ~= target and
				ent ~= self.inst and
				self:IsValidTarget(ent) and
				(validfn == nil or validfn(ent)) then
				self.inst:PushEvent("onareaattackother", { target = target, weapon = weapon, stimuli = stimuli })
				ent.components.combat:Zg_GetAttacked(self.inst, self:CalcDamage(ent, weapon, self.areahitdamagepercent), weapon, stimuli)
				hitcount = hitcount + 1
			end
		end
		return hitcount
	end
	
	--[[
	function inst.components.combat:CanBeAttacked(attacker)
		return attacker
			and not attacker:HasTag("zg_marine")
			and self.inst.replica.combat:CanBeAttacked(attacker)
	end]]
	
	--inst:ListenForEvent("killed", function(inst, data)
	--	if inst.components.combat and data and data.victim == inst.components.combat.target then
	--		inst.components.combat.target = nil
	--	end
	--end)

	------------------------------------------
	inst:AddComponent("shedder")
	inst.components.shedder.shedItemPrefab = "furtuft"
	inst.components.shedder.shedHeight = 6.5
	inst.components.shedder:StartShedding(TUNING.BEARGER_SHED_INTERVAL)

	------------------------------------------

	inst.shouldgoaway = false
	inst:AddComponent("sleeper")
	inst.components.sleeper:SetResistance(4)
	inst.components.sleeper:SetSleepTest(ShouldSleep)
	inst.components.sleeper:SetWakeTest(ShouldWake)
	inst:ListenForEvent("onwakeup", function() inst.homelocation = inst:GetPosition() end )

	------------------------------------------

	inst:AddComponent("lootdropper")
	inst.components.lootdropper:SetChanceLootTable("bearger")

	------------------------------------------

	inst:AddComponent("inspectable")
	inst.components.inspectable:RecordViews()

	------------------------------------------

	inst:AddComponent("knownlocations")
	inst:AddComponent("thief")
	inst:AddComponent("inventory")
	inst:AddComponent("groundpounder")
	inst.components.groundpounder.destroyer = true
	SetGroundPounderSettings(inst, "normal")
	--inst.components.groundpounder.damageRings = 2
	--inst.components.groundpounder.destructionRings = 2
	--inst.components.groundpounder.numRings = 3
	inst.components.groundpounder.groundpoundFn = OnGroundPound
	inst.components.groundpounder.noTags = { "FX", "NOCLICK", "DECOR", "INLIMBO", "shadowboss","zg_marine"}
	
	
	inst:AddComponent("timer")
	inst:AddComponent("eater")
	inst.components.eater:SetDiet({ FOODGROUP.BEARGER }, { FOODGROUP.BEARGER })
	inst.components.eater.eatwholestack = true

	------------------------------------------

	inst:WatchWorldState("season", OnSeasonChange)
	inst:ListenForEvent("attacked", OnAttacked)
	inst:ListenForEvent("onhitother", OnHitOther)
	inst:ListenForEvent("timerdone", ontimerdone)
	inst:ListenForEvent("death", OnDead)
	inst:ListenForEvent("onremove", OnRemove)

	------------------------------------------

	MakeLargeBurnableCharacter(inst, "swap_fire")
	--MakeHugeFreezableCharacter(inst, "bearger_body")

	SetStandState(inst, "quad")--SetStandState(inst, "BI")
	inst.SetStandState = SetStandState
	inst.IsStandState = IsStandState
	inst.seenbase = false
	inst.WorkEntities = WorkEntities
	inst.cangroundpound = false
	inst.killedplayer = false

	inst.num_good_food_eaten = 0
	inst.num_food_cherrypicked = 0

	inst:DoTaskInTime(0, function() inst.homelocation = inst:GetPosition() end)

	inst:ListenForEvent("killed", OnKill)
	inst:ListenForEvent("newcombattarget", OnCombatTarget)

    inst.seenbase = nil -- for brain

	inst.OnSave = OnSave
	inst.OnLoad = OnLoad

	------------------------------------------

	inst:AddComponent("locomotor")
	inst.components.locomotor.walkspeed = 6
	inst.components.locomotor.runspeed = 9
	--inst.components.locomotor:SetShouldRun(true)

	inst:SetStateGraph("SGbearger")
	inst:SetBrain(brain)

	--[[ PLAYER TRACKING ]]

	inst._activeplayers = {}
	inst:ListenForEvent("ms_playerjoined", function(src, player) OnPlayerJoined(inst, player) end, TheWorld)
	inst:ListenForEvent("ms_playerleft", function(src, player) OnPlayerLeft(inst, player) end, TheWorld)

	for i, v in ipairs(AllPlayers) do
		OnPlayerJoined(inst, v)
	end

	--[[ END PLAYER TRACKING ]]

	return inst
end

local function fn_collapse()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetScale(1.25, 1.25, 1.25)
	
	inst.entity:AddSoundEmitter()
	--inst.entity:AddLight()
	inst.entity:AddNetwork()
	
	inst.entity:AddAnimState()
	
	--
	inst.AnimState:SetBank("poopcloud")
	inst.AnimState:SetBuild("poop_cloud")
	inst.AnimState:PlayAnimation("idle")	
	
	--
	inst:AddTag("FX")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
       return inst
    end
	
	inst.persists = false
	
	inst:DoTaskInTime(0, function()
		inst.SoundEmitter:PlaySound("zg_sfx_bearger/zg_sfx_bearger/tp")
	end)
	
	inst:DoTaskInTime(2, inst.Remove)
	
	return inst
end

--------------------------------
local function fn_ball()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --inst.entity:AddLight()
    inst.entity:AddNetwork()

    inst.AnimState:SetBank("forcefield")
    inst.AnimState:SetBuild("forcefield")
    inst.AnimState:PlayAnimation("open")
    inst.AnimState:PushAnimation("idle_loop", true)

    --inst.SoundEmitter:PlaySound("dontstarve/wilson/forcefield_LP", "loop")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false
	inst:DoTaskInTime(1, function()
		inst.SoundEmitter:PlaySound("zg_sfx_bearger/zg_sfx_bearger/tp")
	end)
	inst:DoTaskInTime(3, function()
		inst.SoundEmitter:PlaySound("zg_sfx_bearger/zg_sfx_bearger/tp")
	end)
	inst:DoTaskInTime(5, inst.Remove)

    return inst
end

local function fn_ball2()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --inst.entity:AddLight()
    inst.entity:AddNetwork()

    inst.AnimState:SetBank("forcefield")
    inst.AnimState:SetBuild("forcefield")
    inst.AnimState:PlayAnimation("open")
    inst.AnimState:PushAnimation("idle_loop", true)

    --MakeInventoryPhysics(inst)
    --RemovePhysicsColliders(inst)
	
	local phys = inst.entity:AddPhysics()
    --phys:SetSphere(.1)
	phys:SetCapsule(.5, 2)		
    phys:SetMass(1)
    --phys:SetFriction(.1)
	phys:SetFriction(0)
    phys:SetDamping(0)
    --phys:SetRestitution(.5)
	phys:SetRestitution(0)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	--phys:CollidesWith(COLLISION.FLYERS)
    --phys:CollidesWith(COLLISION.OBSTACLES)
    --phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	--phys:CollidesWith(COLLISION.CHARACTERS)
	--phys:CollidesWith(COLLISION.GIANTS)

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false
	
	inst.zg_s = 4
	inst.zg_master = nil
	
	inst:AddComponent("sizetweener")
	inst.components.sizetweener:StartTween(inst.zg_s, 2.5, nil)
	
	inst:AddComponent("combat")
	
	inst:DoTaskInTime(0, function()
		inst.SoundEmitter:PlaySound("zg_sfx_bearger/zg_sfx_bearger/meatball")
	end)
	
	inst:DoTaskInTime(1, function()
		--开始前进
		local master = inst.zg_master 
		if master and master.components.combat then
			local target = master.components.combat.target
			if target then
				local vel = (target:GetPosition() - inst:GetPosition() ):GetNormalized()
				local angle = math.atan2(vel.z, vel.x)
				local speed = 6
				--每时每刻前进
				--inst:DoPeriodicTask(1/30, function()
					inst.Physics:SetVel(math.cos(angle) * speed, 0, math.sin(angle) * speed)
				--end)
			end
		end
	end)
	
	inst:DoTaskInTime(1, function()
	
		--被推动后开始计算伤害
		local period = .25
		inst:DoPeriodicTask(period, function()
			local pt = inst:GetPosition()
			--local r = inst.zg_s * 2
			local r = inst.Transform:GetScale() * 1.8
			
			local center_dmg = 200 * period * TUNING.ZG_DIFFICULTY
			local ceter_destory = 15 * period
			local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "zg_marine"})
			for k,v in pairs(ents) do
				if v and v.components.health and not v.components.health:IsDead() and v ~= inst.zg_master and v.components.combat then
					
					--local dst = pt:Dist(v:GetPosition())
					--local dmg_mult = 1 - dst/r
					
					
					
					if v:HasTag("player") then
						
						--[[
						local fx = SpawnPrefab("shock_fx")
						if fx then
							if v.components.rider ~= nil and v.components.rider:IsRiding() then
								fx.Transform:SetSixFaced()
							end
							fx.entity:SetParent(v.entity)
							fx.entity:AddFollower()
							fx.Follower:FollowSymbol(v.GUID, "swap_shock_fx", 0, 0, 0)
						end]]
						local fx = SpawnPrefab("shock_fx")
						if fx then
							fx.entity:SetParent(v.entity)
							--fx.Transform:SetPosition(0,1,0)
						end
						v.components.combat:Zg_GetAttacked(inst, center_dmg)
						--if v.components.health and not v.components.health:IsDead() then
						--	v.sg:GoToState("electrocute")
						--end
					elseif not v:HasTag("shadowboss") then
					
						local fx = SpawnPrefab("shock_fx")
						if fx then
							fx.entity:SetParent(v.entity)
							--fx.Transform:SetPosition(0,1,0)
						end
					
						v.components.combat:Zg_GetAttacked(inst.zg_master or inst, center_dmg * 3)
					end
					
				end
				
				--if v and v:IsValid() and v.components.workable and v.components.workable:CanBeWorked() then
				
				--	local fx = SpawnPrefab("shock_fx")
				--	if fx then
				--		fx.entity:SetParent(v.entity)
						--fx.Transform:SetPosition(0,1,0)
				--	end
					
					--local dst = pt:Dist(v:GetPosition())
					--local dmg_mult = 1 - dst/r
				--	v.components.workable:WorkedBy(inst, ceter_destory)
					
				--end
			end
		end)
	end)
	
	inst:DoTaskInTime(7.5, function()
		inst.components.sizetweener:StartTween(1, 2.5, nil)
	end)
	
	inst:DoTaskInTime(10, inst.Remove)

    return inst
end

STRINGS.NAMES.ZG_COLLAPSE_BALL2 = "熊の冲击"

return Prefab("bearger", fn, assets, prefabs),
	Prefab("zg_collapse_small", fn_collapse),
	Prefab("zg_collapse_ball", fn_ball),
	Prefab("zg_collapse_ball2", fn_ball2)
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

