--头材质
local assets_wislon = 
{
	Asset( "ANIM", "anim/bz_head_wilson.zip" ),
	Asset( "ATLAS", "images/bz_head_wilson.xml" ),
}
local assets_willow = 
{
	Asset( "ANIM", "anim/bz_head_willow.zip" ),
	Asset( "ATLAS", "images/bz_head_willow.xml" ),
}
local assets_wolfgang = 
{
	Asset( "ANIM", "anim/bz_head_wolfgang.zip" ),
	Asset( "ATLAS", "images/bz_head_wolfgang.xml" ),
}
local assets_wendy = 
{
	Asset( "ANIM", "anim/bz_head_wendy.zip" ),
	Asset( "ATLAS", "images/bz_head_wendy.xml" ),
}
local assets_wx78 = 
{
	Asset( "ANIM", "anim/bz_head_wx78.zip" ),
	Asset( "ATLAS", "images/bz_head_wx78.xml" ),
}
local assets_wicker = 
{
	Asset( "ANIM", "anim/bz_head_wicker.zip" ),
	Asset( "ATLAS", "images/bz_head_wicker.xml" ),
}
local assets_woodie = 
{
	Asset( "ANIM", "anim/bz_head_woodie.zip" ),
	Asset( "ATLAS", "images/bz_head_woodie.xml" ),
}
local assets_wes = 
{
	Asset( "ANIM", "anim/bz_head_wes.zip" ),
	Asset( "ATLAS", "images/bz_head_wes.xml" ),
}
local assets_waxwell = 
{
	Asset( "ANIM", "anim/bz_head_waxwell.zip" ),
	Asset( "ATLAS", "images/bz_head_waxwell.xml" ),
}
local assets_wigfrid = 
{
	Asset( "ANIM", "anim/bz_head_wigfrid.zip" ),
	Asset( "ATLAS", "images/bz_head_wigfrid.xml" ),
}
local assets_webber = 
{
	Asset( "ANIM", "anim/bz_head_webber.zip" ),
	Asset( "ATLAS", "images/bz_head_webber.xml" ),
}
local assets_wennie = 
{
	Asset( "ANIM", "anim/bz_head_wennie.zip" ),
	Asset( "ATLAS", "images/bz_head_wennie.xml" ),
}

--各种头颅的字符串
STRINGS.NAMES.BZ_HEAD_WILSON = "威尔逊 头颅"
STRINGS.NAMES.BZ_HEAD_WILLOW = "薇洛 头颅"
STRINGS.NAMES.BZ_HEAD_WOLFGANG = "大力士 头颅"
STRINGS.NAMES.BZ_HEAD_WENDY = "温蒂 头颅"
STRINGS.NAMES.BZ_HEAD_WX78 = "机器人 头颅"
STRINGS.NAMES.BZ_HEAD_WICKER = "图书管理员 头颅"
STRINGS.NAMES.BZ_HEAD_WOODIE = "伐木工 头颅"
STRINGS.NAMES.BZ_HEAD_WES = "小丑 头颅"
STRINGS.NAMES.BZ_HEAD_WAXWELL = "麦斯威尔 头颅"
STRINGS.NAMES.BZ_HEAD_WIGFRID = "女武神 头颅"
STRINGS.NAMES.BZ_HEAD_WEBBER = "蜘蛛人 头颅"
STRINGS.NAMES.BZ_HEAD_WENNIE = "温妮 头颅"


--1.威尔逊
local function fn_wislon()
	local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetScale(2.7,2.7,2.7)
	
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("armor_wood")
    inst.AnimState:SetBuild("bz_head_wilson")
    inst.AnimState:PlayAnimation("anim")
	
	inst:AddTag("bz_head")
	inst:AddTag("zg_magic_debossthing")
	inst:AddTag("bz_head_wilson")
	
    inst.entity:SetPristine()
    if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription( "他还没断气" )
	
	inst:AddComponent("talker")
	
	inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "bz_head_wilson"
    inst.components.inventoryitem.atlasname = "images/bz_head_wilson.xml"
	
    return inst
end

--2.薇洛
local function fn_willow()
	local inst = fn_wislon()
	inst.Transform:SetScale(2.9,2.9,2.9)
	inst.AnimState:SetBuild("bz_head_willow")
	inst:AddTag("bz_head_willow")	
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.inspectable:SetDescription( "她好像很享受的样子" )
	inst.components.inventoryitem.imagename = "bz_head_willow"
    inst.components.inventoryitem.atlasname = "images/bz_head_willow.xml"
	
	return inst
end

--3.沃尔夫冈
local function fn_wolfgang()
	local inst = fn_wislon()
	inst.Transform:SetScale(2.75,2.75,2.75)
	inst.AnimState:SetBuild("bz_head_wolfgang")
	inst:AddTag("bz_head_wolfgang")	
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.inspectable:SetDescription( "他怒气未消" )
	inst.components.inventoryitem.imagename = "bz_head_wolfgang"
    inst.components.inventoryitem.atlasname = "images/bz_head_wolfgang.xml"
	
	return inst
end

--4.温蒂
local function fn_wendy()
	local inst = fn_wislon()
	inst.Transform:SetScale(2.25,2.25,2.25)
	inst.AnimState:SetBuild("bz_head_wendy")
	inst:AddTag("bz_head_wendy")	
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.inspectable:SetDescription( "她很痛苦" )
	inst.components.inventoryitem.imagename = "bz_head_wendy"
    inst.components.inventoryitem.atlasname = "images/bz_head_wendy.xml"
	
	return inst
end

--5.机器人
local function fn_wx78()
	local inst = fn_wislon()
	inst.Transform:SetScale(2.25,2.25,2.25)
	inst.AnimState:SetBuild("bz_head_wx78")
	inst:AddTag("bz_head_wx78")	
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.inspectable:SetDescription( "从它的表情看不出什么" )
	inst.components.inventoryitem.imagename = "bz_head_wx78"
    inst.components.inventoryitem.atlasname = "images/bz_head_wx78.xml"
	
	return inst
end

--6.图书管理员
local function fn_wicker()
	local inst = fn_wislon()
	inst.Transform:SetScale(2.25,2.25,2.25)
	inst.AnimState:SetBuild("bz_head_wicker")
	inst:AddTag("bz_head_wicker")	
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.inspectable:SetDescription( "她吓到我了" )
	inst.components.inventoryitem.imagename = "bz_head_wicker"
    inst.components.inventoryitem.atlasname = "images/bz_head_wicker.xml"
	
	return inst
end

--7.伍迪
local function fn_woodie()
	local inst = fn_wislon()
	inst.Transform:SetScale(2,2,2)
	inst.AnimState:SetBuild("bz_head_woodie")
	inst:AddTag("bz_head_woodie")	
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.inspectable:SetDescription( "海獭精" )
	inst.components.inventoryitem.imagename = "bz_head_woodie"
    inst.components.inventoryitem.atlasname = "images/bz_head_woodie.xml"
	
	return inst
end

--8.小丑
local function fn_wes()
	local inst = fn_wislon()
	inst.Transform:SetScale(2.5,2.5,2.5)
	inst.AnimState:SetBuild("bz_head_wes")
	inst:AddTag("bz_head_wes")	
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.inspectable:SetDescription( "简直吃屎, 2333" )
	inst.components.inventoryitem.imagename = "bz_head_wes"
    inst.components.inventoryitem.atlasname = "images/bz_head_wes.xml"
	
	return inst
end

--9.老麦
local function fn_waxwell()
	local inst = fn_wislon()
	inst.Transform:SetScale(1.75,1.75,1.75)
	inst.AnimState:SetBuild("bz_head_waxwell")
	inst:AddTag("bz_head_waxwell")	
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.inspectable:SetDescription( "面目狰狞" )
	inst.components.inventoryitem.imagename = "bz_head_waxwell"
    inst.components.inventoryitem.atlasname = "images/bz_head_waxwell.xml"
	
	return inst
end

--10.维京女
local function fn_wigfrid()
	local inst = fn_wislon()
	inst.Transform:SetScale(2.15,2.15,2.15)
	inst.AnimState:SetBuild("bz_head_wigfrid")
	inst:AddTag("bz_head_wigfrid")	
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.inspectable:SetDescription( "她貌似收到了礼物" )
	inst.components.inventoryitem.imagename = "bz_head_wigfrid"
    inst.components.inventoryitem.atlasname = "images/bz_head_wigfrid.xml"
	
	return inst
end

--11.韦伯
local function fn_webber()
	local inst = fn_wislon()
	inst.Transform:SetScale(2.9,2.9,2.9)
	inst.AnimState:SetBuild("bz_head_webber")
	inst:AddTag("bz_head_webber")	
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.inspectable:SetDescription( "吓人的蜘蛛" )
	inst.components.inventoryitem.imagename = "bz_head_webber"
    inst.components.inventoryitem.atlasname = "images/bz_head_webber.xml"
	
	return inst
end

--12.温妮
local function fn_wennie()
	local inst = fn_wislon()
	inst.Transform:SetScale(2.9,2.9,2.9)
	inst.AnimState:SetBuild("bz_head_wennie")
	inst:AddTag("bz_head_wennie")	
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.inspectable:SetDescription( "好贤惠的尊容" )
	inst.components.inventoryitem.imagename = "bz_head_wennie"
    inst.components.inventoryitem.atlasname = "images/bz_head_wennie.xml"
	
	return inst
end



return Prefab( "bz_head_wilson", fn_wislon, assets_wislon),
Prefab( "bz_head_willow", fn_willow, assets_willow),
Prefab( "bz_head_wolfgang", fn_wolfgang, assets_wolfgang),
Prefab( "bz_head_wendy", fn_wendy, assets_wendy),
Prefab( "bz_head_wx78", fn_wx78, assets_wx78),
Prefab( "bz_head_wicker", fn_wicker, assets_wicker),
Prefab( "bz_head_woodie", fn_woodie, assets_woodie),
Prefab( "bz_head_wes", fn_wes, assets_wes),
Prefab( "bz_head_waxwell", fn_waxwell, assets_waxwell),
Prefab( "bz_head_wigfrid", fn_wigfrid, assets_wigfrid),
Prefab( "bz_head_webber", fn_webber, assets_webber),
Prefab( "bz_head_wennie", fn_wennie, assets_wennie)




