----头材质
local assets = 
{
	Asset( "ANIM", "anim/bz_playerhead1.zip" ),
	
	Asset( "ATLAS", "images/zg_luffyhead.xml" ),
	Asset( "ATLAS", "images/zg_sanjihead.xml" ),
	Asset( "ATLAS", "images/zg_zorohead.xml" ),
}

--各种头颅的字符串
STRINGS.NAMES.ZG_LUFFYHEAD = "路飞 头颅"
STRINGS.NAMES.ZG_ZOROHEAD = "索隆 头颅"
STRINGS.NAMES.ZG_SANJIHEAD = "山治 头颅"
STRINGS.NAMES.ZG_HEAD_BUGGY = "巴基 头颅"

----common
local function fn()
	local inst = CreateEntity()

    inst.entity:AddTransform()
	--inst.Transform:SetScale(2.7,2.7,2.7)
	
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("bz_playerhead1")
    inst.AnimState:SetBuild("bz_playerhead1")
    --inst.AnimState:PlayAnimation("zg_luffyhead")
	
	inst:AddTag("bz_head")
	inst:AddTag("zg_magic_debossthing")
	--inst:AddTag("bz_head_wilson")
	
    inst.entity:SetPristine()
    if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription( "我貌似看到了它的电路板" )
	
	--inst:AddComponent("inventoryitem")
    --inst.components.inventoryitem.imagename = "zg_luffyhead"
    --inst.components.inventoryitem.atlasname = "images/zg_luffyhead.xml"
	
    return inst
end

--1路飞
local function fn_luffy()
	local inst = fn()
	inst.AnimState:PlayAnimation("zg_luffyhead")
	inst.Transform:SetScale(1.5,1.5,1.5)
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	--inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription( "我貌似看到了它的电路板" )
	
	inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "zg_luffyhead"
    inst.components.inventoryitem.atlasname = "images/zg_luffyhead.xml"
	
	return inst
end

--2索隆
local function fn_zoro()
	local inst = fn()
	inst.Transform:SetScale(1.2,1.2,1.2)
	inst.AnimState:PlayAnimation("zg_zorohead")
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	--inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription( "我貌似看到了它的电路板" )
	
	inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "zg_zorohead"
    inst.components.inventoryitem.atlasname = "images/zg_zorohead.xml"
	
	return inst
end

--3山治
local function fn_sanji()
	local inst = fn()
	inst.Transform:SetScale(1.2,1.2,1.2)
	inst.AnimState:PlayAnimation("zg_sanjihead")
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	--inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription( "我貌似看到了它的电路板" )
	
	inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "zg_sanjihead"
    inst.components.inventoryitem.atlasname = "images/zg_sanjihead.xml"
	
	return inst
end

--4巴基
local function fn_buggy()
	local inst = fn()
	inst.Transform:SetScale(2.7,2.7,2.7)
	inst.AnimState:SetBank("armor_wood")
    inst.AnimState:SetBuild("zg_head_buggy")
	inst.AnimState:PlayAnimation("anim")
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	--inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription( "依然是电路板, 不是真身" )
	
	inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "zg_head_buggy"
    inst.components.inventoryitem.atlasname = "images/zg_head_buggy.xml"
	
	return inst
end



return Prefab("zg_luffyhead", fn_luffy, assets),
	Prefab("zg_zorohead", fn_zoro, assets),
	Prefab("zg_sanjihead", fn_sanji, assets),
	Prefab("zg_head_buggy", fn_buggy, assets)


