local assets =
{
    Asset("ANIM", "anim/gravestones.zip"),
}

local function onhammered(inst, worker)
    inst.components.lootdropper:DropLoot()
    SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
    inst.SoundEmitter:PlaySound("dontstarve/common/destroy_stone")
	SpawnPrefab("warg").Transform:SetPosition(inst.Transform:GetWorldPosition())
    inst:Remove()
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()  
	inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeObstaclePhysics(inst, .25)

    inst:AddTag("grave")

    inst.AnimState:SetBank("gravestone")
    inst.AnimState:SetBuild("gravestones")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

	----	墓碑的几种样式
    inst.AnimState:PlayAnimation("grave"..tostring(math.random(4)))

	----	墓碑上的字迹
    inst:AddComponent("inspectable")	
    inst.components.inspectable:SetDescription( "千万不要砸开!!!!" )

	----	掉落
	inst:AddComponent("lootdropper")
	inst.components.lootdropper:SetLoot({ "marble","marble","marble","marble","marble","marble","marble","marble","marble","marble","marble","marble","amulet",})
	
	----	可以被砸碎
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(5)
    inst.components.workable:SetOnFinishCallback(onhammered)

    return inst
end

STRINGS.NAMES.DARKGRAVESTONE = "墓碑"
return Prefab("common/objects/darkgravestone", fn, assets)