--[[
石像鬼会自己内部选出头目，头目的团队成员数量越大，该头目的防御力越高，
2个石像鬼的头目汇合时，小团队全部归入大团队旗下，小头目变为普通成员，大头目成为新头目，
石像鬼睡觉被人的体味弄醒(怪物角色除外)，清醒的时候只定位玩家
]]
local pref="q1bat"
STRINGS.NAMES[string.upper(pref)]="石像鬼"
STRINGS.CHARACTERS.GENERIC.DESCRIBE[string.upper(pref)]="石头蝙蝠"
local def={
	hp=400,
	dmg=50,		
	atkrange=2.5,
	hitrange=2.5,
	atkperiod=2,
	hiteffectsymbol= "bat_body",
	runspeed=6,
	walkspeed=6,
	--sg="q1butterfly_s",
	--brain="q1butterfly_b",
	callsound="wiliya_monster/bat/call",
	hurtsound="wiliya_monster/bat/hit",
	diesound="wiliya_monster/bat/die",
}

local assets={}
wy_asset(assets,"anim","q1bat")

local function BasicWakeCheck(inst)
    return (inst.components.combat ~= nil and inst.components.combat.target ~= nil)
        or (inst.components.homeseeker ~= nil and inst.components.homeseeker:HasHome())
        or (inst.components.burnable ~= nil and inst.components.burnable:IsBurning())
        or (inst.components.follower ~= nil and inst.components.follower.leader ~= nil)
end

local function ShouldSleep(inst)
    return TheWorld.state.isday and not BasicWakeCheck(inst)
end

local function FindTarget(inst, radius)
    return FindEntity(
        inst,
        radius,
        function(guy)
            return guy
        end,
        { "_combat", "character" },
        { "INLIMBO", "monster" }
    )
end

local function ShouldWake(inst)
    return not TheWorld.state.day
        or BasicWakeCheck(inst)
        or FindTarget(inst, 6)
end
--[[
local function EquipWeapon(inst,slot)
	local slot=slot or 1
	if slot==1 then
		wy_virtual_weapon(inst,def.dmg,nil,8,12,"q5butterflyproj",nil,nil,nil,"wy_dark")
	elseif slot==2 then
		wy_virtual_weapon(inst,def.dmg*2,1,8,12,"q5butterflyproj2",nil,nil,nil,"wy_dark")
	end
end	]]
	
local function fn()
    local inst = CreateEntity()

    --核心组件
    inst.entity:AddTransform()	
    inst.entity:AddAnimState()
    inst.entity:AddDynamicShadow()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()
	inst.entity:AddPhysics()
	inst.entity:AddLightWatcher()

    --物理
	local phys = inst.entity:AddPhysics()
    phys:SetMass(750)
    phys:SetCapsule(.5, 1)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
    phys:CollidesWith(COLLISION.GROUND)
    phys:CollidesWith(COLLISION.CHARACTERS)
    --phys:CollidesWith(COLLISION.GIANTS)
	
    inst.Transform:SetFourFaced()

	--外观
	inst.AnimState:SetBank("bat")
    inst.AnimState:SetBuild("q1bat")
    inst.AnimState:PlayAnimation("idle")
    --inst.AnimState:SetRayTestOnBB(true)
	
	--影子
	inst.DynamicShadow:SetSize(1.5, .75)
	
	--标签
	inst:AddTag("cavedweller")
    inst:AddTag("monster")
    inst:AddTag("hostile")
    inst:AddTag("bat")
    inst:AddTag("scarytoprey")
    inst:AddTag("flying")
	
	inst:AddTag("q1bat")
	inst:AddTag("healthinfo")
	--inst:AddTag("hostile")
	------------------------------------------------------------------------
    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	--检阅
	inst:AddComponent("inspectable")
	--引用自己的表
	inst.def=def
	
	inst.wy_leader=nil
	inst.wy_follower={}
	
	inst:AddComponent("inventory")
	--wy_virtual_weapon(inst,damage,uses,attackrange,hitrange,projectile,build,bank,tag,slot,stimuli,onattack)
	
	--inst.EquipWeapon=EquipWeapon
	--EquipWeapon(inst)
	
	--掉落,玩家最关心的问题--------------------------------------------------
    inst:AddComponent("lootdropper")
    inst.components.lootdropper:AddRandomLoot("rocks", 1)
    inst.components.lootdropper:AddRandomLoot("batwing", .1)
    inst.components.lootdropper.numrandomloot = 1
	--血量
	inst:AddComponent("health")
    inst.components.health:SetMaxHealth(def.hp)
	--战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(def.dmg)
    inst.components.combat:SetAttackPeriod(def.atkperiod)
    inst.components.combat:SetRange(def.atkrange or 3,def.hitrange or def.atkrange or 3)
    inst.components.combat.hiteffectsymbol = def.hiteffectsymbol or "marker"
	inst.components.combat:SetHurtSound(def.hurtsound or "")
	
	--移动
    inst:AddComponent("locomotor")
	inst.components.locomotor.runspeed = def.runspeed
	inst.components.locomotor.walkspeed = def.walkspeed
    inst.components.locomotor:EnableGroundSpeedMultiplier(false)
    inst.components.locomotor:SetTriggersCreep(false)
	
	inst:AddComponent("sleeper")
    inst.components.sleeper:SetResistance(3)
    inst.components.sleeper:SetSleepTest(ShouldSleep)
    inst.components.sleeper:SetWakeTest(ShouldWake)
	
	inst:AddComponent("eater")
	inst.components.eater:SetDiet({ FOODTYPE.MEAT }, { FOODTYPE.MEAT })
    inst.components.eater:SetCanEatHorrible()
    inst.components.eater.strongstomach = true
	local selfeater = inst.components.eater
	local old = selfeater.Eat
	function inst.components.eater:Eat(food)
		if selfeater:CanEat(food) then
			if food.components.edible.healthvalue < 1 then
				food.components.edible.healthvalue = 1
			end
		end
		return old(selfeater, food)
	end
	
	--inst:ListenForEvent("toolbroke",function(inst,data)
	--	EquipWeapon(inst)
	--end)
	inst:ListenForEvent("onhitother",function(inst,data)
		
	end)
	
	--火焰冰冻---------------------------------------------------------------
	--MakeSmallBurnableCharacter(inst, def.hiteffectsymbol)
	MakeMediumFreezableCharacter(inst, def.hiteffectsymbol)
    --MakeTinyFreezableCharacter(inst, def.hiteffectsymbol)
	
	--怪物的行为方式
	q1retarget(inst,12,2,nil,function(guy,invader)
		if wy_getn(inst.wy_follower)>0 then
			--队长紧急召唤
			guy.components.combat:wy_ShareTarget(invader,30,function(dude) 
				return dude and dude:HasTag("q1bat") and not dude.components.health:IsDead() end
			,30)
		else
			guy.components.combat:ShareTarget(invader,20,function(dude) 
				return dude and dude:HasTag("q1bat") and not dude.components.health:IsDead() end
			,5)
		end
	end)
	q1keeptarget(inst)
	q1attacked(inst,function(guy,invader)
		if wy_getn(inst.wy_follower)>0 then
			--队长紧急召唤
			guy.components.combat:wy_ShareTarget(invader,30,function(dude) 
				return dude and dude:HasTag("q1bat") and not dude.components.health:IsDead() end
			,30)
		else
			guy.components.combat:ShareTarget(invader,20,function(dude) 
				return dude and dude:HasTag("q1bat") and not dude.components.health:IsDead() end
			,5)
		end
	end)
	q1death(inst, function(inst)
		inst.SoundEmitter:PlaySound(def.diesound or "")
		
		q1loots(inst,{
			goldnugget=.1,
			--armorwood=.01,
			--footballhat=.0033,
			--papyrus=.0033,
			nightmarefuel=.05,
			--gears=.001,
			TOOLS_blueprint=.005,
			LIGHT_blueprint=.005,
			SURVIVAL_blueprint=.005,
			FARM_blueprint=.005,
			SCIENCE_blueprint=.005,
			WAR_blueprint=.005,
			TOWN_blueprint=.005,
			REFINE_blueprint=.005,
			MAGIC_blueprint=.005,
			DRESS_blueprint=.005,
			batbat=.025,
			bluegem=.01,
			redgem=.01,
			thulecite_pieces=.005,
			orangegem=.005,
			purplegem=.005,
			thulecite=.0025,
			armorruins=.0025,
			yellowgem=.001,
			greengem=.001,
			ruinshat=.001,
		})
	end)

	inst:SetStateGraph(def.sg or pref.."_s")
	local brain=require ("brains/"..(def.brain or pref.."_b"))
    inst:SetBrain(brain)
	
	inst.OnSave=function(inst,data)
		
	end
	inst.OnLoad=function(inst,data)
		
	end

    return inst
end

return Prefab(pref, fn, assets)
