--[[
采集花粉回复50血,并且加强自己的攻击力,花粉的力量释放完全后,变回普通的攻击
花粉越多,蝴蝶越诡异,移动速度也越快,最高1.75倍速度
]]
local pref="q1butterfly"
STRINGS.NAMES[string.upper(pref)]="静电蝴蝶"
STRINGS.CHARACTERS.GENERIC.DESCRIBE[string.upper(pref)]="它仿佛是一个巨大的电容"
local def={
	hp=350,
	dmg=25,		--电流自带1.5-2.5倍系数，绝缘是1倍
	atkrange=3,
	hitrange=3.5,
	atkperiod=2,
	hiteffectsymbol= "butterfly_body",
	runspeed=6,
	walkspeed=6,
	--sg="",
	--brain="",
	callsound="wiliya_monster/butterfly/call",
	hurtsound="wiliya_monster/butterfly/hit",
	diesound="wiliya_monster/butterfly/die",
}

local function fn()
    local inst = CreateEntity()

    --核心组件
    inst.entity:AddTransform()	
    inst.entity:AddAnimState()
    inst.entity:AddDynamicShadow()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()
	inst.entity:AddPhysics()
	inst.entity:AddLightWatcher()

    --物理
	inst.Physics:SetCapsule(.25, 1)
	inst.Physics:SetMass(1)
	inst.Physics:SetDamping(5)
    inst.Physics:SetCollisionGroup(COLLISION.FLYERS)
	inst.Physics:ClearCollisionMask()
	--inst.Physics:CollidesWith(COLLISION.FLYERS)
	inst.Physics:CollidesWith(COLLISION.GROUND)
	
    inst.Transform:SetTwoFaced()

	--外观
	inst.AnimState:SetBank("butterfly")
    inst.AnimState:SetBuild("butterfly_basic")
    inst.AnimState:PlayAnimation("idle")
    inst.AnimState:SetRayTestOnBB(true)
	
	--影子
	inst.DynamicShadow:SetSize(.8, .5)
	
	--标签
	inst:AddTag("butterfly")
    inst:AddTag("flying")
    inst:AddTag("insect")
    inst:AddTag("smallcreature")
    inst:AddTag("cattoyairborne")
    inst:AddTag("wildfireprotected")
	
	inst:AddTag("q1butterfly")
	inst:AddTag("healthinfo")
	inst:AddTag("hostile")
	------------------------------------------------------------------------
    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	--检阅
	inst:AddComponent("inspectable")
	--引用自己的表
	inst.def=def
	
	--掉落,玩家最关心的问题--------------------------------------------------
    inst:AddComponent("lootdropper")
    inst.components.lootdropper:AddRandomLoot("butter", 0.3)
    inst.components.lootdropper:AddRandomLoot("butterflywings", 5)
    inst.components.lootdropper.numrandomloot = 3
	--血量
	inst:AddComponent("health")
    inst.components.health:SetMaxHealth(def.hp)
	--战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(def.dmg)
    inst.components.combat:SetAttackPeriod(def.atkperiod)
    inst.components.combat:SetRange(def.atkrange,def.hitrange or def.atkrange)
    inst.components.combat.hiteffectsymbol = def.hiteffectsymbol or "marker"
	inst.components.combat:SetHurtSound(def.hurtsound or "")
	--[[
	function inst.components.combat:StartAttack()
		local t = GetTime()
		if self.nexttaunttime == nil or t > self.nexttaunttime then
            self.nexttaunttime = t + 10 + math.random() * 10
			inst.SoundEmitter:PlaySound(def.callsound or "")
		end
		if self.forcefacing and self.target ~= nil and self.target:IsValid() then
			self.inst:ForceFacePoint(self.target:GetPosition())
		end
		self.laststartattacktime = GetTime()
	end]]
	--移动
    inst:AddComponent("locomotor")
	inst.components.locomotor.runspeed = def.runspeed
	inst.components.locomotor.walkspeed = def.walkspeed
    inst.components.locomotor:EnableGroundSpeedMultiplier(false)
    inst.components.locomotor:SetTriggersCreep(false)
	
	inst:AddComponent("pollinator")
	inst.pollinator=0
	
	--火焰冰冻---------------------------------------------------------------
	MakeSmallBurnableCharacter(inst, def.hiteffectsymbol)
    MakeTinyFreezableCharacter(inst, def.hiteffectsymbol)
	
	--怪物的行为方式
	q1retarget(inst,9)
	q1keeptarget(inst)
	q1attacked(inst)
	q1death(inst, function(inst)
		inst.SoundEmitter:PlaySound(def.diesound or "")
		
		local chancemult=15
		local pol=inst.pollinator
		if pol<1 then
		
		elseif pol<4 then
			chancemult=30
		else
			chancemult=45
		end
		
		q1loots(inst,{
			goldnugget=.01,
			armorwood=.01,
			footballhat=.0033,
			papyrus=.0033,
			nightmarefuel=.001,
			gears=.001,
			TOOLS_blueprint=.0002,
			LIGHT_blueprint=.0002,
			SURVIVAL_blueprint=.0002,
			FARM_blueprint=.0002,
			SCIENCE_blueprint=.0002,
			WAR_blueprint=.0002,
			TOWN_blueprint=.0002,
			REFINE_blueprint=.0002,
			MAGIC_blueprint=.0002,
			DRESS_blueprint=.0002,
			bluegem=.0004,
			redgem=.0004,
			thulecite_pieces=.0004,
			orangegem=.0002,
			purplegem=.0002,
			thulecite=.0002,
			armorruins=.0002,
			yellowgem=.0001,
			greengem=.0001,
			ruinshat=.0001,
		},nil,chancemult)
	end)

	inst:SetStateGraph(def.sg or pref.."_s")
	local brain=require ("brains/"..(def.brain or pref.."_b"))
    inst:SetBrain(brain)
	
	inst.OnSave=function(inst,data)
		data.pollinator=inst.pollinator
	end
	inst.OnLoad=function(inst,data)
		if data then
			inst.pollinator=data.pollinator or 0
		end
	end

    return inst
end

return Prefab(pref, fn)
