--[[
采集花粉回复50血,并且加强自己的攻击力,花粉的力量释放完全后,变回普通的攻击
花粉越多,蝴蝶越诡异,移动速度也越快,最高1.75倍速度
]]
local pref="q1butterfly2"
STRINGS.NAMES[string.upper(pref)]="蝴蝶射手"
STRINGS.CHARACTERS.GENERIC.DESCRIBE[string.upper(pref)]="艺皇制造的辐射已经把世界破坏到这个程度了"
local def={
	hp=400,
	dmg=20,		
	--atkrange=3,
	--hitrange=4,
	atkperiod=2,
	hiteffectsymbol= "butterfly_body",
	runspeed=5,
	walkspeed=5,
	sg="q1butterfly_s",
	brain="q1butterfly_b",
	callsound="wiliya_monster/butterfly/call",
	hurtsound="wiliya_monster/butterfly/hit",
	diesound="wiliya_monster/butterfly/die",
}

local assets={}
wy_asset(assets,"anim","zg_mo_butterfly0")

local function EquipWeapon(inst,slot)
	local slot=slot or 1
	if slot==1 then
		wy_virtual_weapon(inst,def.dmg,nil,8,12,"q5butterflyproj",nil,nil,nil,"wy_dark")
	elseif slot==2 then
		wy_virtual_weapon(inst,def.dmg*2,1,8,12,"q5butterflyproj2",nil,nil,nil,"wy_dark")
	end
end	
	
local function fn()
    local inst = CreateEntity()

    --核心组件
    inst.entity:AddTransform()	
    inst.entity:AddAnimState()
    inst.entity:AddDynamicShadow()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()
	inst.entity:AddPhysics()
	inst.entity:AddLightWatcher()

    --物理
	inst.Physics:SetCapsule(.25, 1)
	inst.Physics:SetMass(1)
	inst.Physics:SetDamping(5)
    inst.Physics:SetCollisionGroup(COLLISION.FLYERS)
	inst.Physics:ClearCollisionMask()
	--inst.Physics:CollidesWith(COLLISION.FLYERS)
	inst.Physics:CollidesWith(COLLISION.GROUND)
	
    inst.Transform:SetTwoFaced()

	--外观
	inst.AnimState:SetBank("butterfly")
    inst.AnimState:SetBuild("zg_mo_butterfly0")
    inst.AnimState:PlayAnimation("idle")
    inst.AnimState:SetRayTestOnBB(true)
	
	--影子
	inst.DynamicShadow:SetSize(.8, .5)
	
	--标签
	inst:AddTag("butterfly")
    inst:AddTag("flying")
    inst:AddTag("insect")
    inst:AddTag("smallcreature")
    inst:AddTag("cattoyairborne")
    inst:AddTag("wildfireprotected")
	
	inst:AddTag("q1butterfly")
	inst:AddTag("healthinfo")
	inst:AddTag("hostile")
	------------------------------------------------------------------------
    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	--检阅
	inst:AddComponent("inspectable")
	--引用自己的表
	inst.def=def
	
	inst:AddComponent("inventory")
	--wy_virtual_weapon(inst,damage,uses,attackrange,hitrange,projectile,build,bank,tag,slot,stimuli,onattack)
	
	inst.EquipWeapon=EquipWeapon
	EquipWeapon(inst)
	
	--掉落,玩家最关心的问题--------------------------------------------------
    inst:AddComponent("lootdropper")
    inst.components.lootdropper:AddRandomLoot("butter", 0.3)
    inst.components.lootdropper:AddRandomLoot("butterflywings", 5)
    inst.components.lootdropper.numrandomloot = 3
	--血量
	inst:AddComponent("health")
    inst.components.health:SetMaxHealth(def.hp)
	--战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(def.dmg)
    inst.components.combat:SetAttackPeriod(def.atkperiod)
    inst.components.combat:SetRange(def.atkrange or 3,def.hitrange or def.atkrange or 3)
    inst.components.combat.hiteffectsymbol = def.hiteffectsymbol or "marker"
	inst.components.combat:SetHurtSound(def.hurtsound or "")
	
	--移动
    inst:AddComponent("locomotor")
	inst.components.locomotor.runspeed = def.runspeed
	inst.components.locomotor.walkspeed = def.walkspeed
    inst.components.locomotor:EnableGroundSpeedMultiplier(false)
    inst.components.locomotor:SetTriggersCreep(false)
	
	inst:AddComponent("pollinator")
	inst.pollinator=0
	
	inst:ListenForEvent("toolbroke",function(inst,data)
		EquipWeapon(inst)
	end)
	inst:ListenForEvent("onhitother",function(inst,data)
		if inst.pollinator>0 then
			inst.pollinator=inst.pollinator-1
		end
	end)
	
	--火焰冰冻---------------------------------------------------------------
	MakeSmallBurnableCharacter(inst, def.hiteffectsymbol)
    MakeTinyFreezableCharacter(inst, def.hiteffectsymbol)
	
	--怪物的行为方式
	q1retarget(inst,9)
	q1keeptarget(inst)
	q1attacked(inst)
	q1death(inst, function(inst)
		inst.SoundEmitter:PlaySound(def.diesound or "")
		
		local chancemult=30
		local pol=inst.pollinator
		if pol<1 then
		
		elseif pol<4 then
			chancemult=60
		else
			chancemult=90
		end
		
		q1loots(inst,{
			goldnugget=.01,
			armorwood=.01,
			footballhat=.0033,
			papyrus=.0033,
			nightmarefuel=.001,
			gears=.001,
			TOOLS_blueprint=.0002,
			LIGHT_blueprint=.0002,
			SURVIVAL_blueprint=.0002,
			FARM_blueprint=.0002,
			SCIENCE_blueprint=.0002,
			WAR_blueprint=.0002,
			TOWN_blueprint=.0002,
			REFINE_blueprint=.0002,
			MAGIC_blueprint=.0002,
			DRESS_blueprint=.0002,
			bluegem=.0004,
			redgem=.0004,
			thulecite_pieces=.0004,
			orangegem=.0002,
			purplegem=.0002,
			thulecite=.0002,
			armorruins=.0002,
			yellowgem=.0001,
			greengem=.0001,
			ruinshat=.0001,
		},nil,chancemult)
	end)

	inst:SetStateGraph(def.sg or pref.."_s")
	local brain=require ("brains/"..(def.brain or pref.."_b"))
    inst:SetBrain(brain)
	
	inst.OnSave=function(inst,data)
		data.pollinator=inst.pollinator
	end
	inst.OnLoad=function(inst,data)
		if data then
			inst.pollinator=data.pollinator or 0
		end
	end

    return inst
end

return Prefab(pref, fn, assets)
