--[[
金石像鬼的激光
]]
local def={
	speed=50,
	hitdist=.1,
	launchoffset=Vector3(0,0,0),
}

local function RemoveArm(inst)
	if inst.arm~=nil then
		inst.arm:Remove()
		inst.arm=nil	
	end
	if inst.arm2~=nil then
		inst.arm2:Remove()
		inst.arm2=nil	
	end
	inst:Remove()
end

local function OnHit(inst, owner, target)
    RemoveArm(inst)
end

local function OnThrown(inst,owner,target)
	--inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
	
	--伸展
	--inst.arm=wy_spawn(owner,"q5batlinearm",nil,"bat_eye")
	--inst.arm=wy_spawn(owner,"q5batlinearm",{0,3,0},1)
	--tw_getforwardpos(inst, dist, theta, other, height)
	
	inst.arm=wy_spawn(inst,"q5batlinearm",wy_getoffset(inst, .5, 90, nil, 3))
	inst.arm2=wy_spawn(inst,"q5batlinearm",wy_getoffset(inst, .5, -90, nil, 3))
	
	inst:DoTaskInTime(0, function()
		inst.arm:FacePoint(inst:GetPosition())
		inst.arm.AnimState:PlayAnimation("idle",true)
		inst.arm.components.stretcher:SetStretchTarget(inst)
		
		inst.arm2:FacePoint(inst:GetPosition())
		inst.arm2.AnimState:PlayAnimation("idle",true)
		inst.arm2.components.stretcher:SetStretchTarget(inst)
	end)
	
	inst:DoTaskInTime(3, function()
		RemoveArm(inst)
	end)
end

local function make(tab)
	return function()
		local inst = CreateEntity()

		inst.entity:AddTransform()
		--inst.entity:AddAnimState()
		inst.entity:AddSoundEmitter()
		inst.entity:AddNetwork()

		MakeInventoryPhysics(inst)
		RemovePhysicsColliders(inst)

		--inst.Transform:SetFourFaced()

		--inst.AnimState:SetBank("blow_dart")
		--inst.AnimState:SetBuild("blow_dart")
		--inst.AnimState:PlayAnimation("dart_red",true)
		
		--inst.AnimState:SetAddColour(208, 120, 86, 0)
		--inst.Transform:SetScale(.75,.75,.75)
		--wy_addcolor(inst,tab)
		--wy_scale(inst,.5)
		
		inst.entity:AddLight()
		inst.Light:Enable(true)
		inst.Light:SetIntensity(.75)
		inst.Light:SetColour(0, 1, 1)
		inst.Light:SetFalloff(0.5)
		inst.Light:SetRadius(2)

		inst:AddTag("projectile")

		inst.entity:SetPristine()

		if not TheWorld.ismastersim then
			return inst
		end

		inst.persists = false

		inst:AddComponent("projectile")
		inst.components.projectile:SetSpeed(def.speed or 30)
		--inst.components.projectile:SetHoming(false)
		inst.components.projectile:SetHitDist(def.hitdist or 2)
		inst.components.projectile:SetOnHitFn(OnHit)
		inst.components.projectile:SetOnMissFn(inst.Remove)
		inst.components.projectile:SetOnThrownFn(OnThrown)
		inst.components.projectile:SetLaunchOffset(def.launchoffset or nil)

		return inst
	end
end

return Prefab("q5batline", make({0, 1, 1, 0}) )