--[[
碧眼石像鬼的绿箭
]]
local def={
	speed=20,
	hitdist=1.5,
	launchoffset=Vector3(0,2,0),
}

local function RemoveArm(inst)
	if inst.arm~=nil then
		inst.arm:Remove()
		inst.arm=nil
	end
	inst:Remove()
end

local function OnHit(inst, owner, target)
	--inst.SoundEmitter:PlaySound("wiliya_monster/butterfly/atk_rh")
    RemoveArm(inst)
end

local function OnThrown(inst)
	inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
	--inst.arm=wy_spawn(inst,"q5batprojsmoke",nil,1)
	inst:DoTaskInTime(5, function()
		--inst.SoundEmitter:PlaySound("wiliya_monster/butterfly/atk_rh")
		RemoveArm(inst)
	end)
    --inst:ListenForEvent("animover", OnAnimOver)
end

local function make(tab)
	return function()
		local inst = CreateEntity()

		inst.entity:AddTransform()
		inst.entity:AddAnimState()
		inst.entity:AddSoundEmitter()
		inst.entity:AddNetwork()

		MakeInventoryPhysics(inst)
		RemovePhysicsColliders(inst)

		--inst.Transform:SetFourFaced()

		inst.AnimState:SetBank("blow_dart")
		inst.AnimState:SetBuild("blow_dart")
		inst.AnimState:PlayAnimation("dart_red",true)
		
		--inst.AnimState:SetAddColour(208, 120, 86, 0)
		--inst.Transform:SetScale(.75,.75,.75)
		wy_addcolor(inst,tab)
		--wy_scale(inst,.5)

		inst:AddTag("projectile")

		inst.entity:SetPristine()

		if not TheWorld.ismastersim then
			return inst
		end

		inst.persists = false

		inst:AddComponent("projectile")
		inst.components.projectile:SetSpeed(def.speed or 30)
		inst.components.projectile:SetHoming(false)
		inst.components.projectile:SetHitDist(def.hitdist or 2)
		inst.components.projectile:SetOnHitFn(OnHit)
		inst.components.projectile:SetOnMissFn(inst.Remove)
		inst.components.projectile:SetOnThrownFn(OnThrown)
		inst.components.projectile:SetLaunchOffset(def.launchoffset or nil)

		return inst
	end
end

return Prefab("q5batproj", make({0, 1, 1, 0}) )