--[[
蝴蝶射手的魔法球
]]
local def={
	speed=20,
	hitdist=1.5,
	launchoffset=Vector3(-.5,0,0),
}

local function OnHit(inst, owner, target)
	inst.SoundEmitter:PlaySound("wiliya_monster/butterfly/atk_rh")
    inst:Remove()
end

local function OnAnimOver(inst)
    --inst:DoTaskInTime(.3, inst.Remove)
end

local function OnThrown(inst)
	inst:DoTaskInTime(10, function()
		inst.SoundEmitter:PlaySound("wiliya_monster/butterfly/atk_rh")
		inst:Remove()
	end)
    --inst:ListenForEvent("animover", OnAnimOver)
end

local function make(tab)
	return function()
		local inst = CreateEntity()

		inst.entity:AddTransform()
		inst.entity:AddAnimState()
		inst.entity:AddSoundEmitter()
		inst.entity:AddNetwork()

		MakeInventoryPhysics(inst)
		RemovePhysicsColliders(inst)

		inst.Transform:SetFourFaced()

		inst.AnimState:SetBank("bishop_attack")
		inst.AnimState:SetBuild("bishop_attack")
		inst.AnimState:PlayAnimation("idle",true)
		
		--inst.AnimState:SetAddColour(208, 120, 86, 0)
		--inst.Transform:SetScale(.75,.75,.75)
		wy_addcolor(inst,tab)
		wy_scale(inst,.5)

		inst:AddTag("projectile")

		inst.entity:SetPristine()

		if not TheWorld.ismastersim then
			return inst
		end

		inst.persists = false

		inst:AddComponent("projectile")
		inst.components.projectile:SetSpeed(def.speed or 30)
		inst.components.projectile:SetHoming(false)
		inst.components.projectile:SetHitDist(def.hitdist or 2)
		inst.components.projectile:SetOnHitFn(OnHit)
		inst.components.projectile:SetOnMissFn(inst.Remove)
		inst.components.projectile:SetOnThrownFn(OnThrown)
		inst.components.projectile:SetLaunchOffset(def.launchoffset or nil)

		return inst
	end
end

return Prefab("q5butterflyproj", make({208, 120, 86, 0}) ),
	Prefab("q5butterflyproj2", make({149/5, 191/5, 242/5, 0}) )