local assets =
{
    Asset("ANIM", "anim/spider_spit.zip"),
}

local prefabs =
{
    "spider_web_spit_creep",
    "splash_spiderweb"
}

local function OnThrown(inst)
    inst:ListenForEvent("entitysleep", inst.Remove)
end

local function OnHit(inst)
	----
	local can_creep = true
	local x,y,z = inst.Transform:GetWorldPosition()
	local ents = TheSim:FindEntities(x, y, z, 9)
	for k,v in pairs(ents) do
		if v and v.prefab == "spider_web_spit_creep" then
			can_creep = false
		end
	end
	if can_creep then
		SpawnPrefab("spider_web_spit_creep").Transform:SetPosition(x,y,z)
	end
	
	inst:Remove()
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst.Transform:SetFourFaced()

    inst.AnimState:SetBank("spider_spit")
    inst.AnimState:SetBuild("spider_spit")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("projectile")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false

    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(20)
    inst.components.projectile:SetHoming(false)
    inst.components.projectile:SetHitDist(1)
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(OnThrown)
    inst.components.projectile:SetOnThrownFn(OnThrown)

    return inst
end

return Prefab("spider_web_spit", fn, assets, prefabs)