local prefix="z_ar_bone2"

local assets =
{
    Asset("ANIM", "anim/"..prefix..".zip"),
	Asset("ATLAS","images/"..prefix.."_i.xml"),
}

local function OnBlocked(owner) 
    owner.SoundEmitter:PlaySound("dontstarve/wilson/hit_armour") 
end

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_body", prefix, "swap_body")
    inst:ListenForEvent("blocked", OnBlocked, owner)
end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
    inst:RemoveEventCallback("blocked", OnBlocked, owner)
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("armor_wood")
    inst.AnimState:SetBuild(prefix)
    inst.AnimState:PlayAnimation("anim")

    --inst:AddTag("wood")
    --MakeDragonflyBait(inst, 3)

    --inst.foleysound = "dontstarve/movement/foley/logarmour"

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname="images/"..prefix.."_i.xml"
	inst.components.inventoryitem.imagename=prefix.."_i"

    --inst:AddComponent("fuel")
    --inst.components.fuel.fuelvalue = TUNING.LARGE_FUEL

    --MakeSmallBurnable(inst, TUNING.SMALL_BURNTIME)
    --MakeSmallPropagator(inst)

    inst:AddComponent("armor")
    inst.components.armor:InitCondition(1500, .9)
    --inst.components.armor:AddWeakness("beaver", TUNING.BEAVER_WOOD_DAMAGE)

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY

    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    --MakeHauntableLaunch(inst)

    return inst
end

STRINGS.NAMES[string.upper(prefix)]=zg_ischs("骨木甲","Bonewood Armor")
STRINGS.CHARACTERS.GENERIC.DESCRIBE[string.upper(prefix)]=zg_ischs("骨头做的","Made of bones")

return Prefab(prefix, fn, assets)
