local prefix="z_arh_bone"

local assets =
{
    Asset("ANIM", "anim/"..prefix..".zip"),
	Asset("ATLAS","images/"..prefix.."_i.xml"),
}

local function onequip(inst, owner) 
	owner.AnimState:OverrideSymbol("swap_hat", prefix, "swap_hat")
    owner.AnimState:Show("HAT")
	owner.AnimState:Show("HAT_HAIR")
	owner.AnimState:Hide("HAIR_NOHAT")
	owner.AnimState:Hide("HAIR")
	if owner:HasTag("player") then
		owner.AnimState:Hide("HEAD")
		owner.AnimState:Show("HEAD_HAT")
	end
end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_hat")
	owner.AnimState:Hide("HAT")
	owner.AnimState:Hide("HAT_HAIR")
	owner.AnimState:Show("HAIR_NOHAT")
	owner.AnimState:Show("HAIR")
	if owner:HasTag("player") then
		owner.AnimState:Show("HEAD")
		owner.AnimState:Hide("HEAD_HAT")
	end
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("footballhat")
	inst.AnimState:SetBuild(prefix)
	inst.AnimState:PlayAnimation("anim")

	inst:AddTag("hat")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname="images/"..prefix.."_i.xml"
	inst.components.inventoryitem.imagename=prefix.."_i"

    inst:AddComponent("armor")
    inst.components.armor:InitCondition(750, .85)

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.HEAD

    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    return inst
end

STRINGS.NAMES[string.upper(prefix)]=zg_ischs("鬼盔","Ghost Helmet")
STRINGS.CHARACTERS.GENERIC.DESCRIBE[string.upper(prefix)]=zg_ischs("变异的鬼木制成","Made form variant wood")

return Prefab(prefix, fn, assets)
