-- 格式 z_redbow

local manshape_defs={
	--红弓
	{
		name="red",
		anim="idle",
		zg_damage=30,
		zg_name=zg_ischs("火木弓","Firelog Bow"),
		zg_desc=zg_ischs("火树人的精髓酿成","Made from firelog of fireleif"),
		uses=50,	--50
		attackrange=10,
		hitrange=14,	
	},
	--骨头弓
	{
		name="bone",
		zg_damage=50,
		zg_name=zg_ischs("白骨弓","Boneow"),
		zg_desc=zg_ischs("死亡的气息","Smell of death"),
		uses=75,	--50
		attackrange=10,
		hitrange=14,	
	}
}


local function MakeManshape(def)
	
	def.assets={
		Asset("ANIM","anim/z_"..def.name.."bow.zip"),
		Asset("ANIM","anim/z_"..def.name.."bow_s.zip"),
		Asset("ATLAS","images/z_"..def.name.."bow_i.xml"),
	}
	def.projectile="zg_proj_"..def.name.."bow"
	
	local function onequip(inst, owner)
		owner.AnimState:OverrideSymbol("swap_object", "z_"..def.name.."bow_s", "z_"..def.name.."bow_s")
		owner.AnimState:Show("ARM_carry")
		owner.AnimState:Hide("ARM_normal")
	end

	local function onunequip(inst, owner)
		owner.AnimState:Hide("ARM_carry")
		owner.AnimState:Show("ARM_normal")
	end

	local function fn()
		local inst = CreateEntity()

		inst.entity:AddTransform()
		inst.entity:AddAnimState()
		inst.entity:AddNetwork()
		inst.entity:AddSoundEmitter()

		MakeInventoryPhysics(inst)

		--地上图片
		inst.AnimState:SetBank("z_"..def.name.."bow")
		inst.AnimState:SetBuild("z_"..def.name.."bow")
		inst.AnimState:PlayAnimation(def.anim or "NewAnimation")
		
		inst:AddTag("zg_bow")
		inst:AddTag("zg_doublehand")

		inst.entity:SetPristine()

		if not TheWorld.ismastersim then
			return inst
		end
		
		--文字
		inst.zg_damage=def.zg_damage or 0
		--inst.zg_name=(def.zg_name or "").." DMG: ".. inst.zg_damage	--伤害写上
		--inst.zg_desc=def.zg_desc or ""

		inst:AddComponent("weapon")
		inst.components.weapon:SetDamage(0)	--弓箭的伤害在箭上不在弓上
		inst.components.weapon:SetRange(def.attackrange or 8, def.hitrange or def.attackrange or 12)
		inst.components.weapon.stimuli=def.stimuli or nil
		inst.components.weapon.projectile=def.projectile or nil
		
		--弓箭不在传统的击中的时候消耗耐久
		function inst.components.weapon:OnAttack(attacker, target, projectile)
			if self.onattack ~= nil then
				self.onattack(self.inst, attacker, target)
			end
		end	
			
		inst:AddComponent("finiteuses")
		inst.components.finiteuses:SetMaxUses(def.uses or 50)
		inst.components.finiteuses:SetUses(def.uses or 50)
		inst.components.finiteuses:SetOnFinished(inst.Remove)

		inst:AddComponent("inspectable")

		--物品栏图片
		inst:AddComponent("inventoryitem")
		inst.components.inventoryitem.atlasname="images/z_"..def.name.."bow_i.xml"
		inst.components.inventoryitem.imagename="z_"..def.name.."bow_i"
	
		--手上图片
		inst:AddComponent("equippable")
		inst.components.equippable:SetOnEquip(onequip)
		inst.components.equippable:SetOnUnequip(onunequip)

		return inst
	end
	return Prefab("z_"..def.name.."bow", fn, def.assets)
end

local manshapes = {}
for i, v in ipairs(manshape_defs) do
    table.insert(manshapes, MakeManshape(v))
	STRINGS.NAMES[string.upper("z_"..v.name.."bow")]=v.zg_name.. (v.zg_damage and " 伤害:"..v.zg_damage) 
	STRINGS.CHARACTERS.GENERIC.DESCRIBE[string.upper("z_"..v.name.."bow")]=v.zg_desc
end
manshape_defs = nil
return unpack(manshapes)