
--引用
local def={
	zg_name=zg_ischs("火焰喷射器(红宝石修复)","Flame Injector"),
	zg_desc=zg_ischs("在家里玩这个武器最爽了","It is fun to play this gun at home"),
	walkspeedmult=.8,
	uses=50,
	projectile="zg_proj_firegun_player",
	onequipff=function(inst, owner)
		owner.components.combat:SetAttackPeriod(1.5)
	end,
	onunequipff=function(inst, owner)
		owner.components.combat:SetAttackPeriod(0)
	end,
}

def.assets={
	Asset("ANIM","anim/z_firegun.zip"),
	Asset("ANIM","anim/z_firegun_s.zip"),
	Asset("ATLAS","images/z_firegun_i.xml"),
}

local function onequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_object", "z_firegun_s", "z_firegun_s")
	owner.AnimState:Show("ARM_carry")
	owner.AnimState:Hide("ARM_normal")
	if def.onequipff then def.onequipff(inst, owner) end
end

local function onunequip(inst, owner)
	owner.AnimState:Hide("ARM_carry")
	owner.AnimState:Show("ARM_normal")
	if def.onunequipff then def.onunequipff(inst, owner) end
end

local function OnGetItemFromPlayer(inst, giver, item)
    if item.prefab == "redgem" then
		local current = inst.components.finiteuses.current
		if current <= 40 then 
			inst.components.finiteuses:SetUses(current + 10)
			inst.SoundEmitter:PlaySound("dontstarve/zg/shotgun/fill")
		end
    end
end

local function OnRefuseItem(inst, giver, item)
	if item.prefab ~= "redgem" then
		giver.components.talker:Say("需要红宝石修理!")
	else
		giver.components.talker:Say("至少用掉10次耐久才能修理!")
	end
	inst.SoundEmitter:PlaySound("dontstarve/zg/shotgun/cantfill")
end

local function AcceptTest(inst, item)
    return item.prefab == "redgem" and inst.components.finiteuses.current <= 40
end

local function fn()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddNetwork()
	inst.entity:AddSoundEmitter()

	MakeInventoryPhysics(inst)

	--地上图片
	inst.AnimState:SetBank("z_firegun")
	inst.AnimState:SetBuild("z_firegun")
	inst.AnimState:PlayAnimation("idle")
	
	--枪类
	inst:AddTag("zg_doublehand")
	inst:AddTag("zg_gun_fire")
	
	inst:AddTag("wildfireprotected")
    inst:AddTag("lighter")

	inst.entity:SetPristine()

	if not TheWorld.ismastersim then
		return inst
	end
	
	--文字
	inst.zg_name=def.zg_name
	inst.zg_desc=def.zg_desc

	inst:AddComponent("weapon")
	inst.components.weapon:SetDamage(def.damage or 0)
	inst.components.weapon:SetRange(def.attackrange or 9, def.hitrange or def.attackrange or 15)
	inst.components.weapon.stimuli=def.stimuli or nil
	inst.components.weapon.projectile=def.projectile or nil
		
	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetMaxUses(def.uses or 30)
	inst.components.finiteuses:SetUses(def.uses or 30)
	
	inst.components.finiteuses:SetOnFinished(inst.Remove)
	
	--枪械不在传统的击中的时候消耗耐久
	function inst.components.weapon:OnAttack(attacker, target, projectile)
		if self.onattack ~= nil then
			self.onattack(self.inst, attacker, target)
		end
	end	

	inst:AddComponent("inspectable")

	--物品栏图片
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname="images/z_firegun_i.xml"
	inst.components.inventoryitem.imagename="z_firegun_i"
	inst:ListenForEvent("ondropped", function(inst) 
		inst:DoTaskInTime(.25,function() 
			inst.SoundEmitter:PlaySound( "zg_melee/gun/ground" )
		end)
	end)

	--手上图片
	inst:AddComponent("equippable")
	inst.components.equippable:SetOnEquip(onequip)
	inst.components.equippable:SetOnUnequip(onunequip)
	
	--减速效果
	inst.components.equippable.walkspeedmult=def.walkspeedmult or 1
	
	--安全点燃
	inst:AddComponent("lighter")
	inst.components.lighter:SetOnLightFn(function(inst,target)
		inst.components.finiteuses:Use(.25)
	end)
	
	----被填充弹药
	inst:AddComponent("trader")
    inst.components.trader:SetAcceptTest(AcceptTest)
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader.onrefuse = OnRefuseItem

	return inst
end

STRINGS.NAMES[string.upper("z_firegun")]=def.zg_name
STRINGS.CHARACTERS.GENERIC.DESCRIBE[string.upper("z_firegun")]=def.zg_desc
return Prefab("z_firegun", fn, def.assets)