--单手格斗武器	前缀 z_
local prefix="z_"

local manshape_defs={
	--骨爪
	{
		name="boneclaw",
		zg_name=zg_ischs("九阴白骨爪(伤害80,+50%对不死族的伤害)","Boneclaw"),
		zg_desc=zg_ischs("用它抓黑板的声音别提多有趣了","It is fun to use it to claw blackboard to make sound"),
		damage=80,	--伤害
		uses=200,	--耐久
		onattack=function(inst, attacker, target)
			if target and target:HasTag("zg_skel") then
				if target.components.health and not target.components.health:IsDead() then
					target.components.combat:Zg_GetAttacked(attacker, 40)
				end
			end	
		end,
	},
	--砍斧
	{
		name="cutaxe",
		scale=3,
		zg_name=zg_ischs("砍斧","Cutaxe"),
		zg_desc=zg_ischs("它们有一股唤醒噩梦的力量","The are near to nightmares"),
		damage=100,	--伤害
		uses=150,	--耐久
		istool=true,
		toolaction=ACTIONS.CHOP,
		effectiveness=2,
	},
	--骨剑
	{
		name="bonesword",
		--scale=3,
		zg_name=zg_ischs("精致的骨剑(伤害110,+50%对不死族的伤害)","Bonesword"),
		zg_desc=zg_ischs("骨头啊骨头","Bone"),
		damage=110,	--伤害
		uses=200,	--耐久
		--istool=true,
		--toolaction=ACTIONS.CHOP,
		--effectiveness=2,
		onattack=function(inst, attacker, target)
			if target and target:HasTag("zg_skel") then
				if target.components.health and not target.components.health:IsDead() then
					target.components.combat:Zg_GetAttacked(attacker, 55)
				end
			end	
		end,
	},
}


local function MakeManshape(def)
	
	def.assets={
		Asset("ANIM","anim/"..prefix..def.name..".zip"),
		Asset("ANIM","anim/"..prefix..def.name.."_s.zip"),
		Asset("ATLAS","images/"..prefix..def.name.."_i.xml"),
	}
	
	local function onequip(inst, owner)
		owner.AnimState:OverrideSymbol("swap_object", prefix..def.name.."_s", prefix..def.name.."_s")
		owner.AnimState:Show("ARM_carry")
		owner.AnimState:Hide("ARM_normal")
		if def.onequipff then def.onequipff(inst, owner) end
	end

	local function onunequip(inst, owner)
		owner.AnimState:Hide("ARM_carry")
		owner.AnimState:Show("ARM_normal")
		if def.onunequipff then def.onunequipff(inst, owner) end
	end

	local function fn()
		local inst = CreateEntity()

		inst.entity:AddTransform()
		inst.entity:AddAnimState()
		
		local s=def.scale or 1
		inst.AnimState:SetScale(s,s,s)
		
		inst.entity:AddNetwork()
		inst.entity:AddSoundEmitter()

		MakeInventoryPhysics(inst)

		--地上图片
		inst.AnimState:SetBank(prefix..def.name)
		inst.AnimState:SetBuild(prefix..def.name)
		inst.AnimState:PlayAnimation(def.anim or "NewAnimation")

		inst.entity:SetPristine()

		if not TheWorld.ismastersim then
			return inst
		end

		inst:AddComponent("weapon")
		inst.components.weapon:SetDamage(def.damage or 35)
		inst.components.weapon:SetRange(def.attackrange or 0, def.hitrange or def.attackrange or 0)
		inst.components.weapon.stimuli=def.stimuli or nil
		inst.components.weapon.onattack=def.onattack or function(inst,attacker,target) end
			
		inst:AddComponent("finiteuses")
		inst.components.finiteuses:SetMaxUses(def.uses or 150)
		inst.components.finiteuses:SetUses(def.uses or 150)
		inst.components.finiteuses:SetOnFinished(inst.Remove)

		inst:AddComponent("inspectable")

		--物品栏图片
		inst:AddComponent("inventoryitem")
		inst.components.inventoryitem.atlasname="images/"..prefix..def.name.."_i.xml"
		inst.components.inventoryitem.imagename=prefix..def.name.."_i"

		--手上图片
		inst:AddComponent("equippable")
		inst.components.equippable:SetOnEquip(onequip)
		inst.components.equippable:SetOnUnequip(onunequip)
		
		--减速效果
		inst.components.equippable.walkspeedmult=def.walkspeedmult or 1
		
		--工具
		if def.istool then
			inst:AddComponent("tool")
			inst.components.tool:SetAction(def.toolaction or ACTIONS.CHOP,def.effectiveness or 1)
			inst.components.finiteuses:SetConsumption(def.toolaction or ACTIONS.CHOP, 1)
		end

		return inst
	end
	return Prefab(prefix..def.name, fn, def.assets)
end

local manshapes = {}
for i, v in ipairs(manshape_defs) do
    table.insert(manshapes, MakeManshape(v))
	STRINGS.NAMES[string.upper(prefix..v.name)]=v.zg_name	--.. (v.damage and " DMG:"..v.damage) 
	STRINGS.CHARACTERS.GENERIC.DESCRIBE[string.upper(prefix..v.name)]=v.zg_desc
end
manshape_defs = nil
return unpack(manshapes)