

local manshape_defs={
	--青龙偃月刀
	{
		name="green",
		zg_name=zg_ischs("青龙偃月刀","Green Dragon Handle Sword"),
		zg_desc=zg_ischs("仿造关云长的武器","Handle Sword of Guan"),
		zg_isheavy=true,
		damage=70,
		uses=150,
		attackrange=2.5,
		hitrange=2.75,	
		walkspeedmult=.8,
		onequipff=function(inst, owner)
			owner.components.combat:SetAttackPeriod(1)
		end,
		onunequipff=function(inst, owner)
			owner.components.combat:SetAttackPeriod(0)
		end,
	}
}


local function MakeManshape(def)
	
	def.assets={
		Asset("ANIM","anim/z_"..def.name.."spear.zip"),
		Asset("ANIM","anim/z_"..def.name.."spear_s.zip"),
		Asset("ATLAS","images/z_"..def.name.."spear_i.xml"),
	}
	
	local function onequip(inst, owner)
		owner.AnimState:OverrideSymbol("swap_object", "z_"..def.name.."spear_s", "z_"..def.name.."spear_s")
		owner.AnimState:Show("ARM_carry")
		owner.AnimState:Hide("ARM_normal")
		if def.onequipff then def.onequipff(inst, owner) end
	end

	local function onunequip(inst, owner)
		owner.AnimState:Hide("ARM_carry")
		owner.AnimState:Show("ARM_normal")
		if def.onunequipff then def.onunequipff(inst, owner) end
	end

	local function fn()
		local inst = CreateEntity()

		inst.entity:AddTransform()
		inst.entity:AddAnimState()
		inst.entity:AddNetwork()
		inst.entity:AddSoundEmitter()

		MakeInventoryPhysics(inst)

		--地上图片
		inst.AnimState:SetBank("z_"..def.name.."spear")
		inst.AnimState:SetBuild("z_"..def.name.."spear")
		inst.AnimState:PlayAnimation("idle")
		
		inst:AddTag("zg_spear")
		if def.zg_isheavy then
			inst:AddTag("zg_heavy")
		end

		inst.entity:SetPristine()

		if not TheWorld.ismastersim then
			return inst
		end
		
		--文字
		--inst.zg_name=def.zg_name
		--inst.zg_desc=def.zg_desc
		
		--inst.zg_isheavy=def.zg_isheavy

		inst:AddComponent("weapon")
		inst.components.weapon:SetDamage(def.damage or 35)
		inst.components.weapon:SetRange(def.attackrange or .5, def.hitrange or def.attackrange or .5)
		inst.components.weapon.stimuli=def.stimuli or nil
			
		inst:AddComponent("finiteuses")
		inst.components.finiteuses:SetMaxUses(def.uses or 150)
		inst.components.finiteuses:SetUses(def.uses or 150)
		inst.components.finiteuses:SetOnFinished(inst.Remove)

		inst:AddComponent("inspectable")

		--物品栏图片
		inst:AddComponent("inventoryitem")
		inst.components.inventoryitem.atlasname="images/z_"..def.name.."spear_i.xml"
		inst.components.inventoryitem.imagename="z_"..def.name.."spear_i"
		--inst:ListenForEvent("ondropped", function(inst) 
		--	inst:DoTaskInTime(.25,function() 
		--		inst.SoundEmitter:PlaySound( "zg_melee/spear/ground"..( def.groundsound or 1) )
		--	end)
		--end)

		--手上图片
		inst:AddComponent("equippable")
		inst.components.equippable:SetOnEquip(onequip)
		inst.components.equippable:SetOnUnequip(onunequip)
		
		--减速效果
		inst.components.equippable.walkspeedmult=def.walkspeedmult or 1

		return inst
	end
	return Prefab("z_"..def.name.."spear", fn, def.assets)
end

local manshapes = {}
for i, v in ipairs(manshape_defs) do
    table.insert(manshapes, MakeManshape(v))
	STRINGS.NAMES[string.upper("z_"..v.name.."spear")]=v.zg_name.. (v.damage and " 伤害:"..v.damage) 
	STRINGS.CHARACTERS.GENERIC.DESCRIBE[string.upper("z_"..v.name.."spear")]=v.zg_desc
end
manshape_defs = nil
return unpack(manshapes)