local assets =
{
    Asset("ANIM", "anim/zg_armor_umbrella.zip"),
    Asset("ANIM", "anim/swap_zg_armor_umbrella.zip"),
	Asset("ATLAS", "images/zg_armor_umbrella.xml"),
    --Asset("ANIM", "anim/parasol.zip"),
    --Asset("ANIM", "anim/swap_parasol.zip"),
}

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_zg_armor_umbrella", "swap_umbrella")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")

    owner.DynamicShadow:SetSize(2.2, 1.4)

    --inst.components.fueled:StartConsuming()
end

local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")

    owner.DynamicShadow:SetSize(1.3, 0.6)

    --inst.components.fueled:StopConsuming()
end

local function OnAttack(inst, attacker, target)
	if target and target.components.health and not target.components.health:IsDead() and target.components.freezable then
		target.components.freezable:AddColdness(.33)
        target.components.freezable:SpawnShatterFX()
	end	
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("umbrella")
    inst.AnimState:SetBuild("zg_armor_umbrella")
    inst.AnimState:PlayAnimation("idle")  

    --inst:AddTag("nopunch")
    inst:AddTag("umbrella")

    --waterproofer (from waterproofer component) added to pristine state for optimization
    inst:AddTag("waterproofer")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("waterproofer")
	inst.components.waterproofer:SetEffectiveness(TUNING.WATERPROOFNESS_HUGE)
	
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("清凉好舒服")
	
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_armor_umbrella.xml"
	inst.components.inventoryitem.imagename = "zg_armor_umbrella"
	
    inst:AddComponent("equippable")
	inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    inst:AddComponent("insulator")
    inst.components.insulator:SetSummer()
	inst.components.insulator:SetInsulation(TUNING.INSULATION_MED)

	inst:AddComponent("weapon")
	inst.components.weapon:SetDamage(10)
	inst.components.weapon:SetAttackCallback(OnAttack)
	
	inst:AddComponent("armor")
	inst.components.armor:InitCondition(1500, .95)

    return inst
end

STRINGS.NAMES.ZG_ARMOR_UMBRELLA = "防弹伞(伤害10,冰冻附加,防具1500吸收95%)"
return Prefab("zg_armor_umbrella", fn, assets)