local assets=
{
	--Asset( "ANIM", "anim/zg_ch0_engineer.zip" ),
	Asset( "ANIM", "anim/zg_it_engineerhat.zip" ),
	Asset( "ANIM", "anim/q2banshou_s.zip" ),
	Asset("SOUNDPACKAGE", "sound/zg_ch0_engineer.fev"),
	Asset("SOUND", "sound/zg_ch0_engineer.fsb"),
}

----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 4, function(guy)
        return guy and guy:HasTag("character") and not guy:HasTag("playerghost") and not guy.components.container
				or (guy.components.combat and guy.components.combat.target and guy.components.combat.target:HasTag("zg_soldier") )
    end)
	if invader then
		if math.random() < .1 then
			inst.SoundEmitter:PlaySound("zg_ch0_engineer/zg_ch0_engineer/call")
		end
		----分享目标
		inst.components.combat:SetTarget(invader)
		inst.components.combat:ShareTarget(invader, 100, function(dude)
			return dude:HasTag("zg_soldier") and not dude:HasTag("zg_engineer")
		end, 20)
	end
    return invader
end
local function KeepTargetFn(inst, target)
    return target and inst.components.combat:CanTarget(target) and (inst:GetPosition():Dist(target:GetPosition())<=(inst.Physics:GetRadius()+5))    
end

SetSharedLootTable( 'zg_ch0_engineer',
{
	{'q4banshou',          	.5},
	{'q4banshou',          	.5},
	{'goldnugget',          	.5},
})

----	击中玩家	特点	--模板
local function onattack(inst,data)
    local victim = data.target
	if victim and victim:HasTag("character") then
		
	end
end

----	被攻击时
local function OnAttacked(inst, data)
	----	群体反攻玩家
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) and not attacker:HasTag("zg_soldier") then
			inst.components.combat:SetTarget(attacker)
			inst.components.combat:ShareTarget(attacker, 100, function(dude)
				return dude:HasTag("zg_soldier") and not dude:HasTag("zg_engineer")
			end, 20)
		end
	end
end
------------------------------------------------------------------------------------------

----	武器栏
local function GetInventory(inst)
	if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
		local meleeweapon = CreateEntity()
		meleeweapon.entity:AddTransform()
		meleeweapon:AddComponent("weapon")
		meleeweapon.components.weapon:SetDamage(60 * TUNING.ZG_DIFFICULTY)	
		meleeweapon:AddComponent("inventoryitem")
		meleeweapon.persists = false
		meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
		meleeweapon:AddComponent("equippable")
		meleeweapon.components.equippable:SetOnEquip(function()
			inst.AnimState:OverrideSymbol("swap_object", "q2banshou_s", "q2banshou_s")
			inst.AnimState:Show("ARM_carry") 
			inst.AnimState:Hide("ARM_normal")
		end)
		inst.components.inventory:Equip(meleeweapon)
	end
end

----------------------------------------------------------------------------------------------

local function common()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("zg_USA_bubing")
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:OverrideSymbol("swap_hat", "zg_it_engineerhat", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")
	
	inst.AnimState:OverrideSymbol("backpack", "swap_backpack", "backpack")
	inst.AnimState:OverrideSymbol("swap_body", "swap_backpack", "swap_body")
	
	MakeCharacterPhysics(inst, 100, .5)
    
	inst.entity:AddSoundEmitter()
	
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 2, 1 )
	
	inst.entity:AddNetwork()

	inst:AddTag("zg_soldier")
	inst:AddTag("zg_engineer")
	
	inst:AddTag("healthinfo")
	inst:AddTag("scarytoprey")
	inst:AddTag("hostile")
	inst:AddTag("shadowboss")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end 

    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed= 5
    inst.components.locomotor.runspeed = 5
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(true)
    
	-------------------------------------------------------------------------------------------------------
    inst:AddComponent("health")
    if TheWorld.state.cycles < 20 then
		inst.components.health:SetMaxHealth(125)
	elseif TheWorld.state.cycles < 35 then
		inst.components.health:SetMaxHealth(150)
	elseif TheWorld.state.cycles < 55 then
		inst.components.health:SetMaxHealth(175)
	elseif TheWorld.state.cycles < 70 then
		inst.components.health:SetMaxHealth(200)
	elseif TheWorld.state.cycles < 140 then
		inst.components.health:SetMaxHealth(225)
	else
		inst.components.health:SetMaxHealth(250)
	end
    
    inst:AddComponent("knownlocations")
    inst:AddComponent("inventory")
    
	inst:AddComponent("talker")
  
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(10 * TUNING.ZG_DIFFICULTY)						----常常不是空手, 因此无用
    inst.components.combat:SetAttackPeriod(1)						----攻击频率取决于SG, 不在这里
    inst.components.combat:SetRange(3)
    inst.components.combat.hiteffectsymbol = "torso"
    inst.components.combat:SetRetargetFunction(1, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	inst.components.combat:SetHurtSound("zg_ch0_engineer/zg_ch0_engineer/hit")
	
	----	攻击特效
	inst:ListenForEvent("onattackother", onattack)

    inst:AddComponent("lootdropper")
	
	----	监听事件
    inst:ListenForEvent("attacked", OnAttacked)
    
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("他们就是 斧头帮 所说的 童子军!")
	
    return inst
end
-----------------------------------------------------------------------
local function fn()
	local inst = common()
	
	if not TheWorld.ismastersim then
        return inst
    end 
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch0_engineer")

    local brain = require "brains/zg_ch0_engineer"
    inst:SetBrain(brain)

	GetInventory(inst)

	MakeMediumBurnableCharacter(inst, "torso")
	MakeMediumFreezableCharacter(inst, "torso")
	
	inst.components.lootdropper:SetChanceLootTable('zg_ch0_engineer')
	
	return inst
end

------------------------------------------------------------------------
STRINGS.NAMES.ZG_CH0_ENGINEER = "童子军工程师" 
return Prefab ("zg_ch0_engineer", fn, assets)