local assets=
{
	Asset( "ANIM", "anim/zg_USA_bubing.zip" ),
	Asset( "ANIM", "anim/zg_it_usahat.zip" ),
	Asset( "ANIM", "anim/zg_it_usahat0.zip" ),	
	Asset( "ANIM", "anim/swap_cutlass.zip" ),
}

----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 15, function(guy)
        return guy and guy:HasTag("character") and not guy:HasTag("playerghost") and not guy.components.container
				or (guy.components.combat and guy.components.combat.target and guy.components.combat.target:HasTag("zg_soldier") )
    end)
	if invader then
		if math.random() < .1 then
			inst.SoundEmitter:PlaySound("dontstarve/zg/ch0_soldier/call")
		end
		----分享目标
		inst.components.combat:SetTarget(invader)
		inst.components.combat:ShareTarget(invader, 100, function(dude)
			return dude:HasTag("zg_soldier")	
		end, 20)
	end
    return invader
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)    
end

SetSharedLootTable( 'zg_ch0_soldier',
{
	{'zg_weapon_ak47',          	0.25},
	{'zg_it_ak47bullet',          	0.75},
})

----	击中玩家	特点	--模板
local function onattack(inst,data)
    local victim = data.target
	if victim and victim:HasTag("character") then
		
	end
end

----	被攻击时
local function OnAttacked(inst, data)
	
	
	----	群体反攻玩家
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) and not attacker:HasTag("zg_soldier") then
			inst.components.combat:SetTarget(attacker)
			inst.components.combat:ShareTarget(attacker, 100, function(dude)
				return dude:HasTag("zg_soldier")	
			end, 20)
			
		end
	end
end
------------------------------------------------------------------------------------------

----	武器栏
local function GetInventory(inst)
	if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
		local meleeweapon = CreateEntity()
		meleeweapon.entity:AddTransform()
		meleeweapon:AddComponent("weapon")
		meleeweapon.name = "ak"
		meleeweapon.components.weapon:SetDamage(21 * TUNING.ZG_DIFFICULTY)			----三连发
		meleeweapon.components.weapon:SetRange(10, 12)
		meleeweapon.components.weapon:SetProjectile("zg_fx_bullet_enemy")
		meleeweapon.components.weapon.stimuli = "zg_ele_bullet"
		
		meleeweapon:AddComponent("inventoryitem")
		meleeweapon.persists = false
		meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
		meleeweapon:AddComponent("equippable")
		meleeweapon.components.equippable:SetOnEquip(function()
			inst.AnimState:OverrideSymbol("swap_object", "zg_swap_weapon_ak47", "zg_swap_weapon_ak47")
			inst.AnimState:Show("ARM_carry") 
			inst.AnimState:Hide("ARM_normal")
		end)
		meleeweapon:AddTag("ak")
		inst.components.inventory:Equip(meleeweapon)
		inst.zg_bullet = 90
	end
end

----------------------------------------------------------------------------------------------

local function common()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("zg_USA_bubing")
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:OverrideSymbol("swap_hat", "zg_it_usahat", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")
	
	MakeCharacterPhysics(inst, 100, .5)
    
	inst.entity:AddSoundEmitter()
	
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 2, 1 )
	
	inst.entity:AddNetwork()

	inst:AddTag("zg_soldier")
	inst:AddTag("healthinfo")
	inst:AddTag("scarytoprey")
	inst:AddTag("hostile")
	inst:AddTag("shadowboss")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end 

    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed= 4
    inst.components.locomotor.runspeed = 4
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(true)
    
	-------------------------------------------------------------------------------------------------------
    inst:AddComponent("health")
    if TheWorld.state.cycles < 20 then
		inst.components.health:SetMaxHealth(125)
	elseif TheWorld.state.cycles < 35 then
		inst.components.health:SetMaxHealth(150)
	elseif TheWorld.state.cycles < 55 then
		inst.components.health:SetMaxHealth(175)
	elseif TheWorld.state.cycles < 70 then
		inst.components.health:SetMaxHealth(200)
	elseif TheWorld.state.cycles < 140 then
		inst.components.health:SetMaxHealth(225)
	else
		inst.components.health:SetMaxHealth(250)
	end
    
    inst:AddComponent("knownlocations")
    inst:AddComponent("inventory")
    
	inst:AddComponent("talker")
	
	--inst:AddComponent("leader")
  
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(10 * TUNING.ZG_DIFFICULTY)						----常常不是空手, 因此无用
    inst.components.combat:SetAttackPeriod(0)						----攻击频率取决于SG, 不在这里
    inst.components.combat:SetRange(3)
    inst.components.combat.hiteffectsymbol = "torso"
    inst.components.combat:SetRetargetFunction(1, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	inst.components.combat:SetHurtSound("dontstarve/zg/ch0_soldier/hit")
	
	----	攻击特效
	inst:ListenForEvent("onattackother", onattack)

    inst:AddComponent("lootdropper")
	
	----	监听事件
    inst:ListenForEvent("attacked", OnAttacked)
    
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("他们就是 斧头帮 所说的 童子军!")
	
    return inst
end
-----------------------------------------------------------------------
local function fn()
	local inst = common()
	
	if not TheWorld.ismastersim then
        return inst
    end 
	
	----	定位队长
	inst:AddComponent("follower")
	--inst:DoPeriodicTask(2, function()
		local nearest = FindEntity(inst, 30, function(guy)
			return guy and guy.prefab == "zg_ch0_soldier0"
		end)
		if nearest and nearest.components.leader then
			nearest.components.leader:AddFollower(inst)
			inst.Master = nearest
		end
	--end)
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch0_soldier")

    local brain = require "brains/zg_ch0_soldier"
    inst:SetBrain(brain)

	GetInventory(inst)
	
	inst:AddComponent("sleeper")
    inst.components.sleeper:SetResistance(3)
	
	MakeMediumBurnableCharacter(inst, "torso")
	MakeMediumFreezableCharacter(inst, "torso")
	
	inst.components.lootdropper:SetChanceLootTable('zg_ch0_soldier')
	
	inst.zg_kill_num = 0
	inst.OnSave = function(inst, data)
		if data then
			data.zg_kill_num = inst.zg_kill_num
		end
	end
	inst.OnLoad = function(inst, data)
		inst.zg_kill_num = data and data.zg_kill_num or 0
	end
	
	inst:ListenForEvent("killed", function (inst, data)
		if data and data.victim then
			inst.zg_kill_num = inst.zg_kill_num + 1
			if inst.zg_kill_num >= 3 then
				----升级
				local pos = inst:GetPosition()
				local man = SpawnPrefab("zg_ch0_soldier0")
				if man then
					man.Transform:SetPosition(pos:Get())
					--if man.SoundEmitter then
					--	man.SoundEmitter:PlaySound("zg_ch0_soldier/zg_ch0_soldier/upgrade")
					--end
				end
				
				local fx = SpawnPrefab("zg_fx_upgrade_soldier")
				if fx then
					local x,y,z = pos:Get()
					fx.Transform:SetPosition(x,y+3,z)
					fx.Transform:SetScale(1.5, 1.5,1.5)
					if fx.SoundEmitter then
						fx.SoundEmitter:PlaySound("zg_ch0_soldier/zg_ch0_soldier/upgrade")
					end
				end
				
				inst:Remove()
			end
		end
	end)
	
	return inst
end
------------------------------------------------------------------------
----	武器栏
local function GetInventory0(inst)
	if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
		local meleeweapon = CreateEntity()
		meleeweapon.entity:AddTransform()
		meleeweapon:AddComponent("weapon")
		meleeweapon.name = "ak"
		meleeweapon.components.weapon:SetDamage(21* TUNING.ZG_DIFFICULTY)			----三连发
		meleeweapon.components.weapon:SetRange(15, 17)
		meleeweapon.components.weapon:SetProjectile("zg_fx_bullet_enemy")
		meleeweapon.components.weapon.stimuli = "zg_ele_bullet"
		
		meleeweapon:AddComponent("inventoryitem")
		meleeweapon.persists = false
		meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
		meleeweapon:AddComponent("equippable")
		meleeweapon.components.equippable:SetOnEquip(function()
			inst.AnimState:OverrideSymbol("swap_object", "zg_swap_weapon_m4", "zg_swap_weapon_m4")
			inst.AnimState:Show("ARM_carry") 
			inst.AnimState:Hide("ARM_normal")
		end)
		meleeweapon:AddTag("ak")
		inst.components.inventory:Equip(meleeweapon)
	end
end

SetSharedLootTable( 'zg_ch0_soldier0',
{
	{'zg_weapon_m4',          	0.2},
	{'zg_it_ak47bullet',          	1},
})

local function fn0()
	local inst = common()
	
	inst.AnimState:OverrideSymbol("swap_hat", "zg_it_usahat0", "swap_hat")
	inst.AnimState:OverrideSymbol("beard", "beard", "beard_medium")
	
	if not TheWorld.ismastersim then
        return inst
    end 
	
	inst:AddComponent("leader")
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch0_soldier")

    local brain = require "brains/zg_ch0_soldier0"
    inst:SetBrain(brain)
	
	if TheWorld.state.cycles < 20 then
		inst.components.health:SetMaxHealth(175)
	elseif TheWorld.state.cycles < 35 then
		inst.components.health:SetMaxHealth(200)
	elseif TheWorld.state.cycles < 55 then
		inst.components.health:SetMaxHealth(225)
	elseif TheWorld.state.cycles < 70 then
		inst.components.health:SetMaxHealth(250)
	elseif TheWorld.state.cycles < 140 then
		inst.components.health:SetMaxHealth(275)
	else
		inst.components.health:SetMaxHealth(300)
	end

	GetInventory0(inst)
	
	MakeMediumBurnableCharacter(inst, "torso")
	MakeMediumFreezableCharacter(inst, "torso")
	
	inst:AddComponent("sleeper")
    inst.components.sleeper:SetResistance(3)
	
	inst.components.lootdropper:SetChanceLootTable('zg_ch0_soldier0')
	
	return inst
end
------------------------------------------------------------------------

SetSharedLootTable( 'zg_ch0_soldier00',
{
	{'charcoal',     1.0},
    {'charcoal',     1.0},
	
	{'armorruins',          0.25},
	{'zg_it_ak47bullet',          	1},

	{'krampus_sack',          0.03},
	
})

local function fn00()
	local inst = common()
	
	inst:RemoveTag("healthinfo")
	
	inst.AnimState:OverrideSymbol("swap_hat", "hat_bush", "swap_hat")
	inst.AnimState:OverrideSymbol("beard", "beard", "beard_long")
	inst.AnimState:OverrideSymbol("swap_body", "swap_krampus_sack", "backpack")
	inst.AnimState:OverrideSymbol("swap_body", "swap_krampus_sack", "swap_body")
	
	if not TheWorld.ismastersim then
        return inst
    end 
	
	inst:AddComponent("leader")
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch0_soldier")
    local brain = require "brains/zg_ch0_soldier00"
    inst:SetBrain(brain)
	
	--inst.components.health:SetMaxHealth(200)		----新任坎普斯
	if TheWorld.state.cycles < 20 then
		inst.components.health:SetMaxHealth(200)
	elseif TheWorld.state.cycles < 35 then
		inst.components.health:SetMaxHealth(210)
	elseif TheWorld.state.cycles < 55 then
		inst.components.health:SetMaxHealth(220)
	elseif TheWorld.state.cycles < 70 then
		inst.components.health:SetMaxHealth(230)
	elseif TheWorld.state.cycles < 140 then
		inst.components.health:SetMaxHealth(240)
	else
		inst.components.health:SetMaxHealth(250)
	end

	GetInventory0(inst)		--按照队长
	
	inst.components.lootdropper:SetChanceLootTable('zg_ch0_soldier00')
	
	inst.components.inspectable:SetDescription("火鸡啊, 别把我的浆果吃完啦!")
	
	----	伪装
	inst:DoPeriodicTask(.5, function(inst)
		local invader = nil
		invader = FindEntity(inst, 15, function(guy)
			return guy and guy:HasTag("character") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
					or (guy.components.combat and guy.components.combat.target and guy.components.combat.target:HasTag("zg_soldier") )
		end)
		if invader then
			----有目标则起身射击
			if inst.sg and inst.sg:HasStateTag("hiding") then
				inst.sg:GoToState("idle")
				inst.components.combat:SetTarget(invader)		
			end
		else
			----没入侵者 且 无 攻击目标 则伪装
			if inst.sg and not inst.sg:HasStateTag("hiding") then
				if inst.components.combat and inst.components.combat.target == nil then
					inst.sg:GoToState("hide")
				end
			end
		end
	end)
	
	return inst
end

------------------------------------------------------------------------
STRINGS.NAMES.ZG_CH0_SOLDIER = "童子军大兵" 
STRINGS.NAMES.ZG_CH0_SOLDIER0 = "童子军队长"
STRINGS.NAMES.ZG_CH0_SOLDIER00 = "浆果灌木丛"
return Prefab ("zg_ch0_soldier", fn, assets),
	Prefab ("zg_ch0_soldier0", fn0, assets),
	Prefab ("zg_ch0_soldier00", fn00, assets)