local assets=
{	
	Asset( "ANIM", "anim/zg_ch0_sweeper.zip" ),
	Asset( "ANIM", "anim/zg_swap_axehat.zip" ),
}

----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 15, function(guy)
        return guy and guy:HasTag("character") and not guy:HasTag("playerghost") and not guy.components.container
    end)
	if invader then
		if inst.sg and inst.sg:HasStateTag("axe_dance") then
			inst.sg:GoToState("idle")
		end
	end
    return invader
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)    
end

SetSharedLootTable( 'zg_ch0_sweeper1',
{
	{'zg_weapon_axe',          		0.33},
	{'zg_it_shotgunbullet',          		0.4},
	{'zg_it_minigunbullet',          		0.3},
})
SetSharedLootTable( 'zg_ch0_sweeper2',
{
	{'zg_weapon_axe0',          		0.33},
	{'zg_it_shotgunbullet',          		0.40},
	{'zg_it_minigunbullet',          		0.35},
})
SetSharedLootTable( 'zg_ch0_sweeper3',
{
	{'zg_weapon_shotgun',          		0.5},
	{'zg_it_shotgunbullet',          		1},
	{'zg_it_shotgunbullet',          		0.5},
	{'zg_it_minigunbullet',          		0.3},
})
SetSharedLootTable( 'zg_ch0_sweeper4',
{
	{'zg_weapon_minigun',          		0.5},
	{'zg_it_shotgunbullet',          		0.2},
	{'zg_it_minigunbullet',          		1},
	{'zg_it_minigunbullet',          		0.25},
})

----	被攻击时
local function OnAttacked(inst, data)
	
	
	----	群体反攻玩家
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) and not attacker:HasTag("zg_axe") then
			inst.components.combat:SetTarget(attacker)
			
			----	斧头帮兄弟们停止跳舞
			local x, y, z = inst.Transform:GetWorldPosition()
			local ents = TheSim:FindEntities(x, y, z, 30, {"zg_axe"})
			for k,v in pairs(ents) do
				if v and v.sg and v.sg:HasStateTag("axe_dance") then
					v.sg:GoToState("idle")
				end
			end
			
			----	"一只穿云箭, 千军万马来相见"
			----	斧头帮的兄弟们抄家伙
			inst.components.combat:ShareTarget(attacker, 30, function(dude)
				return dude:HasTag("zg_axe")	
			end, 20)
			
		end
	end
end
------------------------------------------------------------------------------------------

----	武器栏
local function GetInventory(inst)
	local weaponrandom = math.random()
	if weaponrandom < .5 then
		if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
			local meleeweapon = CreateEntity()
			meleeweapon.entity:AddTransform()
			meleeweapon:AddComponent("weapon")
			meleeweapon.components.weapon:SetDamage(30 * TUNING.ZG_DIFFICULTY)
			meleeweapon:AddComponent("inventoryitem")
			meleeweapon.persists = false
			meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
			meleeweapon:AddComponent("equippable")
			meleeweapon.components.equippable:SetOnEquip(function()
				inst.AnimState:OverrideSymbol("swap_object", "zg_swap_axe", "swap_axe")
				inst.AnimState:Show("ARM_carry") 
				inst.AnimState:Hide("ARM_normal")
			end)
			meleeweapon:AddTag("meleeweapon")
			inst.components.inventory:Equip(meleeweapon)
			inst.zg_loot = 1
		end
	elseif weaponrandom < .75 then
		if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
			local meleeweapon = CreateEntity()
			meleeweapon.entity:AddTransform()
			meleeweapon.name = "boomerangaxe"
			meleeweapon:AddComponent("weapon")
			meleeweapon.components.weapon:SetDamage(30 * TUNING.ZG_DIFFICULTY)
			meleeweapon.components.weapon:SetRange(15, 30)
			meleeweapon.components.weapon:SetProjectile("zg_fx_axe")
			meleeweapon:AddComponent("inventoryitem")
			meleeweapon.persists = false
			meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
			meleeweapon:AddComponent("equippable")
			meleeweapon.components.equippable:SetOnEquip(function()
				inst.AnimState:OverrideSymbol("swap_object", "zg_swap_axe", "swap_axe")
				inst.AnimState:Show("ARM_carry") 
				inst.AnimState:Hide("ARM_normal")
			end)
			meleeweapon:AddTag("meleeweapon")
			inst.components.inventory:Equip(meleeweapon)
			inst.zg_loot = 2
		end	
	elseif weaponrandom < .875 then
		if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
			local meleeweapon = CreateEntity()
			meleeweapon.entity:AddTransform()
			meleeweapon.name = "shortgun"
			meleeweapon:AddComponent("weapon")
			meleeweapon.components.weapon:SetDamage(45 * TUNING.ZG_DIFFICULTY)
			meleeweapon.components.weapon:SetRange(13, 15)
			meleeweapon.components.weapon:SetProjectile("zg_fx_bullet_enemy")
			meleeweapon.components.weapon.stimuli = "zg_ele_bullet"
			
			meleeweapon:AddComponent("inventoryitem")
			meleeweapon.persists = false
			meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
			meleeweapon:AddComponent("equippable")
			meleeweapon.components.equippable:SetOnEquip(function()
				inst.AnimState:OverrideSymbol("swap_object", "zg_we_zhongzheng_swap", "zg_we_zhongzheng_swap")
				inst.AnimState:Show("ARM_carry") 
				inst.AnimState:Hide("ARM_normal")
			end)
			meleeweapon:AddTag("meleeweapon")
			inst.components.inventory:Equip(meleeweapon)
			inst.zg_loot = 3
			inst.zg_bullet = 30
		end
	else
		if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
			local meleeweapon = CreateEntity()
			meleeweapon.entity:AddTransform()
			meleeweapon.name = "prifle"
			meleeweapon:AddComponent("weapon")
			meleeweapon.components.weapon:SetDamage(15 * TUNING.ZG_DIFFICULTY)
			meleeweapon.components.weapon:SetRange(9, 11)
			meleeweapon.components.weapon:SetProjectile("zg_fx_bullet_enemy")
			meleeweapon.components.weapon.stimuli = "zg_ele_bullet"
			
			meleeweapon:AddComponent("inventoryitem")
			meleeweapon.persists = false
			meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
			meleeweapon:AddComponent("equippable")
			meleeweapon.components.equippable:SetOnEquip(function()
				inst.AnimState:OverrideSymbol("swap_object", "zg_we_minim3_swap", "zg_we_minim3_swap")
				inst.AnimState:Show("ARM_carry") 
				inst.AnimState:Hide("ARM_normal")
			end)
			meleeweapon:AddTag("meleeweapon")
			inst.components.inventory:Equip(meleeweapon)
			inst.zg_loot = 4
			inst.zg_bullet = 90
		end
	end
end

----------------------------------------------------------------------------------------------

local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("zg_ch0_sweeper")
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:OverrideSymbol("swap_hat", "zg_swap_axehat", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")
	
	MakeCharacterPhysics(inst, 100, .5)
    
	inst.entity:AddSoundEmitter()
	
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 2, 1 )
	
	inst.entity:AddNetwork()

	inst:AddTag("zg_axe")
	inst:AddTag("healthinfo")
	inst:AddTag("scarytoprey")
	inst:AddTag("zg_music_axe")
	inst:AddTag("hostile")
	inst:AddTag("shadowboss")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end 

    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed= 4
    inst.components.locomotor.runspeed = 4
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(true)
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch0_sweeper")

    local brain = require "brains/zg_ch0_sweeper"
    inst:SetBrain(brain)
    
	-------------------------------------------------------------------------------------------------------
    inst:AddComponent("health")
	
	if TheWorld.state.cycles < 20 then
		inst.components.health:SetMaxHealth(100)
	elseif TheWorld.state.cycles < 35 then
		inst.components.health:SetMaxHealth(125)
	elseif TheWorld.state.cycles < 55 then
		inst.components.health:SetMaxHealth(150)
	elseif TheWorld.state.cycles < 70 then
		inst.components.health:SetMaxHealth(175)
	elseif TheWorld.state.cycles < 140 then
		inst.components.health:SetMaxHealth(200)
	else
		inst.components.health:SetMaxHealth(225)
	end
	
	MakeMediumBurnableCharacter(inst, "torso")
	MakeMediumFreezableCharacter(inst, "torso")
    
    inst:AddComponent("knownlocations")
    inst:AddComponent("inventory")
    
	inst:AddComponent("talker")
	
	inst:AddComponent("leader")
  
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(10)						----常常不是空手, 因此无用
    inst.components.combat:SetAttackPeriod(1.5)
    inst.components.combat:SetRange(2)
    inst.components.combat.hiteffectsymbol = "torso"
    inst.components.combat:SetRetargetFunction(1, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	inst.components.combat:SetHurtSound("dontstarve/zg/wilson/hit")
	
	inst:AddComponent("sleeper")
    inst.components.sleeper:SetResistance(3)

    inst:AddComponent("lootdropper")
	
	inst:DoTaskInTime(.25, function()
		----	掉落
		if inst.zg_loot == 1 then
			inst.components.lootdropper:SetChanceLootTable('zg_ch0_sweeper1')
		elseif inst.zg_loot == 2 then
			inst.components.lootdropper:SetChanceLootTable('zg_ch0_sweeper2')
			inst.components.combat:SetAttackPeriod(2)
		elseif inst.zg_loot == 3 then
			inst.components.lootdropper:SetChanceLootTable('zg_ch0_sweeper3')
		elseif inst.zg_loot == 4 then
			inst.components.lootdropper:SetChanceLootTable('zg_ch0_sweeper4')
		end
	end)
	
	----	监听事件
    inst:ListenForEvent("attacked", OnAttacked)
	
	----	武器
	GetInventory(inst)
    
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("无恶不作的斧头帮!")
	
    return inst
end

STRINGS.NAMES.ZG_CH0_SWEEPER = "斧头帮步兵" 
return Prefab ("zg_ch0_sweeper", fn, assets)