

----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10 + 15 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	----	敌视语句
	if invader then
		local sayrandom = math.random()
		if sayrandom < .05 then
			inst.components.talker:Say("嘎嘎嘎嘎嘎嘎嘎")
			inst.SoundEmitter:PlaySound("zg_voice_buggy/zg_voice_buggy/call1")
			
		elseif sayrandom < .1 then
			inst.components.talker:Say("我是吃了四分五裂果实的人")
			inst.SoundEmitter:PlaySound("zg_voice_buggy/zg_voice_buggy/call2")

		end
		inst.components.combat:ShareTarget(invader, 30, function(dude)
			return dude and dude:HasTag("zg_ch1_buggy_part")
		end, 10)
	end
    return invader
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end

----
SetSharedLootTable( 'zg_ch1_buggy',
{	
	{'gunpowder',					1.00},
	{'gunpowder',					1.00},
	{'gunpowder',					1.00},
	{'gunpowder',					1.00},
	{'gunpowder',					1.00},
	{'gunpowder',					1.00},
	{'gunpowder',					1.00},
	{'gunpowder',					1.00},
	{'gunpowder',					1.00},
	{'gunpowder',					1.00},
	
	{'zg_head_buggy', 		.33},
})


----

local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	--inst.AnimState:SetBank("template")
	inst.AnimState:SetBuild("zg_buggy")
	inst.AnimState:PlayAnimation("idle")
	
	--inst.AnimState:Hide("ARM_carry") 
    --inst.AnimState:Show("ARM_normal")
	
	inst.AnimState:OverrideSymbol("swap_object", "swap_cutlass", "swap_cutlass")
	inst.AnimState:Show("ARM_carry") 
	inst.AnimState:Hide("ARM_normal")
	inst.AnimState:Hide("tail")
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	--phys:CollidesWith(COLLISION.OBSTACLES)
    --phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	phys:CollidesWith(COLLISION.CHARACTERS)
    
	inst.entity:AddSoundEmitter()
	
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 2, 1 )
	
	inst.entity:AddNetwork()

	inst:AddTag("healthinfo")
	inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("scarytoprey")
	inst:AddTag("zg_music_onepiece")
	
	--inst:AddTag("zg_kaizaku")
	
	inst:AddTag("zg_ch1_buggy_master")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end 
	
	----	不会中毒，共性
    inst:AddComponent("eater")  
	inst.components.eater:SetDiet({ FOODGROUP.OMNI }, { FOODGROUP.OMNI})
    inst.components.eater.strongstomach = true
	local selfeater = inst.components.eater
	local old = selfeater.Eat
	function inst.components.eater:Eat(food)
		if selfeater:CanEat(food) then
			if food.components.edible.healthvalue < 1 then
				food.components.edible.healthvalue = 1
			end
		end
		return old(selfeater, food)
	end

	----	移动，共性
    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed= 4
    inst.components.locomotor.runspeed = 5
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(false)
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch1_buggy")

    local brain = require "brains/zg_ch_wolfgangbrain"
	local brain2 = require "brains/zg_ch1_buggybrain"
    inst:SetBrain(brain)
    
	-------------------------------------------------------------------------------------------------------
    inst:AddComponent("health")
	
	--local function GetHealth(inst)
		if TheWorld.state.cycles < 30 then
			inst.components.health:SetMaxHealth(150)
		elseif TheWorld.state.cycles < 60 then
			inst.components.health:SetMaxHealth(180)
		elseif TheWorld.state.cycles < 90 then
			inst.components.health:SetMaxHealth(210)
		elseif TheWorld.state.cycles < 120 then
			inst.components.health:SetMaxHealth(240)
		elseif TheWorld.state.cycles < 150 then
			inst.components.health:SetMaxHealth(270)
		else
			inst.components.health:SetMaxHealth(300)
		end
	--end
	
    --inst.components.health:SetMaxHealth(GetHealth(inst))
	--inst.components.health:StartRegen(2 * TUNING.ZG_DIFFICULTY, 5 * TUNING.ZG_DIFFICULTY_PERIOD)
	--inst.components.health.fire_damage_scale = 3
	--inst.components.health.destroytime = 5
	----	防御力
	inst.components.health:SetAbsorptionAmount(.85)
	
	--MakeMediumBurnableCharacter(inst, "torso")
    --inst.components.burnable:SetBurnTime(TUNING.PLAYER_BURN_TIME)
    
    inst:AddComponent("knownlocations")
    inst:AddComponent("inventory")
	
    inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = -TUNING.SANITYAURA_MED * 3
    
	inst:AddComponent("talker")
	
	inst:AddComponent("leader")
  
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(60 * TUNING.ZG_DIFFICULTY)						
    inst.components.combat:SetAttackPeriod(2)
    inst.components.combat:SetRange(2)
    inst.components.combat.hiteffectsymbol = "torso"
    inst.components.combat:SetRetargetFunction(3, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	
	inst.components.combat:SetAreaDamage(2, 0.6)					----范围攻击
	function inst.components.combat:DoAreaAttack(target, range, weapon, validfn, stimuli)
		local hitcount = 0
		local x, y, z = target.Transform:GetWorldPosition()
		local ents = TheSim:FindEntities(x, y, z, range, { "_combat" }, {"shadowboss"})			----AOE伤害忽略队友
		for i, ent in ipairs(ents) do
			if ent ~= target and
				ent ~= self.inst and
				self:IsValidTarget(ent) and
				(validfn == nil or validfn(ent)) then
				self.inst:PushEvent("onareaattackother", { target = target, weapon = weapon, stimuli = stimuli })
				ent.components.combat:Zg_GetAttacked(self.inst, self:CalcDamage(ent, weapon, self.areahitdamagepercent), weapon, stimuli)
				hitcount = hitcount + 1
			end
		end
		return hitcount
	end
	
	----	攻击特效
	--inst:ListenForEvent("onattackother", onattack)
	
	

    inst:AddComponent("lootdropper")
	----	掉落
	inst.components.lootdropper:SetChanceLootTable('zg_ch1_buggy')
	
	----	监听事件
    --inst:ListenForEvent("attacked", OnAttacked)
	
	--inst:DoTaskInTime(3, function()
	--	inst.SoundEmitter:PlaySound("zg_voice_buggy/zg_voice_buggy/call1")
	--end)
	
	--GetInventory(inst)
    
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("巴基船长")
	
	--inst.zg_canspilt = 1
	inst.zg_spilt_id = math.random(1000)
	
	--[[
	inst.OnSave = function(inst, data)
		data.zg_canspilt = inst.zg_canspilt
		data.zg_spilt_id = inst.zg_spilt_id
	end
	inst.OnLoad = function(inst, data)
		inst.zg_canspilt = data and data.zg_canspilt or 1
		inst.zg_spilt_id = data and data.zg_spilt_id or math.random(1000)
	end]]
	
	inst:ListenForEvent("death", function(inst)
		local pos = inst:GetPosition()
		local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, 1000, {"zg_ch1_buggy_part"}, {"FX", "NOCLICK", "DECOR", "INLIMBO"})
		for k, v in pairs(ents) do
			if v and v.zg_spilt_id == inst.zg_spilt_id then
				v:Remove()
			end
		end
	end)
	
	inst:ListenForEvent("healthdelta", function()
		if inst.components.health:GetPercent() < .75 and not inst.isspilted then
			inst:SetBrain(brain2)
			----四分五裂
			inst.AnimState:SetBuild("zg_buggy2")
			inst.AnimState:ClearOverrideSymbol("swap_object")
			inst.AnimState:Hide("ARM_carry") 
			inst.AnimState:Show("ARM_normal")
			inst.components.combat:SetDefaultDamage(30 * TUNING.ZG_DIFFICULTY)						
			inst.components.combat:SetAttackPeriod(3 - TUNING.ZG_DIFFICULTY)
			inst.components.combat:SetRange(1.5)
			
			local pos = inst:GetPosition()
			local p1 = SpawnPrefab("zg_ch1_buggy_body")
			p1.Transform:SetPosition(pos:Get())
			p1.zg_spilt_id = inst.zg_spilt_id
			p1.components.follower:SetLeader(inst)
			p1.zg_master = inst
			
			local p2 = SpawnPrefab("zg_ch1_buggy_head")
			p2.Transform:SetPosition(pos:Get())
			p2.zg_spilt_id = inst.zg_spilt_id
			p2.components.follower:SetLeader(inst)
			p2.zg_master = inst
			
			local p3 = SpawnPrefab("zg_ch1_buggy_hand")
			p3.Transform:SetPosition(pos:Get())
			p3.zg_spilt_id = inst.zg_spilt_id
			p3.components.follower:SetLeader(inst)
			p3.zg_master = inst
			
			local p4 = SpawnPrefab("zg_ch1_buggy_hand1")
			p4.Transform:SetPosition(pos:Get())
			p4.zg_spilt_id = inst.zg_spilt_id
			p4.components.follower:SetLeader(inst)
			p4.zg_master = inst
			
			inst.isspilted = true
			inst.SoundEmitter:PlaySound("zg_voice_buggy/zg_voice_buggy/split")
		--else
			--inst:SetBrain(brain)
		end
	end)
	
    return inst
end
--------------------------------------------------------------------------



local function fn_common()
	
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	trans:SetFourFaced()
	local anim = inst.entity:AddAnimState()
	inst.AnimState:Hide("tail")
	
	
	local sound = inst.entity:AddSoundEmitter()
	--MakeAmphibiousGhostPhysics(inst, 1, .5)
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.CHARACTERS)
	
	--inst.Transform:SetScale(1.5,1.5,1.5)
	
	--local brain = require "brains/zg_ch1_buggy_headbrain"
    --inst:SetBrain(brain)
	
	anim:SetBank("wilson")
    --anim:SetBuild("zg_buggy_head")
	--anim:PlayAnimation("idle", true)
	
	inst.entity:AddNetwork()

	inst:AddTag("healthinfo")
	inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("scarytoprey")
	inst:AddTag("zg_music_onepiece")
	
	inst:AddTag("zg_kaizaku")
	
	inst:AddTag("zg_ch1_buggy_part")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end 
	
	inst.persists = false
	
	inst:AddComponent("lootdropper")
	
	inst:AddComponent("inventory")
	
	inst:AddComponent("locomotor") -- locomotor must be constructed before the stategraph
    inst.components.locomotor.walkspeed = 9
    inst.components.locomotor.runspeed = 9
	
	inst:SetStateGraph("SGzg_ch1_buggy_part")
	
	inst:AddComponent("inspectable")
	
	inst:AddComponent("health")
    inst.components.health:SetMaxHealth(100)
	inst.components.health.absorb = 1
	inst.components.health:SetInvincible(true)
	inst.components.health.destroytime = 10*FRAMES
	
	inst:AddComponent("combat")
    inst.components.combat.defaultdamage = 10
	inst.components.combat.min_attack_period = 1
	
	inst:AddComponent("follower")
	
	inst.OnSave = function(inst, data)
		data.zg_spilt_id = inst.zg_spilt_id
	end
	inst.OnLoad = function(inst, data)
		inst.zg_spilt_id = data and data.zg_spilt_id or math.random(1000)
	end
	
	inst:DoTaskInTime(0, function()
		local master = nil
		master = FindEntity(inst, 1000, function(guy)
			return guy:HasTag("zg_ch1_buggy_master") and guy.zg_spilt_id == inst.zg_spilt_id
		end)
		if master then
			inst.components.follower:SetLeader(master)
		end
	end)
	
	inst:ListenForEvent("cycleschanged", function(src, cycles)
		local exist = false
		local pos = inst:GetPosition()
		local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, 1000, {"zg_ch1_buggy_master"}, {"FX", "NOCLICK", "DECOR", "INLIMBO"})
		for k, v in pairs(ents) do
			if v and v.zg_spilt_id == inst.zg_spilt_id then
				exist = true
			end
		end
		if not exist then
			inst:Remove()
		end
	end)
	
	return inst

end

--头
local function fn_head()
	local inst = fn_common()

    inst.AnimState:SetBuild("zg_buggy_head")
	inst.AnimState:PlayAnimation("idle", true)

    if not TheWorld.ismastersim then
        return inst
    end 
	
	local brain = require "brains/zg_ch1_buggy_headbrain"
    inst:SetBrain(brain)
	
    inst.components.combat.defaultdamage = 0
	inst.components.combat.min_attack_period = 1
	
	return inst
end

--身
local function fn_body()
	local inst = fn_common()

    inst.AnimState:SetBuild("zg_buggy_body")
	inst.AnimState:PlayAnimation("idle", true)

    if not TheWorld.ismastersim then
        return inst
    end 
	
	local brain = require "brains/zg_ch1_buggy_headbrain"
    inst:SetBrain(brain)
	
    inst.components.combat.defaultdamage = 0
	inst.components.combat.min_attack_period = 1
	
	return inst
end

local function fn_hand()
	local inst = fn_common()
	
    inst.AnimState:SetBuild("zg_buggy_hand")
	inst.AnimState:PlayAnimation("idle", true)
	
	inst.AnimState:OverrideSymbol("swap_object", "swap_cutlass", "swap_cutlass")
	inst.AnimState:Show("ARM_carry") 
	inst.AnimState:Hide("ARM_normal")

    if not TheWorld.ismastersim then
        return inst
    end 
	
	local brain = require "brains/zg_ch1_buggy_handbrain"
    inst:SetBrain(brain)
	
    inst.components.combat.defaultdamage = 60 * TUNING.ZG_DIFFICULTY
	inst.components.combat.min_attack_period = 2 - TUNING.ZG_DIFFICULTY
	
	return inst
end

local function fn_hand1()
	local inst = fn_common()

    inst.AnimState:SetBuild("zg_buggy_hand")
	inst.AnimState:PlayAnimation("idle", true)
	
	inst.AnimState:OverrideSymbol("swap_object", "swap_nightmaresword", "swap_nightmaresword")
	inst.AnimState:Show("ARM_carry") 
	inst.AnimState:Hide("ARM_normal")

    if not TheWorld.ismastersim then
        return inst
    end 
	
	local brain = require "brains/zg_ch1_buggy_handbrain"
    inst:SetBrain(brain)
	
    inst.components.combat.defaultdamage = 60 * TUNING.ZG_DIFFICULTY
	inst.components.combat.min_attack_period = 2 - TUNING.ZG_DIFFICULTY
	
	return inst
end


STRINGS.NAMES.ZG_CH1_BUGGY = "艺皇属下 巴基"
STRINGS.NAMES.ZG_CH1_BUGGY_BODY = "巴基船长的 身体"
STRINGS.NAMES.ZG_CH1_BUGGY_HAND = "巴基船长的 手臂"
STRINGS.NAMES.ZG_CH1_BUGGY_HAND1 = "巴基船长的 手臂"
STRINGS.NAMES.ZG_CH1_BUGGY_HEAD = "巴基船长的 头"

 
return Prefab ("zg_ch1_buggy", fn),
	Prefab ("zg_ch1_buggy_body", fn_body),
	Prefab ("zg_ch1_buggy_hand", fn_hand),
	Prefab ("zg_ch1_buggy_hand1", fn_hand1),
	Prefab ("zg_ch1_buggy_head", fn_head)









