local assets=
{
	----路飞
	Asset( "ANIM", "anim/zg_luffy.zip" ),
	--Asset( "ANIM", "anim/zg_luffy_zf.zip" ),
	
}
-----------------------------------------------------------------------------------------------------------
local function GetWeapon(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(0)
		meleeweapon.components.weapon:SetRange(15, 19)
		meleeweapon.components.weapon:SetProjectile("zg_fx_luffyhand2")
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end

local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10 + 15 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	----	敌视语句
	if invader then
		local sayrandom = math.random()
		if sayrandom < .025 then
			inst.SoundEmitter:PlaySound("zg_ch1_luffy/zg_ch1_luffy/call")
			if inst.components.talker then
				inst.components.talker:Say("我是要当海贼王的人!")
			end
		end
		
		
		if math.random() < .25 then
			----当和目标距离过大时使用橡胶手臂
			if not inst:IsNear(invader, 10) then
				inst.components.combat:SetTarget(invader)
				if not inst.sg:HasStateTag("skill") then
					GetWeapon(inst)
				end
			end
		end
		
	end
	
    return invader, true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end
-------------------------------------------------------------------------------------------------------------
SetSharedLootTable( 'zg_ch1_luffy',
{
	{'dragonpie',          1},
	{'dragonpie',          1},
	
	{'zg_luffyhead', 		.33},
})
-----------------------------------------------------------------------------------------------------

-----------------------------------------------------------------
-----------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
----------------------------
local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	--inst.AnimState:SetBank("template")
	inst.AnimState:SetBuild("zg_luffy")
	inst.AnimState:PlayAnimation("idle")
	
	inst.AnimState:Hide("ARM_carry") 
    inst.AnimState:Show("ARM_normal")
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	--phys:CollidesWith(COLLISION.OBSTACLES)
    --phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	phys:CollidesWith(COLLISION.CHARACTERS)
    
	inst.entity:AddSoundEmitter()
	
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 2, 1 )
	
	inst.entity:AddNetwork()

	inst:AddTag("healthinfo")
	inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("scarytoprey")
	inst:AddTag("zg_music_onepiece")
	
	inst:AddTag("zg_kaizaku")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end 
	
	---抗性
	inst.zg_inh_anti_bullet = 1
	inst.zg_max_anti_bullet = 1
	inst.zg_inh_anti_electric = 1
	inst.zg_max_anti_electric = 1
	
	
	----	不会中毒，共性
    inst:AddComponent("eater")  
	inst.components.eater:SetDiet({ FOODGROUP.OMNI }, { FOODGROUP.OMNI})
    inst.components.eater.strongstomach = true
	local selfeater = inst.components.eater
	local old = selfeater.Eat
	function inst.components.eater:Eat(food)
		if selfeater:CanEat(food) then
			if food.components.edible.healthvalue < 1 then
				food.components.edible.healthvalue = 1
			end
		end
		return old(selfeater, food)
	end
	
	inst:AddComponent("timer")
	
	----	移动，共性
    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed= 4
    inst.components.locomotor.runspeed = 7
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(false)
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch1_luffy")

    local brain = require "brains/zg_ch_wolfgangbrain"
    inst:SetBrain(brain)
    
	-------------------------------------------------------------------------------------------------------
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(200)
	--inst.components.health:StartRegen(2 * TUNING.ZG_DIFFICULTY, 5 * TUNING.ZG_DIFFICULTY_PERIOD)
	--inst.components.health.fire_damage_scale = 3
	--inst.components.health.destroytime = 5
	----	防御力
	inst.components.health:SetAbsorptionAmount(.9)
	
	--MakeMediumBurnableCharacter(inst, "torso")
    --inst.components.burnable:SetBurnTime(TUNING.PLAYER_BURN_TIME)
    
    inst:AddComponent("knownlocations")
    inst:AddComponent("inventory")
	
    inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = -TUNING.SANITYAURA_MED * 3
    
	inst:AddComponent("talker")
	
	inst:AddComponent("leader")
  
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage( 60 * TUNING.ZG_DIFFICULTY )						
    inst.components.combat:SetAttackPeriod( 2 )
    inst.components.combat:SetRange(3)
    inst.components.combat.hiteffectsymbol = "torso"
    inst.components.combat:SetRetargetFunction(1, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	
	inst.components.combat:SetAreaDamage(2, 0.6)					----范围攻击
	function inst.components.combat:DoAreaAttack(target, range, weapon, validfn, stimuli)
		local hitcount = 0
		local x, y, z = target.Transform:GetWorldPosition()
		local ents = TheSim:FindEntities(x, y, z, range, { "_combat" }, {"shadowboss"})			----AOE伤害忽略队友
		for i, ent in ipairs(ents) do
			if ent ~= target and
				ent ~= self.inst and
				self:IsValidTarget(ent) and
				(validfn == nil or validfn(ent)) then
				self.inst:PushEvent("onareaattackother", { target = target, weapon = weapon, stimuli = stimuli })
				ent.components.combat:Zg_GetAttacked(self.inst, self:CalcDamage(ent, weapon, self.areahitdamagepercent), weapon, stimuli)
				hitcount = hitcount + 1
			end
		end
		return hitcount
	end

    inst:AddComponent("lootdropper")
	----	掉落
	inst.components.lootdropper:SetChanceLootTable('zg_ch1_luffy')
	
	----   橡胶果实
    
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("艺皇属下的傀儡路飞")
	
	inst.canzhanfu = true
	inst.canpound = true
	inst:ListenForEvent("timerdone", function (inst, data)

		if data.name == "zhanfu" then
			inst.canzhanfu = true
		elseif data.name == "pound" then
			inst.canpound = true
		end
		
	end)
	
    return inst
end

STRINGS.NAMES.ZG_CH1_LUFFY = "艺皇属下 路飞 (电系免疫,子弹免疫)" 
return Prefab ("zg_ch1_luffy", fn, assets)