local assets=
{
	----山治
	Asset( "ANIM", "anim/zg_sanji.zip" ),
	Asset( "ANIM", "anim/zg_sanji_xft.zip" ),
	
}
-----------------------------------------------------------------------------------------------------------
----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10 + 15 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	----	敌视语句
	if invader then
		local sayrandom = math.random()
		if sayrandom < .05 then
			inst.SoundEmitter:PlaySound("dontstarve/zg/ch_sanji/call")
			inst.components.talker:Say("伙计, 给个草和树枝!")
		elseif sayrandom < .1 then
			inst.SoundEmitter:PlaySound("dontstarve/zg/ch_sanji/call")
			inst.components.talker:Say("基地在哪, 我来给你做饭！")
		end
		if not inst.components.combat:CanHitTarget(invader) 
			and wy_isalive(invader) and math.random()<.2 
			and not inst.sg:HasStateTag("skill")
			then
			inst:PushEvent("zg_ch1_sanji_moonstep",{target=invader})
		end
	end
    return invader
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end

-------------------------------------------------------------------------------------------------------------
SetSharedLootTable( 'zg_ch1_sanji',
{
	{'butterflymuffin',          0.2},
	{'frogglebunwich',          0.2},
	{'taffy',          0.2},
	{'pumpkincookie',          0.2},
	
	{'stuffedeggplant',          0.2},
	{'fishsticks',          0.2},
	{'honeynuggets',          0.2},
	{'honeyham',          0.2},
	
	{'dragonpie',          0.2},
	{'kabobs',          0.2},
	{'mandrakesoup',          0.2},
	{'baconeggs',          0.2},
	
	{'meatballs',          0.2},
	{'bonestew',          0.2},
	{'perogies',          0.2},
	{'turkeydinner',          0.2},
	
	{'ratatouille',          0.2},
	{'jammypreserves',          0.2},
	{'fruitmedley',          0.2},
	{'fishtacos',          0.2},
	
	{'waffles',          0.2},
	{'unagi',          0.2},
	
	{'flowersalad',          0.2},
	{'icecream',          0.2},
	{'watermelonicle',          0.2},
	
	{'trailmix',          0.2},
	{'hotchili',          0.2},
	{'guacamole',          0.2},
	
	{'zg_sanjihead', 		.33},
})
-----------------------------------------------------------------------------------------------------

----	击中玩家	特点	--模板
local function onattack(inst, data)
    local victim = data.target
	if victim and victim.SoundEmitter then
		victim.SoundEmitter:PlaySound("dontstarve/zg/ch_sanji/atk_leg")
	end
	if victim and victim.components.burnable and inst.firetick then
		victim.components.burnable:Ignite()
	end
end

------------------------------------------------------------------------------------------------------------
----------------------------
local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("zg_sanji")
	inst.AnimState:PlayAnimation("idle")
	
	inst.AnimState:Hide("ARM_carry") 
    inst.AnimState:Show("ARM_normal")
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	--phys:CollidesWith(COLLISION.OBSTACLES)
    --phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	phys:CollidesWith(COLLISION.CHARACTERS)
    
	inst.entity:AddSoundEmitter()
	
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 2, 1 )
	
	inst.entity:AddNetwork()

	inst:AddTag("healthinfo")
	inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("scarytoprey")
	inst:AddTag("zg_music_onepiece")
	
	inst:AddTag("zg_kaizaku")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end 
	
	----	不会中毒，共性
    inst:AddComponent("eater")  
	inst.components.eater:SetDiet({ FOODGROUP.OMNI }, { FOODGROUP.OMNI})
    inst.components.eater.strongstomach = true
	local selfeater = inst.components.eater
	local old = selfeater.Eat
	function inst.components.eater:Eat(food)
		if selfeater:CanEat(food) then
			if food.components.edible.healthvalue < 1 then
				food.components.edible.healthvalue = 1
			end
		end
		return old(selfeater, food)
	end

	----	移动，共性
    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed= 4
    inst.components.locomotor.runspeed = 5
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(false)
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch1_sanji")

    local brain = require "brains/zg_ch_wolfgangbrain"
    inst:SetBrain(brain)
    
	-------------------------------------------------------------------------------------------------------
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(200)
	--inst.components.health:StartRegen(2 * TUNING.ZG_DIFFICULTY, 5 * TUNING.ZG_DIFFICULTY_PERIOD)
	inst.components.health.fire_damage_scale = 0
	--inst.components.health.destroytime = 5
	----	防御力
	inst.components.health:SetAbsorptionAmount(.85)
    
    inst:AddComponent("knownlocations")
    inst:AddComponent("inventory")
	
    inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = -TUNING.SANITYAURA_MED * 3
    
	inst:AddComponent("talker")
	
	inst:AddComponent("leader")
  
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(60 * TUNING.ZG_DIFFICULTY)						
    inst.components.combat:SetAttackPeriod(2)
    inst.components.combat:SetRange(2)			
	inst.components.combat:SetAreaDamage(2, 0.6)					----范围攻击
    inst.components.combat.hiteffectsymbol = "torso"
    inst.components.combat:SetRetargetFunction(1, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	
	function inst.components.combat:DoAreaAttack(target, range, weapon, validfn, stimuli)
		local hitcount = 0
		local x, y, z = target.Transform:GetWorldPosition()
		local ents = TheSim:FindEntities(x, y, z, range, { "_combat" }, {"shadowboss"})			----AOE伤害忽略队友
		for i, ent in ipairs(ents) do
			if ent ~= target and
				ent ~= self.inst and
				self:IsValidTarget(ent) and
				(validfn == nil or validfn(ent)) then
				self.inst:PushEvent("onareaattackother", { target = target, weapon = weapon, stimuli = stimuli })
				ent.components.combat:Zg_GetAttacked(self.inst, self:CalcDamage(ent, weapon, self.areahitdamagepercent), weapon, stimuli)
				hitcount = hitcount + 1
			end
		end
		return hitcount
	end
	
	----	攻击特效
	inst:ListenForEvent("onhitother", onattack)	

    inst:AddComponent("lootdropper")
	----	掉落
	inst.components.lootdropper:SetChanceLootTable('zg_ch1_sanji')
    
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("没展示恶魔风脚")
	
	inst:AddComponent("timer")
	inst.canpound = true
	inst:ListenForEvent("timerdone", function (inst, data)

		if data.name == "pound" then		--旋风踢
			inst.canpound = true
		end
		
	end)
	
    return inst
end

STRINGS.NAMES.ZG_CH1_SANJI = "艺皇属下 山治" 
return Prefab ("zg_ch1_sanji", fn, assets)