local assets=
{
	--鹰眼
	Asset("ANIM", "anim/zg_ch2_mihawk.zip"),
	
	Asset("ANIM", "anim/zg_we_blacknight_swap.zip"),
	Asset("ANIM", "anim/zg_we_blacknight.zip"),
	Asset("ATLAS", "images/zg_we_blacknight.xml"),
	
	Asset("ANIM", "anim/zg_mihawk_jq.zip"),
	Asset("ANIM", "anim/zg_wzs_forcefield.zip"),
	Asset("ANIM", "anim/zg_hat_mihawk.zip"),
	Asset("ANIM", "anim/zg_fx_mihawkhsqj.zip"),
	
	Asset("SOUNDPACKAGE", "sound/zg_ch3_mihawk.fev"),
	Asset("SOUND", "sound/zg_ch3_mihawk.fsb"),	
}
-----------------------------------------------------------------------------------------------------------
----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = wy_FindEntity(inst, 60, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	----	敌视语句
	if invader then
		local sayrandom = math.random()
		if sayrandom < .05 then
			inst.SoundEmitter:PlaySound("zg_ch3_mihawk/zg_ch3_mihawk/call")
			if inst.components.talker then
				inst.components.talker:Say("闲来无事罢了!")
			end
		end
		if not inst.components.combat:CanHitTarget(invader) 
			and wy_isalive(invader) and math.random()<.25 
			and not inst.sg:HasStateTag("skill")
			then
			inst:PushEvent("zg_ch3_mihawk_moonstep",{target=invader})
		end
	end
    return invader,true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end
-------------------------------------------------------------------------------------------------------------
SetSharedLootTable( 'zg_ch3_mihawk',
{
	{'armorruins',          .5},
	{'ruinshat',          .5},
	{'thulecite',          .5},
	{'wall_ruins_item',          .5},
	{'nightmare_timepiece',          .5},
	{'orangeamulet',          .5},
	{'yellowamulet',          .5},
	{'greenamulet',          .5},
	{'orangestaff',          .5},
	{'yellowstaff',          .5},
	{'greenstaff',          .5},
	{'multitool_axe_pickaxe',          .5},
	{'ruins_bat',          .5},
	{'panflute',          .5},
	{'armor_sanity',          .5},
	{'nightsword',          .5},
	{'batbat',          .5},
	{'armorslurper',          .5},
	{'amulet',          .5},
	{'blueamulet',          .5},
	{'purpleamulet',          .5},
	{'firestaff',          .5},
	{'icestaff',          .5},
	{'telestaff',          .5},
})
-----------------------------------------------------------------------------------------------------

local function LaunchItem(inst, target, item)
    if item.Physics ~= nil then
        local x, y, z = item.Transform:GetWorldPosition()
        item.Physics:Teleport(x, .1, z)

        local vel = (target:GetPosition() - inst:GetPosition()):GetNormalized()
        local speed = 5 + math.random() * 2
        local angle = math.atan2(vel.z, vel.x) + (math.random() * 20 - 10) * DEGREES
        item.Physics:SetVel(math.cos(angle) * speed, 10, -math.sin(angle) * speed)
    end
end
----	击中玩家	特点	--模板
local function onattack(inst,data)
    local victim = data.target
	if victim then
		if victim:HasTag("player") then
			victim.SoundEmitter:PlaySound("dontstarve/zg/ch_law/atk")
			if math.random() < .5*TUNING.ZG_DIFFICULTY then
				local item = victim.components.inventory and victim.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
				if item then
					victim.components.inventory:DropItem(item)
					LaunchItem(inst, victim, item)
				end
			end
		end
	end
end

-----------------------------------------------------------------
-----------------------------------------------------------------
----	武器样式
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "zg_we_blacknight_swap", "zg_we_blacknight_swap")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end
local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

----	武器栏
local function GetInventory(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(120)
		meleeweapon.components.weapon:SetRange(2)
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
			----	武器外观
			meleeweapon.components.equippable:SetOnEquip(onequip)
			meleeweapon.components.equippable:SetOnUnequip(onunequip)
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end
------------------------------------------------------------------------------------------------------------
----------------------------
local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("zg_ch2_mihawk")
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:SetScale(1.25,1.25,1.25)
	
	inst.AnimState:OverrideSymbol("swap_hat", "zg_hat_mihawk", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")
	
	MakeCharacterPhysics(inst, 75, .5)
	inst.Physics:ClearCollisionMask()
    --phys:CollidesWith(COLLISION.WORLD)
    --phys:CollidesWith(COLLISION.OBSTACLES)
    --phys:CollidesWith(COLLISION.SMALLOBSTACLES)
    inst.Physics:CollidesWith(COLLISION.CHARACTERS)
	inst.Physics:CollidesWith(COLLISION.GROUND)
    --phys:CollidesWith(COLLISION.GIANTS)
	--[[
	local phys = inst.entity:AddPhysics()
	phys:SetMass(75)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.CHARACTERS)]]
    
	inst.entity:AddSoundEmitter()
	
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 2, 1 )
	
	inst.entity:AddNetwork()

	inst:AddTag("healthinfo")
	inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("scarytoprey")
	inst:AddTag("zg_stat_score")
	inst:AddTag("zg_music_onepiece2")
	
	--inst:AddTag("zg_kaizaku")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end 
	
	----	不会中毒，共性
    inst:AddComponent("eater")  
	inst.components.eater:SetDiet({ FOODGROUP.OMNI }, { FOODGROUP.OMNI})
    inst.components.eater.strongstomach = true
	local selfeater = inst.components.eater
	local old = selfeater.Eat
	function inst.components.eater:Eat(food)
		if selfeater:CanEat(food) then
			if food.components.edible.healthvalue < 1 then
				food.components.edible.healthvalue = 1
			end
		end
		return old(selfeater, food)
	end

	----	移动，共性
    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed= 6
    inst.components.locomotor.runspeed = 6
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(false)
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch3_mihawk")
    
	-------------------------------------------------------------------------------------------------------
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(1000)
	inst.components.health.fire_damage_scale = 0
	----	防御力
	inst.components.health:SetAbsorptionAmount(.8)
    
    inst:AddComponent("knownlocations")
    inst:AddComponent("inventory")
	
    inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = 0
    
	inst:AddComponent("talker")
	
	inst:AddComponent("leader")
  
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(60)						----常常不是空手, 因此无用
    inst.components.combat:SetAttackPeriod(2)
    inst.components.combat:SetRange(2)
    inst.components.combat.hiteffectsymbol = "torso"
    inst.components.combat:SetRetargetFunction(1, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	
	inst.components.combat:SetAreaDamage(3, 1)					----范围攻击
	function inst.components.combat:DoAreaAttack(target, range, weapon, validfn, stimuli)
		local hitcount = 0
		local x, y, z = target.Transform:GetWorldPosition()
		local ents = TheSim:FindEntities(x, y, z, range, { "_combat" }, {"shadowboss"})			----AOE伤害忽略队友
		for i, ent in ipairs(ents) do
			if ent ~= target and
				ent ~= self.inst and
				self:IsValidTarget(ent) and
				(validfn == nil or validfn(ent)) then
				self.inst:PushEvent("onareaattackother", { target = target, weapon = weapon, stimuli = stimuli })
				ent.components.combat:Zg_GetAttacked(self.inst, self:CalcDamage(ent, weapon, self.areahitdamagepercent), weapon, stimuli)
				hitcount = hitcount + 1
			end
		end
		return hitcount
	end
	
	--见闻色
	function inst.components.combat:CanTarget(target)
		return true
	end
	function inst.components.combat:IsValidTarget(target)
		return true
	end
	function inst.components.combat:CanHitTarget(target, weapon)
		if self.inst ~= nil and
			self.inst:IsValid() and
			target ~= nil and
			--target:IsValid() and
			--not target:IsInLimbo() and
			(   self:CanExtinguishTarget(target, weapon) or
				self:CanLightTarget(target, weapon) or
				(   target.components.combat ~= nil --and
					--target.components.combat:CanBeAttacked(self.inst)
				)
			) then

			local targetpos = target:GetPosition()
			-- V2C: this is 3D distsq
			if distsq(targetpos, self.inst:GetPosition()) <= self:CalcHitRangeSq(target) then
				return true
			elseif weapon ~= nil and weapon.components.projectile ~= nil then
				local range = target.Physics ~= nil and target.Physics:GetRadius() + weapon.components.projectile.hitdist or weapon.components.projectile.hitdist
				-- V2C: this is 3D distsq
				return distsq(targetpos, weapon:GetPosition()) <= range * range
			end
		end
		return false
	end
	
	----	攻击特效
	inst:ListenForEvent("onhitother", onattack)

    inst:AddComponent("lootdropper")
	----	掉落
	inst.components.lootdropper:SetChanceLootTable('zg_ch3_mihawk')
	
	----	武器
	GetInventory(inst)
	
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("世界第一大剑豪")
	
	inst:AddComponent("timer")
	inst.canpound = true
	inst.canpound2 = true
	inst:ListenForEvent("timerdone", function (inst, data)
		if data.name == "pound" then	----世界第一斩击
			inst.canpound = true
		elseif data.name == "pound2" then	----横扫千军
			inst.canpound2 = true
		end
	end)
	
	--是否开启武装色
	inst:ListenForEvent("healthdelta", function (inst, data)
		local newpercent=data.newpercent
		if newpercent and newpercent<.5 then
			if not inst.wzs then
				inst.wzs=true
				inst.components.combat.damagemultiplier=2
				inst.components.health:SetAbsorptionAmount(.9)
				wy_spawn(inst,"zg_fx_mihawkball",nil,1,1)
				TheNet:Announce("大剑豪开启了武装色霸气")
			end
		end
	end)
	
	--Behaviour
	inst.zg_chaseandattack_period=.1
	inst.zg_runaway_period=.1
	
	inst.zg_chase_time=30	--追杀时间
	inst.zg_see_dist=8	--逃跑检测hunter的距离
	
	inst.zg_startrunaway_dist=2		--开始躲避敌人预留的距离
	inst.zg_stoprunaway_dist=3	--躲避敌人攻击距离 预留的安全距离
	
	inst.target_exdist=1	--玩家要是武器距离超过1,不再走位
	
	local brain = require "brains/zg_ch3_mihawkbrain"
    inst:SetBrain(brain)
	
    return inst
end

STRINGS.NAMES.ZG_CH3_MIHAWK = "艺皇属下 鹰眼米霍克" 
return Prefab ("zg_ch3_mihawk", fn, assets)