local assets=
{
	Asset( "ANIM", "anim/zg_waxwell.zip" ),
}
-----------------------------------------------------------------------------------------------------------
----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10 + 15 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	
    return invader, true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end
-------------------------------------------------------------------------------------------------------------
SetSharedLootTable( 'zg_ch_waxwell',
{
	{'nightsword',          1.00},
	
	{'fruitmedley',          1.00},
	{'fruitmedley',          0.50},
	
	{'bz_head_waxwell', 		.33},
})
-----------------------------------------------------------------------------------------------------

----	衣服被砍掉
local function LaunchItem1(inst, target, item)
    if item.Physics ~= nil then
        local x, y, z = item.Transform:GetWorldPosition()
        item.Physics:Teleport(x, .1, z)

        local vel = (target:GetPosition() - inst:GetPosition()):GetNormalized()
        local speed = 5 + math.random() * 2
        local angle = math.atan2(vel.z, vel.x) + (math.random() * 20 - 10) * DEGREES
        item.Physics:SetVel(math.cos(angle) * speed, 10, -math.sin(angle) * speed)
    end
end

----	击中玩家	特点	--模板
local function onattack(inst,data)
    local victim = data.target
	if victim and victim:HasTag("player") then
		
		----	一定几率砍掉帽子
		if math.random () < .5 then
			local item3 = victim.components.inventory:GetEquippedItem(EQUIPSLOTS.HEAD)
			if item3 then 
				victim.components.inventory:DropItem(item3)
				LaunchItem1(inst, victim, item3)
			end
		end
		
		----	一定几率把玩家打扁
		if math.random () < .5 * TUNING.ZG_DIFFICULTY then
			if victim.components.zg_sizechange then
				victim.components.zg_sizechange:StartChange(.33, 10)
			end
		end
		
	end
end

-----------------------------------------------------------------
-----------------------------------------------------------------
----	武器样式
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_nightmaresword", "swap_nightmaresword")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end
local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

----	武器栏
local function GetInventory(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(60 * TUNING.ZG_DIFFICULTY)
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
			----	武器外观
			meleeweapon.components.equippable:SetOnEquip(onequip)
			meleeweapon.components.equippable:SetOnUnequip(onunequip)
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end
------------------------------------------------------------------------------------------------------------
local function NumPerdsToSpawn(inst)
    local numFollowers = inst.components.leader:CountFollowers()
	local num = 1 - numFollowers
	if num <= 0 then
		return 0
	else
		return num
	end
end
----------------------------
local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("waxwell")
	inst.AnimState:PlayAnimation("idle")
	--inst.AnimState:OverrideSymbol("swap_hat", "hat_top", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")
	--inst.AnimState:OverrideSymbol("swap_body", "armor_sanity", "swap_body")
	--inst.AnimState:OverrideSymbol("beard", "beard", "beard_long")
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	--phys:CollidesWith(COLLISION.OBSTACLES)
    --phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	--phys:CollidesWith(COLLISION.CHARACTERS)
    
	inst.entity:AddSoundEmitter()
	
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 0, 0 )
	
	inst.entity:AddNetwork()

	inst:AddTag("healthinfo")
	inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("scarytoprey")
	inst:AddTag("zg_music_ds")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end 
	
	----	不会中毒，共性
    inst:AddComponent("eater")  
	inst.components.eater:SetDiet({ FOODGROUP.OMNI }, { FOODGROUP.OMNI})
    inst.components.eater.strongstomach = true
	local selfeater = inst.components.eater
	local old = selfeater.Eat
	function inst.components.eater:Eat(food)
		if selfeater:CanEat(food) then
			if food.components.edible.healthvalue < 1 then
				food.components.edible.healthvalue = 1
			end
		end
		return old(selfeater, food)
	end

	----	移动，共性
    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed= 4
    inst.components.locomotor.runspeed = 5
	inst.components.locomotor.fasteronroad = false
	inst.components.locomotor:SetTriggersCreep(false)
	
	inst.NumPerdsToSpawn = NumPerdsToSpawn
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch_waxwell")

    local brain = require "brains/zg_ch_wilsonbrain"		
    inst:SetBrain(brain)
    
	-------------------------------------------------------------------------------------------------------
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(75)
	inst.components.health:StartRegen(2 * TUNING.ZG_DIFFICULTY, 5 * TUNING.ZG_DIFFICULTY_PERIOD)
	inst.components.health.fire_damage_scale = 0
	--inst.components.health.destroytime = 5
	----	防御力
	inst.components.health:SetAbsorptionAmount(.85)
    
    inst:AddComponent("knownlocations")
    inst:AddComponent("inventory")
	
    inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = -TUNING.SANITYAURA_MED * 10
    
	inst:AddComponent("talker")
	
	inst:AddComponent("leader")
  
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage( 60 * TUNING.ZG_DIFFICULTY )						----常常不是空手, 因此无用
    inst.components.combat:SetAttackPeriod( 4 - TUNING.ZG_DIFFICULTY )
    inst.components.combat:SetRange(2)
    inst.components.combat.hiteffectsymbol = "torso"
    inst.components.combat:SetRetargetFunction(3, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	
	----	攻击特效
	inst:ListenForEvent("onattackother", onattack)
	
	

    inst:AddComponent("lootdropper")
	----	掉落
	inst.components.lootdropper:SetChanceLootTable('zg_ch_waxwell')
	
	----	武器
	GetInventory(inst)
	
	inst:AddComponent("timer")
	inst:ListenForEvent("timerdone", function(inst, data)
		if data.name == "pound" then	--暗影闪电
			inst.canpound = true
		end
	end)
    
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("隐身的魔术师,但是我还是看得见它的刀")
	
    return inst
end

local function fn_fx()
	local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    --inst.Transform:SetFourFaced()

    inst.AnimState:SetBank("lightning")
    inst.AnimState:SetBuild("zg_fx_blacklightning")
    inst.AnimState:PlayAnimation("anim", true)
	inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")

    inst:AddTag("fx")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false

    inst:AddComponent("combat")
	
	local meleeweapon = CreateEntity()
	meleeweapon.entity:AddTransform()
	meleeweapon:AddComponent("weapon")
	meleeweapon.components.weapon:SetDamage(0)
	meleeweapon:AddComponent("inventoryitem")
	meleeweapon.persists = false
	meleeweapon.zg_electrocute_mult = 4
	meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
	meleeweapon:AddComponent("equippable")
	
	----暗系伤害+电系伤害
	local period = 1/30
	inst.collide_task_table = {}
	inst:DoPeriodicTask(period, function()
	
		local pt = inst:GetPosition()	
		local r = 1.5
		local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "shadowboss"})
		
		for k,v in pairs(ents) do
			if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
				
				if not table.contains(inst.collide_task_table, v.GUID) then
					v.components.combat:Zg_GetAttacked(inst, 60 *  TUNING.ZG_DIFFICULTY, nil, "zg_ele_dark")
					v.components.combat:Zg_GetAttacked(inst, 60 *  TUNING.ZG_DIFFICULTY, meleeweapon, "zg_ele_electric")
					table.insert(inst.collide_task_table, v.GUID)
				end
				
			end
		end
		
	end)
	
	inst:DoTaskInTime(0, function()
		inst.SoundEmitter:PlaySound("dontstarve/rain/thunder_close")
	end)
	
	----生命周期
	inst.zg_lifetime = 4
	inst:DoTaskInTime(inst.zg_lifetime, function()
		if inst then
			inst:Remove()
		end
	end)

	return inst
end

STRINGS.NAMES.ZG_CH_WAXWELL = "艺皇属下 麦斯威尔" 
STRINGS.NAMES.ZG_FX_BLACKLIGHTNING = "麦斯威尔の暗影闪电" 
return Prefab ("zg_ch_waxwell", fn, assets),
	Prefab ("zg_fx_blacklightning", fn_fx)









