
-----------------------------------------------------------------------------------------------------------
----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10 + 15 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	----	敌视语句
	if invader then
		local sayrandom = math.random()
		if sayrandom < .05 then
			inst.SoundEmitter:PlaySound("dontstarve/zg/webber/call")
			inst.components.talker:Say("我要吃肉!")
		elseif sayrandom < .1 then
			inst.SoundEmitter:PlaySound("dontstarve/zg/webber/call")
			inst.components.talker:Say("不许走!")
		end
	end
    return invader, true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end
-------------------------------------------------------------------------------------------------------------
SetSharedLootTable( 'zg_ch_webber',
{
	
	{'meat',          1.00},
	{'meat',          0.50},
	
	{'silk',          1.00},
	{'silk',          1.00},
	{'silk',          1.00},
	{'silk',          1.00},
	{'silk',          1.00},
	{'silk',          1.00},
	
	{'bz_head_webber', 		.33},
})
-----------------------------------------------------------------------------------------------------
-----------------------------------------------------------------
-----------------------------------------------------------------
----	武器样式
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_boomerang", "swap_boomerang")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end
local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

----	武器栏
local function GetInventory(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(60 * TUNING.ZG_DIFFICULTY)
		meleeweapon.components.weapon:SetRange(4, 6)
		meleeweapon.components.weapon:SetProjectile("zg_fx_webberboomerang")
		
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
			----	武器外观
			meleeweapon.components.equippable:SetOnEquip(onequip)
			meleeweapon.components.equippable:SetOnUnequip(onunequip)
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end
------------------------------------------------------------------------------------------------------------
local function NumPerdsToSpawn(inst)
    local numFollowers = inst.components.leader:CountFollowers()
	local num = 1 - numFollowers
	if num <= 0 then
		return 0
	else
		return num
	end
end
----------------------------
local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
	inst.entity:AddAnimState()
	
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 2, 1 )
	
	--inst.AnimState:SetBank("wilson")
	
	--坐骑
	inst.AnimState:SetBank("wilsonbeefalo")
	inst.AnimState:AddOverrideBuild("beefalo_domesticated")
	
	--显示其余部位
	inst.AnimState:Show("beefalo_mouth")
	
	
	inst.AnimState:SetBuild("webber")
	
	--inst.AnimState:PlayAnimation("idle")
	inst.AnimState:PlayAnimation("idle_loop")
	
	inst.AnimState:OverrideSymbol("swap_hat", "hat_beefalo", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")
	
	--鞍
	inst.AnimState:OverrideSymbol("swap_saddle", "saddle_war", "swap_saddle")
	inst.Transform:SetSixFaced()
	inst.DynamicShadow:SetSize(6, 2)
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.CHARACTERS)
    
	inst.entity:AddSoundEmitter()
	
	inst.entity:AddNetwork()

	inst:AddTag("healthinfo")
	inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("scarytoprey")
	inst:AddTag("zg_music_ds")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end 
	
	----	碰撞
	--inst.Physics:SetCollisionCallback(oncollide)
	
	----	不会中毒，共性
    inst:AddComponent("eater")  
	inst.components.eater:SetDiet({ FOODGROUP.OMNI }, { FOODGROUP.OMNI})
    inst.components.eater.strongstomach = true
	local selfeater = inst.components.eater
	local old = selfeater.Eat
	function inst.components.eater:Eat(food)
		if selfeater:CanEat(food) then
			if food.components.edible.healthvalue < 1 then
				food.components.edible.healthvalue = 1
			end
		end
		return old(selfeater, food)
	end

	----	移动，共性
    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed= 4
    inst.components.locomotor.runspeed = 5
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(false)
	
	inst.NumPerdsToSpawn = NumPerdsToSpawn
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch_webber")

    local brain = require "brains/zg_ch_wickerbrain"
    inst:SetBrain(brain)
    
	-------------------------------------------------------------------------------------------------------
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(175)
	inst.components.health:StartRegen(2 * TUNING.ZG_DIFFICULTY, 5 * TUNING.ZG_DIFFICULTY_PERIOD)
	inst.components.health.fire_damage_scale = 0
	--inst.components.health.destroytime = 5
	----	防御力
	inst.components.health:SetAbsorptionAmount(.85)
    
    inst:AddComponent("knownlocations")
    inst:AddComponent("inventory")
	
    inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = -TUNING.SANITYAURA_MED * 3
    
	inst:AddComponent("talker")
	
	inst:AddComponent("leader")
  
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(60 * TUNING.ZG_DIFFICULTY)						----常常不是空手, 因此无用
    inst.components.combat:SetAttackPeriod(4 - TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetRange(2)
    inst.components.combat.hiteffectsymbol = "torso"
    inst.components.combat:SetRetargetFunction(3, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)

    inst:AddComponent("lootdropper")
	----	掉落
	inst.components.lootdropper:SetChanceLootTable('zg_ch_webber')
	
	----	武器
	GetInventory(inst)
    
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("蜘蛛堡的信差")
	
    return inst
end

local function fn_fx()

	local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst.AnimState:SetBank("boomerang")
    inst.AnimState:SetBuild("boomerang")
    inst.AnimState:PlayAnimation("spin_loop", true)
    inst.AnimState:SetRayTestOnBB(true)

    inst:AddTag("projectile")
    inst:AddTag("thrown")
	inst:AddTag("fx")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false
	
    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(10)
	inst.components.projectile:SetHoming(false)
	inst.components.projectile:SetHitDist(1)
	
	inst.components.projectile:SetOnHitFn( function(inst, owner, target)
		if target ~= nil and target:IsValid() then
			local impactfx = SpawnPrefab("impact")
			if impactfx ~= nil then
				local follower = impactfx.entity:AddFollower()
				follower:FollowSymbol(target.GUID, target.components.combat.hiteffectsymbol, 0, 0, 0)
				impactfx:FacePoint(inst.Transform:GetWorldPosition())
			end
		end
		inst:Remove()
	end)
	
	inst.components.projectile:SetOnMissFn(inst.Remove)
	
	inst:DoTaskInTime(3, inst.Remove)

    return inst
end


STRINGS.NAMES.ZG_CH_WEBBER = "艺皇属下 蜘蛛人" 
return Prefab ("zg_ch_webber", fn),
	Prefab ("zg_fx_webberboomerang", fn_fx)
	



