local assets=
{
	
}
-----------------------------------------------------------------------------------------------------------
----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10 + 15 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	----	敌视语句
	if invader then
		local sayrandom = math.random()
		if sayrandom < .1 then
			inst.SoundEmitter:PlaySound("dontstarve/zg/wes/call")
			inst.components.talker:Say("你可有苦头吃着呢!")
		end
	end
    return invader, true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end
-------------------------------------------------------------------------------------------------------------
SetSharedLootTable( 'zg_ch_wes',
{
	{'walrushat',          0.75},
	
	{'krampus_sack',          0.75},
	
	{'cane',          0.10},
	
	{'bz_head_wes', 		.33},
})
-----------------------------------------------------------------------------------------------------

--[[
----	衣服被砍掉
local function LaunchItem1(inst, target, item)
    if item.Physics ~= nil then
        local x, y, z = item.Transform:GetWorldPosition()
        item.Physics:Teleport(x, .1, z)

        local vel = (target:GetPosition() - inst:GetPosition()):GetNormalized()
        local speed = 5 + math.random() * 2
        local angle = math.atan2(vel.z, vel.x) + (math.random() * 20 - 10) * DEGREES
        item.Physics:SetVel(math.cos(angle) * speed, 10, -math.sin(angle) * speed)
    end
end

----	击中玩家	特点	--模板
local function onattack(inst,data)
    local victim = data.target
	if victim and victim:HasTag("player") then
		----	一定几率砍掉衣服
		if math.random () < .5 then
			local item3 = victim.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY)
			if item3 then 
				victim.components.inventory:DropItem(item3)
				LaunchItem1(inst, victim, item3)
			end
		end
	end
end]]


-----------------------------------------------------------------
-----------------------------------------------------------------
----	武器样式
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_cane", "swap_cane")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end
local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

----	武器栏
local function GetInventory(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage( 30 * TUNING.ZG_DIFFICULTY )
		meleeweapon.zg_electrocute_mult = 4		
		
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
		meleeweapon.components.equippable.walkspeedmult = 1.2
			----	武器外观
			meleeweapon.components.equippable:SetOnEquip(onequip)
			meleeweapon.components.equippable:SetOnUnequip(onunequip)
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end
------------------------------------------------------------------------------------------------------------

----------------------------
local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("wes")
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:OverrideSymbol("swap_hat", "hat_walrus", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")
	inst.AnimState:OverrideSymbol("swap_body", "swap_krampus_sack", "backpack")
	inst.AnimState:OverrideSymbol("swap_body", "swap_krampus_sack", "swap_body")
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	--phys:CollidesWith(COLLISION.OBSTACLES)
    --phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	phys:CollidesWith(COLLISION.CHARACTERS)
    
	inst.entity:AddSoundEmitter()
	
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 2, 1 )
	
	inst.entity:AddNetwork()

	inst:AddTag("healthinfo")
	inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("scarytoprey")
	inst:AddTag("zg_music_ds")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end 
	
	----	不会中毒，共性
    inst:AddComponent("eater")  
	inst.components.eater:SetDiet({ FOODGROUP.OMNI }, { FOODGROUP.OMNI})
    inst.components.eater.strongstomach = true
	local selfeater = inst.components.eater
	local old = selfeater.Eat
	function inst.components.eater:Eat(food)
		if selfeater:CanEat(food) then
			if food.components.edible.healthvalue < 1 then
				food.components.edible.healthvalue = 1
			end
		end
		return old(selfeater, food)
	end

	----	移动，共性
    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed= 9
    inst.components.locomotor.runspeed = 9
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(false)
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch_wes")

    local brain = require "brains/zg_ch_wolfgangbrain"			--使用大力士的AI
    inst:SetBrain(brain)
    
	-------------------------------------------------------------------------------------------------------
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(113)
	inst.components.health:StartRegen(2 * TUNING.ZG_DIFFICULTY, 5 * TUNING.ZG_DIFFICULTY_PERIOD)
	inst.components.health.fire_damage_scale = 0
	--inst.components.health.destroytime = 5
	----	防御力
	inst.components.health:SetAbsorptionAmount(.85)
    
    inst:AddComponent("knownlocations")
    inst:AddComponent("inventory")
	
    inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = -TUNING.SANITYAURA_MED * 3
    
	inst:AddComponent("talker")
	
	inst:AddComponent("leader")
  
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage( 30 * TUNING.ZG_DIFFICULTY )						----常常不是空手, 因此无用
    inst.components.combat:SetAttackPeriod( 4 - TUNING.ZG_DIFFICULTY )
    inst.components.combat:SetRange(2)
    inst.components.combat.hiteffectsymbol = "torso"
    inst.components.combat:SetRetargetFunction(3, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)

    inst:AddComponent("lootdropper")
	----	掉落
	inst.components.lootdropper:SetChanceLootTable('zg_ch_wes')
	
	inst:ListenForEvent("zg_pre_attacked", function(inst, data)
	
		if inst.sg:HasStateTag("pound") then
		
			local attacker = data and data.attacker
			
			if attacker  and attacker.components.health and not attacker.components.health:IsDead() and attacker.components.combat then
			
				if attacker:HasTag("player") then
				
					----	卸掉玩家的装备
					local inv = attacker.components.inventory
					if inv then
						--for kk, vv in pairs( inv.equipslots ) do
							local item = inv:GetEquippedItem(EQUIPSLOTS.HANDS)
							--local item = vv
							if item and item.Physics then
								inv:DropItem(item)
								local a, b, c = item:GetPosition():Get()
								item.Physics:Teleport(a,.1,c)
								local hp = attacker:GetPosition()
								local pt = inst:GetPosition()
								local vel = (pt - hp):GetNormalized()
								local speed = 5 + (math.random() * 2)
								local angle = math.atan2(vel.z, vel.x) + (math.random() * 20 - 10) * DEGREES
								item.Physics:SetVel(math.cos(angle) * speed, 10, math.sin(angle) * speed)
							end	
						--end
					end
				end
				
				attacker.components.combat:Zg_GetAttacked(inst, 30 * TUNING.ZG_DIFFICULTY, inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS), "zg_ele_electric" )
				
			end
		
		end
	end)
	
	----	武器
	GetInventory(inst)
	
	inst:AddComponent("timer")
	inst:ListenForEvent("timerdone", function(inst, data)
		if data.name == "pound" then	--催眠迷乱
			inst.canpound = true
		end
	end)
	
	----	开头就准备技能
	if not (inst.canpound or inst.components.timer:TimerExists("pound")) then
		inst.components.timer:StartTimer("pound", 5)
	end
    
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("他一直装聋作哑,隐藏着自己的实力")
	
    return inst
end

STRINGS.NAMES.ZG_CH_WES = "艺皇属下 小丑" 
return Prefab ("zg_ch_wes", fn, assets)