local assets=
{
	
}
-----------------------------------------------------------------------------------------------------------
----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10 + 15 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	----	敌视语句
	if invader then
		local sayrandom = math.random()
		
		if inst._is_riding then
			if sayrandom < .05 then
				inst.SoundEmitter:PlaySound("dontstarve/zg/wigfrid/call")
				inst.components.talker:Say("祝你好运!")
			elseif sayrandom < .1 then
				inst.components.talker:Say("翻滚吧! 牛宝宝!")
			end
		else
			if sayrandom < .1 then
				inst.SoundEmitter:PlaySound("dontstarve/zg/wigfrid/call")
				inst.components.talker:Say("祝你好运!")
			end
		end
		
	end
    return invader, true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end
-------------------------------------------------------------------------------------------------------------
SetSharedLootTable( 'zg_ch_wigfrid',
{
	{'honeyham',          1.00},
	{'honeyham',          0.50},
	
	{'bz_head_wigfrid', 		.33},
})
-----------------------------------------------------------------------------------------------------
-----------------------------------------------------------------
-----------------------------------------------------------------
----	武器样式
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_spear_wathgrithr", "swap_spear_wathgrithr")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end
local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

----	武器栏
local function GetInventory(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(60 * TUNING.ZG_DIFFICULTY)
		meleeweapon.components.weapon:SetOnAttack( function(meleeweapon, inst, target)
			if inst._is_riding then
				if target and target.components.health and not target.components.health:IsDead() and target.components.combat then
					target.components.combat:Zg_GetAttacked(inst, 60 * TUNING.ZG_DIFFICULTY)
				end
			end
		end)	
		
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
			----	武器外观
			meleeweapon.components.equippable:SetOnEquip(onequip)
			meleeweapon.components.equippable:SetOnUnequip(onunequip)
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end
------------------------------------------------------------------------------------------------------------

----------------------------
local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("wathgrithr")
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:OverrideSymbol("swap_hat", "hat_wathgrithr", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")
	--inst.AnimState:OverrideSymbol("swap_body", "armor_wood", "swap_body")
	--inst.AnimState:OverrideSymbol("beard", "beard", "beard_long")
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(10000)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	--phys:CollidesWith(COLLISION.OBSTACLES)
    --phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	phys:CollidesWith(COLLISION.CHARACTERS)
    
	inst.entity:AddSoundEmitter()
	
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 2, 1 )
	
	inst.entity:AddNetwork()

	inst:AddTag("healthinfo")
	inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("scarytoprey")
	inst:AddTag("zg_music_ds")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end 
	
	----	不会中毒，共性
    inst:AddComponent("eater")  
	inst.components.eater:SetDiet({ FOODGROUP.OMNI }, { FOODGROUP.OMNI})
	--inst.components.eater:SetDiet({ FOODGROUP.OMNI }, { FOODTYPE.MEAT })
    inst.components.eater.strongstomach = true
	local selfeater = inst.components.eater
	local old = selfeater.Eat
	function inst.components.eater:Eat(food)
		if selfeater:CanEat(food) then
			if food.components.edible.healthvalue < 1 then
				food.components.edible.healthvalue = 1
			end
		end
		return old(selfeater, food)
	end

	----	移动，共性
    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed= 4.25
    inst.components.locomotor.runspeed = 5.25
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(false)
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch_wigfrid")

    local brain = require "brains/zg_ch_wolfgangbrain"		----使用沃尔夫冈的AI
    inst:SetBrain(brain)
    
	-------------------------------------------------------------------------------------------------------
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(200)
	inst.components.health:StartRegen(2 * TUNING.ZG_DIFFICULTY, 5 * TUNING.ZG_DIFFICULTY_PERIOD)
	inst.components.health.fire_damage_scale = 0
	--inst.components.health.destroytime = 5
	----	防御力
	inst.components.health:SetAbsorptionAmount(.9)
    
    inst:AddComponent("knownlocations")
    inst:AddComponent("inventory")
	
    inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = -TUNING.SANITYAURA_MED * 3
    
	inst:AddComponent("talker")
	
	inst:AddComponent("leader")
  
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(60 * TUNING.ZG_DIFFICULTY)						----常常不是空手, 因此无用
    inst.components.combat:SetAttackPeriod(4 - TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetRange(2)
	inst.components.combat:SetAreaDamage(2, 0.8)					----范围攻击
    inst.components.combat.hiteffectsymbol = "torso"
    inst.components.combat:SetRetargetFunction(2, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	
	function inst.components.combat:DoAreaAttack(target, range, weapon, validfn, stimuli)
		local hitcount = 0
		local x, y, z = target.Transform:GetWorldPosition()
		local ents = TheSim:FindEntities(x, y, z, range, { "_combat" }, {"shadowboss"})			----AOE伤害忽略队友
		for i, ent in ipairs(ents) do
			if ent ~= target and
				ent ~= self.inst and
				self:IsValidTarget(ent) and
				(validfn == nil or validfn(ent)) then
				self.inst:PushEvent("onareaattackother", { target = target, weapon = weapon, stimuli = stimuli })
				ent.components.combat:Zg_GetAttacked(self.inst, self:CalcDamage(ent, weapon, self.areahitdamagepercent), weapon, stimuli)
				hitcount = hitcount + 1
			end
		end
		return hitcount
	end

    inst:AddComponent("lootdropper")
	----	掉落
	inst.components.lootdropper:SetChanceLootTable('zg_ch_wigfrid')
	
	----	武器
	GetInventory(inst)
	
	----	骑牛造成3倍打击
	--[[千万不要这么写, 因为这样会陷入死循环,是错误的结构
	inst:ListenForEvent("onhitother", function(inst, data)
		if inst._is_riding then
			local tar = data.target
			if tar and tar.components.health and not tar.components.health:IsDead() and tar.components.combat then
				tar.components.combat:Zg_GetAttacked(inst, 60 * 2 * TUNING.ZG_DIFFICULTY)
			end
		end
	end)]]
	
	inst.pound_cd = 12.5
	inst.pound2_cd = 2.5
	
	inst:AddComponent("timer")
	inst:ListenForEvent("timerdone", function(inst, data)
		if data.name == "pound" then	--身体旋风
			inst.canpound = true
		elseif data.name == "pound2" then	--骑牛冲锋
			inst.canpound2 = true
		end
	end)
	
	----	开头就准备技能
	if not (inst.canpound2 or inst.components.timer:TimerExists("pound2")) then
		inst.components.timer:StartTimer("pound2", inst.pound2_cd)
	end
    
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("标准女武神")
	
    return inst
end

STRINGS.NAMES.ZG_CH_WIGFRID = "艺皇属下 女武神" 
return Prefab ("zg_ch_wigfrid", fn, assets)