local assets=
{
	
}
-----------------------------------------------------------------------------------------------------------
----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10 + 15 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy and
			(
				( guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost") ) or 
				( guy.components.combat and guy.components.combat.target == inst )
			)
    end)
	----	敌视语句
	if invader then
		local sayrandom = math.random()
		if sayrandom < .05 then
			inst.SoundEmitter:PlaySound("dontstarve/zg/willow/call")
			
			inst.components.talker:Say("奉艺皇之命, 让我烧熟你!")
		elseif sayrandom < .1 then
			inst.SoundEmitter:PlaySound("dontstarve/zg/willow/call")
			
			inst.components.talker:Say("真该死！")
		end
	end
    return invader, true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end
-------------------------------------------------------------------------------------------------------------
SetSharedLootTable( 'zg_ch_willow',
{
	{'armordragonfly',          1.00},
	
	{'hotchili',          1.00},
	{'hotchili',          0.50},
	
	{'bz_head_willow', 		.33},
})
-----------------------------------------------------------------------------------------------------

-----------------------------------------------------------------
-----------------------------------------------------------------
----	武器样式
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_staffs", "redstaff")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end
local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

----	武器栏
local function GetInventory(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
		meleeweapon.entity:AddSoundEmitter()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(30 * TUNING.ZG_DIFFICULTY)
		meleeweapon.components.weapon:SetOnAttack( function(meleeweapon, attacker, target)
			if target then
				
				meleeweapon.SoundEmitter:PlaySound("dontstarve/zg/zg_mo_evergreen/explode")
			
				----位置
				local x, y, z = target:GetPosition():Get()
				
				----偏差
				local offset =
				{
					{x = 0, z = 0},
					{x = 1, z = 1},
					{x = 1, z = -1},
					{x = -1, z = -1},
					{x = -1, z = 1},
					{x = 2, z = 2},
					{x = 2, z = -2},
					{x = -2, z = -2},
					{x = -2, z = 2},
				}
				
				----定义火焰
				for k = 1, #offset do
					local fire = SpawnPrefab("zg_fx_willowfire")
					if fire then
						if fire.components.burnable then
							fire.components.burnable:SetBurnTime(9 * TUNING.ZG_DIFFICULTY)
						end
						fire._output = .75  * TUNING.ZG_DIFFICULTY
					end
					fire.Transform:SetPosition(x + offset[k].x, 0, z + offset[k].z)
				end
				
			end
		end)
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
			----	武器外观
			meleeweapon.components.equippable:SetOnEquip(onequip)
			meleeweapon.components.equippable:SetOnUnequip(onunequip)
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end
------------------------------------------------------------------------------------------------------------
local function NumPerdsToSpawn(inst)
    local numFollowers = inst.components.leader:CountFollowers()
	local num = 1 - numFollowers
	if num <= 0 then
		return 0
	else
		return num
	end
end
----------------------------
local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("willow")
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:OverrideSymbol("swap_hat", "hat_football", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")
	inst.AnimState:OverrideSymbol("swap_body", "torso_dragonfly", "swap_body")
	--inst.AnimState:OverrideSymbol("beard", "beard", "beard_long")
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	--phys:CollidesWith(COLLISION.OBSTACLES)
    --phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	phys:CollidesWith(COLLISION.CHARACTERS)
    
	inst.entity:AddSoundEmitter()
	
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 2, 1 )
	
	inst.entity:AddNetwork()

	inst:AddTag("healthinfo")
	inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("scarytoprey")
	inst:AddTag("zg_music_ds")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end 

	
	----	不会中毒，共性
    inst:AddComponent("eater")  
	inst.components.eater:SetDiet({ FOODGROUP.OMNI }, { FOODGROUP.OMNI})
    inst.components.eater.strongstomach = true
	local selfeater = inst.components.eater
	local old = selfeater.Eat
	function inst.components.eater:Eat(food)
		if selfeater:CanEat(food) then
			if food.components.edible.healthvalue < 1 then
				food.components.edible.healthvalue = 1
			end
		end
		return old(selfeater, food)
	end

	----	移动，共性
    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed= 4
    inst.components.locomotor.runspeed = 5
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(false)
	
	inst.NumPerdsToSpawn = NumPerdsToSpawn		--召唤兽的数量
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch_willow")

    local brain = require "brains/zg_ch_wilsonbrain"		--就用威尔逊的AI
    inst:SetBrain(brain)
    
	-------------------------------------------------------------------------------------------------------
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(150)
	inst.components.health:StartRegen(2 * TUNING.ZG_DIFFICULTY, 5 * TUNING.ZG_DIFFICULTY_PERIOD)
	inst.components.health.fire_damage_scale = 0
	--inst.components.health.destroytime = 5
	----	防御力
	inst.components.health:SetAbsorptionAmount(.85)
    
    inst:AddComponent("knownlocations")
    inst:AddComponent("inventory")
	
    inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = -TUNING.SANITYAURA_MED * 3
    
	inst:AddComponent("talker")
	
	inst:AddComponent("leader")
  
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(45 * TUNING.ZG_DIFFICULTY)						----作为三连拍的攻击力
    inst.components.combat:SetAttackPeriod(3 - TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetRange(2)
    inst.components.combat.hiteffectsymbol = "torso"
    inst.components.combat:SetRetargetFunction(3, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	
	----	三连击
	inst:AddComponent("groundpounder")
	inst.components.groundpounder.numRings = 2	
	inst.components.groundpounder.damageRings = 2	
    inst.components.groundpounder.burner = true
    inst.components.groundpounder.groundpoundfx = "firesplash_fx"
    inst.components.groundpounder.groundpounddamagemult = 1
    inst.components.groundpounder.groundpoundringfx = "firering_fx"
	inst.components.groundpounder.destroyer = false
	inst.components.groundpounder.destructionRings = 2
	inst.components.groundpounder.noTags = { "FX", "NOCLICK", "DECOR", "INLIMBO", "shadowboss"}
	
	----	攻击特效
	--inst:ListenForEvent("onattackother", onattack)
	
	

    inst:AddComponent("lootdropper")
	----	掉落
	inst.components.lootdropper:SetChanceLootTable('zg_ch_willow')
	
	inst:AddComponent("timer")
	inst:ListenForEvent("timerdone", function(inst, data)
		if data.name == "pound" then	--火环
			inst.canpound = true
		end
	end)
	
	----	武器
	GetInventory(inst)
    
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("她的气息都可以用来烧玻璃了")
	
    return inst
end

-------------------------------三昧真火
local function fnfiredrop()
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddNetwork()
	
    MakeInventoryPhysics(inst)
	
    inst.entity:SetPristine()
	
    if not TheWorld.ismastersim then
        return inst
    end
    
	inst:AddComponent("burnable")
    inst.components.burnable:SetFXLevel(4)
    inst.components.burnable:SetBurnTime(5)
    inst.components.burnable:AddBurnFX("zg_fx_truefire", Vector3(0, 0, 0) )
    inst.components.burnable:SetOnIgniteFn(nil)
    inst.components.burnable:SetOnExtinguishFn(inst.Remove)
    inst.components.burnable:Ignite()
	
	inst._output = .75
	
	inst:DoPeriodicTask(.25, function()
		local x, y, z = inst.Transform:GetWorldPosition()
			
		----烧火
		local ents = TheSim:FindEntities(x, y, z, 3, nil, {"campfire"})
		for k, v in pairs(ents) do
			if v and v.components.burnable then		
				if not (v.components.inventoryitem and v.components.inventoryitem:IsHeld() ) then
					v.components.burnable:Ignite()
				end
			end
			if v and not v:HasTag("shadowboss") then
				if v.components.health and not v.components.health:IsDead() and v.components.combat then
					--v.components.health:DoDelta(-2.5 * TUNING.ZG_DIFFICULTY, nil, inst.prefab)
					--v.components.combat:Zg_GetAttacked(inst, 3 * TUNING.ZG_DIFFICULTY, nil, "zg_ele_fire", true)
					v.components.health:DoFireDamage(inst._output)
				end
			end
		end
	end)

    return inst
end

STRINGS.NAMES.ZG_CH_WILLOW = "艺皇属下 薇洛" 
STRINGS.NAMES.ZG_FX_WILLOWFIRE = "三昧真火"
return Prefab ("zg_ch_willow", fn, assets),
	Prefab ("zg_fx_willowfire", fnfiredrop)