local assets=
{
	--Asset("ANIM", "anim/swap_flashgun.zip"), 
}
-----------------------------------------------------------------------------------------------------------
----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10 + 15 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	----	敌视语句
	if invader then
		local sayrandom = math.random()
		if sayrandom < .05 then
			inst.SoundEmitter:PlaySound("dontstarve/zg/wx78/call")
			inst.components.talker:Say("奉艺皇之命, 终结你!")
		elseif sayrandom < .1 then
			inst.SoundEmitter:PlaySound("dontstarve/zg/wx78/call")
			inst.components.talker:Say("站住！目标！")
		end
	end
    return invader, true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end
-------------------------------------------------------------------------------------------------------------
SetSharedLootTable( 'zg_ch_wx78',
{
	
	{'gears',          1.00},
	{'gears',          0.50},
	
	{'bz_head_wx78', 		.33},
})
-----------------------------------------------------------------------------------------------------

-----------------------------------------------------------------
-----------------------------------------------------------------
----	武器样式
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "zg_weapon_swap_lightninggun", "zg_weapon_swap_lightninggun")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end
local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

----	武器栏
local function GetInventory1(inst)
    if inst.components.inventory then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
		meleeweapon.entity:AddSoundEmitter()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(60* TUNING.ZG_DIFFICULTY)
		meleeweapon.components.weapon:SetRange(4, 7)				----电枪
		--meleeweapon.components.weapon:SetProjectile("zg_fx_flashgun")
		
		meleeweapon.components.weapon:SetProjectile("zg_fx_arrow_yellow_ring")
		meleeweapon.components.weapon.stimuli = "zg_ele_electric"
		meleeweapon.zg_electrocute_mult = 4
		
		--[[
		meleeweapon.components.weapon:SetOnAttack( function(meleeweapon, attacker, target)
			
			----连续击中8目标
			inst.elecric_ring_table = {}
			
			local pt = target and target:GetPosition()
			local fx = SpawnPrefab("zg_fx_arrow_yellow_ring")
			if fx and pt then
				fx.Transform:SetPosition(pt:Get())
				
				table.insert(inst.elecric_ring_table, target.GUID)
				
				----定义飞出函数
				fx.throw_fn = function()
				
					----定位新目标
					local target1 = FindEntity(inst, 20, function(guy)
						return guy and 
							not table.contains(inst.elecric_ring_table, guy.GUID) and
							guy.components.health and not guy.components.health:IsDead() and
							guy.components.combat and
							not guy:HasTag("shadowboss") and not guy:HasTag("shadow")							
					end)
					if target1 then
						--将新目标列入表内
						table.insert(inst.elecric_ring_table, target1.GUID)
						
						--生成新arm
						fx.arm = SpawnPrefab("zg_fx_arrow_yellow0_ring")
						fx.arm.Transform:SetPosition(inst.Transform:GetWorldPosition())
						fx.arm:FacePoint(inst:GetPosition())
						fx.arm.components.stretcher:SetStretchTarget(inst)
						--飞向物体
						fx.components.projectile:Throw(inst, target1)
					else
						--没有目标则移除自己
						fx:Remove()
					end
					
				end
				
			end
			
		end)]]
		
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
			----	武器外观
			meleeweapon.components.equippable:SetOnEquip(onequip)
			meleeweapon.components.equippable:SetOnUnequip(onunequip)
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end

local function GetInventory2(inst)
    if inst.components.inventory then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
		meleeweapon.entity:AddSoundEmitter()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(30 * TUNING.ZG_DIFFICULTY)
		--meleeweapon.components.weapon:SetRange(11, 15)				----电枪
		--meleeweapon.components.weapon:SetProjectile("zg_fx_flashgun")
		--meleeweapon.components.weapon:SetProjectile("zg_fx_arrow_yellow")
		
		meleeweapon.components.weapon.stimuli = "zg_ele_electric"
		meleeweapon.zg_electrocute_mult = 3
		
		meleeweapon.components.weapon:SetOnAttack( function(meleeweapon, attacker, target)
			meleeweapon.SoundEmitter:PlaySound("dontstarve/zg/wx78/atk")
			--[[
			if target and target:HasTag("player") then
				if not target.components.health:IsDead() then
					target:GoToState("electrocute")
				end
			end]]
		end)
		
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
			----	武器外观
			meleeweapon.components.equippable:SetOnEquip(onequip)
			meleeweapon.components.equippable:SetOnUnequip(onunequip)
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end
------------------------------------------------------------------------------------------------------------

----------------------------
local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("wx78")
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:OverrideSymbol("swap_hat", "hat_football", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")
	inst.AnimState:OverrideSymbol("swap_body", "torso_rain", "swap_body")
	--inst.AnimState:OverrideSymbol("beard", "beard", "beard_long")
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	--phys:CollidesWith(COLLISION.OBSTACLES)
    --phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	phys:CollidesWith(COLLISION.CHARACTERS)
    
	inst.entity:AddSoundEmitter()
	
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 2, 1 )
	
	inst.entity:AddNetwork()
	
	inst:AddTag("healthinfo")
	inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("scarytoprey")
	inst:AddTag("zg_music_ds")
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end 
	
	inst.zg_inh_anti_electric = 1
	inst.zg_max_anti_electric = 1
	
	----	不会中毒，共性
    inst:AddComponent("eater")  
	inst.components.eater:SetDiet({ FOODGROUP.OMNI }, { FOODGROUP.OMNI})
    inst.components.eater.strongstomach = true
	inst.components.eater:SetCanEatGears()
	local selfeater = inst.components.eater
	local old = selfeater.Eat
	function inst.components.eater:Eat(food)
		if selfeater:CanEat(food) then
			if food.components.edible.healthvalue < 1 then
				food.components.edible.healthvalue = 1
			end
		end
		return old(selfeater, food)
	end

	----	移动，共性
    inst:AddComponent("locomotor")
    inst.components.locomotor.walkspeed= 4
    inst.components.locomotor.runspeed = 5
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(false)
	
	
	----	状态图和AI
    inst:SetStateGraph("SGzg_ch_wx78")

    local brain = require "brains/zg_ch_wolfgangbrain"		----用沃尔夫冈的AI
    inst:SetBrain(brain)
    
	-------------------------------------------------------------------------------------------------------
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(100)
	inst.components.health:StartRegen(2 * TUNING.ZG_DIFFICULTY, 5 * TUNING.ZG_DIFFICULTY_PERIOD)
	inst.components.health.fire_damage_scale = 0
	--inst.components.health.destroytime = 5
	----	防御力
	inst.components.health:SetAbsorptionAmount(.85)
    
    inst:AddComponent("knownlocations")
    inst:AddComponent("inventory")
	
    inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = -TUNING.SANITYAURA_MED * 3
    
	inst:AddComponent("talker")
	
	inst:AddComponent("leader")
  
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(30* TUNING.ZG_DIFFICULTY)						----常常不是空手, 因此无用
    inst.components.combat:SetAttackPeriod(3 - TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetRange(2)
    inst.components.combat.hiteffectsymbol = "torso"
    inst.components.combat:SetRetargetFunction(3, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	

    inst:AddComponent("lootdropper")
	----	掉落
	inst.components.lootdropper:SetChanceLootTable('zg_ch_wx78')
	
	inst.GetInventory1 = function() GetInventory1(inst) end
	inst.GetInventory2 = function() GetInventory2(inst) end
	
	----	武器
	inst:GetInventory2(inst)
	
	inst:AddComponent("timer")
	inst:ListenForEvent("timerdone", function(inst, data)
		if data.name == "pound" then	--连环闪电
			inst.canpound = true
			inst:GetInventory1(inst)
		end
	end)
    
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("它不像是艺皇制造的仪器")
	
	inst:ListenForEvent("onmissother", function(inst, data)
		if inst.sg:HasStateTag("pound") then
			inst.components.talker:Say("目标失败! Miss Target!")
		end
	end)
	
	
	inst:ListenForEvent("zg_pre_attacked", function(inst, data)
		if inst.sg:HasStateTag("pound") then
			local attacker = data.attacker
			if attacker  and attacker.components.health and not attacker.components.health:IsDead() and attacker.components.combat then
				
				attacker.components.combat:Zg_GetAttacked(inst, 30 * TUNING.ZG_DIFFICULTY, inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS), "zg_ele_electric" )
				
			end
		end
	end)
	
    return inst
end

STRINGS.NAMES.ZG_CH_WX78 = "艺皇属下 未来机器人(电系免疫)" 
return Prefab ("zg_ch_wx78", fn, assets)