local assets =
{	
	Asset("ANIM", "anim/zg_cr_icepig_build.zip"),
	Asset("ANIM", "anim/zg_cr_icebore_build.zip"),
	
	----
    Asset("ANIM", "anim/ds_pig_charge.zip"),
}

----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
    return invader, true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end

----	被攻击时
local function OnAttacked(inst, data)
    
    ----	群体反攻玩家
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) and not attacker:HasTag("shadowboss") then
			inst.components.combat:SetTarget(attacker)
			----	小伙伴何在
			inst.components.combat:ShareTarget(attacker, 20, function(dude)
				return dude:HasTag("zg_icepig")	
			end, 5)
		end
	end
end

----击中别人
local function OnHitOther(inst, data)
    local other = data.target
    if other and other.components.freezable then
        other.components.freezable:AddColdness(2)
        other.components.freezable:SpawnShatterFX()
		----刺骨的寒冷
		if other.components.temperature then
			other.components.temperature:DoDelta(-60)
		end
		
		----一定几率击倒玩家
		if other:HasTag("player") and not ( other.components.health and other.components.health:IsDead() ) then
			if math.random() < .33 * (inst.zg_freezemult or 1) then
				other:PushEvent("zg_buff_knockout")
			end
		end
    end
end

local function onattack(inst,data)
	inst.SoundEmitter:PlaySound("zg_cr_icepig/zg_cr_icepig/atk")
end

SetSharedLootTable( 'zg_cr_icepig',
{
	{'ice',          1},
	{'ice',          1},
	{'meat',          1},
	{'zg_it_icepigskin',          0.25},
})

SetSharedLootTable( 'zg_cr_icepig0',
{
	{'ice',          1},
	{'ice',          1},
	{'ice',          1},
	{'ice',          1},
	
	{'meat',          1},
	{'meat',          1},
	
	{'zg_it_icepigskin',          1},
	{'zg_it_icepigskin',          1},
	{'zg_it_icepigskin',          .25},

	{'blueamulet',          0.50},
	{'amulet',          0.50},
	
})


local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
    inst.entity:AddAnimState()
	inst.AnimState:SetBank("pigman")
	inst.AnimState:SetBuild("zg_cr_icepig_build")
    inst.AnimState:Hide("hat")
	inst.AnimState:PlayAnimation("idle_loop")
	
    inst.entity:AddSoundEmitter()
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.CHARACTERS)
	phys:CollidesWith(COLLISION.OBSTACLES)
    phys:CollidesWith(COLLISION.SMALLOBSTACLES)
    phys:CollidesWith(COLLISION.GIANTS)
	
    inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize(1.5, .75)
	
    inst.entity:AddNetwork()
   
	inst:AddTag("healthinfo")
    inst:AddTag("zg_icepig")
	inst:AddTag("scarytoprey")
	inst:AddTag("hostile")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("locomotor") 
    inst.components.locomotor.runspeed = 5 
    inst.components.locomotor.walkspeed = 3 
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(true)

    ------------------------------------------
    inst:AddComponent("combat")
    inst.components.combat.hiteffectsymbol = "pig_torso"
    inst.components.combat:SetDefaultDamage( 66 * 1 )
    inst.components.combat:SetAttackPeriod( 3 - 1 )
	inst.components.combat:SetRange(2)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
    inst.components.combat:SetRetargetFunction(3, RetargetFn)

    ------------------------------------------
    inst:AddComponent("follower")
	
	inst:AddComponent("lootdropper")
	----	掉落
	inst.components.lootdropper:SetChanceLootTable('zg_cr_icepig')
   
    inst:AddComponent("health")
    --inst.components.health:StartRegen(5, 1)
	inst.components.health:SetMaxHealth(666)
    ------------------------------------------

    --inst:AddComponent("inventory")
    inst:AddComponent("knownlocations")
    --inst:AddComponent("talker")
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("它们的胃都是冻住的")
	
	local brain = require "brains/zg_cr_icepigbrain"
    inst:SetBrain(brain)
    inst:SetStateGraph("SGzg_cr_icepig")
	
	inst:ListenForEvent("attacked", OnAttacked)
	
	inst.zg_freezemult = 1
	inst:ListenForEvent("onhitother", OnHitOther)
	--inst:ListenForEvent("onattackother", onattack)
	
    return inst
end
---------------------------------------------------------------------------------
local function oncollide(inst, other)
	if not other then
		return
	else
		if not other:IsValid() then
			return
		elseif other:HasTag("smashable") then
			other.components.health:Kill()
		elseif other.components.workable ~= nil and other.components.workable:CanBeWorked() 
			and not (other:HasTag("tree") or other:HasTag("boulder") or other:HasTag("structure") or other:HasTag("stalagmite")) 
			then
			SpawnPrefab("collapse_small").Transform:SetPosition(other.Transform:GetWorldPosition())
			other.components.workable:Destroy(inst)
		end
	end
end

local function fn0()
	local inst = fn()
	inst.Transform:SetScale(1.3,1.3,1.3)
	
	inst:AddTag("zg_icepig_boss")

    if not TheWorld.ismastersim then
        return inst
    end
	
	----	碰撞
	--inst.Physics:SetCollisionCallback(oncollide)
	
	inst.components.health:SetMaxHealth(1600)
	--inst.components.health:StartRegen(5, 5)
	inst.components.combat:SetDefaultDamage(99 * 1)
	inst.components.combat:SetRange(2.5)
	
	--inst:ListenForEvent("onhitother", OnHitOther0)
	inst.zg_freezemult = 2
	inst.zg_canchange = true
	
	local brain0 = require "brains/zg_cr_iceborebrain"
	
	inst:ListenForEvent("healthdelta", function()
		if inst.zg_canchange == true then
			----血低了就变身
			if inst.components.health.currenthealth < 800 then
				inst.AnimState:SetBuild("zg_cr_icebore_build")
				
				inst.components.locomotor.runspeed = 6
				inst:SetStateGraph("SGzg_cr_icebore")
				
				inst.components.combat:SetDefaultDamage(99 * 1)
				inst.components.combat:SetAttackPeriod(3 - 1)
				
				inst:SetBrain(brain0)
				inst.zg_canchange = false
			end
		end
	end)
	
	inst.components.lootdropper:SetChanceLootTable('zg_cr_icepig0')
	
	return inst
end

STRINGS.NAMES.ZG_CR_ICEPIG = "冷冻猪人"
STRINGS.NAMES.ZG_CR_ICEPIG0 = "冷冻贪婪者"
return Prefab("zg_cr_icepig", fn, assets),
	Prefab("zg_cr_icepig0", fn0, assets)