local assets =
{
    Asset("ANIM", "anim/zg_ele_dark_spear.zip"),
    Asset("ANIM", "anim/zg_ele_dark_spear_swap.zip"),
	Asset("ATLAS", "images/zg_ele_dark_spear.xml"),
}

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "zg_ele_dark_spear_swap", "swap_spear")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("spear")
    inst.AnimState:SetBuild("zg_ele_dark_spear")
    inst.AnimState:PlayAnimation("idle")
		
    inst:AddTag("sharp")	

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(34)
	inst.components.weapon.stimuli = "zg_ele_dark"

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(150)
    inst.components.finiteuses:SetUses(150)
    inst.components.finiteuses:SetOnFinished(inst.Remove)

    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("用来对付暗影生物的")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_ele_dark_spear.xml"
	inst.components.inventoryitem.imagename = "zg_ele_dark_spear"

    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    return inst
end

----------------------------------------------------------------------------------------
STRINGS.NAMES.ZG_ELE_DARK_SPEAR = "暗系长矛(暗系伤害34)" 
return Prefab("zg_ele_dark_spear", fn, assets)