
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "zg_weapon_zapstick_swap", "zg_weapon_zapstick_swap")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
	
	inst.Transform:SetScale(.5,.5,.5)

    inst.AnimState:SetBank("zg_weapon_zapstick")
    inst.AnimState:SetBuild("zg_weapon_zapstick")
    inst.AnimState:PlayAnimation("idle")
		
    inst:AddTag("sharp")	

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(34)
	inst.components.weapon.stimuli = "zg_ele_electric"

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(150)
    inst.components.finiteuses:SetUses(150)
    inst.components.finiteuses:SetOnFinished(inst.Remove)

    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("战斗用品或生活用品")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_ele_electric_stick.xml"
	inst.components.inventoryitem.imagename = "zg_ele_electric_stick"

    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    return inst
end

----------------------------------------------------------------------------------------
STRINGS.NAMES.ZG_ELE_ELECTRIC_STICK = "闪电刺(电系伤害34)" 
return Prefab("zg_ele_electric_stick", fn)