local assets =
{
    Asset("ANIM", "anim/zg_fx_arrow_yellow.zip"),
}

local function RemoveHand(inst)
	if inst.arm ~= nil then
		inst.arm:Remove()
		inst.arm = nil
	end
	inst:Remove()
end

local function fn0()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst.AnimState:SetBank("zg_fx_arrow_yellow")
    inst.AnimState:SetBuild("zg_fx_arrow_yellow")
	inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    inst.AnimState:SetLayer(LAYER_BACKGROUND)
    inst.AnimState:SetSortOrder(3)
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("projectile")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false
	
	inst:AddComponent("stretcher")
    --inst.components.stretcher:SetRestingLength(4.85)
	inst.components.stretcher:SetRestingLength(2)
    inst.components.stretcher:SetWidthRatio(0)

    return inst
end

--------------------
local function fn()
	local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst:AddTag("projectile")
	
	local light = inst.entity:AddLight()
    inst.Light:Enable(true)
	inst.Light:SetRadius(15)
    inst.Light:SetFalloff(0.3)
    inst.Light:SetIntensity(0.9)
    inst.Light:SetColour(150/255,150/255,255/255)

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false

    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(50)
    inst.components.projectile:SetOnHitFn(function()
		RemoveHand(inst)
	end)
    inst.components.projectile:SetOnMissFn(function()
		RemoveHand(inst)
	end)
	
	inst:DoTaskInTime(0, function()
		inst.arm = SpawnPrefab("zg_fx_arrow_yellow0")
		inst.arm.Transform:SetPosition(inst.Transform:GetWorldPosition())
		inst.arm:FacePoint(inst:GetPosition())
		inst.arm.components.stretcher:SetStretchTarget(inst)
	end)
	
	inst:DoTaskInTime(1, function()
		if inst then 
			RemoveHand(inst)
		end
	end)

    return inst
end

return Prefab("zg_fx_arrow_yellow0", fn0, assets),
	Prefab("zg_fx_arrow_yellow", fn, assets)