local assets =
{
    Asset("ANIM", "anim/zg_fx_arrow_yellow.zip"),
}

local function RemoveHand(inst)
	if inst.arm ~= nil then
		inst.arm:Remove()
		inst.arm = nil
	end
	inst:Remove()
end

local function fn0()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst.AnimState:SetBank("zg_fx_arrow_yellow")
    inst.AnimState:SetBuild("zg_fx_arrow_yellow")
	inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    inst.AnimState:SetLayer(LAYER_BACKGROUND)
    inst.AnimState:SetSortOrder(3)
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("projectile")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false
	
	inst:AddComponent("stretcher")
    --inst.components.stretcher:SetRestingLength(4.85)
	inst.components.stretcher:SetRestingLength(2)
    inst.components.stretcher:SetWidthRatio(0)

    return inst
end

--------------------
local function fn()
	local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst:AddTag("projectile")
	
	local light = inst.entity:AddLight()
    inst.Light:Enable(true)
	inst.Light:SetRadius(15)
    inst.Light:SetFalloff(0.3)
    inst.Light:SetIntensity(0.9)
    inst.Light:SetColour(150/255,150/255,255/255)

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false
	inst.zg_damage = 60 * TUNING.ZG_DIFFICULTY
	
	inst.num_ring = 9

    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(50)
	
	----б
	inst.elecric_ring_table = {}
	
    inst.components.projectile:SetOnHitFn(function(inst, attacker, target)
	
		----Ŀ걻Ͱid뻥б
		if target and target.components.combat and not table.contains(inst.elecric_ring_table, target.GUID) then
			target.components.combat:Zg_GetAttacked(attacker, inst.zg_damage or 0, nil, "zg_ele_electric")
			table.insert(inst.elecric_ring_table, target.GUID)
		end
		
		inst.num_ring = inst.num_ring - 1
		
		----С0Ƴ
		if inst.num_ring <= 0 then
			RemoveHand(inst)
		else
			--Ƴԭarm
			if inst.arm ~= nil then
				inst.arm:Remove()
				inst.arm = nil
			end

			----λĿ(ԸĿΪѰһĿ)
			
			--һĿ겻Ŀ, ϸĿ
			if #(inst.elecric_ring_table) >= 3 then
				table.remove(inst.elecric_ring_table, 1)
			end
			
			local target1 = FindEntity(target, 15, function(guy)
				return guy and 
					not table.contains(inst.elecric_ring_table, guy.GUID) and
					guy.components.health and not guy.components.health:IsDead() and
					guy.components.combat and
					not guy:HasTag("shadowboss") and not guy:HasTag("shadow")							
			end)
			if target1 then
				
				--arm
				inst.arm = SpawnPrefab("zg_fx_arrow_yellow0_ring")
				inst.arm.Transform:SetPosition(inst.Transform:GetWorldPosition())
				inst.arm:FacePoint(inst:GetPosition())
				inst.arm.components.stretcher:SetStretchTarget(inst)
				--
				inst.components.projectile:Throw(inst, target1)
				
			else
				--ûĿƳԼ
				inst:Remove()
			end
		end
	end)
    inst.components.projectile:SetOnMissFn(function()
		RemoveHand(inst)
	end)
	
	inst:DoTaskInTime(0, function()
		inst.arm = SpawnPrefab("zg_fx_arrow_yellow0_ring")
		inst.arm.Transform:SetPosition(inst.Transform:GetWorldPosition())
		inst.arm:FacePoint(inst:GetPosition())
		inst.arm.components.stretcher:SetStretchTarget(inst)
	end)

    return inst
end

return Prefab("zg_fx_arrow_yellow0_ring", fn0, assets),
	Prefab("zg_fx_arrow_yellow_ring", fn, assets)