local assets=
{
	Asset( "ANIM", "anim/zg_fx_axe.zip" ),
}

local function OnThrown(inst, owner, target)
    inst.SoundEmitter:PlaySound("dontstarve/wilson/boomerang_throw")
	inst.AnimState:PlayAnimation("idle", true)
end

local function OnHit(inst, owner, target)
    if target ~= nil and target:IsValid() then
        local impactfx = SpawnPrefab("impact")
        if impactfx ~= nil then
            local follower = impactfx.entity:AddFollower()
            follower:FollowSymbol(target.GUID, target.components.combat.hiteffectsymbol, 0, 0, 0)
            impactfx:FacePoint(inst.Transform:GetWorldPosition())
        end
    end
	inst:Remove()
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst.AnimState:SetBank("zg_fx_axe")
    inst.AnimState:SetBuild("zg_fx_axe")
    inst.AnimState:PlayAnimation("idle", true)
    --inst.AnimState:SetRayTestOnBB(true)

    inst:AddTag("projectile")
    --inst:AddTag("thrown")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(10)
	inst.components.projectile:SetHoming(false)
	inst.components.projectile:SetHitDist(1)
    inst.components.projectile:SetOnThrownFn(OnThrown)
    inst.components.projectile:SetOnHitFn(OnHit)
    --inst.components.projectile:SetOnMissFn(inst.Remove)
	
	inst:DoTaskInTime(5, function()
		inst:Remove()
	end)
	
    return inst
end

return Prefab("zg_fx_axe", fn, assets)