local assets =
{
    Asset("ANIM", "anim/zg_fx_blood.zip"),
}

local function PlayBrokenAnim(proxy)
    local inst = CreateEntity()

    inst:AddTag("FX")
    --[[Non-networked entity]]
    inst.entity:SetCanSleep(false)
    inst.persists = false

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)

    inst.Transform:SetFromProxy(proxy.GUID)

    inst.AnimState:SetBank("broketool")
    inst.AnimState:SetBuild("zg_fx_blood")
    inst.AnimState:PlayAnimation("used")

    inst:ListenForEvent("animover", inst.Remove)
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddNetwork()

    --Delay one frame so that we are positioned properly before starting the effect
    --or in case we are about to be removed
    inst:DoTaskInTime(0, PlayBrokenAnim)

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false
    inst:DoTaskInTime(1, inst.Remove)

    return inst
end

return Prefab("zg_fx_blood", fn, assets)
