local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst.persists=false
	
	inst:AddComponent("burnable")
    inst.components.burnable:SetFXLevel(4)
    inst.components.burnable:SetBurnTime(1)
    inst.components.burnable:AddBurnFX("fire", Vector3(0, 0, 0) )
    inst.components.burnable:SetOnIgniteFn(nil)
    inst.components.burnable:SetOnExtinguishFn(inst.Remove)
    inst.components.burnable:Ignite()
	
	--每秒伤害
	inst.zg_damage=30	--60
	--每秒升温
	inst.zg_temp=5
	--检测范围
	inst.zg_radius=2
	
	local period=1/30
	inst:DoPeriodicTask(period, function()
		local x, y, z = inst.Transform:GetWorldPosition()
		----烧火
		local ents = TheSim:FindEntities(x, y, z, inst.zg_radius, nil, {"campfire"})
		for k, v in pairs(ents) do
			
			--不伤害自己主人
			if v and inst and inst.master and v~=inst.master 
				then
				
				
				--local dist = v:GetPosition():Dist( inst:GetPosition() )
				--local v_radius = v.Physics and v.Physics:GetRadius() or 0
				--if inst.zg_radius + v_radius >= dist then
				
					--[[
					if v and v.components.burnable 
						and not (inst.master:HasTag("zg_goblin") and v:HasTag("shadowboss")) --哥布林不打人形
						and not (inst.master:HasTag("zg_goblin") and v:HasTag("zg_goblin")) --哥布林不打哥布林
						and not (inst.master:HasTag("shadowboss") and v:HasTag("shadowboss")) --人形不打人形
						and not (inst.master:HasTag("player") and v:HasTag("player")) --玩家不打玩家
						then		
						if not (v.components.inventoryitem and v.components.inventoryitem:IsHeld() ) then
							v.components.burnable:Ignite(nil,inst.master,true)
						end
					end]]
					
					if v.components.health and not v.components.health:IsDead() and v.components.combat 
						and not (inst.master:HasTag("zg_goblin") and v:HasTag("shadowboss")) --哥布林不打人形
						and not (inst.master:HasTag("zg_goblin") and v:HasTag("zg_goblin")) --哥布林不打哥布林
						and not (inst.master:HasTag("shadowboss") and v:HasTag("shadowboss")) --人形不打人形
						and not (inst.master:HasTag("player") and v:HasTag("player")) --玩家不打玩家
						then
						v.components.health:DoFireDamage(period*inst.zg_damage,inst.master,true, true)	--第四个参数是不显示伤害显示	
						v.components.combat:SuggestTarget(inst.master)	--知道肇事者
					end
					--[[
					if v.components.temerature then
						v.components.temerature:DoDelta(period*inst.zg_temp)
					end]]
				--end
				
			end

		end
	end)

    return inst
end

return Prefab("zg_fx_firegunfire", fn)