local assets =
{
	Asset("ANIM", "anim/zg_luffy_longarm.zip"),
	Asset("ANIM", "anim/zg_luffy_longarm2.zip"),
}

local function fn()
    local inst = CreateEntity()

    inst:AddTag("NOCLICK")
    inst:AddTag("FX")

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()

    inst.AnimState:SetBank("shadowcreatures")
    inst.AnimState:SetBuild("zg_luffy_longarm2")
    inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    inst.AnimState:SetLayer(LAYER_BACKGROUND)
    inst.AnimState:SetSortOrder(3)
    inst.AnimState:PlayAnimation("arm_loop",true)

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst.persists = false

    inst:AddComponent("stretcher")
    inst.components.stretcher:SetRestingLength(4.85)
    inst.components.stretcher:SetWidthRatio(0)
	--inst.components.stretcher:SetWidthRatio(0)
	
	--测试伸长
	--[[
	inst:DoPeriodicTask(1, function()
		local invader = nil
		invader = FindEntity(inst, 15, function(guy)
			return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
		end)
		if invader then
			inst.components.stretcher:SetStretchTarget(invader)
		end
	end)
	
	inst:AddComponent("health")
	inst.components.health:SetMaxHealth(100)]]

    return inst
end

local function RemoveHand(inst)
	if inst.arm ~= nil then
		inst.arm:Remove()
		inst.arm = nil
	end
	inst:Remove()
end

local function fn1()
    local inst = CreateEntity()

    inst:AddTag("NOCLICK")
    inst:AddTag("FX")

    inst.entity:AddTransform()
	--inst.Transform:SetScale(2,2,2)
	
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()
	
	MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst.AnimState:SetBank("zg_luffy_longarm")
    inst.AnimState:SetBuild("zg_luffy_longarm")
    inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    inst.AnimState:SetLayer(LAYER_BACKGROUND)
    inst.AnimState:SetSortOrder(3)
    inst.AnimState:PlayAnimation("hand")
	
	inst:AddTag("projectile")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst.persists = false
	
	inst:DoTaskInTime(0, function()
		inst.arm = SpawnPrefab("zg_fx_luffyarm")
		inst.arm.Transform:SetPosition(inst.Transform:GetWorldPosition())
		inst.arm:FacePoint(inst:GetPosition())
		inst.arm.components.stretcher:SetStretchTarget(inst)
	end)
	
	inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(12.5)
    inst.components.projectile:SetOnHitFn(function(inst, owner, target)
		
	end)
	--inst.components.projectile:SetOnThrownFn(OnThrown)
    --inst.components.projectile:SetOnMissFn(RemoveHand(inst))
	
	inst:DoTaskInTime(3, function()
		if inst then 
			RemoveHand(inst)
		end
	end)

    return inst
end

-------------------------------------------------------------------------------------------------
local function RemoveHand2(inst)
	if inst.arm ~= nil then
		inst.arm:Remove()
		inst.arm = nil
	end
	if inst.hand ~= nil then
		if inst.hand.arm ~= nil then
			inst.hand.arm:Remove()
			inst.hand.arm = nil
		end
		inst.hand:Remove()
		inst.hand = nil
	end
	inst:Remove()
end

local function fn2()
    local inst = CreateEntity()

    inst:AddTag("NOCLICK")
    inst:AddTag("FX")

    inst.entity:AddTransform()
	inst.Transform:SetScale(2,2,2)
	
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()
	
	MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst.AnimState:SetBank("zg_luffy_longarm")
    inst.AnimState:SetBuild("zg_luffy_longarm")
    inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    inst.AnimState:SetLayer(LAYER_BACKGROUND)
    inst.AnimState:SetSortOrder(3)
    inst.AnimState:PlayAnimation("hand")
	
	inst:AddTag("projectile")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst.persists = false
	
	inst:DoTaskInTime(0, function()
		inst.arm = SpawnPrefab("zg_fx_luffyarm")
		inst.arm.Transform:SetPosition(inst.Transform:GetWorldPosition())
		inst.arm:FacePoint(inst:GetPosition())
		inst.arm.components.stretcher:SetStretchTarget(inst)
		
		----另一只手平行
		inst.hand = SpawnPrefab("zg_fx_luffyhand")
		local heading_angle = inst.Transform:GetRotation()
		local dir = Vector3(-math.sin(heading_angle * DEGREES)*.25, 0, -math.cos(heading_angle * DEGREES)*.25)
		inst.hand.entity:SetParent(inst.entity)
		inst.hand.Transform:SetPosition(dir:Get())
	end)
	
	inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(10)
	--inst.components.projectile:SetHoming(false)
	--inst.components.projectile:SetHitDist(3)
    inst.components.projectile:SetOnHitFn(function(inst, owner, target)
		if inst and owner and target then
			--local x, y, z = owner.Transform:GetWorldPosition()
			--target.Transform:SetPosition(x, y, z)
			if math.random() < .5 then
				local x, y, z = owner.Transform:GetWorldPosition()
				target.Transform:SetPosition(x, y, z)
			else
				local x, y, z = target.Transform:GetWorldPosition()
				owner.Transform:SetPosition(x, y, z)
			end
			--local x, y, z = target.Transform:GetWorldPosition()
			--owner.Transform:SetPosition(x, y, z)
			if owner.components.health and not owner.components.health:IsDead() and owner.sg then
				--if math.random() < .5 then
					owner.sg:GoToState("attack_zf")
				--end
			end
			RemoveHand2(inst)
		end
		
	end)
	
	inst:DoTaskInTime(3, function()
		if inst then 
			RemoveHand2(inst)
		end
	end)

    return inst
end

return Prefab("zg_fx_luffyarm", fn, assets),
	Prefab("zg_fx_luffyhand", fn1, assets),
	Prefab("zg_fx_luffyhand2", fn2, assets)