local assets =
{
	Asset("ANIM", "anim/zg_luffy_longarm.zip"),
	Asset("ANIM", "anim/zg_luffy_longarm2.zip"),
}

-------------------------------------------------------------------------------------------------
local function RemoveHand2(inst)
	if inst.arm ~= nil then
		inst.arm:Remove()
		inst.arm = nil
	end
	inst:Remove()
end

local function fn2()
    local inst = CreateEntity()

    inst:AddTag("NOCLICK")
    inst:AddTag("FX")

    inst.entity:AddTransform()
	inst.Transform:SetScale(2,2,2)
	
	inst.entity:AddSoundEmitter()
	
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()
	
	MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst.AnimState:SetBank("zg_luffy_longarm")
    inst.AnimState:SetBuild("zg_luffy_longarm")
    inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    inst.AnimState:SetLayer(LAYER_BACKGROUND)
    inst.AnimState:SetSortOrder(3)
    inst.AnimState:PlayAnimation("hand")
	
	inst:AddTag("fx")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst.persists = false
	
	----生成橡胶手臂
	inst:DoTaskInTime(0, function()
		inst.arm = SpawnPrefab("zg_fx_luffyarm")
		inst.arm.Transform:SetPosition(inst.Transform:GetWorldPosition())
		inst.arm:FacePoint(inst:GetPosition())
		inst.arm.components.stretcher:SetStretchTarget(inst)
		inst.SoundEmitter:PlaySound("dontstarve/tentacle/tentacle_attack")
	end)
	
	----物理
	local period = 1/30
	inst.collide_task_table = {}
	inst:DoPeriodicTask(period, function()
	
		local pt = inst:GetPosition()	
		local r = 1
		local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "shadowboss"})
		
		for k,v in pairs(ents) do
			if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
				
				if not table.contains(inst.collide_task_table, v.GUID) then
					v.components.combat:Zg_GetAttacked(inst, 30 *  TUNING.ZG_DIFFICULTY)
					table.insert(inst.collide_task_table, v.GUID)
				end
				
			end
		end
		
	end)
	
	inst:DoTaskInTime(.5, function()
		if inst then 
			RemoveHand2(inst)
		end
	end)

    return inst
end

return Prefab("zg_fx_luffyhand_jgq", fn2, assets)







