local assets = 
{
	Asset("ANIM", "anim/zg_fx_manshape.zip"),
}

local bosstable1 =
{
	"zg_ch_wilson",
	"zg_ch_willow",
	"zg_ch_wolfgang",
	"zg_ch_wendy",
	"zg_ch_wx78",
	"zg_ch_wicker",
	"zg_ch_woodie",
	"zg_ch_wes",
	"zg_ch_waxwell",		
	"zg_ch_wigfrid",
	"zg_ch_webber",
}

local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetScale(3,3,3)
	--inst.Transform:SetFourFaced()
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("zg_fx_manshape")
	inst.AnimState:SetBuild("zg_fx_manshape")
	
	inst.AnimState:PlayAnimation("idle", true)
	
	--MakeCharacterPhysics(inst, 100, 2)
    
	inst.entity:AddSoundEmitter()
	
	inst.entity:AddNetwork()
	
	inst.entity:SetPristine()
	
	if not TheWorld.ismastersim then
        return inst
    end 
	
	--if inst._fx ~= nil then
	--	inst._fx:kill_fx()
	--end
	--inst._fx = SpawnPrefab("forcefieldfx")
	--inst._fx.entity:SetParent(inst.entity)
	--inst._fx.Transform:SetPosition(0, 0.2, 0)
	
	inst.zg_boss = bosstable1[math.random(#bosstable1)]
	
	inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("会中奖得到什么人形怪呢?")
	
	inst.OnSave = function(inst, data)
		if data then
			data.zg_boss = inst.zg_boss
		end
	end
	inst.OnLoad = function(inst, data)
		inst.zg_boss = data and data.zg_boss or bosstable1[math.random(#bosstable1)]
	end
	
	inst:DoTaskInTime(.25, function()
		inst:DoTaskInTime(20, function()
			if inst then
				SpawnPrefab(inst.zg_boss).Transform:SetPosition(inst.Transform:GetWorldPosition())
			end
			inst:Remove()
		end)
	end)

	return inst
end

local bosstable2 =
{
	"zg_ch2_wilson",
	"zg_ch2_willow",
	"zg_ch2_wolfgang_mighty",
	"zg_ch2_wendy",
	"zg_ch2_wx78",
	"zg_ch2_wickerbottom",
	"zg_ch2_woodie",
	"zg_ch2_wes",
	"zg_ch2_waxwell",		
	"zg_ch2_wathgrithr",
	"zg_ch2_webber",
}

local function fn2()
	local inst=fn()
	if not TheWorld.ismastersim then
        return inst
    end 
	inst.zg_boss = bosstable2[math.random(#bosstable2)]
	inst.components.inspectable:SetDescription("这个转盘和上一个不一样")
	
	inst.OnSave = function(inst, data)
		if data then
			data.zg_boss = inst.zg_boss
		end
	end
	inst.OnLoad = function(inst, data)
		inst.zg_boss = data and data.zg_boss or bosstable2[math.random(#bosstable2)]
	end
	return inst
end

STRINGS.NAMES.ZG_FX_MANSHAPE = "人形兵器转盘"
STRINGS.NAMES.ZG_FX_MANSHAPE2 = "貌似并不能抽奖的抽奖转盘"
return Prefab("zg_fx_manshape", fn, assets),
	Prefab("zg_fx_manshape2", fn2, assets)
