
local bosstable2 =
{
	"zg_ch1_luffy",
	"zg_ch1_zoro",
	"zg_ch1_sanji",
	"zg_ch1_buggy",
}

local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	--inst.Transform:SetScale(3,3,3)
	--inst.Transform:SetFourFaced()
	
	inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize(6, 3.5)
	
	inst.entity:AddLight()
	inst.Light:Enable(true)
    inst.Light:SetIntensity(.9)
    inst.Light:SetColour(255 / 255, 0 / 255, 0 / 255)
    inst.Light:SetFalloff(0.3)
    inst.Light:SetRadius(12)
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("zg_fx_manshape1")
	inst.AnimState:SetBuild("zg_fx_manshape1")
	
	inst.AnimState:PlayAnimation("idle", true)
	
	--MakeCharacterPhysics(inst, 100, 2)
    
	inst.entity:AddSoundEmitter()
	
	inst.entity:AddNetwork()
	
	inst.entity:SetPristine()
	
	if not TheWorld.ismastersim then
        return inst
    end 
	
	inst.zg_boss = bosstable2[math.random(#bosstable2)]
	
	inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("做好战斗准备吧!")
	
	inst.OnSave = function(inst, data)
		if data then
			data.zg_boss = inst.zg_boss
		end
	end
	inst.OnLoad = function(inst, data)
		inst.zg_boss = data and data.zg_boss or bosstable2[math.random(#bosstable2)]
	end
	
	inst:DoTaskInTime(9 * math.random(6), function()
		if inst then
			if inst.zg_boss == "zg_ch1_luffy" then
			
				inst.SoundEmitter:PlaySound("zg_ch1_luffy/zg_ch1_luffy/baga")
				for k,v in pairs(AllPlayers) do
					if v and v.components.talker then
						v.components.talker:Say("那个一定要成为海贼王的人来了")
					end
				end
				
				inst:DoTaskInTime(12, function()
					SpawnPrefab(inst.zg_boss).Transform:SetPosition(inst.Transform:GetWorldPosition())
					inst.SoundEmitter:PlaySound("zg_appear_onepiece/zg_appear_onepiece/"..inst.zg_boss)
					
					inst:Remove()
				end)
			else
				SpawnPrefab(inst.zg_boss).Transform:SetPosition(inst.Transform:GetWorldPosition())
				inst.SoundEmitter:PlaySound("zg_appear_onepiece/zg_appear_onepiece/"..inst.zg_boss)
				
				inst:Remove()
			end
		end
		--inst:DoTaskInTime(9, function()
		--	inst:Remove()
		--end
	end)

	return inst

end

STRINGS.NAMES.ZG_FX_MANSHAPE1 = "海贼传送门?"
return Prefab("zg_fx_manshape1", fn)
