local function fn_fx()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	local s=1
	inst.Transform:SetScale(s,s,s)
	
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    --inst.Transform:SetFourFaced()

    inst.AnimState:SetBank("zg_fx_mihawkhsqj")
    inst.AnimState:SetBuild("zg_fx_mihawkhsqj")
	inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    inst.AnimState:SetLayer(LAYER_BACKGROUND)
    inst.AnimState:SetSortOrder(3)
    inst.AnimState:PlayAnimation("idle")
	inst.AnimState:SetAddColour(0, 1, 1, 0)

    inst:AddTag("FX")
	inst:AddTag("NOCLICK")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false
	
	----物理
	local period = 1/30
	inst.collide_task_table = {}
	inst:DoPeriodicTask(period, function()
	
		local pt = inst:GetPosition()	
		local r = 3
		local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "shadowboss","playerghost"})
		
		for k,v in pairs(ents) do
			if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
				
				if not table.contains(inst.collide_task_table, v.GUID) then
					v.components.combat:Zg_GetAttacked(inst, 120*TUNING.ZG_DIFFICULTY, nil, "zg_ele_bone")
					if math.random() <.25*TUNING.ZG_DIFFICULTY and v:HasTag("player") then
						v:PushEvent("zg_buff_knockout")
					end
					table.insert(inst.collide_task_table, v.GUID)
				end
				
			end
		end
		
	end)
	
	inst:DoTaskInTime(3, function()
		if inst then 
			inst:Remove()
		end
	end)

    return inst
end

STRINGS.NAMES.ZG_FX_MIHAWKHSQJ = "鹰眼の斩击"
return Prefab("zg_fx_mihawkhsqj", fn_fx)






