local function fn_fx()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetScale(2,2,2)
	
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst.AnimState:SetBank("zg_mihawk_jq")
    inst.AnimState:SetBuild("zg_mihawk_jq")

    inst.AnimState:PlayAnimation("idle", true)

	inst:AddTag("NOCLICK")
    inst:AddTag("FX")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false
	--
	local period = 1/30
	inst.collide_task_table = {}
	inst:DoPeriodicTask(period, function()
	
		local pt = inst:GetPosition()	
		local r = 3
		local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "shadowboss","playerghost"})
		
		for k,v in pairs(ents) do
			if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
				
				if not table.contains(inst.collide_task_table, v.GUID) then
					v.components.combat:Zg_GetAttacked(inst, 60 *  TUNING.ZG_DIFFICULTY, nil, "zg_ele_bone")
					table.insert(inst.collide_task_table, v.GUID)
				end
				
			end
		end
		
	end)
	
	inst:DoTaskInTime(3, function()
		if inst then 
			inst:Remove()
		end
	end)

    return inst
end

return Prefab("zg_fx_mihawkjq", fn_fx)
