local function fn()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddSoundEmitter()
	inst.entity:AddAnimState()
	inst.entity:AddNetwork()

	inst.AnimState:SetBank("max_fx")
	inst.AnimState:SetBuild("max_fx")
	inst.AnimState:PlayAnimation("anim")
	inst.AnimState:SetAddColour(0, 1, 1, 0)
	
	MakeInventoryPhysics(inst)
	RemovePhysicsColliders(inst)
	
	inst:AddTag("FX")
	inst:AddTag("NOCLICK")

	inst.entity:SetPristine()
	if not TheWorld.ismastersim then
		return inst
	end
	
	inst.persists=false
	
	inst:DoTaskInTime(0,function()
		if inst then
			local pt = inst:GetPosition()	
			local r = inst.Transform:GetScale() * 2
			local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "shadowboss"})
			for k,v in pairs(ents) do
				if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
					--if not table.contains(inst.collide_task_table, v.GUID) then
						v.components.combat:Zg_GetAttacked(inst, 1200/inst.Transform:GetScale()*TUNING.ZG_DIFFICULTY )
					--	table.insert(inst.collide_task_table, v.GUID)
					--end
					if math.random() <.25*TUNING.ZG_DIFFICULTY and v:HasTag("player") then
						v:PushEvent("zg_buff_knockout")
					end
				end
			end
		end
	end)
	
	--inst:ListenForEvent("animover",inst.Remove)
	inst:DoTaskInTime(2,function()
		if inst then
			inst:Remove()
		end
	end)
	
	return inst
end

STRINGS.NAMES.ZG_FX_MIHAWKSMOKE = "世界第一の斩击"
return Prefab("zg_fx_mihawksmoke", fn)