
local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetScale(1.5,1.5,1.5)
	
    inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("zg_we_blacknight")
    inst.AnimState:SetBuild("zg_we_blacknight")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("sharp")
	inst:AddTag("shadow")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_we_blacknight.xml"
	inst.components.inventoryitem.imagename = "zg_we_blacknight"
	inst.components.inventoryitem.nobounce = true
	inst.components.inventoryitem.onpickupfn=function(inst,guy)
		if guy then
			guy:DoTaskInTime(0,function()
				if guy.components.inventory then
					guy.components.inventory:DropItem(inst)
				end
				SpawnPrefab("lightning")
				TheNet:Announce("大剑豪现身")
				local man=wy_spawn(inst,"zg_ch3_mihawk",{math.random()*4-8,0,math.random()*4-8})
				wy_spawn(man,"collapse_small")
				inst:Remove()
			end)
		end
	end

    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("只有世界第一剑豪才配得上这把剑")

    return inst
end

STRINGS.NAMES.ZG_FX_MIHAWKSYMBOL = "黑刀·夜 乱刃重花丁字" 
return Prefab("zg_fx_mihawksymbol", fn)