
local assets={

}

local proj_defs =
{
	--阿比盖尔
    {
		name="abi",
		bank="abigail_flower",
		build="abigail_flower",
		anim="idle_1",
		onhit=function(inst, owner, target)
			if target then 
				if owner.abi~=nil then
					owner.abi.components.health:Kill()
					owner.abi=nil
				end
				if owner.abi==nil then
					local abi=zg_spawn(target,"zg_mo1_abi")
					abi.components.follower:SetLeader(owner)	
					owner.abi=abi
				end
				inst:Remove()
			end
		end,
	},
	
	--发条主教
	{
		name="bishop",
		bank="bishop_attack",
		build="bishop_attack",
		anim="idle",
		onhit=function(inst, owner, target)
			if target then 
				if owner.abi~=nil then
					owner.abi.components.health:Kill()
					owner.abi=nil
				end
				if owner.abi==nil then
					local abi=zg_spawn(target,"zg_mo1_bishop")
					abi.components.follower:SetLeader(owner)	
					owner.abi=abi
				end
				inst:Remove()
			end
		end,
	},
	
	--红色弓的箭矢
	{
		name="redbow",
		bank="blow_dart",
		build="blow_dart",
		anim="dart_pipe",
		multcolour={1,0,0,1},
		homing="no",
		speed=30,
		--hitdist=.25,		--math.sqrt(5),
		offset=Vector3(.5,1,0),
		onthrown=function(inst,data) inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround) end,
		onhit=function(inst, attacker, target) zg_spawn(target,"impact") inst:Remove() end,
		onmiss=function(inst) inst:Remove() end,
	},
	
	--骨头弓的箭矢
	{
		name="bonebow",
		bank="blow_dart",
		build="blow_dart",
		anim="dart_pipe",
		--multcolour={1,0,0,1},
		addcolour={1,1,1,0},
		homing="no",
		speed=30,
		--hitdist=.25,		--math.sqrt(5),
		offset=Vector3(.5,1,0),
		onthrown=function(inst,data) inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround) end,
		onhit=function(inst, attacker, target) zg_spawn(target,"impact") inst:Remove() end,
		onmiss=function(inst) inst:Remove() end,
	},
	
	--火焰喷射器
	{
		name="firegun",
		bank="projectile",
		build="staff_projectile",
		anim="fire_spin_loop",
		homing="no",
		speed=30,
		offset=Vector3(.5,1,0),
		zg_exttime=.5,
		--hitdist=0,	--特殊,因为不是要这个虚拟的抛射物去击中目标
		zg_isvirtual=true,
		onthrown=function(inst,data)
			local attacker=data.attacker
			inst:DoPeriodicTask(2/30, function()
				local fire=zg_spawn(inst,"zg_fx_firegunfire")
				fire.master=attacker	--设置主人
			end)
		end,
	},
	
	--玩家火焰喷射器
	{
		name="firegun_player",
		bank="projectile",
		build="staff_projectile",
		anim="fire_spin_loop",
		homing="no",
		speed=30,
		offset=Vector3(.5,1,0),
		zg_exttime=.5,
		--hitdist=0,	--特殊,因为不是要这个虚拟的抛射物去击中目标
		zg_isvirtual=true,
		onthrown=function(inst,data)
			local attacker=data.attacker
			inst:DoPeriodicTask(2/30, function()
				local fire=zg_spawn(inst,"zg_fx_firegunfire")
				fire.master=attacker	--设置主人
				fire.zg_damage=50
			end)
		end,
	},
}

local function MakeProj(def)
 
    local function fn()
        local inst = CreateEntity()

        inst.entity:AddTransform()
        inst.entity:AddAnimState()
        inst.entity:AddSoundEmitter()
        inst.entity:AddNetwork()

        MakeInventoryPhysics(inst)
		RemovePhysicsColliders(inst)

        inst.AnimState:SetBank(def.bank)
        inst.AnimState:SetBuild(def.build)
        inst.AnimState:PlayAnimation(def.anim or "idle", true)
		
		local multcolour=def.multcolour
		if multcolour then
			inst.AnimState:SetMultColour(multcolour[1] or 1,multcolour[2] or 1,multcolour[3] or 1,multcolour[4] or 1)
		end
		local addcolour=def.addcolour
		if addcolour then
			inst.AnimState:SetAddColour(addcolour[1] or 1,addcolour[2] or 1,addcolour[3] or 1,addcolour[4] or 0)
		end
		
		inst:AddTag("projectile")

        inst.entity:SetPristine()

        if not TheWorld.ismastersim then
            return inst
        end
		
		inst.persists=false

		inst:AddComponent("projectile")
		if def.homing=="no" then
			inst.components.projectile:SetHoming(false)
		end
		inst.components.projectile:SetSpeed(def.speed or 50)
		inst.components.projectile:SetOnHitFn(def.onhit or inst.Remove)
		inst.components.projectile:SetOnMissFn(def.onmiss or def.onhit or inst.Remove)
		inst.components.projectile:SetHitDist(def.hitdist or 1)
		--inst.components.projectile:SetLaunchOffset(Vector3(3, 2, 0))
		inst.components.projectile:SetLaunchOffset( def.offset or Vector3(0, 0, 0))
		
		inst:ListenForEvent("onthrown", def.onthrown or function() end)
		
		--需要修正throw
		function inst.components.projectile:Throw(owner, target, attacker)
			if def.zg_isvirtual then
				self.owner = owner
				self.target = target
				self.start = owner:GetPosition()
				self.dest = target:GetPosition()

				if attacker ~= nil and self.launchoffset ~= nil then
					local x, y, z = self.inst.Transform:GetWorldPosition()
					local facing_angle = attacker.Transform:GetRotation() * DEGREES
					self.inst.Transform:SetPosition(x + self.launchoffset.x * math.cos(facing_angle), y + self.launchoffset.y, z - self.launchoffset.x * math.sin(facing_angle))
					
					local angle = attacker:GetAngleToPoint(self.dest)
					self.inst.Transform:SetRotation(angle)
				end
				
				--self:RotateToTarget(self.dest)	--不用传统的瞄准目标函数
				self.inst.Physics:SetMotorVel(self.speed, 0, 0)
				--self.inst:StartUpdatingComponent(self)	--不需要更新
				self.inst:PushEvent("onthrown", { thrower = owner, target = target, attacker=attacker })		--补全事件的参数,官方没有传递attacker这个参数
				--target:PushEvent("hostileprojectile", { thrower = owner, attacker = attacker, target = target })	--只是轨迹引导者
				if self.onthrown ~= nil then
					self.onthrown(self.inst, owner, target)
				end
				--if self.cancatch and target.components.catcher ~= nil then	--只是轨迹引导者
				--	target.components.catcher:StartWatching(self.inst)
				--end
				self.inst:DoTaskInTime(def.zg_exttime or 1,self.inst.Remove)
			else
				self.owner = owner
				self.target = target
				self.start = owner:GetPosition()
				self.dest = target:GetPosition()
				
				--发射攻击者
				self.zg_attacker=attacker or owner
				--发射从武器定义过来的伤害
				self.zg_damage=owner and owner.zg_damage or 0

				if attacker ~= nil and self.launchoffset ~= nil then
					local x, y, z = self.inst.Transform:GetWorldPosition()
					local facing_angle = attacker.Transform:GetRotation() * DEGREES
					self.inst.Transform:SetPosition(x + self.launchoffset.x * math.cos(facing_angle), y + self.launchoffset.y, z - self.launchoffset.x * math.sin(facing_angle))
				end

				self:RotateToTarget(self.dest)
				self.inst.Physics:SetMotorVel(self.speed, 0, 0)
				self.inst:StartUpdatingComponent(self)
				
				self.inst:PushEvent("onthrown", { thrower = owner, target = target, attacker=self.zg_attacker, zg_damage=self.zg_damage })		--补全参数
				
				target:PushEvent("hostileprojectile", { thrower = owner, attacker = attacker, target = target })
				if self.onthrown ~= nil then
					self.onthrown(self.inst, owner, target)
				end
				if self.cancatch and target.components.catcher ~= nil then
					target.components.catcher:StartWatching(self.inst)
				end
			end
		end
		
		--需要修正hit
		function inst.components.projectile:Hit(target)
			local attacker = self.owner
			local weapon = self.inst
			self:Stop()
			self.inst.Physics:Stop()
			--
			if attacker ~= nil and attacker.components.combat == nil and attacker.components.weapon ~= nil and attacker.components.inventoryitem ~= nil then
				weapon = attacker
				attacker = weapon.components.inventoryitem.owner
			end
			if attacker ~= nil and attacker.components.combat ~= nil then
				attacker.components.combat:DoAttack(target, weapon, self.inst, self.stimuli)
			end
			
			--被抛射物打中的伤害
			if self.zg_damage and self.zg_damage>0 then
				if zg_isalive(target) then 
					target.components.combat:Zg_GetAttacked(attacker or self.zg_attacker, self.zg_damage) 
				end	
			end
			
			--击中的效果
			if self.onhit ~= nil then
				self.onhit(self.inst, attacker or self.zg_attacker, target)		--这样可以保证对于弓箭枪械这样的, 在发射的同时消耗耐久 而不是击中才消耗耐久 的现象, 正确运行
			end
		end

        return inst
    end

    return Prefab("zg_proj_"..def.name, fn, assets)
end


--返回prefabs
local projs = {}
for i, v in ipairs(proj_defs) do
    table.insert(projs, MakeProj(v))
end
proj_defs = nil
return unpack(projs)