local assets =
{
    Asset("ANIM", "anim/ds_spider_basic.zip"),
    --Asset("ANIM", "anim/spider_build.zip"),
    --Asset("SOUND", "sound/spider.fsb"),
}

local function OnHit(inst, attacker, target)
    --inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/firesupressor_impact")
    SpawnPrefab("zg_mo_greenspider").Transform:SetPosition(inst.Transform:GetWorldPosition())
    --inst.components.wateryprotection:SpreadProtection(inst)
    inst:Remove()
end

local function fn()
	local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetScale(1.3,1.3,1.3)
	
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

	inst.entity:AddPhysics()
	inst.Physics:SetMass(1)
	inst.Physics:SetCapsule(0.2, 0.2)
	inst.Physics:SetFriction(0)
	inst.Physics:SetDamping(0)
	inst.Physics:SetCollisionGroup(COLLISION.CHARACTERS)
	inst.Physics:ClearCollisionMask()
	inst.Physics:CollidesWith(COLLISION.WORLD)

    inst.AnimState:SetBank("spider")
    inst.AnimState:SetBuild("zg_mo_greenspider")
    inst.AnimState:PlayAnimation("idle")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst.persists = false

    inst:AddComponent("locomotor")
    --inst:AddComponent("wateryprotection")

    inst:AddComponent("complexprojectile")
    inst.components.complexprojectile:SetHorizontalSpeed(15)
    inst.components.complexprojectile:SetGravity(-25)
    inst.components.complexprojectile:SetLaunchOffset(Vector3(0, .5, 0))
    inst.components.complexprojectile:SetOnHit(OnHit)

    return inst
end

return Prefab("zg_fx_spider", fn, assets)