local easing = require("easing")

local assets =
{  
	
}

local function LaunchProj(inst)
	local r=6
	local angle_d=360/inst.numspider
	inst:StartThread(function()
		for k = 1, inst.numspider do
			
			local x, y, z = inst.Transform:GetWorldPosition()
			local targetpos = Vector3( x + r*math.cos(angle_d*(k-1)*DEGREES), 0, z - r*math.sin(angle_d*(k-1)*DEGREES) )

			local projectile = SpawnPrefab("zg_fx_spider")
			projectile.Transform:SetPosition(x, y, z)

			local dx = targetpos.x - x
			local dz = targetpos.z - z
			local rangesq = dx * dx + dz * dz
			local maxrange = 15
			local speed = easing.linear(rangesq, 15, 3, maxrange * maxrange)
			projectile.components.complexprojectile:SetHorizontalSpeed(speed)
			projectile.components.complexprojectile:SetGravity(-25)
			projectile.components.complexprojectile:Launch(targetpos, inst, inst)
			
			Sleep(.1)
		end
	end)
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --inst.entity:AddMiniMapEntity()
    inst.entity:AddNetwork()

    --inst.MiniMapEntity:SetIcon("wormhole.png")

    inst.AnimState:SetBank("teleporter_worm")
    inst.AnimState:SetBuild("teleporter_sickworm_build")
    inst.AnimState:PlayAnimation("idle_loop", true)
	
	inst.AnimState:SetMultColour(0,1,0,1)

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst.persists=false

    inst:AddComponent("inspectable")
	
	inst.numspider = 6
	
	inst.LaunchProj=LaunchProj
	
	inst:SetStateGraph("sg_spiderhole")
	
	inst:DoTaskInTime(.1,function()
		inst.sg:GoToState("opening")
	end)
	
    return inst
end

STRINGS.NAMES[string.upper("zg_fx_spiderhole")]=zg_ischs("恶心的虫洞","Lousy Wormhole")
STRINGS.CHARACTERS.GENERIC.DESCRIBE[string.upper("zg_fx_spiderhole")]=zg_ischs("它通向某个空间","It leads to a space")
return Prefab("zg_fx_spiderhole", fn, assets)
