local function PlayWarningSound(proxy, radius)
    local inst = CreateEntity()

    --[[Non-networked entity]]

    inst.entity:AddTransform()
    inst.entity:AddSoundEmitter()
    inst.entity:SetParent(TheFocalPoint.entity)

    --Everyone gets their own hounds and therefore their own warnings
    local theta = math.random() * 2 * PI

    inst.Transform:SetPosition(radius * math.cos(theta), 0, radius * math.sin(theta))
    inst.SoundEmitter:PlaySound("dontstarve/zg/ch2_wukong/appear")

    inst:Remove()
end

local function fn()
	local inst = CreateEntity()

	inst.entity:AddNetwork()

	inst:AddTag("FX")

	--Dedicated server does not need to spawn the local fx
	if not TheNet:IsDedicated() then
		--Delay one frame in case we are about to be removed
		inst:DoTaskInTime(0, PlayWarningSound, 30)
	end

	inst.entity:SetPristine()

	if not TheWorld.ismastersim then
		return inst
	end

	inst.entity:SetCanSleep(false)
	inst.persists = false

	inst:DoTaskInTime(30, inst.Remove)

	return inst
end

return Prefab("zg_fx_wukong_appear", fn)