local function fn_fx()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetScale(.675,.675,.675)
	
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    --inst.Transform:SetFourFaced()

    inst.AnimState:SetBank("zg_fx_zoromoon")
    inst.AnimState:SetBuild("zg_fx_zoromoon")
	inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    inst.AnimState:SetLayer(LAYER_BACKGROUND)
    inst.AnimState:SetSortOrder(3)
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("fx")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false
	
	----物理
	local period = 1/30
	inst.collide_task_table = {}
	inst:DoPeriodicTask(period, function()
	
		local pt = inst:GetPosition()	
		local r = 2
		local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "shadowboss"})
		
		for k,v in pairs(ents) do
			if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
				
				if not table.contains(inst.collide_task_table, v.GUID) then
					v.components.combat:Zg_GetAttacked(inst, 15 *  TUNING.ZG_DIFFICULTY, nil, "zg_ele_bone")
					table.insert(inst.collide_task_table, v.GUID)
				end
				
			end
		end
		
	end)
	
	inst:DoTaskInTime(1.5, function()
		if inst then 
			inst:Remove()
		end
	end)


    return inst
end

STRINGS.NAMES.ZG_FX_ZOROMOON = "索隆の新月"
return Prefab("zg_fx_zoromoon", fn_fx)






