

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetScale(1.5,1.5,1.5)
	
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst.AnimState:SetBank("zg_fx_zorotornado")
    inst.AnimState:SetBuild("zg_fx_zorotornado")
    inst.AnimState:PlayAnimation("idle", true)

    inst:AddTag("projectile")

	inst.entity:SetPristine()
    if not TheWorld.ismastersim then
        return inst
    end
	
	inst.persists = false

	--[[
    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(7)
    inst.components.projectile:SetOnHitFn(function() 
		inst:DoTaskInTime(1, function()
			inst:Remove()
		end)
	end)
    inst.components.projectile:SetOnMissFn(function() end)
	inst.components.projectile:SetHoming(false)
	inst.components.projectile:SetHitDist(3)]]
	
	--[[
	inst:DoPeriodicTask(.25, function()
		local x, y, z = inst.Transform:GetWorldPosition()
		local ents = TheSim:FindEntities(x, y, z, 3, nil, { "INLIMBO", "shadowboss" })
		for i, v in ipairs(ents) do
			if v:IsValid() then
				--if v.components.workable ~= nil and v.components.workable:CanBeWorked() then
				--	SpawnPrefab("collapse_small").Transform:SetPosition(v.Transform:GetWorldPosition())
				--	v.components.workable:Destroy(inst)
				--end
				if v:IsValid() and v.components.health ~= nil and not v.components.health:IsDead() and v.components.combat ~= nil then
					v.components.combat:Zg_GetAttacked(inst, 5 * TUNING.ZG_DIFFICULTY)
				end
			end
		end
	end)]]
	
	----物理
	local period = 1/30
	inst.collide_task_table = {}
	inst:DoPeriodicTask(period, function()
	
		local pt = inst:GetPosition()	
		local r = 2.5
		local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "shadowboss"})
		
		for k,v in pairs(ents) do
			if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
				
				if not table.contains(inst.collide_task_table, v.GUID) then
					v.components.combat:Zg_GetAttacked(inst, 120 *  TUNING.ZG_DIFFICULTY)
					table.insert(inst.collide_task_table, v.GUID)
				end
				
			end
		end
		
	end)
	
	inst:DoTaskInTime(3, function()
		inst:Remove()
	end)

    return inst
    
end
---------------------------------------------------
STRINGS.NAMES.ZG_FX_ZOROTORNADO = "索隆の烦恼风" 
return Prefab("zg_fx_zorotornado", fn)