local assets =
{
    Asset("ANIM", "anim/zg_it_icepigskin.zip"),
	Asset("ATLAS", "images/zg_it_icepigskin.xml"),
}

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("pigskin")
    inst.AnimState:SetBuild("zg_it_icepigskin")
    inst.AnimState:PlayAnimation("idle")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("冰猪猪皮, 很好的防护材料")

    inst:AddComponent("tradable")
    inst.components.tradable.goldvalue = 4

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_it_icepigskin.xml"
	inst.components.inventoryitem.imagename = "zg_it_icepigskin"

    inst:AddComponent("edible")
    inst.components.edible.foodtype = FOODTYPE.HORRIBLE

    return inst
end

STRINGS.NAMES.ZG_IT_ICEPIGSKIN = "冰猪猪皮"
return Prefab("zg_it_icepigskin", fn, assets)