local assets = 
{
	Asset("ANIM", "anim/zg_it_livingbone.zip"),
	Asset("ATLAS", "images/zg_it_livingbone.xml"),
}

local function fn()
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.Transform:SetScale(2,2,2)
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("zg_it_livingbone")
	inst.AnimState:SetBuild("zg_it_livingbone")
	inst.AnimState:PlayAnimation("idle")
	
	MakeInventoryPhysics(inst)
	
	inst.entity:AddNetwork()
	
	inst:AddTag("zg_magic_material")
	
	inst.entity:SetPristine()
	
	if not TheWorld.ismastersim then
		return inst
	end
	
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_it_livingbone.xml"
	inst.components.inventoryitem.imagename = "zg_it_livingbone"
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_LARGEITEM
	
	inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("这是好装备的材料")
	
	return inst
end

STRINGS.NAMES.ZG_IT_LIVINGBONE = "活骨头"
return Prefab("zg_it_livingbone", fn, assets)
