--西瓜兵器团

local assets={
	Asset("SOUNDPACKAGE", "sound/zg_manshape.fev"),
	Asset("SOUND", "sound/zg_manshape.fsb"),
}

local manshape_defs ={
	--科学家--
	wilson={
		name="wilson",
		zg_name=zg_ischs("人形兵器-威风堂堂","Human Weapon-Wilson"),
		loot={
			{"z_greenspear",1},
			{'bz_head_wilson',.66},
		},
		weaponlist={
			--偃月刀
			{damage=70,uses=5,attackrange=2.5,hitrange=2.75,projectile=nil,build="z_greenspear_s",bank="z_greenspear_s",tag={"zg_spear","zg_heavy"}},
			--肉棒
			{damage=60,uses=5,attackrange=nil,hitrange=nil,projectile=nil,build="swap_ham_bat",bank="swap_ham_bat",tag=nil},
		},
		hatlist={
			{condition=nil,absorb=nil,build="hat_watermelon",open=nil,tag={"hat"}},
		},
		armorlist={
			{condition=450,absorb=.8,build="armor_wood",tag=nil},
		},
	},
	
	--火女--
	willow={
		name="willow",
		zg_name=zg_ischs("人形兵器-薇辣","Human Weapon-Willow"),
		burnable_burntime=0,
		fire_damage_scale=0,
		loot={
			{"z_firegun",1},
			{'bz_head_willow',.66},
		},
		weaponlist={
			--火焰喷射器
			{damage=0,uses=3,attackrange=9,hitrange=15,projectile="zg_proj_firegun",build="z_firegun_s",bank="z_firegun_s",tag={"zg_gun","zg_gun_fire"}
			
			},
			--打火机
			{damage=60,uses=6,attackrange=nil,hitrange=nil,projectile=nil,build="swap_lighter",bank="swap_lighter",tag=nil,
				onattack=function (weapon, attacker, target)
					if target and target.components.burnable then
						target.components.burnable:Ignite(nil, attacker)
					end
				end,
			},
			--火魔杖
			{damage=30,uses=3,attackrange=8,hitrange=10,projectile="fire_projectile",build="swap_staffs",bank="redstaff",tag=nil,
				onattack=function (weapon, attacker, target)
					if target then
						if target.components.burnable then
							target.components.burnable:Ignite(nil, attacker)
						end
						if target.components.temperature then
							target.components.temperature:DoDelta(15)
						end
					end
				end,
			},
		},
		hatlist={
			{condition=nil,absorb=nil,build="hat_watermelon",open=nil,tag={"hat"}},
		},
		armorlist={
			{condition=450,absorb=.8,build="armor_wood",tag=nil},
			{condition=450,absorb=.8,build="torso_reflective",tag=nil},
			{condition=450,absorb=.8,build="armor_trunkvest_summer",tag=nil},
		},
	},
	wolfgang_mighty={
		name="wolfgang_mighty",
		zg_name=zg_ischs("人形兵器-王大锤","Human Weapon-Big Hammer Wang"),
		health=223,
		damage=20,
		attackrange=2*1.25,
		scale=1.25,
		mass=1000,
		radius=.5*1.25,
		loot={
			{"hammer",1},
			{'bz_head_wolfgang',.66},
		},
		retargetfn=function(inst)
			local target = FindEntity(inst,30,
				function(guy)
					return inst.components.combat:CanTarget(guy) and (zg_isenemy(guy,inst,{"zg_manshape"}) or guy:HasTag("player"))
				end,
				nil,
				{"zg_manshape", "playerghost","shadowboss",}
			)
			if target and math.random()<.05 then
				--闪现
				inst.SoundEmitter:PlaySound("dontstarve/zg/wolfgang/flash")
				inst.components.talker:Say("突击!")
				local a,b,c = target.Transform:GetWorldPosition()
				local ran = math.random()
				if ran < .25 then
					inst.Transform:SetPosition(a+1.5,b,c+1.5)
				elseif ran < .5 then
					inst.Transform:SetPosition(a+1.5,b,c-1.5)
				elseif ran < .75 then
					inst.Transform:SetPosition(a-1.5,b,c+1.5)
				else 
					inst.Transform:SetPosition(a-1.5,b,c-1.5)
				end
			end
			return target,true
		end,
		weaponlist={
			--锤子
			{damage=102,uses=5,attackrange=nil,hitrange=nil,projectile=nil,build="swap_hammer",bank="swap_hammer",tag=nil,
				onattack=function (weapon, attacker, target)
					if target then
						if target.components.hunger then target.components.hunger:DoDelta(-target.components.hunger.current/8) end
						zg_spawn(target,"collapse_small")
					end
				end,
			},
			--饥饿标
			{damage=51,uses=1,attackrange=8,hitrange=10,projectile="blowdart_walrus",build="swap_blowdart",bank="swap_blowdart",tag=nil,
				onattack=function (weapon, attacker, target)
					if target then
						if target.components.hunger then target.components.hunger:DoDelta(-target.components.hunger.current/4) end
						zg_spawn(target,"collapse_small")
					end
				end,
			},
		},
		hatlist={
			{condition=nil,absorb=nil,build="hat_watermelon",open=nil,tag={"hat"}},
		},
		armorlist={
			{condition=500,absorb=.8,build="armor_slurple"},
		},
	},
	
	--鬼女--
	wendy={
		name="wendy",
		zg_name=zg_ischs("人形兵器-温如玉","Human Weapon-Wendy"),
		damage=7.5,
		loot={
			{"nightmaresword",1},
			{'bz_head_wendy',.66},
		},
		weaponlist={
			--召唤姐姐
			{damage=50,uses=1,attackrange=8,hitrange=10,projectile="zg_proj_abi",build="swap_nightmaresword",bank="swap_nightmaresword",tag={"zg_summon"},
				onattack=function (weapon, attacker, target)
					if target then
						if target.components.sanity then target.components.sanity:DoDelta(-target.components.hunger.current/8) end
						zg_spawn(target,"statue_transition")
					end
				end,
			},
			--暗影剑
			{damage=70,uses=10,attackrange=nil,hitrange=nil,projectile=nil,build="swap_nightmaresword",bank="swap_nightmaresword",tag=nil,
				onattack=function (weapon, attacker, target)
					if target then
						if target.components.sanity then target.components.sanity:DoDelta(-target.components.hunger.current/8) end
						zg_spawn(target,"statue_transition")
					end
				end,
			},
		},
		hatlist={
			{condition=nil,absorb=nil,build="hat_watermelon",open=nil,tag={"hat"}},
		},
		armorlist={
			{condition=450,absorb=.8,build="armor_wood",tag=nil},
			{condition=450,absorb=.8,build="torso_hawaiian",tag=nil},
			{condition=450,absorb=.8,build="armor_sweatervest",tag=nil},
			{condition=750,absorb=.9,build="armor_sanity",tag={"shadow"}},
		},
		zg_ondeathfn=function(inst)
			if inst.abi~=nil then
				inst.abi.components.health:Kill()
				inst.abi=nil
			end
		end,
	},
	
	--老奶奶--
	wickerbottom={
		name="wickerbottom",
		zg_name=zg_ischs("人形兵器-维基百科","Human Weapon-Wicker"),
		freezable_resistance=10,
		loot={
			{"nightmaresword",1},
			{'bz_head_wicker',.66},
		},
		weaponlist={
			--召唤触手
			{damage=0,uses=1,attackrange=8,hitrange=24,projectile=nil,build="swap_spike",bank="swap_spike",tag={"zg_readbook"},
				onattack=function (weapon, attacker, target)
					if target then
					
						--缴械
						local x,y,z = attacker.Transform:GetWorldPosition()
						attacker.components.talker:Say("奥义之除你武器")
						SpawnPrefab("book_fx").Transform:SetPosition(x,y,z)
						
						----	卸掉玩家的手中的武器
						local ents = TheSim:FindEntities(x, y, z, 25, {"player"})
						for k,v in pairs(ents) do
							if v.components.inventory and not v:HasTag("playerghost") then
								local item = v.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
								if item and item.Physics then
									v.components.inventory:DropItem(item)
									local a, b, c = item:GetPosition():Get()
									item.Physics:Teleport(a,.1,c)
									local hp = v:GetPosition()
									local pt = attacker:GetPosition()
									local vel = (hp - pt):GetNormalized()
									local speed = 5 + (math.random() * 2)
									local angle = math.atan2(vel.z, vel.x) + (math.random() * 20 - 10) * DEGREES
									item.Physics:SetVel(math.cos(angle) * speed, 10, math.sin(angle) * speed)
								end	
							end
						end
						----    紧接着收走范围内亮在外面 的武器
						attacker:DoTaskInTime(.5, function()
							if attacker and attacker.components.health and not attacker.components.health:IsDead() then
								local ents2 = TheSim:FindEntities(x, y, z, 25)
								for k,v in pairs(ents2) do
									----	筛选出 不处于 拥有状态 的 武器
									if v.components.weapon
										and v.components.inventoryitem 
										and not v.components.inventoryitem:IsHeld() 
										then
										local x1,y1,z1 = v.Transform:GetWorldPosition()
										SpawnPrefab("book_fx").Transform:SetPosition(x1,y1,z1)
										attacker.components.inventory:GiveItem(v)
									end
								end
							end
						end)
					
						local pt = target:GetPosition()
						local numtentacles = 13
						attacker:StartThread(function()
							for k = 1, numtentacles do
								local theta = math.random() * 2 * PI
								local radius = math.random(3, 7)
								local result_offset = FindValidPositionByFan(theta, radius, 12, function(offset)
									local pos = pt + offset
									local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, 1)
									return next(ents) == nil
								end)
								if result_offset ~= nil then
									local pos = pt + result_offset
									local tentacle = SpawnPrefab("zg_mo_tentaclearm")
									--tentacle.persists=false
									tentacle:DoTaskInTime(13,function() tentacle.components.health:Kill() end)
									tentacle.Transform:SetPosition(pos:Get())
									ShakeAllCameras(CAMERASHAKE.FULL, .2, .02, .25, attacker, 40)
									SpawnPrefab("splash_ocean").Transform:SetPosition(pos:Get())
									--tentacle.sg:GoToState("attack_pre")
								end
								Sleep(.1)
							end
						end)
					end
				end,
			},
			--触手棒
			{damage=51,uses=5,attackrange=nil,hitrange=nil,projectile=nil,build="swap_spike",bank="swap_spike",tag=nil,
			
			},
			--冰杖
			{damage=30,uses=4,attackrange=8,hitrange=10,projectile="ice_projectile",build="swap_staffs",bank="bluestaff",tag=nil,
				onattack=function (weapon, attacker, target)
					if target then
						if target.components.freezable ~= nil then
							target.components.freezable:AddColdness(2)
							target.components.freezable:SpawnShatterFX()
						end
						if target.components.temperature then
							target.components.temperature:DoDelta(-15)
						end
					end
				end,
			},
		},
		hatlist={
			{condition=nil,absorb=nil,build="hat_watermelon",open=nil,tag={"hat"}},
		},
		armorlist={
			{condition=450,absorb=.8,build="armor_wood",tag=nil},
			{condition=450,absorb=.8,build="torso_hawaiian",tag=nil},
			{condition=450,absorb=.8,build="armor_sweatervest",tag=nil},
		},
	},
	
	--机器人
	wx78={
		name="wx78",
		zg_name=zg_ischs("人形兵器-Windows7","Human Weapon-Wx78"),
		health=200,
		electricdamageimmune=true,
		lightning_hitchance=1,
		zg_isrobot=true,
		loot={
			{"nightstick",1},
			{'bz_head_wx78',.66},
		},
		weaponlist={
			--召唤主教
			{damage=0,uses=1,attackrange=8,hitrange=24,projectile="zg_proj_bishop",build="swap_nightstick",bank="swap_nightstick",tag={"zg_summon"},
				
			},
			--晨星
			{damage=60,uses=10,attackrange=nil,hitrange=nil,projectile=nil,build="swap_nightstick",bank="swap_nightstick",tag=nil,stimuli="electric",
				
			},
		},
		hatlist={
			{condition=nil,absorb=nil,build="hat_watermelon",open=nil,tag={"hat"}},
		},
		armorlist={
			{condition=450,absorb=.8,build="armor_wood",tag=nil},
			{condition=450,absorb=.8,build="torso_hawaiian",tag=nil},
			{condition=450,absorb=.8,build="armor_sweatervest",tag=nil},
		},
		zg_ondeathfn=function(inst)
			if inst.abi~=nil then
				inst.abi.components.health:Kill()
				inst.abi=nil
			end
		end,
	},
	
	--伐木工--
	woodie={
		name="woodie",
		zg_name=zg_ischs("人形兵器-吴承恩","Human Weapon-Woodie"),
		loot={
			{'bz_head_woodie',.66},
		},
		weaponlist={
			--召唤海狸
			{damage=0,uses=1,attackrange=8,hitrange=24,projectile=nil,build="swap_lucy_axe",bank="swap_lucy_axe",tag={"zg_summon2"},
				onattack=function (weapon, attacker, target)
					if target then
						local pt = target:GetPosition()
						local numtentacles = 2
						--attacker:StartThread(function()
							for k = 1, numtentacles do
								local theta = math.random() * 2 * PI
								local radius = math.random(3, 6)
								local result_offset = FindValidPositionByFan(theta, radius, 12, function(offset)
									local pos = pt + offset
									local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, 1)
									return next(ents) == nil
								end)
								if result_offset ~= nil then
									local pos = pt + result_offset
									
									if attacker["abi"..k]~=nil then
										attacker["abi"..k].components.health:Kill()
										attacker["abi"..k]=nil
									end
									if attacker["abi"..k]==nil then
										attacker["abi"..k]=SpawnPrefab("zg_mo1_beaver") --zg_spawn(target,"zg_mo1_beaver")
										attacker["abi"..k].Transform:SetPosition(pos:Get())
										attacker["abi"..k].components.follower:SetLeader(attacker)	
										attacker["abi"..k].SoundEmitter:PlaySound("zg_summon/zg_summon/summon3")
										SpawnPrefab("splash_ocean").Transform:SetPosition(pos:Get())
									end
									
									--local tentacle = SpawnPrefab("zg_mo_tentaclearm")
									--tentacle.persists=false
									--tentacle:DoTaskInTime(20,function() tentacle.components.health:Kill() end)
									--tentacle.Transform:SetPosition(pos:Get())
									ShakeAllCameras(CAMERASHAKE.FULL, .2, .02, .25, attacker, 40)
									--SpawnPrefab("splash_ocean").Transform:SetPosition(pos:Get())
									--tentacle.sg:GoToState("attack_pre")
								end
								--Sleep(.1)
							end
						--end)
					end
				end,
			},
			--露西斧
			{damage=60,uses=10,attackrange=nil,hitrange=nil,projectile=nil,build="swap_lucy_axe",bank="swap_lucy_axe",tag=nil,
				
			},
		},
		hatlist={
			{condition=nil,absorb=nil,build="hat_watermelon",open=nil,tag={"hat"}},
		},
		armorlist={
			{condition=450,absorb=.8,build="armor_wood",tag=nil},
			{condition=450,absorb=.8,build="torso_hawaiian",tag=nil},
			{condition=450,absorb=.8,build="armor_sweatervest",tag=nil},
		},
		zg_ondeathfn=function(inst)
			for k=1,2 do
				if inst["abi"..k]~=nil then
					inst["abi"..k].components.health:Kill()
					inst["abi"..k]=nil
				end
			end
		end,
	},
	
	--小丑--
	wes={
		name="wes",
		zg_name=zg_ischs("人形兵器-韦小宝","Human Weapon-Wes"),
		health=113,
		damage=7.5,
		runspeed=9,
		loot={
			{'bz_head_wes',.66},
		},
		weaponlist={
			--召唤气球
			{damage=0,uses=1,attackrange=16,hitrange=48,projectile=nil,build="swap_parasol",bank="swap_parasol",tag={"zg_summon2"},
				onattack=function (weapon, attacker, target)
					if target then
						local pt = target:GetPosition()
						local numtentacles = 26
						attacker:StartThread(function()
							for k = 1, numtentacles do
								local theta = math.random() * 2 * PI
								local radius = math.random(3, 5)
								local result_offset = FindValidPositionByFan(theta, radius, 12, function(offset)
									local pos = pt + offset
									local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, 1)
									return next(ents) == nil
								end)
								if result_offset ~= nil then
									local pos = pt + result_offset
									local tentacle = SpawnPrefab("zg_fx_balloon")
									--tentacle.persists=false
									tentacle.components.combat:SetDefaultDamage(20)
									tentacle:DoTaskInTime(math.random(),function() tentacle.components.health:Kill() end)
									tentacle.Transform:SetPosition(pos:Get())
									ShakeAllCameras(CAMERASHAKE.FULL, .2, .02, .25, attacker, 40)
									--SpawnPrefab("splash_ocean").Transform:SetPosition(pos:Get())
									--tentacle.sg:GoToState("attack_pre")
								end
								Sleep(.1)
							end
						end)
					end
				end,
			},
			--花伞
			{damage=60,uses=5,attackrange=nil,hitrange=nil,projectile=nil,build="swap_parasol",bank="swap_parasol",tag=nil,
				
			},
		},
		hatlist={
			{condition=nil,absorb=nil,build="hat_watermelon",open=nil,tag={"hat"}},
		},
		armorlist={
			{condition=450,absorb=.8,build="armor_wood",tag=nil},
			{condition=450,absorb=.8,build="torso_hawaiian",tag=nil},
			{condition=450,absorb=.8,build="armor_sweatervest",tag=nil},
		},
		zg_ondeathfn=function(inst)
			
		end,
	},
	
	--蜘蛛人--
	webber={
		name="webber",
		zg_name=zg_ischs("人形兵器-围魏救赵","Human Weapon-Webber"),
		health=175,
		loot={
			{'bz_head_webber',.66},
		},
		--retargetdist=192,
		retargetfn=function(inst)
		
			local tar=inst.components.combat.target
			if tar then
				if not inst:IsNear(tar, 24) then
					inst:EquipWeapon(inst,3)
				end
			end
			
			return FindEntity(inst,192,
				function(guy)
					return inst.components.combat:CanTarget(guy) and (zg_isenemy(guy,inst,{"zg_manshape"}) or guy:HasTag("player"))
				end,
				nil,
				{"zg_manshape", "playerghost",}
			)
		end,
		weaponlist={
			--召唤蜘蛛坑
			{damage=0,uses=1,attackrange=16,hitrange=48,projectile=nil,build="swap_pickaxe",bank="swap_pickaxe",tag=nil,
				onattack=function (weapon, attacker, target)
					if target then
						zg_spawn(target, "zg_fx_spiderhole2")
					end
				end,
			},
			--挖地搞
			{damage=50,uses=5,attackrange=nil,hitrange=nil,projectile=nil,build="swap_pickaxe",bank="swap_pickaxe",tag=nil,
				
			},
			--召唤自己挖的坑
			{damage=0,uses=1,attackrange=128,hitrange=256,projectile=nil,build="swap_multitool_axe_pickaxe",bank="swap_object",tag={"zg_makehole"},
				onattack=function (weapon, attacker, target)
					if target then
						local holein=zg_spawn(attacker, "zg_fx_holein")
						--attacker.sg:GoToState("jumpin_pre")
						attacker.holein=holein
						
						attacker.holetarget=target
						--local holeout=zg_spawn(target, "zg_fx_holeout")
						--attacker.holeout=holeout
						
					end
				end,
			},
			--金镐
			{damage=60,uses=5,attackrange=nil,hitrange=nil,projectile=nil,build="swap_goldenpickaxe",bank="swap_goldenpickaxe",tag=nil,
				
			},
		},
		hatlist={
			{condition=nil,absorb=nil,build="hat_watermelon",open=nil,tag={"hat"}},
		},
		armorlist={
			{condition=450,absorb=.8,build="armor_wood",tag=nil},
			{condition=450,absorb=.8,build="torso_hawaiian",tag=nil},
			{condition=450,absorb=.8,build="armor_sweatervest",tag=nil},
		},
		zg_ondeathfn=function(inst)
			
		end,
	},
	
	--老麦--
	waxwell={
		name="waxwell",
		zg_name=zg_ischs("人形兵器-麦立强","Human Weapon-Maxwell"),
		health=75,
		loot={
			{'nightmaresword',1},
			{'bz_head_waxwell',.66},
		},
		weaponlist={
			--召唤暗影
			{damage=0,uses=1,attackrange=16,hitrange=48,projectile=nil,build="swap_nightmaresword",bank="swap_nightmaresword",tag={"zg_readbook"},
				onattack=function (weapon, attacker, target)
					if target then
						local pt = target:GetPosition()
						local numtentacles = 2
						
						for k = 1, numtentacles do
							local theta = math.random() * 2 * PI
							local radius = math.random(3, 6)
							local result_offset = FindValidPositionByFan(theta, radius, 12, function(offset)
								local pos = pt + offset
								local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, 1)
								return next(ents) == nil
							end)
							if result_offset ~= nil then
								local pos = pt + result_offset
								
								if attacker["abi"..k]~=nil then
									attacker["abi"..k].components.health:Kill()
									attacker["abi"..k]=nil
								end
								if attacker["abi"..k]==nil then
									attacker["abi"..k]=SpawnPrefab("zg_mo1_shadowwaxwell") --zg_spawn(target,"zg_mo1_beaver")
									attacker["abi"..k].Transform:SetPosition(pos:Get())
									attacker["abi"..k].components.follower:SetLeader(attacker)	
									attacker["abi"..k].SoundEmitter:PlaySound("zg_summon/zg_summon/summon3")	--召唤出来的音效
									attacker["abi"..k].Transform:SetRotation( attacker["abi"..k]:GetAngleToPoint(target:GetPosition():Get()) )
									attacker["abi"..k].sg:GoToState("jump")
									SpawnPrefab("splash_ocean").Transform:SetPosition(pos:Get())
								end
								
								ShakeAllCameras(CAMERASHAKE.FULL, .2, .02, .25, attacker, 40)
								SpawnPrefab("statue_transition").Transform:SetPosition(pos:Get())
							end
							
						end
						
					end
				end,
			},
			--暗影剑
			{damage=70,uses=10,attackrange=nil,hitrange=nil,projectile=nil,build="swap_nightmaresword",bank="swap_nightmaresword",tag={"shadow"},
				
			},
		},
		hatlist={
			{condition=nil,absorb=nil,build="hat_watermelon",open=nil,tag={"hat"}},
		},
		armorlist={
			{condition=750,absorb=.9,build="armor_sanity",tag=nil},
		},
		zg_ondeathfn=function(inst)
			for k=1,2 do
				if inst["abi"..k]~=nil then
					inst["abi"..k].components.health:Kill()
					inst["abi"..k]=nil
				end
			end
		end,
	},
	
	--女武神--
	wathgrithr={
		name="wathgrithr",
		zg_name=zg_ischs("人形兵器-大姨妈","Human Weapon-Wigfrid"),
		health=200,
		damage=12.5,
		mass=1000,
		absorb=.25,
		num_attack_to_swap=8,
		loot={
			{'z_redbow',1},
			{'bz_head_wigfrid',.66},
		},
		weaponlist={
			--弓箭
			{damage=50,uses=5,attackrange=10,hitrange=14,projectile="zg_proj_redbow",build="z_redbow_s",bank="z_redbow_s",tag={"zg_bow"}},
			--战斗长矛
			{damage=70,uses=5,attackrange=.5,hitrange=nil,projectile=nil,build="swap_spear_wathgrithr",bank="swap_spear_wathgrithr",tag={"sharp","pointy","zg_spear"}},
		},
		hatlist={
			{condition=nil,absorb=nil,build="hat_watermelon",open=nil,tag={"hat"}},
		},
		armorlist={
			{condition=450,absorb=.8,build="armor_wood",tag=nil},
			{condition=450,absorb=.8,build="torso_hawaiian",tag=nil},
			{condition=450,absorb=.8,build="armor_sweatervest",tag=nil},
		},
	},
}

for k,v in pairs(manshape_defs) do
	SetSharedLootTable("zg_ch1_"..v.name, v.loot or {{"meat",1},{"meat",1}})
end

local function EquipWeapon(inst,slot)
	local weapon=inst.def.weaponlist
	if type(weapon)=="table" then
		local ws = weapon[slot]
		if type(ws)=="table" then
			zg_virtual_weapon(inst,ws.damage,ws.uses,ws.attackrange,ws.hitrange,ws.projectile,ws.build,ws.bank,ws.tag,slot,ws.onattack,ws.stimuli)
		end
	end
end
local function EquipHat(inst,slot)
	local hat=inst.def.hatlist
	if type(hat)=="table" then
		local ws = hat[slot]
		if type(ws)=="table" then
			zg_virtual_hat(inst,ws.condition,ws.absorb,ws.build,ws.open,ws.tag,slot)
		end
	end
end
local function EquipArmor(inst,slot)
	local hat=inst.def.armorlist
	if type(hat)=="table" then
		local ws = hat[slot]
		if type(ws)=="table" then
			zg_virtual_armor(inst,ws.condition,ws.absorb,ws.build,ws.tag,slot)
		end
	end
end

local function EquipRandomArmor(inst)
	local hat=inst.def.armorlist
	if type(hat)=="table" then
		local slot=math.random(#hat)
		local ws = hat[slot]
		if type(ws)=="table" then
			zg_virtual_armor(inst,ws.condition,ws.absorb,ws.build,ws.tag,slot)
		end
	end
end

local function EquipRandomWeapon(inst)
	local current=inst.zg_weapon_slot
	local weapon=inst.def.weaponlist
	if type(weapon)=="table" then
		if #weapon<=1 then
			EquipWeapon(inst,current)
		else
			local ran=math.random(#weapon)
			if ran==current then
				EquipWeapon(inst,zg_loop_next(weapon,ran))
			else
				EquipWeapon(inst,ran)
			end
		end
	end
end

local function MakeManshape(def)
 
    local function fn()
        local inst = CreateEntity()

        inst.entity:AddTransform()
		
		local s=def.scale or 1
		inst.Transform:SetScale(s,s,s)
		inst.Transform:SetFourFaced()
		
        inst.entity:AddAnimState()
		inst.AnimState:Hide("ARM_carry")
        inst.AnimState:Hide("HAT")
        inst.AnimState:Hide("HAT_HAIR")
        inst.AnimState:Show("HAIR_NOHAT")
        inst.AnimState:Show("HAIR")
        inst.AnimState:Show("HEAD")
        inst.AnimState:Hide("HEAD_HAT")
		
        inst.entity:AddSoundEmitter()
		
		inst.entity:AddDynamicShadow()
		inst.DynamicShadow:SetSize(1.3, .6)
	
        inst.entity:AddNetwork()

        MakeCharacterPhysics(inst,def.mass or 75,def.radius or .5)

        inst.AnimState:SetBank("wilson")
        inst.AnimState:SetBuild(def.name)
		--[[--失败了
		--加载皮肤survivor系列
		CreatePrefabSkin( def.name.."_survivor",
		{
			base_prefab = "zg_ch2_"..def.name, 
			skins = {normal_skin = def.name.."_survivor", ghost_skin = "",}, 
			assets = {},
			ui_preview = {build = def.name.."_survivor",},
			tags = {},
			has_alternate_for_body = { def.name.."_survivor", },
			rarity = "Elegant",
		})
		inst.AnimState:SetSkin(def.name.."_survivor", def.name)
		]]
        inst.AnimState:PlayAnimation("idle")
		
		inst:AddTag("zg_stat_manshape")
		inst:AddTag("hostile")
		
		inst:AddTag("scarytoprey")
		inst:AddTag("shadowboss")
		inst:AddTag("zg_music_ds2")
		
		inst:AddTag("zg_manshape")
		
		--if def.name=="webber" then
		--inst:AddTag("monster")
		--end

        inst.entity:SetPristine()

        if not TheWorld.ismastersim then
            return inst
        end
		
		--引用
		inst.def=def
		inst.num_attack_to_swap=def.num_attack_to_swap or 15
		inst.num_attack=0
		
		inst.zg_isrobot=def.zg_isrobot or nil
		
		--检测
		inst:AddComponent("inspectable")
		inst.components.inspectable:SetDescription(def.str or zg_ischs("人形兵器","Human Weapon"))
		--inst.name=def.zg_name or zg_ischs("人形兵器","Human Weapon")
		
		--基础属性
		inst:AddComponent("talker")
		inst:AddComponent("health")
		inst.components.health:SetMaxHealth( (def.health or 150)*20 )
		inst.components.health:SetAbsorptionAmount(def.absorb or 0)
		inst:AddComponent("locomotor")
		inst.components.locomotor:zg_setspeed(def.runspeed or 6,def.walkspeed or 4)
		inst:AddComponent("leader")
		
		--战斗属性
		inst:AddComponent("combat")
		inst.components.combat:SetDefaultDamage(def.damage or 10)
		inst.components.combat:SetRange(def.attackrange or 2)
		inst.components.combat:SetAttackPeriod(def.attackperiod or .75)
		inst.components.combat:SetRetargetFunction(def.retargetperiod or 1,def.retargetfn or function(inst)
			return FindEntity(inst,def.retargetdist or 30,
				function(guy)
					return inst.components.combat:CanTarget(guy) and (zg_isenemy(guy,inst,{"zg_manshape"}) or guy:HasTag("player"))
				end,
				nil,
				{"zg_manshape", "playerghost","shadowboss",}
			)
		end)
		inst.components.combat:SetKeepTargetFunction(def.keeptargetfn or function (inst, target)
			return inst.components.combat:CanTarget(target) and inst:IsNear(target,def.keeptargetdist or 40)
		end)
		function inst.components.combat:CanBeAttacked(attacker)
			return attacker
				and not attacker:HasTag("shadowboss")
				and not attacker:HasTag("shadowcreature")
				and not ( not inst:HasTag("zg_kaizaku") and attacker:HasTag("zg_marine") )
				and self.inst.replica.combat:CanBeAttacked(attacker)
		end
		
		inst:ListenForEvent("attacked",def.attackedfn or function(inst,data)
			local invader = nil
			invader = FindEntity(inst, inst.components.combat.attackrange+1, function(guy)
				return guy:HasTag("player") and not guy:HasTag("zg_manshape")
			end)
			if invader then
				inst.components.combat:SetTarget(invader)
			else
				inst.components.combat:SetTarget(data.attacker)
			end
		end)
		
		--[[
		--远程减益
		local old_GetAttacked=inst.components.combat.GetAttacked
		function inst.components.combat:GetAttacked(attacker, damage, weapon, stimuli)
			local dmg=damage or 0
			if attacker then 
				local pos=attacker:GetPosition()
				if pos then
					local dist=inst:GetPosition():Dist(pos)
					if dist>3.5 then
						--计算减益因子
						local per=3.5/dist
						dmg=dmg*per
					end
				end
			end
			return old_GetAttacked(self, attacker, dmg, weapon, stimuli)
		end]]
		
		--物品栏 + 武器切换
		inst:AddComponent("inventory")
		inst.EquipWeapon=EquipWeapon	--定义 装备武器
		inst.EquipRandomWeapon=EquipRandomWeapon	--定义 装备随机下一个武器
		inst.EquipHat=EquipHat	--定义 戴帽子
		inst.EquipArmor=EquipArmor	--定义 穿护甲
		inst.EquipRandomArmor=EquipRandomArmor	--定义 穿随机护甲
		EquipWeapon(inst,1)	
		EquipHat(inst,1)
		--EquipArmor(inst,1)
		EquipRandomArmor(inst)
		
		--抗火
		inst:AddComponent("burnable")
		inst.components.burnable:SetFXLevel(2)
		inst.components.burnable.canlight = false
		inst.components.burnable:SetBurnTime(def.burnable_burntime or 3)
		inst.components.burnable:AddBurnFX("character_fire", Vector3(0, 0, 1), "torso")
		MakeSmallPropagator(inst)
		inst.components.propagator.acceptsheat = false
		inst.components.health.fire_damage_scale = def.fire_damage_scale or .25
		
		--抗冰
		inst:AddComponent("freezable")
		inst.components.freezable:SetShatterFXLevel(3)
		inst.components.freezable:SetResistance(def.freezable_resistance or 2)
		inst.components.freezable:SetDefaultWearOffTime(def.freezable_wearofftime or 3)
		inst.components.freezable:AddShatterFX("shatter", Vector3(0, 0, 0), "torso")
		
		--抗电
		inst:AddComponent("playerlightningtarget")
		inst.components.playerlightningtarget:SetHitChance(def.lightning_hitchance or .3)
		inst.components.playerlightningtarget:SetOnStrikeFn(function(inst)
			if zg_isalive(inst) then
				if not inst.components.inventory:IsInsulated() then
					local mult = TUNING.ELECTRIC_WET_DAMAGE_MULT * ( inst:GetIsWet() and 1 or 0)
					local damage = TUNING.LIGHTNING_DAMAGE + mult * TUNING.LIGHTNING_DAMAGE
					inst.components.health:DoDelta(-damage, false, "lightning")
					--inst.sg:GoToState("electrocute")
				else
					inst:PushEvent("lightningdamageavoided")
				end
			end
		end)
		if def.electricdamageimmune then 
			inst:AddTag("electricdamageimmune") 
			inst.components.playerlightningtarget:SetOnStrikeFn(function(inst)
				if zg_isalive(inst) then
					if inst.components.inventory:IsInsulated() then
						inst:PushEvent("lightningdamageavoided")
					else
						inst.components.health:DoDelta(100, false, "lightning")
					end
				end
			end)
		end
		
		--食谱
		inst:AddComponent("eater")
		if def.name=="woodie" then
			inst.components.eater:SetDiet({ FOODGROUP.WOODIE }, { FOODGROUP.WOODIE })
		--elseif def.name=="wathgrithr" then
		--	inst.components.eater:SetDiet({ FOODGROUP.OMNI }, { FOODTYPE.MEAT })
		else
			inst.components.eater:SetDiet({ FOODGROUP.OMNI }, { FOODGROUP.OMNI })
			if def.name=="wx78" then
				inst.components.eater:SetCanEatGears()
			end
		end
		inst.components.eater.strongstomach = true
		inst.components.eater.ignoresspoilage = true
		
		
		--掉落物
		inst:AddComponent("lootdropper")
		inst.components.lootdropper:SetChanceLootTable("zg_ch1_"..def.name)
		
		--SG
		--inst.zg_atksound=def.zg_atksound or "dontstarve/tentacle/tentacle_attack"
		inst.zg_hurtsound=def.zg_hurtsound or "zg_manshape/"..def.name.."/hit"
		inst.zg_deathsound=def.zg_deathsound or "zg_manshape/"..def.name.."/die"
		inst.zg_ondeathfn=def.zg_ondeathfn and def.zg_ondeathfn(inst) or function() end
		inst:SetStateGraph(def.sg or "sg_manshape")
		
		--Behaviour
		inst.zg_chaseandattack_period=def.zg_chaseandattack_period or .1
		inst.zg_runaway_period=def.zg_runaway_period or .1
		
		--AI
		inst.zg_ai_period=def.zg_ai_period or .1	--AI刷新时间
		inst.zg_chase_time=def.zg_chase_time or 30	--追杀时间
		inst.zg_see_dist=def.zg_see_dist or 8	--逃跑检测hunter的距离
		
		inst.zg_startrunaway_dist=def.zg_startrunaway_dist or 2		--开始躲避敌人预留的距离
		inst.zg_stoprunaway_dist=def.zg_stoprunaway_dist or 3	--躲避敌人攻击距离 预留的安全距离
		
		inst.target_exdist=def.target_exdist or 1	--玩家要是武器距离超过1,不再走位
		inst.zg_findfood_dist=def.zg_findfood_dist or 10	--寻找食物的距离
		
		local brain=require "brains/br_manshape"
		inst:SetBrain(def.brain or brain)
		
		--inst.zg_runaway_dist=def.zg_runaway_dist or zg_startdogedist(inst,3)
		--inst.zg_stoprunaway_dist=def.zg_stoprunaway_dist or zg_stopdogedist(inst,6)

        return inst
    end

    return Prefab("zg_ch2_"..def.name, fn, assets)
end

--返回prefabs
local manshapes = {}
for i, v in pairs(manshape_defs) do
    table.insert(manshapes, MakeManshape(v))
	STRINGS.NAMES[string.upper("zg_ch2_"..v.name)]=v.zg_name
end
manshape_defs = nil
return unpack(manshapes)