
local assets =
{
  
}

--空表
local def={}

local function EquipWeapon(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local weapon = CreateEntity()
        --[[Non-networked entity]]
        weapon.entity:AddTransform()
        weapon:AddComponent("weapon")
        weapon.components.weapon:SetDamage(inst.components.combat.defaultdamage)
        weapon.components.weapon:SetRange(inst.components.combat.attackrange, inst.components.combat.attackrange+8)
        weapon.components.weapon:SetProjectile("bishop_charge")
		weapon.components.weapon.stimuli="electric"
        weapon:AddComponent("inventoryitem")
        weapon.persists = false
        weapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        weapon:AddComponent("equippable")
        
        inst.components.inventory:Equip(weapon)
    end
end


local function common_fn(build, tag)
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddDynamicShadow()
    inst.entity:AddNetwork()

    MakeCharacterPhysics(inst, 50, .5)

    inst.DynamicShadow:SetSize(1.5, .75)
    inst.Transform:SetFourFaced()

    inst.AnimState:SetBank("bishop")
    inst.AnimState:SetBuild(build)

	inst:AddTag("healthinfo")
	inst:AddTag("zg_manshape")
	
    inst:AddTag("monster")
    inst:AddTag("hostile")
    inst:AddTag("chess")
    inst:AddTag("bishop")

    if tag ~= nil then
        inst:AddTag(tag)
    end

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst.persists=false

    inst:AddComponent("lootdropper")

    inst:AddComponent("locomotor")
	inst.components.locomotor.runspeed=10
    inst.components.locomotor.walkspeed = 10

    inst:SetStateGraph("SGbishop")
	
	--Behaviour
	inst.zg_chaseandattack_period=def.zg_chaseandattack_period or .1
	inst.zg_runaway_period=def.zg_runaway_period or .1
	
	--AI
	inst.zg_ai_period=def.zg_ai_period or .1	--AI刷新时间
	inst.zg_chase_time=def.zg_chase_time or 30	--追杀时间
	inst.zg_see_dist=def.zg_see_dist or 15	--逃跑检测hunter的距离
	
	inst.zg_startrunaway_dist=def.zg_startrunaway_dist or 2		--开始躲避敌人预留的距离
	inst.zg_stoprunaway_dist=def.zg_stoprunaway_dist or 3	--躲避敌人攻击距离 预留的安全距离
	
	inst.target_exdist=def.target_exdist or 1	--玩家要是武器距离超过1,不再走位
	local brain=require "brains/br_bishop"
    inst:SetBrain(brain)

    inst:AddComponent("combat")
    inst.components.combat.hiteffectsymbol = "waist"
	inst.components.combat:SetDefaultDamage(20)
    inst.components.combat:SetAttackPeriod(3)
    inst.components.combat:SetRange(8)
    inst.components.combat:SetRetargetFunction(def.retargetperiod or 1,def.retargetfn or function(inst)
		return FindEntity(inst,def.retargetdist or 30,
			function(guy)
				return inst.components.combat:CanTarget(guy) and (zg_isenemy(guy,inst,{"zg_manshape"}) or guy:HasTag("player"))
			end,
			nil,
			{"zg_manshape", "playerghost",}
		)
	end)
	inst.components.combat:SetKeepTargetFunction(def.keeptargetfn or function (inst, target)
		return inst.components.combat:CanTarget(target) and inst:IsNear(target,def.keeptargetdist or 40)
	end)
	inst:ListenForEvent("attacked",def.attackedfn or function(inst,data)
		local invader = nil
		invader = FindEntity(inst, inst.components.combat.attackrange+1, function(guy)
			return guy:HasTag("player") and not guy:HasTag("zg_manshape")
		end)
		if invader then
			inst.components.combat:SetTarget(invader)
		else
			inst.components.combat:SetTarget(data.attacker)
		end
	end)

    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(450)

    inst:AddComponent("inventory")

    inst:AddComponent("inspectable")

    inst:AddComponent("follower")

    MakeMediumBurnableCharacter(inst, "waist")
    MakeMediumFreezableCharacter(inst, "waist")

    EquipWeapon(inst)

    return inst
end

local function bishop_fn()
    local inst = common_fn("bishop_build")

    if not TheWorld.ismastersim then
        return inst
    end

    inst.kind = ""
    inst.soundpath = "dontstarve/creatures/bishop/"
    inst.effortsound = "dontstarve/creatures/bishop/idle"

    return inst
end
STRINGS.NAMES[string.upper("zg_mo1_bishop")]=zg_ischs("机械兵器-发条主教","Robot Weapon-Bishop Toy")
return Prefab("zg_mo1_bishop", bishop_fn, assets)
