
local assets =
{
  
}

--空表
local def={
	isshadow_phys=true,
	weaponlist={
		--暗影剑
		{damage=68*.5,uses=10,attackrange=nil,hitrange=nil,projectile=nil,build="swap_nightmaresword",bank="swap_nightmaresword",tag={"shadow"},
			
		},
	},
	zg_ondeathfn=function(inst)
		zg_spawn(inst,"statue_transition")
	end,
}

local function EquipWeapon(inst,slot)
	local weapon=inst.def.weaponlist
	if type(weapon)=="table" then
		local ws = weapon[slot]
		if type(ws)=="table" then
			zg_virtual_weapon(inst,ws.damage,ws.uses,ws.attackrange,ws.hitrange,ws.projectile,ws.build,ws.bank,ws.tag,slot,ws.onattack,ws.stimuli)
		end
	end
end

local function EquipRandomWeapon(inst)
	local current=inst.zg_weapon_slot
	local weapon=inst.def.weaponlist
	if type(weapon)=="table" then
		if #weapon<=1 then
			EquipWeapon(inst,current)
		else
			local ran=math.random(#weapon)
			if ran==current then
				EquipWeapon(inst,zg_loop_next(weapon,ran))
			else
				EquipWeapon(inst,ran)
			end
		end
	end
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddDynamicShadow()
    inst.entity:AddNetwork()

    MakeGhostPhysics(inst, 1, 0.5)

    inst.DynamicShadow:SetSize(0, 0)
    inst.Transform:SetFourFaced()

    inst.AnimState:SetBank("wilson")
    inst.AnimState:SetBuild("waxwell")
	inst.AnimState:SetMultColour(0, 0, 0, .5)

	inst:AddTag("healthinfo")
	inst:AddTag("zg_manshape")
	
    inst:AddTag("monster")
    inst:AddTag("hostile")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst.persists=false
	
	--引用
	inst.def=def

	inst.isshadow_phys=def.isshadow_phys or false
	
    inst:AddComponent("lootdropper")

    inst:AddComponent("locomotor")
	inst.components.locomotor.runspeed=6
    inst.components.locomotor.walkspeed=6
	
	inst.zg_hurtsound=def.zg_hurtsound or "zg_manshape/waxwell/shadow_hit"		--"dontstarve/sanity/creature2/taunt"
	inst.zg_deathsound=def.zg_deathsound or ( math.random() < .5 and "zg_ghost/zg_ghost/die" or "zg_manshape/waxwell/shadow_die" )
	inst.zg_ondeathfn=def.zg_ondeathfn and def.zg_ondeathfn(inst) or function() end
    inst:SetStateGraph("sg_manshape")
	
	--Behaviour
	inst.zg_chaseandattack_period=def.zg_chaseandattack_period or .1
	inst.zg_runaway_period=def.zg_runaway_period or .1
	
	--AI
	inst.zg_ai_period=def.zg_ai_period or .1	--AI刷新时间
	inst.zg_chase_time=def.zg_chase_time or 30	--追杀时间
	inst.zg_see_dist=def.zg_see_dist or 15	--逃跑检测hunter的距离
	
	inst.zg_startrunaway_dist=def.zg_startrunaway_dist or 2		--开始躲避敌人预留的距离
	inst.zg_stoprunaway_dist=def.zg_stoprunaway_dist or 3	--躲避敌人攻击距离 预留的安全距离
	
	inst.target_exdist=def.target_exdist or 1	--玩家要是武器距离超过1,不再走位
	local brain=require "brains/br_bishop"
    inst:SetBrain(brain)

    inst:AddComponent("combat")
    inst.components.combat.hiteffectsymbol = "torso"
	inst.components.combat:SetDefaultDamage(10)
    inst.components.combat:SetAttackPeriod(2)
    inst.components.combat:SetRange(2)
    inst.components.combat:SetRetargetFunction(def.retargetperiod or 1,def.retargetfn or function(inst)
		return FindEntity(inst,def.retargetdist or 30,
			function(guy)
				return inst.components.combat:CanTarget(guy) and (zg_isenemy(guy,inst,{"zg_manshape"}) or guy:HasTag("player"))
			end,
			nil,
			{"zg_manshape", "playerghost",}
		)
	end)
	inst.components.combat:SetKeepTargetFunction(def.keeptargetfn or function (inst, target)
		return inst.components.combat:CanTarget(target) and inst:IsNear(target,def.keeptargetdist or 40)
	end)
	inst:ListenForEvent("attacked",def.attackedfn or function(inst,data)
		local invader = nil
		invader = FindEntity(inst, inst.components.combat.attackrange+1, function(guy)
			return guy:HasTag("player") and not guy:HasTag("zg_manshape")
		end)
		if invader then
			inst.components.combat:SetTarget(invader)
		else
			inst.components.combat:SetTarget(data.attacker)
		end
	end)

    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(150)

    inst:AddComponent("inventory")
	inst.EquipWeapon=EquipWeapon
	inst.EquipRandomWeapon=EquipRandomWeapon
	EquipWeapon(inst,1)

    inst:AddComponent("inspectable")

    inst:AddComponent("follower")

    MakeMediumBurnableCharacter(inst,"torso")
    MakeMediumFreezableCharacter(inst,"torso")

    return inst
end

STRINGS.NAMES[string.upper("zg_mo1_shadowwaxwell")]=zg_ischs("暗影麦立强","Shadow Maxwell")
STRINGS.CHARACTERS.GENERIC.DESCRIBE[string.upper("zg_mo1_shadowwaxwell")]=zg_ischs("黑暗的魔法凝形","From dark magic")
return Prefab("zg_mo1_shadowwaxwell", fn, assets)
