
-----------------------------------------------------------------------
----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10 + 15 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	----	敌视语句
	if invader then
		local sayrandom = math.random()
		if sayrandom < .025 then
			inst.components.talker:Say("Dont hit my sister!")
		elseif sayrandom < .05 then
			inst.components.talker:Say("Death is waiting for you!")
		end
	end
    return invader
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end
------------------------------------------------------------------------
----	暗黑姐姐的范围攻击筛选
local function auratest(inst, target)
    return target and not target:HasTag("shadowboss") and not target:HasTag("playerghost")
end
-----------------------------------------------------------------------
local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	--inst.Transform:SetScale(.875, .875, .875)
	
    inst.entity:AddAnimState()
	inst.AnimState:SetBank("ghost")
	inst.AnimState:SetBuild("ghost_wendy_build")
    inst.AnimState:PlayAnimation("idle", true)
	--inst.AnimState:SetMultColour(1,1,1,.5)
	
    inst.entity:AddSoundEmitter()
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
	phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.CHARACTERS)
	
    inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize(1.5, .75)
	
    inst.entity:AddNetwork()
   
	inst:AddTag("healthinfo")
    inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("shadowcreature")
	inst:AddTag("scarytoprey")
	inst:AddTag("hostile")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("locomotor") 
    inst.components.locomotor.runspeed = 5.25 
    inst.components.locomotor.walkspeed = 4 
	inst.components.locomotor.fasteronroad = false
	inst.components.locomotor:SetTriggersCreep(false)

    ------------------------------------------
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(30 * TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetAttackPeriod(4 - TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
    inst.components.combat:SetRetargetFunction(2, RetargetFn)
	
	----	范围攻击
	inst:AddComponent("aura")
    inst.components.aura.radius = 2
    inst.components.aura.tickperiod = 2 - TUNING.ZG_DIFFICULTY
    inst.components.aura.ignoreallies = true
    inst.components.aura.auratestfn = auratest

    ------------------------------------------
    inst:AddComponent("follower")
   
    inst:AddComponent("health")
    --inst.components.health:StartRegen(5, 1)
	inst.components.health:SetMaxHealth(600)
    ------------------------------------------

    inst:AddComponent("inventory")
    inst:AddComponent("knownlocations")
    inst:AddComponent("talker")
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("Ghost")
	
	local brain = require "brains/zg_mo_bunnybrain"		----和胡须兔兔相同的AI
    inst:SetBrain(brain)
    inst:SetStateGraph("SGzg_mo_abigail")
	
	inst:DoTaskInTime( 30, function()
		inst.components.talker:Say("(Lifetime is over)")
		inst.SoundEmitter:PlaySound("dontstarve/zg/spell/summon02")
		inst.components.health:Kill()
	end)

    return inst
end

STRINGS.NAMES.ZG_MO_ABIGAIL = "暗黑阿比盖尔" 
return Prefab("zg_mo_abigail", fn)