local assets =
{
    
}
-----------------------------------------------------------------------
----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10 + 15 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	----	敌视语句
	if invader then
		local sayrandom = math.random()
		if sayrandom < .025 then
			inst.components.talker:Say("Attack!")
		elseif sayrandom < .05 then
			inst.components.talker:Say("Revenge!")
		end
	end
    return invader
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end
------------------------------------------------------------------------
local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
    inst.entity:AddAnimState()
	inst.AnimState:SetBank("manrabbit")
	inst.AnimState:SetBuild("manrabbit_beard_build")
    inst.AnimState:Hide("hat")
	inst.AnimState:PlayAnimation("idle_loop")
	inst.AnimState:SetMultColour(1,1,1,.5)
	
    inst.entity:AddSoundEmitter()
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.CHARACTERS)
	
    inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize(1.5, .75)
	
    inst.entity:AddNetwork()
   
	inst:AddTag("healthinfo")
    inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("shadowcreature")
	inst:AddTag("scarytoprey")
	inst:AddTag("hostile")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("locomotor") 
    inst.components.locomotor.runspeed = 12 
    inst.components.locomotor.walkspeed = 6 
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(false)

    ------------------------------------------
    inst:AddComponent("combat")
    inst.components.combat.hiteffectsymbol = "manrabbit_torso"
    inst.components.combat:SetDefaultDamage(40 * TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetAttackPeriod(1 * TUNING.ZG_DIFFICULTY_PERIOD)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
    inst.components.combat:SetRetargetFunction(2, RetargetFn)

    ------------------------------------------
    inst:AddComponent("follower")
   
    inst:AddComponent("health")
    --inst.components.health:StartRegen(5, 1)
	inst.components.health:SetMaxHealth(300)
    ------------------------------------------

    inst:AddComponent("inventory")
    inst:AddComponent("knownlocations")
    inst:AddComponent("talker")
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("Hairy and Fierce")
	
	local brain = require "brains/zg_mo_bunnybrain"
    inst:SetBrain(brain)
    inst:SetStateGraph("SGzg_mo_bunny")
	
	inst:DoTaskInTime( 30, function()
		inst.components.talker:Say("(Lifetime is over)")
		inst.SoundEmitter:PlaySound("dontstarve/zg/spell/summon02")
		inst.components.health:Kill()
	end)

    return inst
end

STRINGS.NAMES.ZG_MO_BUNNY = "暗黑胡须大兔兔" 
return Prefab("zg_mo_bunny", fn, assets)