
----	被攻击时
local function OnAttacked(inst, data)
    
    ----	群体反攻玩家
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) and not attacker:HasTag("shadowboss") then
			inst.components.combat:SetTarget(attacker)
		end
	end
end

----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 3 + 9 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
    return invader, true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end

local function fn()
    local inst = CreateEntity()

    --Core components
    inst.entity:AddTransform()	
    inst.entity:AddAnimState()
    inst.entity:AddDynamicShadow()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()
	inst.entity:AddPhysics()

    --Initialize physics
	inst.Physics:SetCapsule(.5, 1)
	inst.Physics:SetMass(100)
    inst.Physics:SetCollisionGroup(COLLISION.CHARACTERS)
	inst.Physics:ClearCollisionMask()
	inst.Physics:CollidesWith(COLLISION.CHARACTERS)
	inst.Physics:CollidesWith(COLLISION.GROUND)

    inst:AddTag("flying")
	inst:AddTag("zg_butterfly")
	inst:AddTag("healthinfo")
	inst:AddTag("hostile")

	inst.Transform:SetScale(1.25, 1.25, 1.25)
    inst.Transform:SetTwoFaced()

	inst.AnimState:SetBank("butterfly")
    inst.AnimState:SetBuild("butterfly_basic")
    inst.AnimState:PlayAnimation("idle")
    inst.AnimState:SetRayTestOnBB(true)

    inst.DynamicShadow:SetSize(.8, .5)

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    ---------------------
    inst:AddComponent("locomotor") -- locomotor must be constructed before the stategraph
	inst.components.locomotor.walkspeed = 4
	inst.components.locomotor.runspeed = 4
    inst.components.locomotor:EnableGroundSpeedMultiplier(false)
    inst.components.locomotor:SetTriggersCreep(false)

    ------------------
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(200)
	
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(0 * TUNING.ZG_DIFFICULTY)		----攻击不在这里
    inst.components.combat:SetAttackPeriod(4 - TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetRange(2)
    inst.components.combat.hiteffectsymbol = "butterfly_body"
    inst.components.combat:SetRetargetFunction(3, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	
	inst:ListenForEvent("attacked", OnAttacked)

    ------------------
    inst:AddComponent("knownlocations")
	
	MakeSmallBurnableCharacter(inst, "butterfly_body")
    MakeTinyFreezableCharacter(inst, "butterfly_body")

    ------------------
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("变异蝴蝶")

    ------------------
    inst:AddComponent("lootdropper")
    inst.components.lootdropper:AddRandomLoot("butter", 0.3)
    inst.components.lootdropper:AddRandomLoot("butterflywings", 5)
    inst.components.lootdropper.numrandomloot = 3
	

    ------------------
    
	local brain = require "brains/zg_mo_butterfly"
    inst:SetBrain(brain)
	
	inst:SetStateGraph("SGzg_mo_butterfly")
	
	----变异变回去
	inst:AddComponent("zg_creature_variation")
	inst.components.zg_creature_variation:SetVariationTime(20 * 3)
	inst.components.zg_creature_variation:StartVariation()
	inst.components.zg_creature_variation.onvariationreplacement = "butterfly"
	inst.components.zg_creature_variation.chance = .2 * TUNING.ZG_DIFFICULTY_PERIOD

    return inst
end

STRINGS.NAMES.ZG_MO_BUTTERFLY = "静电蝴蝶"
return Prefab("zg_mo_butterfly", fn)
