local assets =
{
	Asset("ANIM", "anim/zg_mo_butterfly0.zip"),
}

----	被攻击时
local function OnAttacked(inst, data)
    
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) and not attacker:HasTag("shadowboss") then
			inst.components.combat:SetTarget(attacker)
			
		end
	end
end

----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 3 + 9 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
    return invader
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end
----------------------------------------------------------------------------------------
----	武器栏
local function GetInventory(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage( 15 * TUNING.ZG_DIFFICULTY )
		meleeweapon.components.weapon:SetRange(8, 12)				
		meleeweapon.components.weapon:SetProjectile("zg_fx_butterflyspit")
		meleeweapon.components.weapon.stimuli = "zg_ele_bone"
		
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
		inst.components.inventory:Equip(meleeweapon)
    end
end

-----------------------------------------------------------------------------------------
SetSharedLootTable( 'zg_mo_butterfly0',
{
	{'butterflywings',          1},
	{'butterflywings',          1},
	{'butter', 				0.5},
})
----------------------------------------------------------
local function fn()
    local inst = CreateEntity()

    --Core components
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddDynamicShadow()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    inst.entity:AddPhysics()

    --Initialize physics
	inst.Physics:SetCapsule(.5, 1)
	inst.Physics:SetMass(100)
    inst.Physics:SetCollisionGroup(COLLISION.CHARACTERS)
	inst.Physics:ClearCollisionMask()
	inst.Physics:CollidesWith(COLLISION.CHARACTERS)
	inst.Physics:CollidesWith(COLLISION.GROUND)

	inst:AddTag("healthinfo")
    inst:AddTag("zg_butterfly")
    inst:AddTag("flying")
	inst:AddTag("healthinfo")
	inst:AddTag("hostile")
	
	inst.Transform:SetScale(1.25, 1.25, 1.25)
    inst.Transform:SetTwoFaced()

	inst.AnimState:SetBank("butterfly")
    inst.AnimState:SetBuild("zg_mo_butterfly0")
    inst.AnimState:PlayAnimation("idle")
    inst.AnimState:SetRayTestOnBB(true)

    inst.DynamicShadow:SetSize(.8, .5)

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

	inst:AddComponent("inventory")
	
    ---------------------
    inst:AddComponent("locomotor") -- locomotor must be constructed before the stategraph
	inst.components.locomotor.walkspeed = 4
	inst.components.locomotor.runspeed = 4
    inst.components.locomotor:EnableGroundSpeedMultiplier(false)
    inst.components.locomotor:SetTriggersCreep(false)
    inst:SetStateGraph("SGbutterfly")

    ------------------
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(300)
	
	----	战斗
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(30 * TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetAttackPeriod(4 - TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetRange(2)
    inst.components.combat.hiteffectsymbol = "butterfly_body"
    inst.components.combat:SetRetargetFunction(3, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	
	
	inst:ListenForEvent("attacked", OnAttacked)

    ------------------
    inst:AddComponent("knownlocations")

	----	武器
	--inst:DoTaskInTime(.5, function()
		GetInventory(inst)
	--end)
	
	MakeSmallBurnableCharacter(inst, "butterfly_body")
    MakeTinyFreezableCharacter(inst, "butterfly_body")
	
    ------------------
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("变异蝴蝶")

    ------------------
    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('zg_mo_butterfly0')
	

    ------------------
    
	local brain = require "brains/zg_mo_butterfly"
    inst:SetBrain(brain)
	
	inst:SetStateGraph("SGzg_mo_butterfly")
	
	----变异变回去
	inst:AddComponent("zg_creature_variation")
	inst.components.zg_creature_variation:SetVariationTime(20 * 3)
	inst.components.zg_creature_variation:StartVariation()
	inst.components.zg_creature_variation.onvariationreplacement = "butterfly"
	inst.components.zg_creature_variation.chance = .2 * TUNING.ZG_DIFFICULTY_PERIOD

    return inst
end


local function fn_fx()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    inst.Transform:SetFourFaced()

    inst.AnimState:SetBank("spider_spit")
    inst.AnimState:SetBuild("spider_spit")
	inst.AnimState:SetAddColour(32, 0, 0, 0)
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("projectile")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst.persists = false

    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(10)
    inst.components.projectile:SetHoming(false)
    inst.components.projectile:SetHitDist(1)
    inst.components.projectile:SetOnHitFn(inst.Remove)
    inst.components.projectile:SetOnMissFn(function(inst)
		inst:ListenForEvent("entitysleep", inst.Remove)
	end)
    inst.components.projectile:SetOnThrownFn(function(inst)
		inst:ListenForEvent("entitysleep", inst.Remove)
	end)

    return inst
end

STRINGS.NAMES.ZG_MO_BUTTERFLY0 = "蝴蝶射手"
return Prefab("zg_mo_butterfly0", fn, assets),
	Prefab("zg_fx_butterflyspit", fn_fx, assets)



