local assets =
{
    Asset("ANIM", "anim/zg_leif_build.zip"),
}

local function spawnchest(inst)
    inst.SoundEmitter:PlaySound("dontstarve/common/ghost_spawn")

    local chest = SpawnPrefab("treasurechest")
    local x, y, z = inst.Transform:GetWorldPosition()
    chest.Transform:SetPosition(x, 0, z)

    local fx = SpawnPrefab("statue_transition_2")
    if fx ~= nil then
        fx.Transform:SetPosition(x, y, z)
        fx.Transform:SetScale(1, 2, 1)
    end

    fx = SpawnPrefab("statue_transition")
    if fx ~= nil then
        fx.Transform:SetPosition(x, y, z)
        fx.Transform:SetScale(1, 1.5, 1)
    end

    chest:AddComponent("scenariorunner")
    chest.components.scenariorunner:SetScript("chest_zg_mo_evergreen")
    chest.components.scenariorunner:Run()
end

local function fn()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
	inst.entity:AddSoundEmitter()
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.25, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.CHARACTERS)
	phys:CollidesWith(COLLISION.OBSTACLES)
    phys:CollidesWith(COLLISION.SMALLOBSTACLES)

	--inst.entity:AddMiniMapEntity()
	--inst.MiniMapEntity:SetIcon("evergreen.png")
	--inst.MiniMapEntity:SetPriority(-1)
	
	inst.entity:AddAnimState()
	inst.AnimState:SetBank("leif")
	inst.AnimState:SetBuild("zg_leif_build")
	inst.AnimState:PlayAnimation("idle_loop", true)
	
	inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize(4, 1.5)
	
	inst:AddTag("healthinfo")
	inst:AddTag("leif")
	inst:AddTag("shadowboss")
	inst:AddTag("scarytoprey")
	inst:AddTag("hostile")
	
	inst.entity:AddNetwork()

	inst.entity:SetPristine()

	if not TheWorld.ismastersim then
		return inst
	end
	
	inst:AddComponent("locomotor") 
    inst.components.locomotor.runspeed = 5 
    inst.components.locomotor.walkspeed = 5 
	inst.components.locomotor.fasteronroad = false
	inst.components.locomotor:SetTriggersCreep(false)

    ------------------------------------------
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(60 * TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetAttackPeriod(3 * TUNING.ZG_DIFFICULTY_PERIOD)
	inst.components.combat:SetRange(4)
	inst.components.combat:SetAreaDamage(6, 0.8)					----范围攻击
    --inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
    --inst.components.combat:SetRetargetFunction(2, RetargetFn)
	
	function inst.components.combat:DoAreaAttack(target, range, weapon, validfn, stimuli)
		local hitcount = 0
		local x, y, z = target.Transform:GetWorldPosition()
		local ents = TheSim:FindEntities(x, y, z, range, { "_combat" }, {"shadowboss", "leif"})			----AOE伤害忽略队友
		for i, ent in ipairs(ents) do
			if ent ~= target and
				ent ~= self.inst and
				self:IsValidTarget(ent) and
				(validfn == nil or validfn(ent)) then
				self.inst:PushEvent("onareaattackother", { target = target, weapon = weapon, stimuli = stimuli })
				ent.components.combat:Zg_GetAttacked(self.inst, self:CalcDamage(ent, weapon, self.areahitdamagepercent), weapon, stimuli)
				hitcount = hitcount + 1
			end
		end
		return hitcount
	end
	
	inst:AddComponent("health")
    --inst.components.health:StartRegen(1, 1)
	inst.components.health:SetMaxHealth(960)
	inst.components.health.fire_damage_scale = 0
	
	inst:ListenForEvent("death", spawnchest)
	
	local brain = require "brains/zg_mo_evergreenbrain"			
    inst:SetBrain(brain)
    inst:SetStateGraph("SGzg_mo_evergreen")

	-------------------        
	inst:AddComponent("inspectable")
    inst.components.inspectable:SetDescription("Everred, red evergreen?")

	return inst
end

STRINGS.NAMES.ZG_MO_EVERGREEN = "红色树精" 
return Prefab("zg_mo_evergreen", fn, assets)