local assets=
{

}

----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10 + 15 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	----	敌视语句
	if invader then
		local sayrandom = math.random()
		if sayrandom < .025 then
			inst.components.talker:Say("Burn!")
		elseif sayrandom < .05 then
			inst.components.talker:Say("HAHA!")
		end
	end
    return invader
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end
------------------------------------------------------------

----	武器栏
local function GetInventory(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(12 * TUNING.ZG_DIFFICULTY)
		meleeweapon.components.weapon.stimuli = "zg_ele_fire"
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
			
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end
------------------------------------------------------------------------
local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	inst.Transform:SetScale(.75, .75, .75)
	
    inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("willow")
	inst.AnimState:PlayAnimation("idle")
	--inst.AnimState:SetMultColour(1,1,1,.5)
	inst.AnimState:SetAddColour(1, .25, .25, 0)
	
	inst.AnimState:Hide("ARM_carry") 
    inst.AnimState:Show("ARM_normal")
	
    inst.entity:AddSoundEmitter()
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.CHARACTERS)
	
    inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize(1.5, .75)
	
    inst.entity:AddNetwork()
   
	inst:AddTag("healthinfo")
    inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("shadowcreature")
	inst:AddTag("scarytoprey")
	inst:AddTag("hostile")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("locomotor") 
    inst.components.locomotor.runspeed = 5 
    inst.components.locomotor.walkspeed = 5 
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(false)

    ------------------------------------------
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(12 * TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetAttackPeriod(4 - TUNING.ZG_DIFFICULTY)
	inst.components.combat:SetRange(1.5)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
    inst.components.combat:SetRetargetFunction(2, RetargetFn)

    ------------------------------------------
    inst:AddComponent("follower")
   
    inst:AddComponent("health")
    --inst.components.health:StartRegen(5, 1)
	inst.components.health:SetMaxHealth(300)
    ------------------------------------------

    inst:AddComponent("inventory")
    inst:AddComponent("knownlocations")
    inst:AddComponent("talker")
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("Very hot and dangerous")
	
	local brain = require "brains/zg_mo_bunnybrain"		----和胡须兔兔相同的AI
    inst:SetBrain(brain)
    inst:SetStateGraph("SGzg_mo_firegirl")
	
	----	武器
	GetInventory(inst)
	
	inst:DoTaskInTime( 30, function()
		inst.components.talker:Say("(Lifetime is over)")
		inst.SoundEmitter:PlaySound("dontstarve/zg/spell/summon02")
		inst.components.health:Kill()
	end)

    return inst
end

STRINGS.NAMES.ZG_MO_FIREGIRL = "火焰女孩" 
return Prefab("zg_mo_firegirl", fn, assets)