

local brain = require "brains/zg_mo_frog"

local function retargetfn(inst)
    local invader = nil
    invader = FindEntity(inst, 2 + 6 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	return invader, true
end

local function ShouldSleep(inst)
    return false -- frogs either go to their home, or just sit on the ground.
end

local function OnAttacked(inst, data)
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) and not attacker:HasTag("shadowboss") then
			inst.components.combat:SetTarget(attacker)
			----	小伙伴何在
			inst.components.combat:ShareTarget(attacker, 30, function(dude)
				return dude and dude:HasTag("frog")		
			end, 5)
		end
	end
	
	--inst.components.combat:SetTarget(data.attacker)
    --inst.components.combat:ShareTarget(data.attacker, 30, function(dude) return dude:HasTag("frog") and not dude.components.health:IsDead() end, 5)
end

local function OnGoingHome(inst)
    local fx = SpawnPrefab("splash")
    local pos = inst:GetPosition()
    fx.Transform:SetPosition(pos.x, pos.y, pos.z)

    --local splash = PlayFX(Vector3(inst.Transform:GetWorldPosition() ), "splash", "splash", "splash")
    inst.SoundEmitter:PlaySound("dontstarve/frog/splash")
end

local function OnHitOther(inst, other, damage)
    inst.components.thief:StealItem(other)
end

local function wilsononcollide(inst, other)
	if not other then
		return
	else
		if not other:IsValid() then
			return
		end
		----遇到障碍物就跳跃
		if inst.components.health and not inst.components.health:IsDead() and 
			not (other:HasTag("shadowboss") or other:HasTag("projectile") or other:HasTag("character") or other:HasTag("hound") or other:HasTag("frog")) then
			inst.sg:GoToState("mydarkjump")
		end
	end
end
------------------------------------------------------------------
----	武器栏
local function GetInventory(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage( (inst.components.combat.defaultdamage or 50) * TUNING.ZG_DIFFICULTY)
		meleeweapon.components.weapon:SetRange(11, 15)				
		meleeweapon.components.weapon:SetProjectile("zg_fx_arrow_green")
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
		inst.components.inventory:Equip(meleeweapon)
    end
end
------------------------------------------------------------------
local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.3, 1)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.CHARACTERS)
	--phys:CollidesWith(COLLISION.OBSTACLES)
    --phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddDynamicShadow()
    inst.entity:AddNetwork()

    --MakeCharacterPhysics(inst, 1, .3)

    inst.DynamicShadow:SetSize(1.5, .75)
    inst.Transform:SetFourFaced()

    inst.AnimState:SetBank("frog")
    inst.AnimState:SetBuild("frog")
    inst.AnimState:PlayAnimation("idle")
	--inst.AnimState:SetAddColour(.25, .75, .25, 0)
	inst.AnimState:SetMultColour(.25,1,.25,.75)

	inst:AddTag("healthinfo")
	
    inst:AddTag("animal")
    inst:AddTag("prey")
    inst:AddTag("smallcreature")
    inst:AddTag("frog")
    inst:AddTag("canbetrapped")
	inst:AddTag("hostile")
	inst:AddTag("shadowboss")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddComponent("inventory")

    inst:AddComponent("locomotor") -- locomotor must be constructed before the stategraph
    inst.components.locomotor.walkspeed = 4
    inst.components.locomotor.runspeed = 8

    inst:SetStateGraph("SGzg_mo_frog")
	----	软实体的碰撞
	--inst.Physics:SetCollisionCallback(wilsononcollide)

    inst:SetBrain(brain)

    inst:AddComponent("sleeper")
    inst.components.sleeper:SetSleepTest(ShouldSleep)

    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(138)
	--inst.components.health:StartRegen(1,2)

    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(30 * TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetAttackPeriod(1.5)
    inst.components.combat:SetRetargetFunction(2, retargetfn)

    inst.components.combat.onhitotherfn = OnHitOther

    inst:AddComponent("thief")

    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetLoot({"froglegs", "froglegs"})

    inst:AddComponent("knownlocations")
	
	----	武器
	inst:DoTaskInTime(.5, function()
		GetInventory(inst)
	end)
	
    inst:AddComponent("inspectable")

    inst:ListenForEvent("attacked", OnAttacked)
    inst:ListenForEvent("goinghome", OnGoingHome)
	
	--[[
	inst:AddComponent("zg_creature_variation")
	inst.components.zg_creature_variation:SetVariationTime(30 * 3)
	inst.components.zg_creature_variation:StartVariation()
	inst.components.zg_creature_variation.onvariationreplacement = "frog"
	inst.components.zg_creature_variation.chance = .15 * TUNING.ZG_DIFFICULTY_PERIOD
	]]
    return inst
end

STRINGS.NAMES.ZG_MO_FROG0 = "毒箭蛙" 
return Prefab("zg_mo_frog0", fn)