local assets=
{
	Asset("ANIM", "anim/zg_mo_goblin_grunt.zip"),
}

SetSharedLootTable('zg_mo_goblin_grunt',
{
    {'meat',             1.00}, 
})

----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 15 + 15 * 1, function(guy)
        return guy and not guy:HasTag("playerghost") and
			(
				guy:HasTag("character") or guy:HasTag("animal")
			)
    end)
    return invader, true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end

local function OnAttacked(inst, data)
    ----	群体反攻玩家
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) then
			inst.components.combat:SetTarget(attacker)
			----	小伙伴何在
			inst.components.combat:ShareTarget(attacker, 30, function(dude)
				return dude and dude:HasTag("zg_goblin")
			end, 20)
		end
	end
end
---------------------------------------
----	武器样式
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_spear", "swap_spear")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end
local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

----	武器栏
local function GetInventory(inst)
    if inst.components.inventory then
	
		--[[
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(60 * 1)
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
			----	武器外观
			meleeweapon.components.equippable:SetOnEquip(onequip)
			meleeweapon.components.equippable:SetOnUnequip(onunequip)
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)]]
		
		----武器
		local hand_table = 
		{
			"spear", "axe", "pickaxe", "shovel", 
			"pitchfork", "hammer", "spear_wathgrithr",
		}
		local hand = SpawnPrefab( hand_table[math.random(#hand_table)] )
		hand.persists = false
		hand.components.inventoryitem:SetOnDroppedFn(hand.Remove)
		
		--hand.components.inventoryitem.onunequipfn=function(hand,owner) 
			--if math.random() < .75 then 
				--hand:Remove() 
			--end 
		--end
		inst.components.inventory:Equip(hand)
		
		----帽子
		local hat_table = 
		{
			"footballhat", "footballhat", "footballhat", "footballhat", 
			"minerhat", "tophat", "wathgrithrhat", "bushhat",
		}
		local hat = SpawnPrefab( hat_table[math.random(#hat_table)] )
		hat.persists = false
		hat.components.inventoryitem:SetOnDroppedFn(hat.Remove)
		--hat.components.inventoryitem.onunequipfn=function(hat,owner) 
			--if math.random() < .75 then 
				--hat:Remove() 
			--end 
		--end
		inst.components.inventory:Equip(hat)
		
    end
end
---------------------------------------
local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
    inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("zg_mo_goblin_grunt")
	inst.AnimState:PlayAnimation("idle")
	
    inst.entity:AddSoundEmitter()
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.CHARACTERS)
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.OBSTACLES)
    phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	
    inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize(1.5, .75)
	
    inst.entity:AddNetwork()
   
	inst:AddTag("healthinfo")
  
	inst:AddTag("zg_goblin")
	inst:AddTag("scarytoprey")
	inst:AddTag("shadowboss")
	
	inst:AddTag("hostile")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	----	碰撞
	--inst.Physics:SetCollisionCallback(oncollide)
	
	inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(60 * 1)
    inst.components.combat:SetAttackPeriod( 3 - 1)
	inst.components.combat:SetRange(2)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
    inst.components.combat:SetRetargetFunction(3, RetargetFn)

    inst:AddComponent("locomotor") 
    inst.components.locomotor.runspeed = 4 
    inst.components.locomotor.walkspeed = 4 
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(true)

    ------------------------------------------

    ------------------------------------------
    --inst:AddComponent("follower")
	
	inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('zg_mo_goblin_grunt')
   
    inst:AddComponent("health")
	inst.components.health:SetMaxHealth(320)
		
    ------------------------------------------

    inst:AddComponent("inventory")
    inst:AddComponent("knownlocations")
    --inst:AddComponent("talker")
	
	MakeMediumBurnableCharacter(inst, "torso")
	
	----	武器
	GetInventory(inst)
	
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("曾经在哪里见过它们")
	
	inst:ListenForEvent("attacked", OnAttacked)
	
	local brain = require "brains/zg_mo_goblin_grunt"			
    inst:SetBrain(brain)
    inst:SetStateGraph("SGzg_mo_goblin_grunt")
	
	local function updatedamage(inst, phase)
		if phase == "day" then
			inst.components.locomotor.runspeed = 4
		elseif phase == "night" then
			inst.components.locomotor.runspeed = 6    
		elseif phase == "dusk" then
			inst.components.locomotor.runspeed = 5 
		end
	end
	
	inst:WatchWorldState("phase", updatedamage)
	updatedamage(inst, TheWorld.state.phase)
	
    return inst
end

STRINGS.NAMES.ZG_MO_GOBLIN_GRUNT = "哥布林步兵"
return Prefab("zg_mo_goblin_grunt", fn, assets)