local assets=
{
	Asset("ANIM", "anim/zg_mo_goblin_robot.zip"),
}

SetSharedLootTable('zg_mo_goblin_robot_lightning',
{
    {'gears',             0.10}, 
	{'gears',             0.05},
	{'zg_weapon_lightninggun',             0.50},
})

SetSharedLootTable('zg_mo_goblin_robot_fire',
{
    {'gears',             0.10}, 
	{'gears',             0.05},
	{'redgem',             0.05},
	{'z_firegun',             0.50},
})

----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 15 + 15 * 1, function(guy)
        return guy and not guy:HasTag("playerghost") and
			(
				guy:HasTag("character") or guy:HasTag("animal")
			)
    end)
    return invader, true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end

local function OnAttacked(inst, data)
    ----	群体反攻玩家
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) then
			inst.components.combat:SetTarget(attacker)
			----	小伙伴何在
			inst.components.combat:ShareTarget(attacker, 30, function(dude)
				return dude and dude:HasTag("zg_goblin")
			end, 20)
			
		end
	end
end
---------------------------------------
---------------------------------------
local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
    inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("zg_mo_goblin_robot")
	inst.AnimState:PlayAnimation("idle")
	
    inst.entity:AddSoundEmitter()
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.CHARACTERS)
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.OBSTACLES)
    phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	
    inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize(1.5, .75)
	
    inst.entity:AddNetwork()
   
	inst:AddTag("healthinfo")
	inst:AddTag("zg_goblin")
	inst:AddTag("scarytoprey")
	inst:AddTag("hostile")
	inst:AddTag("shadowboss")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(30 * 1)
    inst.components.combat:SetAttackPeriod( 4 - 1 )
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
    inst.components.combat:SetRetargetFunction(3, RetargetFn)

    inst:AddComponent("locomotor") 
    inst.components.locomotor.runspeed = 4 
    inst.components.locomotor.walkspeed = 4 
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(true)

    ------------------------------------------

    -----------------------------------------
	
	inst:AddComponent("lootdropper")
    
   
    inst:AddComponent("health")
	inst.components.health:SetMaxHealth(660)		
    ------------------------------------------

    inst:AddComponent("inventory")
    inst:AddComponent("knownlocations")
	
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("曾经在哪里见过它们")
	
	inst:ListenForEvent("attacked", OnAttacked)
	
	local brain = require "brains/zg_mo_goblin_robot"			
    inst:SetBrain(brain)
    inst:SetStateGraph("SGzg_mo_goblin_robot")
	
    return inst
end

----电枪机器人

local function onequip1(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "zg_weapon_swap_lightninggun", "zg_weapon_swap_lightninggun")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end
local function onequip2(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "z_firegun_s", "z_firegun_s")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end
local function onunequip1(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

local function GetInventory_lightning(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(25 * 1)
		meleeweapon.components.weapon:SetRange(11, 15)
		meleeweapon.components.weapon:SetProjectile("zg_fx_arrow_yellow")
		meleeweapon.components.weapon.stimuli = "zg_ele_electric"
		
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
			----	武器外观
			meleeweapon.components.equippable:SetOnEquip(onequip1)
			meleeweapon.components.equippable:SetOnUnequip(onunequip1)
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end

local function GetInventory_fire(inst)
	if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(0)
		meleeweapon.components.weapon:SetRange(9, 15)
		meleeweapon.components.weapon:SetProjectile("zg_proj_firegun")
		--meleeweapon.components.weapon.stimuli = "zg_ele_electric"
		
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
			----	武器外观
			meleeweapon.components.equippable:SetOnEquip(onequip2)
			meleeweapon.components.equippable:SetOnUnequip(onunequip1)
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end

local function lightning()
	local inst = fn()
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst["zg_inh_anti_electric"] = .75
	inst["zg_inh_anti_fire"] = .5

	inst.components.combat:SetAttackPeriod(3 - 1)
	----	攻击特效
	--inst:ListenForEvent("onattackother", onattack1)
	inst.components.lootdropper:SetChanceLootTable('zg_mo_goblin_robot_lightning')
	----	武器
	GetInventory_lightning(inst)

	return inst
end

local function fire()
	local inst = fn()
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst["zg_inh_anti_electric"] = .5
	inst["zg_inh_anti_fire"] = .75

	inst.components.combat:SetAttackPeriod(3 - 1)
	----	攻击特效
	--inst:ListenForEvent("onattackother", onattack1)
	inst.components.lootdropper:SetChanceLootTable('zg_mo_goblin_robot_fire')
	----	武器
	GetInventory_fire(inst)

	return inst
end

STRINGS.NAMES.ZG_MO_GOBLIN_ROBOT_LIGHTNING = "哥布林电枪机器人"
STRINGS.NAMES.ZG_MO_GOBLIN_ROBOT_FIRE = "哥布林火枪机器人"
return Prefab("zg_mo_goblin_robot_lightning", lightning, assets),
	Prefab("zg_mo_goblin_robot_fire", fire, assets)