local assets = 
{
	Asset("ANIM", "anim/zg_mo_greenspider.zip"),
}

----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 5, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
    return invader, true
end

----	被攻击时
local function OnAttacked(inst, data)
	
	----	群体反攻玩家
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) and not attacker:HasTag("shadowboss") then
			inst.components.combat:SetTarget(attacker)
			----	小伙伴何在
			inst.components.combat:ShareTarget(attacker, 30, function(dude)
				return dude:HasTag("spider")	
			end, 20)
		end
	end
end

----击中别人
local function OnHitOther(inst, data)
    local other = data.target
    if other then
	
		----几率让目标中毒
		if math.random() < .5 * 1 and other.components.health and not other.components.health:IsDead() then
			if other:HasTag("player") then
				if other.components.grogginess then
					other.components.grogginess:AddGrogginess(10, 10)
				end
			else
				if other.components.sleeper then
					other.components.sleeper:AddSleepiness(10, 10)
				end
			end
		end
		
    end
end

local function fn()
	local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetScale(1.3,1.3,1.3)
	
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --inst.entity:AddLightWatcher()
    inst.entity:AddDynamicShadow()
    inst.entity:AddNetwork()

    --MakeCharacterPhysics(inst, 10, .5)
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.CHARACTERS)
	phys:CollidesWith(COLLISION.OBSTACLES)
    phys:CollidesWith(COLLISION.SMALLOBSTACLES)
    phys:CollidesWith(COLLISION.GIANTS)

    inst.DynamicShadow:SetSize(2, .75)
    inst.Transform:SetFourFaced()

    ----------

    --inst:AddTag("cavedweller")
	inst:AddTag("healthinfo")
    inst:AddTag("monster")
    inst:AddTag("hostile")
    inst:AddTag("scarytoprey")    
    --inst:AddTag("canbetrapped")    
    --inst:AddTag("smallcreature")
    inst:AddTag("spider")

    inst.AnimState:SetBank("spider")
    inst.AnimState:SetBuild("zg_mo_greenspider")
    inst.AnimState:PlayAnimation("idle")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    ----------
    --inst.OnEntitySleep = OnEntitySleep

    -- locomotor must be constructed before the stategraph!
    inst:AddComponent("locomotor")
	inst.components.locomotor.runspeed = 4 
    inst.components.locomotor.walkspeed = 4 
    inst.components.locomotor:SetSlowMultiplier( 1 )
    inst.components.locomotor:SetTriggersCreep(false)
    inst.components.locomotor.pathcaps = { ignorecreep = true }

    inst:AddComponent("lootdropper")
    inst.components.lootdropper:AddRandomLoot("spoiled_food", 2)
    inst.components.lootdropper:AddRandomLoot("silk", 2)
    inst.components.lootdropper:AddRandomLoot("spidergland", 2)
    --inst.components.lootdropper:AddRandomHauntedLoot("spidergland", 1)
    inst.components.lootdropper.numrandomloot = 6

    ---------------------
    MakeMediumBurnableCharacter(inst, "body")
    MakeMediumFreezableCharacter(inst, "body")
    --inst.components.burnable.flammability = TUNING.SPIDER_FLAMMABILITY
    ---------------------

    ------------------
    inst:AddComponent("health")
	inst.components.health:SetMaxHealth(773)
    ------------------

    inst:AddComponent("combat")
    inst.components.combat.hiteffectsymbol = "body"
    inst.components.combat:SetDefaultDamage(75  * 1)
    inst.components.combat:SetAttackPeriod(3 - 1)
    inst.components.combat:SetRange(2.5)
    inst.components.combat:SetRetargetFunction(3, RetargetFn)

    inst:AddComponent("follower")
    ------------------

    inst:AddComponent("knownlocations")

    ------------------

    inst:AddComponent("eater")
    inst.components.eater:SetDiet({ FOODTYPE.MEAT }, { FOODTYPE.MEAT })
    inst.components.eater:SetCanEatHorrible()
    inst.components.eater.strongstomach = true -- can eat monster meat!

    ------------------

    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("令人毛骨悚然")

	local brain = require "brains/zg_mo_greenspider"
    inst:SetBrain(brain)
	inst:SetStateGraph("SGzg_mo_greenspider")

    inst:ListenForEvent("attacked", OnAttacked)
	inst:ListenForEvent("onhitother", OnHitOther)

    return inst
end

STRINGS.NAMES.ZG_MO_GREENSPIDER = "腐败截肢手" 
return Prefab("zg_mo_greenspider", fn, assets)