
local assets =
{
  
}

--空表
local def={}

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddDynamicShadow()
    inst.entity:AddNetwork()

    MakeCharacterPhysics(inst, 1000, .5)

    inst.DynamicShadow:SetSize(1.5, .75)
    inst.Transform:SetFourFaced()

    inst.AnimState:SetBank("spider_spitter")
    inst.AnimState:SetBuild("DS_spider2_caves")
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:SetMultColour(0,1,0,1)

	inst:AddTag("healthinfo")
	inst:AddTag("zg_manshape")
	
    inst:AddTag("monster")
    inst:AddTag("hostile")
	inst:AddTag("cavedweller")
	inst:AddTag("scarytoprey") 
	inst:AddTag("spider")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	--inst.persists=false

    inst:AddComponent("lootdropper")
	inst.components.lootdropper:SetLoot({"spoiled_food","spoiled_food","silk"})

    inst:AddComponent("locomotor")
	inst.components.locomotor.runspeed=6
    inst.components.locomotor.walkspeed=6

    inst:SetStateGraph("sg_holespider")
	
	--Behaviour
	inst.zg_chaseandattack_period=def.zg_chaseandattack_period or .1
	inst.zg_runaway_period=def.zg_runaway_period or .1
	
	--AI
	inst.zg_ai_period=def.zg_ai_period or .1	--AI刷新时间
	inst.zg_chase_time=def.zg_chase_time or 30	--追杀时间
	inst.zg_see_dist=def.zg_see_dist or 15	--逃跑检测hunter的距离
	
	inst.zg_startrunaway_dist=def.zg_startrunaway_dist or 2		--开始躲避敌人预留的距离
	inst.zg_stoprunaway_dist=def.zg_stoprunaway_dist or 3	--躲避敌人攻击距离 预留的安全距离
	
	inst.target_exdist=def.target_exdist or 1	--玩家要是武器距离超过1,不再走位
	local brain=require "brains/br_bishop"
    inst:SetBrain(brain)

    inst:AddComponent("combat")
    --inst.components.combat.hiteffectsymbol = "waist"
	inst.components.combat:SetDefaultDamage(20)
    inst.components.combat:SetAttackPeriod(2)
    inst.components.combat:SetRange(3)
    inst.components.combat:SetRetargetFunction(def.retargetperiod or 1,def.retargetfn or function(inst)
		return FindEntity(inst,def.retargetdist or 30,
			function(guy)
				return inst.components.combat:CanTarget(guy) and (zg_isenemy(guy,inst,{"zg_manshape"}) or guy:HasTag("player"))
			end,
			nil,
			{"zg_manshape", "playerghost",}
		)
	end)
	inst.components.combat:SetKeepTargetFunction(def.keeptargetfn or function (inst, target)
		return inst.components.combat:CanTarget(target) and inst:IsNear(target,def.keeptargetdist or 40)
	end)
	inst:ListenForEvent("attacked",def.attackedfn or function(inst,data)
		local invader = nil
		invader = FindEntity(inst, inst.components.combat.attackrange+1, function(guy)
			return guy:HasTag("player") and not guy:HasTag("zg_manshape")
		end)
		if invader then
			inst.components.combat:SetTarget(invader)
		else
			inst.components.combat:SetTarget(data.attacker)
		end
	end)

    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(150)

    inst:AddComponent("inventory")

    inst:AddComponent("inspectable")

    inst:AddComponent("follower")

    MakeMediumBurnableCharacter(inst,"body")
    MakeMediumFreezableCharacter(inst,"body")

    return inst
end

STRINGS.NAMES[string.upper("zg_mo_holespider")]=zg_ischs("墓穴蜘蛛","Grave Spider")
STRINGS.CHARACTERS.GENERIC.DESCRIBE[string.upper("zg_mo_holespider")]=zg_ischs("它们身上有一股腐烂的气息","They have a rotten smell.")
return Prefab("zg_mo_holespider", fn, assets)
