local assets=
{
	Asset("ANIM", "anim/zg_swap_bow.zip"),
	Asset( "ANIM", "anim/zg_bow_attack.zip" ),
}

-----------------------------------------------------------------------
----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10 + 15 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	----	敌视语句
	if invader then
		local sayrandom = math.random()
		if sayrandom < .05 then
			inst.SoundEmitter:PlaySound("dontstarve/zg/wicker/call2")
			inst.components.talker:Say("Shoot!")
		elseif sayrandom < .1 then
			inst.SoundEmitter:PlaySound("dontstarve/zg/wicker/call2")
			inst.components.talker:Say("Aim!")
		end
	end
    return invader
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end

-----------------------------------------
----	武器样式
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "zg_swap_bow", "swap_bow")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end
local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

----	武器栏
local function GetInventory(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(12 * TUNING.ZG_DIFFICULTY)
		meleeweapon.components.weapon:SetRange(9, 11)
		meleeweapon.components.weapon:SetProjectile("zg_fx_arrow")
		meleeweapon.components.weapon.stimuli = "zg_ele_ice"
		
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
			----	武器外观
			meleeweapon.components.equippable:SetOnEquip(onequip)
			meleeweapon.components.equippable:SetOnUnequip(onunequip)
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end
------------------------------------------------------------------------

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
    inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("wickerbottom")
    inst.AnimState:Hide("hat")
	inst.AnimState:PlayAnimation("idle")
	--inst.AnimState:SetMultColour(1,1,1,.5)
	inst.AnimState:SetAddColour(.75, .75, 1, 0)
	
    inst.entity:AddSoundEmitter()
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.CHARACTERS)
	
    inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize(1.5, .75)
	
    inst.entity:AddNetwork()
	
	inst:AddTag("healthinfo")
    inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("shadowcreature")
	inst:AddTag("scarytoprey")
	inst:AddTag("hostile")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("locomotor") 
    inst.components.locomotor.runspeed = 5 
    inst.components.locomotor.walkspeed = 4 
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(false)

    ------------------------------------------
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(12 * TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetAttackPeriod(5 - TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
    inst.components.combat:SetRetargetFunction(2, RetargetFn)
	inst.components.combat:SetRange(2)

    ------------------------------------------
    inst:AddComponent("follower")
   
    inst:AddComponent("health")
    --inst.components.health:StartRegen(5, 1)
	inst.components.health:SetMaxHealth(500)
    ------------------------------------------

    inst:AddComponent("inventory")
    inst:AddComponent("knownlocations")
    inst:AddComponent("talker")
	
	----	武器
	GetInventory(inst)
	
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("The assistant of evil witch")
	
	local brain = require "brains/zg_mo_bunnybrain"			
    inst:SetBrain(brain)
    inst:SetStateGraph("SGzg_mo_icearcher")
	
	inst:DoTaskInTime( 45, function()
		inst.components.talker:Say("(Lifetime is over)")
		inst.SoundEmitter:PlaySound("dontstarve/zg/spell/summon02")
		inst.components.health:Kill()
	end)

    return inst
end
----------------------------------------------------------------------------------------------------------------------

local function fnarrow()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
	RemovePhysicsColliders(inst)

    inst.AnimState:SetBank("blow_dart")
    inst.AnimState:SetBuild("blow_dart")
    inst.AnimState:PlayAnimation("dart_pipe")
	--inst.AnimState:SetAddColour(.75, .75, 1, 0)
	
	inst:AddTag("NOCLICK")
    inst:AddTag("sharp")
    inst:AddTag("projectile") 

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddComponent("projectile")
	inst.components.projectile:SetSpeed(30)
    inst.components.projectile:SetHoming(false)
    inst.components.projectile:SetHitDist(.5)
    inst.components.projectile:SetOnHitFn( function(inst, attacker, target)
		local impactfx = SpawnPrefab("impact")
		if impactfx ~= nil then
			local follower = impactfx.entity:AddFollower()
			follower:FollowSymbol(target.GUID, target.components.combat.hiteffectsymbol, 0, 0, 0)
			if attacker ~= nil then
				impactfx:FacePoint(attacker.Transform:GetWorldPosition())
			end
		end
		inst:Remove()
	end)
    inst.components.projectile:SetOnMissFn(inst.Remove)
    inst.components.projectile:SetOnThrownFn(function(inst, data)
		inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
	end)
	inst.components.projectile:SetLaunchOffset( Vector3(0, 0, 0) )
	
	inst:DoTaskInTime(3, function()
		inst:Remove()
	end)

    return inst
end

local function whitearrow()
	local inst = fnarrow()
	
	inst.AnimState:SetAddColour(.75, .75, 1, 0)
	
	return inst
end

local function greenarrow()
	local inst = fnarrow()
	
	inst.AnimState:SetAddColour(.25, .75, .25, 0)
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	return inst
end

----------------------------------------------------------------------------------------
STRINGS.NAMES.ZG_MO_ICEARCHER = "冷酷弓箭手" 
return Prefab("zg_mo_icearcher", fn, assets),
	Prefab("zg_fx_arrow", whitearrow, assets),
	Prefab("zg_fx_arrow_green", greenarrow, assets)