local assets=
{
	Asset("ANIM", "anim/zg_mo_skel.zip"),
}

SetSharedLootTable('zg_mo_skel',
{
	{'zg_it_livingbone',      0.025},
	{'zg_weapon_mace',        0.5},
})

----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 20, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
    return invader, true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end

local function OnAttacked(inst, data)
    ----	群体反攻玩家
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) and not attacker:HasTag("shadowboss") then
			inst.components.combat:SetTarget(attacker)
			----	小伙伴何在
			inst.components.combat:ShareTarget(attacker, 100, function(dude)
				return dude and dude:HasTag("zg_skel")
			end, 20)
		end
	end
end
----------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------
local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
    inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("wilton")
	inst.AnimState:PlayAnimation("idle")
	
    inst.entity:AddSoundEmitter()
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.CHARACTERS)
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.OBSTACLES)
    phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	
    inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize(1.5, .75)
	
    inst.entity:AddNetwork()
   
	inst:AddTag("healthinfo")
	inst:AddTag("zg_skel")
	inst:AddTag("monster")
	inst:AddTag("scarytoprey")
	inst:AddTag("shadowboss")
	
	inst.AnimState:OverrideSymbol("swap_object", "swap_zg_weapon_mace", "swap_zg_weapon_mace")
    inst.AnimState:Show("ARM_carry")
    inst.AnimState:Hide("ARM_normal")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(120 * TUNING.ZG_DIFFICULTY)
	inst.components.combat:SetRange(2)
    inst.components.combat:SetAttackPeriod(3 - TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
    inst.components.combat:SetRetargetFunction(3, RetargetFn)

    inst:AddComponent("locomotor") 
    inst.components.locomotor.runspeed = 2 
    inst.components.locomotor.walkspeed = 2 
	inst.components.locomotor.fasteronroad = false
	inst.components.locomotor:SetTriggersCreep(true)

    ------------------------------------------

    ------------------------------------------
    inst:AddComponent("follower")
	
	inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('zg_mo_skel')
   
    inst:AddComponent("health")
	inst.components.health:SetMaxHealth(754)
	inst["zg_inh_anti_bone"] = .75
	inst.components.health.destroytime = .25			--瞬间死亡,表现为骨头炸裂
    ------------------------------------------

    inst:AddComponent("inventory")
    inst:AddComponent("knownlocations")
	
	MakeHugeFreezableCharacter(inst, "torso")
	
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("Skeleton man!!!")
	
	inst:ListenForEvent("attacked", OnAttacked)
	
	local brain = require "brains/zg_mo_skelbrain"			
    inst:SetBrain(brain)
    inst:SetStateGraph("SGzg_mo_skel")
	
	inst:DoTaskInTime(3, function()
		inst.SoundEmitter:PlaySound("dontstarve/zg/mo_skel/call")
	end)
	
    return inst
end
---------------------------------------------------------------------------------------
--步兵
SetSharedLootTable('zg_mo_skel0',
{
	{'zg_it_livingbone',      0.05},
	{'zg_weapon_shortsword',		0.5},
})

local function fn0()
	local inst = fn()
	--inst.Transform:SetScale(1.1,1.1,1.1)
	
	inst.AnimState:OverrideSymbol("swap_object", "swap_zg_weapon_shortsword", "swap_zg_weapon_shortsword")
    inst.AnimState:Show("ARM_carry")
    inst.AnimState:Hide("ARM_normal")
	
	inst.AnimState:OverrideSymbol("swap_hat", "hat_football", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.combat:SetDefaultDamage(150 * TUNING.ZG_DIFFICULTY)
	inst.components.combat:SetRange(2)
	
	inst.components.health:SetMaxHealth(773)
	inst["zg_inh_anti_bone"] = .75
	inst["zg_inh_anti_physics"] = .5
	
	inst.components.locomotor.runspeed = 2 
    inst.components.locomotor.walkspeed = 2 
	
	inst.components.lootdropper:SetChanceLootTable('zg_mo_skel0')
	
	return inst
end
---------------------------------------------------------------------------------------
--突击兵
SetSharedLootTable('zg_mo_skel1',
{
	{'zg_it_livingbone',      0.075},
	{'zg_weapon_longsword',		0.5},
})

local function fn1()
	local inst = fn()
	--inst.Transform:SetScale(1.2,1.2,1.2)
	
	inst.AnimState:OverrideSymbol("swap_object", "swap_zg_weapon_longsword", "swap_zg_weapon_longsword")
    inst.AnimState:Show("ARM_carry")
    inst.AnimState:Hide("ARM_normal")
	
	inst.AnimState:OverrideSymbol("swap_hat", "hat_football", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")
	inst.AnimState:OverrideSymbol("swap_body", "armor_wood", "swap_body")
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.combat:SetDefaultDamage(180 * TUNING.ZG_DIFFICULTY)
	inst.components.combat:SetRange(3)
	
	inst.components.health:SetMaxHealth(953)
	inst["zg_inh_anti_bone"] = .75
	inst["zg_inh_anti_physics"] = .5
	
	inst.components.locomotor.runspeed = 3 
    inst.components.locomotor.walkspeed = 3 
	
	inst.components.lootdropper:SetChanceLootTable('zg_mo_skel1')
	
	return inst
end
---------------------------------------------------------------------------------------
--守卫
SetSharedLootTable('zg_mo_skel2',
{
    {'boneshard',             1.00}, 
	{'boneshard',             1.00}, 	
    {'boneshard',             0.25},
	{'zg_it_livingbone',      0.1},
	{'zg_weapon_longsword',		0.5},
})

local function fn2()
	local inst = fn()
	--inst.Transform:SetScale(1.3,1.3,1.3)
	
	inst.AnimState:OverrideSymbol("swap_object", "swap_zg_weapon_longsword", "swap_zg_weapon_longsword")
    inst.AnimState:Show("ARM_carry")
    inst.AnimState:Hide("ARM_normal")
	
	inst.AnimState:OverrideSymbol("swap_hat", "hat_wathgrithr", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")
	inst.AnimState:OverrideSymbol("swap_body", "armor_wood", "swap_body")
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.combat:SetDefaultDamage(210 * TUNING.ZG_DIFFICULTY)
	inst.components.combat:SetRange(3)
	
	inst.components.health:SetMaxHealth(998)
	inst["zg_inh_anti_bone"] = .75
	inst["zg_inh_anti_physics"] = .6
	
	inst.components.locomotor.runspeed = 3 
    inst.components.locomotor.walkspeed = 3 
	
	inst.components.lootdropper:SetChanceLootTable('zg_mo_skel2')
	
	return inst
end
---------------------------------------------------------------------------------------
--骑士
SetSharedLootTable('zg_mo_skel3',
{
	{'zg_it_livingbone',      0.15},
	{'zg_weapon_longsword',		0.5},
})

local function fn3()
	local inst = fn()
	--inst.Transform:SetScale(1.3,1.3,1.3)
	
	inst.AnimState:OverrideSymbol("swap_object", "swap_zg_weapon_longsword", "swap_zg_weapon_longsword")
    inst.AnimState:Show("ARM_carry")
    inst.AnimState:Hide("ARM_normal")
	
	inst.AnimState:OverrideSymbol("swap_hat", "hat_wathgrithr", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")
	inst.AnimState:OverrideSymbol("swap_body", "armor_marble", "swap_body")
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.combat:SetDefaultDamage(300 * TUNING.ZG_DIFFICULTY)
	inst.components.combat:SetRange(3)
	
	inst.components.health:SetMaxHealth(2016)
	inst["zg_inh_anti_bone"] = .75
	inst["zg_inh_anti_physics"] = .75
	
	inst.components.locomotor.runspeed = 4 
    inst.components.locomotor.walkspeed = 4 
	
	inst.components.lootdropper:SetChanceLootTable('zg_mo_skel3')
	
	return inst
end
---------------------------------------------------------------------------------------
STRINGS.NAMES.ZG_MO_SKEL = "骷髅佣兵"
STRINGS.NAMES.ZG_MO_SKEL0 = "骷髅步兵"
STRINGS.NAMES.ZG_MO_SKEL1 = "骷髅突击兵"
STRINGS.NAMES.ZG_MO_SKEL2 = "骷髅守卫"
STRINGS.NAMES.ZG_MO_SKEL3 = "骷髅骑士"
return Prefab("zg_mo_skel", fn, assets),
	Prefab("zg_mo_skel0", fn0, assets),
	Prefab("zg_mo_skel1", fn1, assets),
	Prefab("zg_mo_skel2", fn2, assets),
	Prefab("zg_mo_skel3", fn3, assets)