--骷髅	前缀 zg_skel_
local prefix="zg_skel2_"

local assets={
	--Asset("ANIM","anim/zg_mo_skel.zip"),
}


local manshape_defs ={
	--佣兵--
	{
		name="mer",
		hasshield=true,
		zg_name=zg_ischs("精锐骷髅佣兵","Skel Mercenary"),
		runspeed=4,		--速度
		health=400,		--血量
		attackperiod=2,		--攻击间隔
		zg_chase_time=15,	--追杀时间
		brain=require("brains/br_skel"),
		loot={
			{'zg_it_livingbone',      0.1},
			{'zg_weapon_mace',        0.5},
		},
		weaponlist={
			--骨爪
			{damage=60,uses=nil,attackrange=.5,hitrange=.5,projectile=nil,build="z_boneclaw_s",bank="z_boneclaw_s",tag={"sharp",}},
		},
		armorlist={
			{condition=450,absorb=.8,build=nil,tag=nil},	--防御
		},
	},
	
	--步兵--
	{
		name="gru",
		hasshield=true,
		zg_name=zg_ischs("精锐骷髅步兵","Skel Grunt"),
		runspeed=4,		--速度
		health=560,		--血量
		attackperiod=2,		--攻击间隔
		zg_chase_time=15,	--追杀时间
		brain=require("brains/br_skel"),
		loot={
			{'zg_it_livingbone',      0.2},
			{'z_cutaxe',        0.5},
			{'z_ar_bone2',        .125},
		},
		weaponlist={
			--砍斧
			{damage=80,uses=nil,attackrange=.5,hitrange=.5,projectile=nil,build="z_cutaxe_s",bank="z_cutaxe_s",tag={"sharp",}},
		},
		armorlist={
			{condition=1000,absorb=.85,build="z_ar_bone",tag=nil},	--鬼木甲
		},
	},
	
	--弓箭手--
	{
		name="arc",
		zg_name=zg_ischs("精锐骷髅弓箭手","Skel Archery"),
		runspeed=7,		--速度
		health=540,		--血量
		attackperiod=2,		--攻击间隔
		zg_chase_time=15,	--追杀时间
		--brain=require("brains/br_skel"),
		loot={
			{'zg_it_livingbone',      0.2},
			{'zg_it_livingbone',      0.25},
			{'z_bonebow',        0.5},
			{'z_ar_bone',        .2},
		},
		weaponlist={
			--白骨弓
			{damage=50,uses=nil,attackrange=10,hitrange=14,projectile="zg_proj_bonebow",build="z_bonebow_s",bank="z_bonebow_s",tag={"zg_bow",}},
		},
		armorlist={
			{condition=450,absorb=.8,build="z_ar_bone",tag=nil},	--鬼木甲
		},
	},
	
	--突击兵
	{
		name="ass",
		hasshield=true,
		zg_name=zg_ischs("精锐骷髅突击兵","Skel Assault"),
		runspeed=4,		--速度
		health=1100,		--血量
		attackperiod=1.75,		--攻击间隔
		zg_chase_time=15,	--追杀时间
		hasskill=true,	--有技能
		jump_outstate="z_s_ass",
		brain=require("brains/br_skel"),
		loot={
			{'zg_it_livingbone',      0.5},
			{'z_cutaxe',        0.5},
			{'z_ar_bone2',        .25},
		},
		weaponlist={
			--突击技能
			{damage=80*1.25*2,uses=1,attackrange=12,hitrange=.5,projectile=nil,build="z_cutaxe_s",bank="z_cutaxe_s",tag={"z_s_ass",},
				onattack=function (weapon, attacker, target)
					if target and attacker then
						zg_spawn(target,"zg_fx_impact",nil,nil,2)
						weapon.SoundEmitter:PlaySound("zg_melee/skill/assult_hit")
						--击退
						local dist=3
						local theta=tw_anglediff(target,attacker)
						if tw_iscontinuous(target, dist, theta) then
							target.Transform:SetPosition( tw_getforwardpos(target, dist, theta):Get() )
						end
						
					end
				end,
			},
			--砍斧	
			{damage=80*1.25,uses=7,attackrange=.5,hitrange=.5,projectile=nil,build="z_cutaxe_s",bank="z_cutaxe_s",tag={"sharp","zg_heavy_axe",},
				
			},
		},
		hatlist={
			{condition=450,absorb=.8,build="hat_football",tag={"hat"}},	
		},
		armorlist={
			{condition=1500,absorb=.9,build="z_ar_bone2",tag=nil},	--骨木甲
		},
	},
	
	--守卫
	{
		name="gua",
		hasshield=true,
		zg_name=zg_ischs("精锐骷髅守卫","Skel Guard"),
		runspeed=4,		--速度
		health=1320,		--血量
		attackperiod=1.75,		--攻击间隔
		zg_chase_time=15,	--追杀时间
		hasskill=true,	--有技能
		jump_outstate="z_s_ass",
		brain=require("brains/br_skel"),
		loot={
			{'zg_it_livingbone',      0.5},
			{'z_cutaxe',        1},
			{'z_arh_bone',        .25},
			{'z_ar_bone2',        .25},
		},
		weaponlist={
			--突击技能
			{damage=80*1.5*2,uses=1,attackrange=12,hitrange=.5,projectile=nil,build="z_cutaxe_s",bank="z_cutaxe_s",tag={"z_s_ass",},
				onattack=function (weapon, attacker, target)
					if target and attacker then
						zg_spawn(target,"zg_fx_impact",nil,nil,2)
						weapon.SoundEmitter:PlaySound("zg_melee/skill/assult_hit")
						--击退
						local dist=3
						local theta=tw_anglediff(target,attacker)
						if tw_iscontinuous(target, dist, theta) then
							target.Transform:SetPosition( tw_getforwardpos(target, dist, theta):Get() )
						end
						--击昏
						zg_spawn(target,"zg_fx_dizzy",{0,-150,0},"headbase",1.125)
					end
				end,
			},
			--砍斧 附带击退
			{damage=80*1.5,uses=7,attackrange=.5,hitrange=.5,projectile=nil,build="z_cutaxe_s",bank="z_cutaxe_s",tag={"sharp","zg_heavy_axe",},
				onattack=function (weapon, attacker, target)
					if target and attacker then
						zg_spawn(target,"zg_fx_impact",nil,nil,2)
						weapon.SoundEmitter:PlaySound("zg_melee/skill/assult_hit")
						--击退
						local dist=3
						local theta=tw_anglediff(target,attacker)
						if tw_iscontinuous(target, dist, theta) then
							target.Transform:SetPosition( tw_getforwardpos(target, dist, theta):Get() )
						end
						--击昏
						zg_spawn(target,"zg_fx_dizzy",{0,-150,0},"headbase",1.125)
					end
				end,
			},
		},
		hatlist={
			{condition=750,absorb=.85,build="z_arh_bone",tag={"hat"}},	--鬼盔		
		},
		armorlist={
			{condition=1500,absorb=.9,build="z_ar_bone2",tag=nil},	--骨木甲
		},
	},
	
	--战士
	{
		name="sol",
		hasshield=true,
		zg_name=zg_ischs("精锐骷髅战士","Skel Soldier"),
		runspeed=4,		--速度
		health=800,		--血量
		attackperiod=1.75,		--攻击间隔
		zg_chase_time=15,	--追杀时间
		--hasskill=true,	--有技能
		hasreiki=true,	--有灵气
		reiki=function() 
			return "zg_reiki_liliang"
			--[[
			local ran=math.random()
			if ran<.33 then
				return "zg_reiki_liliang"
			elseif ran<.67 then
				return "zg_reiki_cizhen"
			else
				return "zg_reiki_kuangre"
			end]]
		end,
		--jump_outstate="z_s_ass",
		brain=require("brains/br_skel"),
		loot={
			{'zg_it_livingbone',      1},
			{'z_bonesword',        1},
			{'armor_marble',      .5},
		},
		weaponlist={		
			--骨剑
			{damage=90*1.25,uses=nil,attackrange=.5,hitrange=.5,projectile=nil,build="z_bonesword_s",bank="z_bonesword_s",tag={"sharp",},
			
			},
		},
		armorlist={
			{condition=1050,absorb=.95,build="armor_marble",tag=nil},	--大理石护甲
		},
		zg_ondeathfn=function(inst)
			if inst.rei then
				--inst.rei:Remove()
				zg_remove(inst.rei)
				inst.rei=nil
			end
		end,
	},
}

for k,v in pairs(manshape_defs) do
	SetSharedLootTable(prefix..v.name, v.loot or {})
end

local function EquipWeapon(inst,slot)
	local weapon=inst.def.weaponlist
	if type(weapon)=="table" then
		local ws = weapon[slot]
		if type(ws)=="table" then
			zg_virtual_weapon(inst,ws.damage,ws.uses,ws.attackrange,ws.hitrange,ws.projectile,ws.build,ws.bank,ws.tag,slot,ws.onattack,ws.stimuli)
		end
	end
end
local function EquipHat(inst,slot)
	local hat=inst.def.hatlist
	if type(hat)=="table" then
		local ws = hat[slot]
		if type(ws)=="table" then
			zg_virtual_hat(inst,ws.condition,ws.absorb,ws.build,ws.open,ws.tag,slot)
		end
	end
end
local function EquipArmor(inst,slot)
	local hat=inst.def.armorlist
	if type(hat)=="table" then
		local ws = hat[slot]
		if type(ws)=="table" then
			zg_virtual_armor(inst,ws.condition,ws.absorb,ws.build,ws.tag,slot)
		end
	end
end

local function EquipRandomArmor(inst)
	local hat=inst.def.armorlist
	if type(hat)=="table" then
		local slot=math.random(#hat)
		local ws = hat[slot]
		if type(ws)=="table" then
			zg_virtual_armor(inst,ws.condition,ws.absorb,ws.build,ws.tag,slot)
		end
	end
end

local function EquipRandomWeapon(inst)
	local current=inst.zg_weapon_slot
	local weapon=inst.def.weaponlist
	if type(weapon)=="table" then
		if #weapon<=1 then
			EquipWeapon(inst,current)
		else
			local ran=math.random(#weapon)
			if ran==current then
				EquipWeapon(inst,zg_loop_next(weapon,ran))
			else
				EquipWeapon(inst,ran)
			end
		end
	end
end

local function MakeManshape(def)
 
    local function fn()
        local inst = CreateEntity()

        inst.entity:AddTransform()
		
		local s=def.scale or 1
		inst.Transform:SetScale(s,s,s)
		inst.Transform:SetFourFaced()
		
        inst.entity:AddAnimState()
		inst.AnimState:Hide("ARM_carry")
        inst.AnimState:Hide("HAT")
        inst.AnimState:Hide("HAT_HAIR")
        inst.AnimState:Show("HAIR_NOHAT")
        inst.AnimState:Show("HAIR")
        inst.AnimState:Show("HEAD")
        inst.AnimState:Hide("HEAD_HAT")
		
        inst.entity:AddSoundEmitter()
		
		inst.entity:AddDynamicShadow()
		inst.DynamicShadow:SetSize(1.3, .6)
	
        inst.entity:AddNetwork()

        MakeCharacterPhysics(inst,def.mass or 75,def.radius or .5)

        inst.AnimState:SetBank("wilson")
        inst.AnimState:SetBuild("wilton")
        inst.AnimState:PlayAnimation("idle")
		
		if def.hasshield then
			inst.AnimState:OverrideSymbol("zg_swap_shield", math.random()<.5 and "zg_shield_wood" or"zg_shield_armored", "swap_hat")
		end
		
		inst:AddTag("healthinfo")
		inst:AddTag("hostile")
		
		inst:AddTag("scarytoprey")
		inst:AddTag("shadowboss")
		
		inst:AddTag("zg_manshape")
		inst:AddTag("zg_skel")
		inst:AddTag("monster")
		inst:AddTag("shadowboss")

        inst.entity:SetPristine()

        if not TheWorld.ismastersim then
            return inst
        end
		
		--引用
		inst.def=def
		--inst.num_attack_to_swap=def.num_attack_to_swap or 15
		--inst.num_attack=0
		inst.hasshield=def.hasshield
		
		if def.hasskill then
			inst.num_attack_to_swap=def.num_attack_to_swap or 15
			inst.num_attack=0
		end
		
		if def.hasreiki then
			inst:DoTaskInTime(0,function() 
				local rei=zg_spawn(inst,def.reiki(),nil,1,1,nil,{"zg_melee/reiki/liliang",0}) 
				inst.rei=rei
				rei.master=inst
			end)
		end
		
		inst.jump_outstate=def.jump_outstate
		
		inst.zg_isskel=true
		
		inst.zg_isrobot=def.zg_isrobot or nil
		
		--检测
		inst:AddComponent("inspectable")
		inst.components.inspectable:SetDescription(def.str or zg_ischs("人形兵器","Human Weapon"))
		--inst.name=def.zg_name or zg_ischs("人形兵器","Human Weapon")
		
		--基础属性
		inst:AddComponent("talker")
		inst:AddComponent("health")
		inst.components.health:SetMaxHealth( (def.health or 150)*5 )
		inst.components.health:SetAbsorptionAmount(.25 or 0)
		inst:AddComponent("locomotor")
		inst.components.locomotor:zg_setspeed(def.runspeed or 6,def.walkspeed or 4)
		--inst:AddComponent("leader")
		
		inst:AddComponent("follower")
		
		--战斗属性
		inst:AddComponent("combat")
		inst.components.combat:SetDefaultDamage(def.damage or 10)
		inst.components.combat:SetRange(def.attackrange or 2)
		inst.components.combat:SetAttackPeriod(def.attackperiod or 2)
		inst.components.combat:SetRetargetFunction(def.retargetperiod or 1,def.retargetfn or function(inst)
			return FindEntity(inst,def.retargetdist or 30,
				function(guy)
					return inst.components.combat:CanTarget(guy) and (zg_isenemy(guy,inst,{"zg_manshape"}) or guy:HasTag("player"))
				end,
				nil,
				{"zg_manshape", "playerghost",}
			)
		end)
		inst.components.combat:SetKeepTargetFunction(def.keeptargetfn or function (inst, target)
			return inst.components.combat:CanTarget(target) and inst:IsNear(target,def.keeptargetdist or 40)
		end)
		inst:ListenForEvent("attacked",def.attackedfn or function(inst,data)
			local invader = nil
			invader = FindEntity(inst, inst.components.combat.attackrange+1, function(guy)
				return guy:HasTag("player") and not guy:HasTag("zg_manshape")
			end)
			if invader then
				inst.components.combat:SetTarget(invader)
			else
				inst.components.combat:SetTarget(data.attacker)
			end
		end)
		
		--[[
		--远程减益
		local old_GetAttacked=inst.components.combat.GetAttacked
		function inst.components.combat:GetAttacked(attacker, damage, weapon, stimuli)
			local dmg=damage or 0
			if attacker then 
				local pos=attacker:GetPosition()
				if pos then
					local dist=inst:GetPosition():Dist(pos)
					if dist>3.5 then
						--计算减益因子
						local per=3.5/dist
						dmg=dmg*per
					end
				end
			end
			return old_GetAttacked(self, attacker, dmg, weapon, stimuli)
		end]]
		
		--物品栏 + 武器切换
		inst:AddComponent("inventory")
		inst.EquipWeapon=EquipWeapon	--定义 装备武器
		inst.EquipRandomWeapon=EquipRandomWeapon	--定义 装备随机下一个武器
		inst.EquipHat=EquipHat	--定义 戴帽子
		inst.EquipArmor=EquipArmor	--定义 穿护甲
		inst.EquipRandomArmor=EquipRandomArmor	--定义 穿随机护甲
		EquipWeapon(inst,1)	
		EquipHat(inst,1)
		--EquipArmor(inst,1)
		EquipRandomArmor(inst)
		
		--抗火
		inst:AddComponent("burnable")
		inst.components.burnable:SetFXLevel(2)
		inst.components.burnable.canlight = false
		inst.components.burnable:SetBurnTime(def.burnable_burntime or 3)
		inst.components.burnable:AddBurnFX("character_fire", Vector3(0, 0, 1), "torso")
		MakeSmallPropagator(inst)
		inst.components.propagator.acceptsheat = false
		inst.components.health.fire_damage_scale = def.fire_damage_scale or .75
		
		--抗冰
		inst:AddComponent("freezable")
		inst.components.freezable:SetShatterFXLevel(3)
		inst.components.freezable:SetResistance(def.freezable_resistance or 2)
		inst.components.freezable:SetDefaultWearOffTime(def.freezable_wearofftime or 3)
		inst.components.freezable:AddShatterFX("shatter", Vector3(0, 0, 0), "torso")
		
		--抗电
		inst:AddComponent("playerlightningtarget")
		inst.components.playerlightningtarget:SetHitChance(def.lightning_hitchance or .3)
		inst.components.playerlightningtarget:SetOnStrikeFn(function(inst)
			if zg_isalive(inst) then
				if not inst.components.inventory:IsInsulated() then
					local mult = TUNING.ELECTRIC_WET_DAMAGE_MULT * ( inst:GetIsWet() and 1 or 0)
					local damage = TUNING.LIGHTNING_DAMAGE + mult * TUNING.LIGHTNING_DAMAGE
					inst.components.health:DoDelta(-damage, false, "lightning")
					--inst.sg:GoToState("electrocute")
				else
					inst:PushEvent("lightningdamageavoided")
				end
			end
		end)
		if def.electricdamageimmune then 
			inst:AddTag("electricdamageimmune") 
			inst.components.playerlightningtarget:SetOnStrikeFn(function(inst)
				if zg_isalive(inst) then
					if inst.components.inventory:IsInsulated() then
						inst:PushEvent("lightningdamageavoided")
					else
						inst.components.health:DoDelta(100, false, "lightning")
					end
				end
			end)
		end
		
		--掉落物
		inst:AddComponent("lootdropper")
		inst.components.lootdropper:SetChanceLootTable(prefix..def.name)
		
		--SG
		--inst.zg_atksound=def.zg_atksound or "dontstarve/tentacle/tentacle_attack"
		inst.zg_hurtsound=def.zg_hurtsound or "zg_skel/skel/hit"
		inst.zg_deathsound=def.zg_deathsound or "zg_skel/skel/die"
		inst.zg_ondeathfn=def.zg_ondeathfn and def.zg_ondeathfn(inst) or function() end
		inst:SetStateGraph(def.sg or "sg_manshape")
		
		--Behaviour
		inst.zg_chaseandattack_period=def.zg_chaseandattack_period or .1
		inst.zg_runaway_period=def.zg_runaway_period or .1
		
		--AI
		inst.zg_ai_period=def.zg_ai_period or .1	--AI刷新时间
		inst.zg_chase_time=def.zg_chase_time or 30	--追杀时间
		inst.zg_see_dist=def.zg_see_dist or 8	--逃跑检测hunter的距离
		
		inst.zg_startrunaway_dist=def.zg_startrunaway_dist or 2		--开始躲避敌人预留的距离
		inst.zg_stoprunaway_dist=def.zg_stoprunaway_dist or 3	--躲避敌人攻击距离 预留的安全距离
		
		inst.target_exdist=def.target_exdist or 1	--玩家要是武器距离超过1,不再走位
		inst.zg_findfood_dist=def.zg_findfood_dist or 10	--寻找食物的距离
		
		local brain=require "brains/br_manshape"
		inst:SetBrain(def.brain or brain)
		
		--inst.zg_runaway_dist=def.zg_runaway_dist or zg_startdogedist(inst,3)
		--inst.zg_stoprunaway_dist=def.zg_stoprunaway_dist or zg_stopdogedist(inst,6)
		
		inst:ListenForEvent("newcombattarget",function(inst,data)
			inst.SoundEmitter:PlaySound("zg_skel/skel/call")
		end)

        return inst
    end

    return Prefab(prefix..def.name, fn, assets)
end

--返回prefabs
local manshapes = {}
for i, v in ipairs(manshape_defs) do
    table.insert(manshapes, MakeManshape(v))
	STRINGS.NAMES[string.upper(prefix..v.name)]=v.zg_name
end
manshape_defs = nil
return unpack(manshapes)