local assets=
{	
	Asset("ANIM", "anim/zg_mo_skel.zip"),
	Asset("ANIM", "anim/zg_swap_bow.zip"),
	Asset( "ANIM", "anim/zg_bow_attack.zip" ),
	Asset("ANIM", "anim/blow_dart.zip"),
}

SetSharedLootTable('zg_mo_skelarcher',
{
	{'zg_it_livingbone',      0.25},
	{'zg_weapon_mace',        0.10},
	{'zg_weapon_shortsword',		0.07},
	{'zg_weapon_longsword',		0.05},
})

----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 20, function(guy)
        return guy:HasTag("character") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
    return invader
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end

local function OnAttacked(inst, data)
    ----	群体反攻玩家
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) and not attacker:HasTag("shadowboss") then
			inst.components.combat:SetTarget(attacker)
			----	小伙伴何在
			inst.components.combat:ShareTarget(attacker, 100, function(dude)
				return dude and dude:HasTag("zg_skel")
			end, 20)
		end
	end
end
---------------------------------------
----	武器样式
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "zg_swap_bow", "swap_bow")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end
local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

----	武器栏
local function GetInventory(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(60 * TUNING.ZG_DIFFICULTY)
		meleeweapon.components.weapon:SetRange(9, 11)
		meleeweapon.components.weapon:SetProjectile("zg_fx_arrow")
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
			----	武器外观
			meleeweapon.components.equippable:SetOnEquip(onequip)
			meleeweapon.components.equippable:SetOnUnequip(onunequip)
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end
---------------------------------------
local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
    inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("wilton")
	inst.AnimState:PlayAnimation("idle")
	
    inst.entity:AddSoundEmitter()
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.CHARACTERS)
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.OBSTACLES)
    phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	
    inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize(1.5, .75)
	
    inst.entity:AddNetwork()
   
	inst:AddTag("healthinfo")
	inst:AddTag("zg_skel")
	inst:AddTag("monster")
	inst:AddTag("scarytoprey")
	inst:AddTag("shadowboss")
	
	--inst.AnimState:OverrideSymbol("swap_object", "swap_zg_weapon_mace", "swap_zg_weapon_mace")
    --inst.AnimState:Show("ARM_carry")
    --inst.AnimState:Hide("ARM_normal")
	inst.AnimState:OverrideSymbol("swap_hat", "hat_wathgrithr", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(69 * TUNING.ZG_DIFFICULTY)
	inst.components.combat:SetRange(2)
    inst.components.combat:SetAttackPeriod(4 - TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
    inst.components.combat:SetRetargetFunction(3, RetargetFn)

    inst:AddComponent("locomotor") 
    inst.components.locomotor.runspeed = 5 
    inst.components.locomotor.walkspeed = 5 
	inst.components.locomotor.fasteronroad = false
	inst.components.locomotor:SetTriggersCreep(true)

    ------------------------------------------

    ------------------------------------------
    inst:AddComponent("follower")
	
	inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('zg_mo_skelarcher')
   
    inst:AddComponent("health")
    
	inst.components.health:SetMaxHealth(574)
	inst["zg_inh_anti_bone"] = .75
	inst["zg_inh_anti_physics"] = .5
	inst.components.health.destroytime = .25			--瞬间死亡,表现为骨头炸裂
    ------------------------------------------

    inst:AddComponent("inventory")
    inst:AddComponent("knownlocations")
    --inst:AddComponent("talker")
	
	----	武器
	GetInventory(inst)
	
	MakeHugeFreezableCharacter(inst, "torso")
	
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("Skeleton man!!!")
	
	inst:ListenForEvent("attacked", OnAttacked)
	
	local brain = require "brains/zg_mo_skelarcherbrain"			
    inst:SetBrain(brain)
    inst:SetStateGraph("SGzg_mo_skel")
	
	inst:DoTaskInTime(3, function()
		inst.SoundEmitter:PlaySound("dontstarve/zg/mo_skel/call")
	end)
	
    return inst
end

STRINGS.NAMES.ZG_MO_SKELARCHER = "骷髅弓箭手"
return Prefab("zg_mo_skelarcher", fn, assets)