local assets =
{
    
}

-----------------------------------------------------------------------
----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 10 + 15 * TUNING.ZG_DIFFICULTY, function(guy)
        return guy:HasTag("player") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
	----	敌视语句
	if invader then
		local sayrandom = math.random()
		if sayrandom < .05 then
			--inst.SoundEmitter:PlaySound("dontstarve/zg/wicker/call2")
			inst.components.talker:Say("Shoot!")
		elseif sayrandom < .1 then
			--inst.SoundEmitter:PlaySound("dontstarve/zg/wicker/call2")
			inst.components.talker:Say("Die!")
		end
	end
    return invader
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end

-----------------------------------------

----	武器栏
local function GetInventory(inst)
    if inst.components.inventory ~= nil and not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local meleeweapon = CreateEntity()
        meleeweapon.entity:AddTransform()
        meleeweapon:AddComponent("weapon")
        meleeweapon.components.weapon:SetDamage(12 * TUNING.ZG_DIFFICULTY)
		meleeweapon.components.weapon:SetRange(9, 11)
		meleeweapon.components.weapon:SetProjectile("spider_web_spit")
        meleeweapon:AddComponent("inventoryitem")
        meleeweapon.persists = false
        meleeweapon.components.inventoryitem:SetOnDroppedFn(inst.Remove)
        meleeweapon:AddComponent("equippable")
			
        meleeweapon:AddTag("meleeweapon")
		inst.components.inventory:Equip(meleeweapon)
    end
end
------------------------------------------------------------------------

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	
    inst.entity:AddAnimState()
	inst.AnimState:SetBank("spider_spitter")
	inst.AnimState:SetBuild("DS_spider2_caves")
    --inst.AnimState:Hide("hat")
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:SetMultColour(0,0,0,.5)
	--inst.AnimState:SetAddColour(.75, .75, 1, 0)
	
    inst.entity:AddSoundEmitter()
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.CHARACTERS)
	
    inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize(1.5, .75)
	
    inst.entity:AddNetwork()
   
	inst:AddTag("healthinfo")
    inst:AddTag("shadowboss")
	inst:AddTag("notraptrigger")
	inst:AddTag("shadowcreature")
	inst:AddTag("scarytoprey")
	inst:AddTag("hostile")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("locomotor") 
    inst.components.locomotor.runspeed = 10 
    inst.components.locomotor.walkspeed = 8 
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(false)

    ------------------------------------------
    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(12 * TUNING.ZG_DIFFICULTY )
    inst.components.combat:SetAttackPeriod(5 - TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
    inst.components.combat:SetRetargetFunction(3, RetargetFn)
	
    ------------------------------------------
    inst:AddComponent("follower")
   
    inst:AddComponent("health")
    --inst.components.health:StartRegen(5, 1)
	inst.components.health:SetMaxHealth(350)
    ------------------------------------------

    inst:AddComponent("inventory")
    inst:AddComponent("knownlocations")
    inst:AddComponent("talker")
	
	----	武器
	GetInventory(inst)
	
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("The assistant of evil spiderman")
	
	local brain = require "brains/zg_mo_bunnybrain"			
    inst:SetBrain(brain)
    inst:SetStateGraph("SGzg_mo_spider")
	
	inst:DoTaskInTime( 60, function()
		inst.components.talker:Say("(Lifetime is over)")
		inst.SoundEmitter:PlaySound("dontstarve/zg/spell/summon02")
		inst.components.health:Kill()
	end)

    return inst
end
----------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------
STRINGS.NAMES.ZG_MO_SPIDER = "暗影蜘蛛" 
return Prefab("zg_mo_spider", fn, assets)