local assets=
{
	Asset("ANIM", "anim/zg_mo_skel.zip"),	
}

SetSharedLootTable('zg_mo_stygiandoll',
{
	{'zg_it_livingbone',      0.25},
})

----	重定位目标
local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 30, function(guy)
        return guy:HasTag("character") and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost")
    end)
    return invader, true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end

local function OnAttacked(inst, data)
    ----	群体反攻玩家
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) and not attacker:HasTag("shadowboss") then
			inst.components.combat:SetTarget(attacker)
			----	小伙伴何在
			inst.components.combat:ShareTarget(attacker, 100, function(dude)
				return dude and dude:HasTag("zg_skel")
			end, 20)
		end
	end
end

---------------------------------------
local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	inst.Transform:SetScale(.5,.5,.5)
	
    inst.entity:AddAnimState()
	inst.AnimState:SetBank("wilson")
	inst.AnimState:SetBuild("wilton")
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:SetMultColour(200/255,255/255,200/255,1)
	
    inst.entity:AddSoundEmitter()
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(10)
    phys:SetCapsule(.25, .5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.CHARACTERS)
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.OBSTACLES)
    phys:CollidesWith(COLLISION.SMALLOBSTACLES)
	
    inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize(1.5, .75)
	
    inst.entity:AddNetwork()
   
	inst:AddTag("healthinfo")
    inst:AddTag("shadowboss")
	inst:AddTag("zg_skel")
	inst:AddTag("monster")
	inst:AddTag("scarytoprey")
	inst:AddTag("shadowboss")
	
	inst.AnimState:OverrideSymbol("swap_object", "swap_spear_wathgrithr", "swap_spear_wathgrithr")
    inst.AnimState:Show("ARM_carry") 
    inst.AnimState:Hide("ARM_normal") 
	
	inst.AnimState:OverrideSymbol("swap_hat", "hat_wathgrithr", "swap_hat")
	inst.AnimState:Show("HAT")
	inst.AnimState:Show("HAT_HAIR")
	inst.AnimState:Hide("HAIR_NOHAT")
	inst.AnimState:Hide("HAIR")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(60 * TUNING.ZG_DIFFICULTY)
	inst.components.combat:SetRange(1)
    inst.components.combat:SetAttackPeriod(3 - TUNING.ZG_DIFFICULTY)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
    inst.components.combat:SetRetargetFunction(3, RetargetFn)

    inst:AddComponent("locomotor") 
    inst.components.locomotor.runspeed = 14 
    inst.components.locomotor.walkspeed = 14 
	inst.components.locomotor.fasteronroad = true
	inst.components.locomotor:SetTriggersCreep(false)

    ------------------------------------------

    ------------------------------------------
    inst:AddComponent("follower")
	
	inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('zg_mo_stygiandoll')
   
    inst:AddComponent("health")
    --inst.components.health:StartRegen(5, 1)
	inst.components.health:SetMaxHealth(773)
	--inst.components.health:SetAbsorptionAmount(.1)
	inst.components.health.destroytime = .25			--瞬间死亡,表现为骨头炸裂
    ------------------------------------------

    inst:AddComponent("inventory")
    inst:AddComponent("knownlocations")
    --inst:AddComponent("talker")
	
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("SSS danger!!!")
	
	MakeHugeFreezableCharacter(inst, "torso")
	
	inst:ListenForEvent("attacked", OnAttacked)
	
	local brain = require "brains/zg_mo_skelbrain"			
    inst:SetBrain(brain)
    inst:SetStateGraph("SGzg_mo_skel")
	
	inst:DoTaskInTime(3, function()
		inst.SoundEmitter:PlaySound("dontstarve/zg/mo_stygiandoll/call")
	end)
	
    return inst
end

STRINGS.NAMES.ZG_MO_STYGIANDOLL = "冥河娃娃"
return Prefab("zg_mo_stygiandoll", fn, assets)