local brain = require "brains/zg_mo_tentacle"

local assets =
{
   
}

SetSharedLootTable( 'zg_mo_tentacle',
{
    {'monstermeat',   1.0},
    {'monstermeat',   1.0},
	{'monstermeat',   1.0},
    {'monstermeat',   1.0},
	
	{'tentaclespots', 1},
	
    {'tentaclespike', 1.0},
	{'tentaclespike', 0.5},
	
	{'armorruins', 0.0005},
	{'krampus_sack', 0.0005},
	{'cane', 0.00025},
	{'gears', 0.00025},
	{'walrushat', 0.00025},
	
})

local function retargetfn(inst)
	local invader = nil
    invader = FindEntity(inst, 2 + 6 * 1, function(guy)
        return guy and not guy:HasTag("playerghost") and not guy:HasTag("tentacle") and
			(
				guy:HasTag("character") or guy:HasTag("animal")
			)
    end)
	return invader, true
end

local function shouldKeepTarget(inst, target)
	return inst.components.combat:CanTarget(target)
end

local function OnAttacked(inst, data)
	
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) and not attacker:HasTag("shadowboss") then
			inst.components.combat:SetTarget(attacker)
		end
	end
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetScale(1.25,1.25,1.25)
    --inst.entity:AddPhysics()
	
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.CHARACTERS)
	phys:CollidesWith(COLLISION.WORLD)
	
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    --inst.Physics:SetCylinder(0.25, 2)

    inst.AnimState:SetBank("tentacle")
    inst.AnimState:SetBuild("tentacle")
    inst.AnimState:PlayAnimation("idle")
	
	inst:AddTag("healthinfo")
    inst:AddTag("monster")    
    inst:AddTag("hostile")
	inst:AddTag("tentacle")
	inst:AddTag("shadowboss")
	--inst:AddTag("shadowcreature")
    --inst:AddTag("wet")
    --inst:AddTag("WORM_DANGER")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(750)
	--inst.components.health:StartRegen(1,2)

    inst:AddComponent("combat")
    inst.components.combat:SetRange(3.5)
    inst.components.combat:SetDefaultDamage(30)
    inst.components.combat:SetAttackPeriod(2)
    inst.components.combat:SetRetargetFunction(3, retargetfn)
    inst.components.combat:SetKeepTargetFunction(shouldKeepTarget)

    --MakeLargeFreezableCharacter(inst)

    inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = -TUNING.SANITYAURA_MED * 3

    inst:AddComponent("inspectable")
    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('zg_mo_tentacle')

	inst:AddComponent("locomotor") -- locomotor must be constructed before the stategraph
    inst.components.locomotor.walkspeed = 3
    inst.components.locomotor.runspeed = 3
    inst:SetStateGraph("SGzg_mo_tentacle")
	
	inst:SetBrain(brain)

    inst:ListenForEvent("attacked", OnAttacked)
	
	----变异变回去
	--[[
	inst:AddComponent("zg_creature_variation")
	inst.components.zg_creature_variation:SetVariationTime(30 * 3)
	inst.components.zg_creature_variation:StartVariation()
	inst.components.zg_creature_variation.onvariationreplacement = "tentacle"
	inst.components.zg_creature_variation.chance = .1
]]
    return inst
end

STRINGS.NAMES.ZG_MO_TENTACLE = "变异触手"
return Prefab("zg_mo_tentacle", fn, assets)