local assets =
{   
	Asset("ANIM", "anim/zg_mo_wolf_build.zip"),
	Asset("ANIM", "anim/zg_mo_snowwolf_build.zip"),
	Asset("ANIM", "anim/zg_mo_blackwolf_build.zip"),
}

local brain = require("brains/zg_mo_wolfbrain")

SetSharedLootTable('zg_mo_wolf',
{
    {'monstermeat',             1},  
    {'houndstooth',             .25},
})
SetSharedLootTable('zg_mo_snowwolf',
{
    {'monstermeat',             1},  
    {'houndstooth',             1},
	{'houndstooth',             1},
})
SetSharedLootTable('zg_mo_blackwolf',
{
    {'monstermeat',             1.00},  
	{'monstermeat',             1.00},
    {'houndstooth',             1.00},
})


local function RetargetFn(inst)
    local invader = nil
    invader = FindEntity(inst, 5 + 15 * 1, function(guy)
        return guy and not guy:HasTag("shadowboss") and not guy:HasTag("playerghost") and not guy:HasTag("hound") and not guy:HasTag("houndfriend") and
			(
				guy:HasTag("player")
			)
    end)
	if invader then
		if math.random() < .1 then
			inst.SoundEmitter:PlaySound("dontstarve/zg/mo_wolf/call")
		end
	end
    return invader, true
end
local function KeepTargetFn(inst, target)
    return inst.components.combat:CanTarget(target)     
end

local function OnAttacked(inst, data)
    ----	群体反攻玩家
    local attacker = data and data.attacker
	if attacker then
		if inst.components.combat:CanTarget(attacker) then
			inst.components.combat:SetTarget(attacker)
			----	小伙伴何在
			inst.components.combat:ShareTarget(attacker, 30, function(dude)
				return dude and (dude:HasTag("hound") or dude:HasTag("houndfriend")	)
			end, 20)
		end
	end
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddDynamicShadow()
    inst.entity:AddNetwork()

    inst.DynamicShadow:SetSize(1.25, .75)

    local s = .4
    inst.Transform:SetScale(s, s, s)
    inst.Transform:SetSixFaced()

    --MakeCharacterPhysics(inst, 100, .5)
	local phys = inst.entity:AddPhysics()
	phys:SetMass(100)
    phys:SetCapsule(.5, 1.5)
    phys:SetFriction(0)
    phys:SetDamping(5)
    phys:SetCollisionGroup(COLLISION.CHARACTERS)
    phys:ClearCollisionMask()
	phys:CollidesWith(COLLISION.GROUND)
	phys:CollidesWith(COLLISION.OBSTACLES)
	phys:CollidesWith(COLLISION.CHARACTERS)
    phys:CollidesWith(COLLISION.SMALLOBSTACLES)

	inst:AddTag("healthinfo")
    inst:AddTag("monster")
    inst:AddTag("warg")
    inst:AddTag("scarytoprey")
    inst:AddTag("houndfriend")
	inst:AddTag("shadowboss")
    --inst:AddTag("largecreature")

    inst.AnimState:SetBank("warg")
    inst.AnimState:SetBuild("zg_mo_wolf_build")
    inst.AnimState:PlayAnimation("idle_loop", true)
	--inst.AnimState:SetMultColour(10,10,10,1)

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

	inst:AddComponent("follower")
	inst:AddComponent("eater")
	inst.components.eater:SetDiet({ FOODTYPE.MEAT }, { FOODTYPE.MEAT })
    inst.components.eater:SetCanEatHorrible()

    inst.components.eater.strongstomach = true -- can eat monster meat!
	
    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("狼!!!")

    inst:AddComponent("locomotor")
    inst.components.locomotor.runspeed = 15
    inst.components.locomotor:SetShouldRun(true)

    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(30 * 1)
    inst.components.combat:SetRange(2.5)
    inst.components.combat:SetAttackPeriod(3 - 1)
    inst.components.combat:SetRetargetFunction(3, RetargetFn)
    inst.components.combat:SetKeepTargetFunction(KeepTargetFn)
	
    inst:ListenForEvent("attacked", OnAttacked)

    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(270)

    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('zg_mo_wolf') 

    --inst:AddComponent("sleeper")

    MakeLargeBurnableCharacter(inst, "swap_fire")

    inst:SetStateGraph("SGzg_mo_wolf")

    inst:SetBrain(brain)

    return inst
end
------------------------------------------------------------------------------------------
----击中别人
local function onattack2(inst, data)
    local other = data.target
    if other and other.components.freezable then
        other.components.freezable:AddColdness(1)
        other.components.freezable:SpawnShatterFX()
		----刺骨的寒冷
		if other.components.temperature then
			other.components.temperature:DoDelta(-20)
		end
    end
end

local function fnsnow()
	local inst = fn()
	inst.Transform:SetScale(.4, .4, .4)
	inst.AnimState:SetBuild("zg_mo_snowwolf_build")
	--inst.AnimState:SetAddColour(.25,.25,.25,0)
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.combat:SetRange(2.5)
	inst.components.combat:SetDefaultDamage(60 * 1)
	inst.components.combat:SetAttackPeriod(3 - 1)
	inst.components.health:SetMaxHealth(510)
	
	----	攻击特效
	inst:ListenForEvent("onhitother", onattack2)
	
	inst.components.lootdropper:SetChanceLootTable('zg_mo_snowwolf')
	
	return inst
end

local function fnblack()
	local inst = fn()
	inst.Transform:SetScale(.45, .45, .45)
	inst.AnimState:SetBuild("zg_mo_blackwolf_build")
	--inst.AnimState:SetMultColour(0,0,0,1)
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.combat:SetRange(2.75)
	inst.components.combat:SetDefaultDamage(60 * 1)
	inst.components.combat:SetAttackPeriod(3 - 1)
	inst.components.health:SetMaxHealth(540)
	
	inst.components.lootdropper:SetChanceLootTable('zg_mo_blackwolf')
	
	return inst
end
-----------------------------------------------------------------------------------------

STRINGS.NAMES.ZG_MO_WOLF = "灰狼"
STRINGS.NAMES.ZG_MO_SNOWWOLF = "雪狼"
STRINGS.NAMES.ZG_MO_BLACKWOLF = "黑狼"
return Prefab("zg_mo_wolf", fn, assets),
	Prefab("zg_mo_snowwolf", fnsnow, assets),
	Prefab("zg_mo_blackwolf", fnblack, assets)
