
local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()
	inst.entity:AddSoundEmitter()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("beehat")
    inst.AnimState:SetBuild("zg_shield_armored")
    inst.AnimState:PlayAnimation("anim")
	
	inst:AddTag("zg_shield")
	
	inst["zg_shield_destill"] = .3
	--inst.net_zg_shield_destill = GLOBAL.net_float(inst.GUID, "zg_shield_destill", "zg_shield_destill_dirty")
	--inst:ListenForEvent("zg_hp_cur_dirty", function()
	--	inst.zg_hp_cur = inst.net_zg_hp_cur:value()
	--end)
	
	inst["zg_shield_block"] = .8		--法向格挡率
	inst["zg_shield_absorb"] = .8		--最大伤害吸收
	inst["zg_shield_absorb2"] = .3		--最小伤害吸收

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddComponent("armor")
	inst.components.armor:InitCondition(1040, 0)		----盾牌不用官方的absorb

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_shield_armored.xml"
	inst.components.inventoryitem.imagename = "zg_shield_armored"

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.ZGHAND2

    inst.components.equippable:SetOnEquip( function (inst, owner) 
		owner.AnimState:OverrideSymbol("zg_swap_shield", "zg_shield_armored", "swap_hat")
	end)
    inst.components.equippable:SetOnUnequip( function (inst, owner) 
		owner.AnimState:ClearOverrideSymbol("zg_swap_shield")
	end)
	
	----选择附魔
	local function Choose_magic(inst, num)
		
		--local collide_table = {}
		
		if type(num) == "table" then
		
			local n = 0		--用于求集合的大于一定数字的成员数量, 不能用#num以及table.getn(num)
			for k, v in pairs(num) do
				--if v and not table.contains(collide_table, v) then
					
				if k <= 7 then
					--加最大吸收
					if k == 1 then
						inst["zg_shield_absorb"] = .8 + .1
						inst["net_zg_shield_absorb"]:set( inst["zg_shield_absorb"] )
					--快速打击恢复
					elseif k == 2 then
						inst["zg_shield_destill"] = .3 + .3
						inst["net_zg_shield_destill"]:set( inst["zg_shield_destill"] )
					--加格挡概率
					elseif k == 3 then
						inst["zg_shield_block"] = .8 + .1
						inst["net_zg_shield_block"]:set( inst["zg_shield_block"] )
					--加火炕
					elseif k == 4 then
						inst["zg_add_anti_fire"] = .25
						inst["net_zg_add_anti_fire"]:set( inst["zg_add_anti_fire"] )
					--加冰抗
					elseif k == 5 then
						inst["zg_add_anti_ice"] = .25
						inst["net_zg_add_anti_ice"]:set( inst["zg_add_anti_ice"] )
					--加电抗
					elseif k == 6 then
						inst["zg_add_anti_electric"] = .25
						inst["net_zg_add_anti_electric"]:set( inst["zg_add_anti_electric"] )
					--加子弹抗性
					elseif k == 7 then
						inst["zg_add_anti_bullet"] = .25
						inst["net_zg_add_anti_bullet"]:set( inst["zg_add_anti_bullet"] )
					end
					
					n = n + 1
					--table.insert(collide_table, v)
					--print(k)
				end
			end
			
			--print(n)
			
			----附魔项数
			if n < 1 then
				--
			elseif n < 4 then
				inst:AddTag("zg_magic_rarething")
			else
				inst:AddTag("zg_magic_debossthing")
			end
			
		end
			
	end
	
	inst.zg_choose_magic = {}
	
	----建造的时候
	inst.OnBuiltFn = function()
	
		----数字只有在制作的时候赋予
		inst.zg_choose_magic0 = {}
		
		for i = 1, math.random(4) do
			table.insert( inst.zg_choose_magic0, math.random(14) )
		end
		
		----table去重
		--inst.zg_choose_magic = {}
		for k, v in pairs(inst.zg_choose_magic0) do
			inst.zg_choose_magic[v] = true
		end
		
		Choose_magic(inst, inst.zg_choose_magic)
	end
	
	inst:DoTaskInTime(.1, function()
		Choose_magic(inst, inst.zg_choose_magic)
	end)
	
	----可修复耐久
	inst:AddComponent("trader")
    inst.components.trader:SetAcceptTest(function(inst, item)
		return item.prefab == "zg_steelmonstermeat"
	end)
    inst.components.trader.onaccept = function(inst, giver, item)
		if item.prefab == "zg_steelmonstermeat" then
			local current = inst.components.armor.condition
			inst.components.armor:SetCondition(current + 100)
		end
	end
    inst.components.trader.onrefuse = function (inst, giver, item)
		if item.prefab ~= "zg_steelmonstermeat" then
			if giver.components.talker then
				giver.components.talker:Say("需要武装色肉恢复盾牌耐久!")
			end
		end
		inst.SoundEmitter:PlaySound("dontstarve/zg/shotgun/cantfill")
	end
	
	inst.OnSave = function(inst, data)
		if data then
			data.zg_choose_magic = inst.zg_choose_magic
		end
	end
	
	inst.OnLoad = function(inst, data)
		inst.zg_choose_magic = data.zg_choose_magic or {}
	end

    return inst
end

STRINGS.NAMES.ZG_SHIELD_ARMORED = "武装盾(武装肉可修复耐久)"
return Prefab("zg_shield_armored", fn)











