
local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("beehat")
    inst.AnimState:SetBuild("zg_shield_lion")
    inst.AnimState:PlayAnimation("anim")
	
	inst:AddTag("zg_shield")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_shield_lion.xml"
	inst.components.inventoryitem.imagename = "zg_shield_lion"

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.ZGHAND2

    inst.components.equippable:SetOnEquip( function (inst, owner) 
		owner.AnimState:OverrideSymbol("zg_swap_shield", "zg_shield_lion", "swap_hat")
	end)
    inst.components.equippable:SetOnUnequip( function (inst, owner) 
		owner.AnimState:ClearOverrideSymbol("zg_swap_shield")
	end)

    return inst
end

STRINGS.NAMES.ZG_SHIELD_LION = "太阳印记盾"
return Prefab("zg_shield_lion", fn)
