
local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("beehat")
    inst.AnimState:SetBuild("zg_shield_wood")
    inst.AnimState:PlayAnimation("anim")
	
	inst:AddTag("zg_shield")
	
	inst["zg_shield_destill"] = .25
	inst["zg_shield_block"] = .75		--法向格挡率
	inst["zg_shield_absorb"] = .75		--最大伤害吸收
	inst["zg_shield_absorb2"] = .25		--最小伤害吸收

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddComponent("armor")
	inst.components.armor:InitCondition(750, 0)		----盾牌不用官方的absorb

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_shield_wood.xml"
	inst.components.inventoryitem.imagename = "zg_shield_wood"

    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.ZGHAND2

    inst.components.equippable:SetOnEquip( function (inst, owner) 
		owner.AnimState:OverrideSymbol("zg_swap_shield", "zg_shield_wood", "swap_hat")
	end)
    inst.components.equippable:SetOnUnequip( function (inst, owner) 
		owner.AnimState:ClearOverrideSymbol("zg_swap_shield")
	end)

    return inst
end

STRINGS.NAMES.ZG_SHIELD_WOOD = "圆盾"
return Prefab("zg_shield_wood", fn)
