local assets =
{
    Asset("ANIM", "anim/silk.zip"),
}

local assets_steel =
{
    --Asset("ANIM", "anim/zg_steelsilk.zip"),
	--Asset("ATLAS", "images/zg_steelsilk.xml"),
}

local function CanUpgrade(inst, target, doer)
    return doer:HasTag("spiderwhisperer")
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("silk")
    inst.AnimState:SetBuild("silk")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("cattoy")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddComponent("inspectable")
    inst:AddComponent("inventoryitem")
    inst:AddComponent("tradable")

    inst:AddComponent("upgrader")
    inst.components.upgrader.canupgradefn = CanUpgrade
    inst.components.upgrader.upgradetype = UPGRADETYPES.SPIDER

    --MakeHauntableLaunch(inst)

    return inst
end

local function fn_steel(inst)
	local inst = fn()
	inst.AnimState:SetBuild("zg_steelsilk")
	
	inst:AddTag("zg_magic_material")
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst.components.inventoryitem.atlasname = "images/zg_steelsilk.xml"
	inst.components.inventoryitem.imagename = "zg_steelsilk"
	
	inst:RemoveComponent("upgrader")
	
	return inst
end


return Prefab("zg_steelsilk", fn_steel, assets)