local function OnGetItemFromPlayer(inst, giver, item)
    local pref=string.sub(inst.prefab,8)
	wy_spawn(inst,pref)
	if giver and giver.SoundEmitter then
		giver.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
	end
	inst:Remove()
end

local function OnRefuseItem(inst, giver, item)
	if giver and giver.components.talker then
		giver.components.talker:Say("做不了")
	end
end

local function AcceptTest(inst, item)
    return item and item.prefab=="q4banshou"
end

local function common()
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
	inst.AnimState:SetAddColour(.75,.25,.25,0)
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()
    --inst:AddTag("structure")
	
    inst.entity:SetPristine()
    if not TheWorld.ismastersim then
        return inst
    end
	inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("需要一个扳手修回来,不然它毁了就没有了")
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
	inst:AddComponent("trader")
	inst.components.trader:SetAcceptTest(AcceptTest)
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader.onrefuse = OnRefuseItem
    return inst
end

local prefix="zg_utf_"
local def=
{
	--锅子
	cookpot={fn=function()
		local inst=common()
		inst.AnimState:SetBank("cook_pot")
		inst.AnimState:SetBuild("cook_pot")
		inst.AnimState:PlayAnimation("idle_empty")
		if not TheWorld.ismastersim then
			return inst
		end
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			local fx = SpawnPrefab("collapse_small")
			fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			fx:SetMaterial("metal")
			inst:Remove()
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
			inst.AnimState:PlayAnimation("hit_empty")
			inst.AnimState:PushAnimation("idle_empty")
		end)
		return inst
	end,str="被占领的 烹饪锅"},
	
	--冰箱
	icebox={fn=function()
		local inst=common()
		inst.AnimState:SetBank("icebox")
		inst.AnimState:SetBuild("ice_box")
		inst.AnimState:PlayAnimation("closed")
		if not TheWorld.ismastersim then
			return inst
		end
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			local fx = SpawnPrefab("collapse_small")
			fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			fx:SetMaterial("metal")
			inst:Remove()
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
			inst.AnimState:PlayAnimation("hit")
			inst.AnimState:PushAnimation("closed",false)
		end)
		return inst
	end,str="被占领的 冰箱"},
	
	--火堆
	firepit={fn=function()
		local inst=common()
		inst.AnimState:SetBank("firepit")
		inst.AnimState:SetBuild("firepit")
		inst.AnimState:PlayAnimation("idle", false)
		if not TheWorld.ismastersim then
			return inst
		end
		--inst.components.inspectable:SetDescription()
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			local x, y, z = inst.Transform:GetWorldPosition()
			SpawnPrefab("ash").Transform:SetPosition(x, y, z)
			local fx = SpawnPrefab("collapse_small")
			fx.Transform:SetPosition(x, y, z)
			fx:SetMaterial("stone")
			inst:Remove()
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
			inst.AnimState:PlayAnimation("hit")
			inst.AnimState:PushAnimation("idle")
		end)
		return inst
	end,str="被占领的 篝火"},
	
	--冷火堆
	coldfirepit={fn=function()
		local inst=common()
		inst.AnimState:SetBank("coldfirepit")
		inst.AnimState:SetBuild("coldfirepit")
		inst.AnimState:PlayAnimation("idle", false)
		if not TheWorld.ismastersim then
			return inst
		end
		--inst.components.inspectable:SetDescription()
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			local x, y, z = inst.Transform:GetWorldPosition()
			SpawnPrefab("ash").Transform:SetPosition(x, y, z)
			local fx = SpawnPrefab("collapse_small")
			fx.Transform:SetPosition(x, y, z)
			fx:SetMaterial("stone")
			inst:Remove()
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
			inst.AnimState:PlayAnimation("hit")
			inst.AnimState:PushAnimation("idle")
		end)
		return inst
	end,str="被占领的 冰焰篝火"},
	
	--灭火器
	firesuppressor={fn=function()
		local inst=common()
		inst.AnimState:SetBank("firefighter")
		inst.AnimState:SetBuild("firefighter")
		inst.AnimState:PlayAnimation("idle_off")
		inst.AnimState:OverrideSymbol("swap_meter", "firefighter_meter", 10)
		if not TheWorld.ismastersim then
			return inst
		end
		--inst.components.inspectable:SetDescription()
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			local fx = SpawnPrefab("collapse_small")
			fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			fx:SetMaterial("metal")
			inst:Remove()
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
			--inst.AnimState:PlayAnimation("idle_off")
		end)
		return inst
	end,str="被占领的 雪球机"},
	
	--一本科技
	researchlab={fn=function()
		local inst=common()
		inst.AnimState:SetBank("researchlab")
		inst.AnimState:SetBuild("researchlab")
		inst.AnimState:PlayAnimation("idle")
		if not TheWorld.ismastersim then
			return inst
		end
		--inst.components.inspectable:SetDescription()
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			local fx = SpawnPrefab("collapse_small")
			fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			fx:SetMaterial("wood")
			inst:Remove()
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
			inst.AnimState:PlayAnimation("hit")
			inst.AnimState:PushAnimation("idle", false)
		end)
		return inst
	end,str="被占领的 科学机器"},
	
	--二本科技
	researchlab2={fn=function()
		local inst=common()
		inst.AnimState:SetBank("researchlab2")
		inst.AnimState:SetBuild("researchlab2")
		inst.AnimState:PlayAnimation("idle")
		if not TheWorld.ismastersim then
			return inst
		end
		--inst.components.inspectable:SetDescription()
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			local fx = SpawnPrefab("collapse_small")
			fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			fx:SetMaterial("wood")
			inst:Remove()
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
			inst.AnimState:PlayAnimation("hit")
			inst.AnimState:PushAnimation("idle", false)
		end)
		return inst
	end,str="被占领的 炼金引擎"},
	
	--一本魔法
	researchlab4={fn=function()
		local inst=common()
		inst.AnimState:SetBank("researchlab4")
		inst.AnimState:SetBuild("researchlab4")
		inst.AnimState:PlayAnimation("idle")
		if not TheWorld.ismastersim then
			return inst
		end
		--inst.components.inspectable:SetDescription()
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			local fx = SpawnPrefab("collapse_small")
			fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			fx:SetMaterial("wood")
			inst:Remove()
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
			inst.AnimState:PlayAnimation("hit")
			inst.AnimState:PushAnimation("idle", false)
		end)
		return inst
	end,str="被占领的 魔法帽子"},
	
	--二本魔法
	researchlab3={fn=function()
		local inst=common()
		inst.AnimState:SetBank("researchlab3")
		inst.AnimState:SetBuild("researchlab3")
		inst.AnimState:PlayAnimation("idle")
		if not TheWorld.ismastersim then
			return inst
		end
		--inst.components.inspectable:SetDescription()
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			local fx = SpawnPrefab("collapse_small")
			fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			fx:SetMaterial("wood")
			inst:Remove()
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
			inst.AnimState:PlayAnimation("hit")
			inst.AnimState:PushAnimation("idle", false)
		end)
		return inst
	end,str="被占领的 三相之力"},
	
	--[[
	--远古科技
	ancient_altar={fn=function()
		local inst=common()
		inst.AnimState:SetBank("crafting_table")
		inst.AnimState:SetBuild("crafting_table")
		inst.AnimState:PlayAnimation("ancient_altar")
		if not TheWorld.ismastersim then
			return inst
		end
		--inst.components.inspectable:SetDescription()
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			local pos = inst:GetPosition()
			TheWorld:PushEvent("ms_sendlightningstrike", pos)
			local fx = SpawnPrefab("collapse_small")
			fx.Transform:SetPosition(pos:Get())
			fx:SetMaterial("stone")
			inst:Remove()
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
		
		end)
		return inst
	end,str="被占领的 远古祭坛"},
	
	--破坏的远古科技
	ancient_altar_broken={fn=function()
		local inst=common()
		inst.AnimState:SetBank("crafting_table")
		inst.AnimState:SetBuild("crafting_table")
		inst.AnimState:PlayAnimation("ancient_altar_broken")
		if not TheWorld.ismastersim then
			return inst
		end
		--inst.components.inspectable:SetDescription()
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			local pos = inst:GetPosition()
			TheWorld:PushEvent("ms_sendlightningstrike", pos)
			local fx = SpawnPrefab("collapse_small")
			fx.Transform:SetPosition(pos:Get())
			fx:SetMaterial("stone")
			inst:Remove()
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
		
		end)
		return inst
	end,str="被占领的 残破的 远古祭坛"},
	]]
	
	--帐篷
	tent={fn=function()
		local inst=common()
		inst.AnimState:SetBank("tent")
		inst.AnimState:SetBuild("tent")
		inst.AnimState:PlayAnimation("idle", true)
		if not TheWorld.ismastersim then
			return inst
		end
		--inst.components.inspectable:SetDescription()
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			inst.AnimState:PlayAnimation("destroy")
			inst:ListenForEvent("animover", inst.Remove)
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
			inst.AnimState:PlayAnimation("hit")
			inst.AnimState:PushAnimation("idle", true)
		end)
		return inst
	end,str="被占领的 帐篷"},
	
	--白天帐篷
	siestahut={fn=function()
		local inst=common()
		inst.AnimState:SetBank("siesta_canopy")
		inst.AnimState:SetBuild("siesta_canopy")
		inst.AnimState:PlayAnimation("idle", true)
		if not TheWorld.ismastersim then
			return inst
		end
		--inst.components.inspectable:SetDescription()
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			inst.AnimState:PlayAnimation("destroy")
			inst:ListenForEvent("animover", inst.Remove)
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
			inst.AnimState:PlayAnimation("hit")
			inst.AnimState:PushAnimation("idle", true)
		end)
		return inst
	end,str="被占领的 帐篷"},
	
	--猪房子
	pighouse={fn=function()
		local inst=common()
		inst.AnimState:SetBank("pig_house")
		inst.AnimState:SetBuild("pig_house")
		inst.AnimState:PlayAnimation("idle", true)
		if not TheWorld.ismastersim then
			return inst
		end
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			local fx = SpawnPrefab("collapse_big")
			fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			fx:SetMaterial("wood")
			inst:Remove()
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
			inst.AnimState:PlayAnimation("hit")
			inst.AnimState:PushAnimation("idle")
		end)
		return inst
	end,str="被占领的 猪猪房"},
	
	--兔房子
	rabbithouse={fn=function()
		local inst=common()
		inst.AnimState:SetBank("rabbithouse")
		inst.AnimState:SetBuild("rabbit_house")
		inst.AnimState:PlayAnimation("idle", true)
		if not TheWorld.ismastersim then
			return inst
		end
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			local fx = SpawnPrefab("collapse_big")
			fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			fx:SetMaterial("wood")
			inst:Remove()
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
			inst.AnimState:PlayAnimation("hit")
			inst.AnimState:PushAnimation("idle")
		end)
		return inst
	end,str="被占领的 兔兔房"},
	
	--鸟笼
	birdcage={fn=function()
		local inst=common()
		inst.AnimState:SetBank("birdcage")
		inst.AnimState:SetBuild("bird_cage")
		inst.AnimState:PlayAnimation("idle_empty")
		if not TheWorld.ismastersim then
			return inst
		end
		inst.components.workable:SetWorkLeft(4)
		inst.components.workable:SetOnFinishCallback(function(inst, worker)
			local fx = SpawnPrefab("collapse_big")
			fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
			fx:SetMaterial("wood")
			inst:Remove()
		end)
		inst.components.workable:SetOnWorkCallback(function(inst, worker)
			
		end)
		return inst
	end,str="被占领的 鸟笼"},
}

local prefabs={}
for k,v in pairs(def) do
	STRINGS.NAMES[string.upper(prefix..k)] = v.str
	table.insert(prefabs, Prefab(prefix..k,v.fn))
end
return unpack(prefabs)



