require "prefabutil"
require "recipes"

local assets =
{
	Asset("ANIM", "anim/zg_ut_icepig_house.zip"),
}

local function onhammered(inst, worker)
	if inst then
		local fx = SpawnPrefab("collapse_big")
		fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
		fx:SetMaterial("wood")
		
		--local pig = SpawnPrefab("zg_cr_icepig0")
		--pig.Transform:SetPosition(inst.Transform:GetWorldPosition())
		
		inst:Remove()
	end
end

local function onhit(inst, worker)
    --if not inst:HasTag("burnt") then 
	--inst.AnimState:PlayAnimation("hit")
	--inst.Light:Enable(false)
	--inst.AnimState:PushAnimation("lit")
	local fx = SpawnPrefab("collapse_big")
    fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
    fx:SetMaterial("wood")
	
	local pig = SpawnPrefab("zg_cr_icepig0")
	pig.Transform:SetPosition(inst.Transform:GetWorldPosition())
	
	inst:Remove()
	
	--if worker and worker:HasTag("player") and worker.components.temperature then
	--	 worker.components.temperature.current = worker.components.temperature.current - 100
	--end
    --end
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddLight()
    inst.entity:AddSoundEmitter()
    --inst.entity:AddMiniMapEntity()
    inst.entity:AddNetwork()
    --inst.entity:AddLightWatcher()

    MakeObstaclePhysics(inst, 1)

    --inst.MiniMapEntity:SetIcon("pighouse.png")
--{anim="level1", sound="dontstarve/common/campfire", radius=2, intensity=.75, falloff=.33, colour = {197/255,197/255,170/255}},
    inst.Light:SetFalloff(1)
    inst.Light:SetIntensity(.5)
    inst.Light:SetRadius(1)
    inst.Light:Enable(true)
    inst.Light:SetColour(50/255, 195/255, 180/255)

    inst.AnimState:SetBank("pig_house")
    inst.AnimState:SetBuild("zg_ut_icepig_house")
    --inst.AnimState:PlayAnimation("idle", true)
	inst.AnimState:PlayAnimation("lit", true)

    inst:AddTag("structure")
	inst:AddTag("zg_ut_icepig_house")

    --MakeSnowCoveredPristine(inst)

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    --inst:AddComponent("lootdropper")
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(40)					--我设定为一碰就碎, 因为服务器端不知出了什么鬼问题
    inst.components.workable:SetOnFinishCallback(onhammered)
    inst.components.workable:SetOnWorkCallback(onhit)

    --inst:AddComponent("spawner")
    --inst.components.spawner:Configure("pigman", TUNING.TOTAL_DAY_TIME*4)
    --inst.components.spawner.onoccupied = onoccupied
    --inst.components.spawner.onvacate = onvacate

    --inst:WatchWorldState("startcaveday", OnStartDay)

    --inst:AddComponent("playerprox")
    --inst.components.playerprox:SetDist(10,13)
    --inst.components.playerprox:SetOnPlayerNear(onnear)
    --inst.components.playerprox:SetOnPlayerFar(onfar)

    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("SSS级危险!!!定期出没冰猪人!!!")
    --inst.components.inspectable.getstatus = getstatus

    --MakeSnowCovered(inst)
	
	----定期刷小冰猪
	inst:AddComponent("spawner")
    inst.components.spawner:Configure("zg_cr_icepig", TUNING.TOTAL_DAY_TIME * 8)
    inst.components.spawner:SetOnlySpawnOffscreen(true)
    --inst.components.spawner:SetOnVacateFn(OnVacate)


    --inst.OnSave = onsave 
    --inst.OnLoad = onload

    --MakeHauntableWork(inst)

    --inst:ListenForEvent("onbuilt", onbuilt)
    --inst:DoTaskInTime(math.random(), spawncheckday)

    return inst
end

STRINGS.NAMES.ZG_UT_ICEPIG_HOUSE = "冰猪人房屋" 
return Prefab("zg_ut_icepig_house", fn, assets)
