local easing = require("easing")

local assets =
{  
	Asset("ANIM", "anim/zg_ut_wormhole.zip"),
}

local function LaunchProjectile(inst)

    local x, y, z = inst.Transform:GetWorldPosition()
	local targetpos = Vector3( x + math.random()* 10 - 20, 0, z + math.random()* 10 - 20)

    local projectile = SpawnPrefab("zg_fx_spider")
    projectile.Transform:SetPosition(x, y, z)

    local dx = targetpos.x - x
    local dz = targetpos.z - z
    local rangesq = dx * dx + dz * dz
    local maxrange = TUNING.FIRE_DETECTOR_RANGE
    local speed = easing.linear(rangesq, 15, 3, maxrange * maxrange)
    projectile.components.complexprojectile:SetHorizontalSpeed(speed)
    projectile.components.complexprojectile:SetGravity(-25)
    projectile.components.complexprojectile:Launch(targetpos, inst, inst)
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    --inst.entity:AddMiniMapEntity()
    inst.entity:AddNetwork()

    inst.entity:AddPhysics() -- no collision, this is just for buffered actions
    inst.Physics:SetSphere(1)
    inst.Physics:ClearCollisionMask()

    --inst.MiniMapEntity:SetIcon("wormhole.png")

    inst.AnimState:SetBank("teleporter_worm")
    inst.AnimState:SetBuild("zg_ut_wormhole")
    inst.AnimState:PlayAnimation("idle_loop", true)
    --inst.AnimState:SetLayer(LAYER_BACKGROUND)
    --inst.AnimState:SetSortOrder(3)

    --trader, alltrader (from trader component) added to pristine state for optimization
    --inst:AddTag("trader")
    --inst:AddTag("alltrader")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:SetStateGraph("SGzg_ut_wormhole")

    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("通往某个实验室")
	
	--inst.LaunchProjectile = LaunchProjectile
	inst.numspider = math.random(3) + 3
	
	----定期刷出虫子
	inst:DoPeriodicTask(60, function()
		if inst then
			----刷怪在状态图里写
			inst.sg:GoToState("opening")
		end
	end)
	
	----存活时间
	inst:DoTaskInTime(200, function()
		SpawnPrefab("statue_transition").Transform:SetPosition(inst.Transform:GetWorldPosition())
		inst:Remove()
	end)
	
	--inst:AddComponent("inspectable")
	--inst.components.inspectable:SetDescription("通往某个实验室")
	
    --inst.components.inspectable.getstatus = GetStatus
    --inst.components.inspectable:RecordViews()

    --inst:AddComponent("playerprox")
    --inst.components.playerprox:SetDist(4, 5)
    --inst.components.playerprox.onnear = onnear
    --inst.components.playerprox.onfar = onfar

    --inst.teleporting = nil

    --inst:AddComponent("teleporter")
    --inst.components.teleporter.onActivate = OnActivate
    --inst.components.teleporter.onActivateByOther = OnActivateByOther
    --inst.components.teleporter.offset = 0
    --inst:ListenForEvent("starttravelsound", StartTravelSound) -- triggered by player stategraph
    --inst:ListenForEvent("doneteleporting", OnDoneTeleporting)

    --inst:AddComponent("inventory")

    --inst:AddComponent("trader")
    --inst.components.trader.acceptnontradable = true
    --inst.components.trader.onaccept = onaccept
    --inst.components.trader.deleteitemonaccept = false


    return inst
end

STRINGS.NAMES.ZG_UT_WORMHOLE = "真正的虫洞"
return Prefab("zg_ut_wormhole", fn, assets)
