local assets =
{
    Asset("ANIM", "anim/zg_weapon_axe.zip"),
	Asset("ANIM", "anim/zg_we_axefly.zip"),
	
    Asset("ANIM", "anim/zg_swap_weapon_axe.zip"),
	
	Asset("ATLAS", "images/zg_weapon_axe.xml"),
	Asset("ATLAS", "images/zg_we_axefly.xml"),
	
}

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "zg_swap_axe", "swap_axe")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("axe")
    inst.AnimState:SetBuild("zg_weapon_axe")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("sharp")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(55)
	
	inst:AddComponent("tool")
    inst.components.tool:SetAction(ACTIONS.CHOP)

    -------

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(100)
    inst.components.finiteuses:SetUses(100)

    inst.components.finiteuses:SetOnFinished(inst.Remove)
	inst.components.finiteuses:SetConsumption(ACTIONS.CHOP, .5)

    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("好斧头")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_weapon_axe.xml"
	inst.components.inventoryitem.imagename = "zg_weapon_axe"

    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    return inst
end
------------------------------------------------------------------------------------

--------------------------------------
local function fn0()
	local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetScale(3,3,3)
	
    inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("zg_we_axefly")
    inst.AnimState:SetBuild("zg_we_axefly")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("sharp")

    inst.entity:SetPristine()
	
	if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("翻滚吧, 小斧头")
	
	inst:AddComponent("weapon")
	inst.components.weapon:SetDamage(100)
	inst.components.weapon:SetRange(10, 12)
	inst.components.weapon:SetProjectile("zg_fx_axe")
	
	inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(10)
    inst.components.finiteuses:SetUses(10)
	inst.components.finiteuses:SetOnFinished(inst.Remove)
	
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_we_axefly.xml"
	inst.components.inventoryitem.imagename = "zg_we_axefly"

    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)
	
	
	return inst
end
----------------------------------------------------------------------------------------
STRINGS.NAMES.ZG_WEAPON_AXE = "手斧(伤害55)"
STRINGS.NAMES.ZG_WEAPON_AXE0 = "飞斧(伤害100)" 
return Prefab("zg_weapon_axe", fn, assets),
	Prefab("zg_weapon_axe0", fn0, assets)