local assets =
{
    Asset("ANIM", "anim/zg_weapon_gaintsword.zip"),
    Asset("ANIM", "anim/swap_zg_weapon_gaintsword.zip"),
	Asset("ATLAS", "images/zg_weapon_gaintsword.xml"),
}

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_zg_weapon_gaintsword", "swap_zg_weapon_gaintsword")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end

----  +50%对不死族的攻击
local function OnAttack(inst, attacker, target)
	if target and target:HasTag("zg_skel") then
		if target.components.health and not target.components.health:IsDead() then
			target.components.combat:Zg_GetAttacked(attacker, 71)
		end
	end	
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("zg_weapon_gaintsword")
    inst.AnimState:SetBuild("zg_weapon_gaintsword")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("sharp")
	inst:AddTag("zg_heavy_weapon")
	
	inst:AddTag("zg_doublehand")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(142)
	inst.components.weapon:SetRange(1)					--攻击距离+1
	inst.components.weapon:SetAttackCallback(OnAttack)

    -------

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(125)
    inst.components.finiteuses:SetUses(125)

    inst.components.finiteuses:SetOnFinished(inst.Remove)

    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("Nice!!!")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_weapon_gaintsword.xml"
	inst.components.inventoryitem.imagename = "zg_weapon_gaintsword"

    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    return inst
end

STRINGS.NAMES.ZG_WEAPON_GAINTSWORD = "骨巨剑(伤害142,+50%对不死族的伤害)" 
return Prefab("zg_weapon_gaintsword", fn, assets)