local assets=
{ 
    Asset("ANIM", "anim/zg_weapon_lightninggun.zip"),
    Asset("ANIM", "anim/zg_weapon_swap_lightninggun.zip"), 
    Asset("ATLAS", "images/zg_weapon_lightninggun.xml"),		
}

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "zg_weapon_swap_lightninggun", "zg_weapon_swap_lightninggun")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

---------------------------------------------------------------
local function fn()

	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter() 
	inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    
    anim:SetBank("zg_weapon_lightninggun")
    anim:SetBuild("zg_weapon_lightninggun")
    anim:PlayAnimation("idle")

	inst:AddTag("zg_weapon_lightninggun")
	
	inst:AddTag("zg_doublehand")

	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
    
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(0)				--不在这里写攻击力
    inst.components.weapon:SetRange(9, 11)
	--inst.components.weapon:SetProjectile("zg_fx_flashgun2_0")
	inst.components.weapon:SetProjectile("zg_fx_arrow_yellow2")
	--inst.components.weapon:SetElectric()
	--inst.components.weapon:SetOnAttack(onattack)
	
	--inst.components.weapon.stimuli = "zg_ele_electric"
	
	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetMaxUses(50)
    inst.components.finiteuses:SetUses(50)
	inst.components.finiteuses:SetOnFinished(inst.Remove)

	inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("这把武器很顺手!")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_weapon_lightninggun.xml"
	inst.components.inventoryitem.imagename = "zg_weapon_lightninggun"
	inst.components.inventoryitem:SetOnDroppedFn( function(inst)
		inst:DoTaskInTime(.25, function()
			inst.SoundEmitter:PlaySound("dontstarve/zg/shotgun/putdown")
		end)
	end)
 
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )	
 
    return inst
end

STRINGS.NAMES.ZG_WEAPON_LIGHTNINGGUN = "闪光枪(电系伤害31-77,射速普通)"
return  Prefab("common/inventory/zg_weapon_lightninggun", fn, assets)