local assets=
{ 
    Asset("ANIM", "anim/zg_weapon_m4.zip"),
    Asset("ANIM", "anim/zg_swap_weapon_m4.zip"), 
    Asset("ATLAS", "images/zg_weapon_m4.xml"),		
}

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "zg_swap_weapon_m4", "zg_swap_weapon_m4")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end
---------------------------------------------------------------
local function OnGetItemFromPlayer(inst, giver, item)
    if item.prefab == inst.zg_gunbullet then
		local current = inst.components.finiteuses.current
		if current <= 70 then 
			--inst.components.finiteuses.current = inst.components.finiteuses.current + 30
			--inst:PushEvent("percentusedchange", {percent = inst.components.finiteuses:GetPercent()})
			inst.components.finiteuses:SetUses(current + 30)
			inst.SoundEmitter:PlaySound("dontstarve/zg/shotgun/fill")
		end
    end
end

local function OnRefuseItem(inst, giver, item)
	if item.prefab == inst.zg_gunbullet then
		giver.components.talker:Say("至少用掉30弹药才可装填!")
	else
		giver.components.talker:Say("不是配套的子弹!")
	end
	inst.SoundEmitter:PlaySound("dontstarve/zg/shotgun/cantfill")
end

local function AcceptTest(inst, item)
    return inst.components.finiteuses.current <= 70 and item.prefab == inst.zg_gunbullet
end
---------------------------------------------------------------
local function fn()

	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter() 
	inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
    
    anim:SetBank("zg_weapon_m4")
    anim:SetBuild("zg_weapon_m4")
    anim:PlayAnimation("idle")

	inst:AddTag("zg_m4")
	inst:AddTag("zg_no_dmgid")
	inst:AddTag("zg_class_gun")
	
	inst:AddTag("zg_doublehand")

	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	----枪械耐久
	inst.zg_num_ini = 400
	inst.zg_detail_gunhp = inst.zg_num_ini
	
	inst.zg_gunbullet = "zg_it_ak47bullet"
	
	----被填充弹药
	inst:AddComponent("trader")
    inst.components.trader:SetAcceptTest(AcceptTest)
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader.onrefuse = OnRefuseItem
    
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(0)					----不在枪定义攻击力
    inst.components.weapon:SetRange(7, 9)
	
	----结算
	inst:AddComponent("lootdropper")
	 
	inst.components.weapon:SetOnAttack(function(attacker, target, projectile)
		inst.zg_detail_gunhp = inst.zg_detail_gunhp - 1
		inst["net_zg_detail_gunhp"]:set( inst["zg_detail_gunhp"] )
		
		if inst.zg_detail_gunhp then
			inst.net_zg_detail_gunhp:set(inst.zg_detail_gunhp)
		end
		
		if inst.zg_detail_gunhp <= 0 then
			local pt = inst:GetPosition()
			local num = inst.components.finiteuses.current
			num = math.ceil(num / 30)
			inst.components.lootdropper.loot = {}
			if num > 0 then
				for k = 1, num do
					table.insert(inst.components.lootdropper.loot, inst.zg_gunbullet)
				end
				inst.components.lootdropper:DropLoot(pt)
			end
			inst:Remove()
		end
	end)
	
	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetMaxUses(100)
    inst.components.finiteuses:SetUses(15)

	inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("M-4自动步枪, 哇塞!")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_weapon_m4.xml"
	inst.components.inventoryitem.imagename = "zg_weapon_m4"
	inst.components.inventoryitem:SetOnDroppedFn( function(inst)
		inst:DoTaskInTime(.25, function()
			inst.SoundEmitter:PlaySound("dontstarve/zg/shotgun/putdown")
		end)
	end)
 
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )

	----保存载入
	inst.OnSave = function(inst, data)
		if data then
			data.zg_detail_gunhp = inst.zg_detail_gunhp
		end
	end
	inst.OnLoad = function(inst, data)
		inst.zg_detail_gunhp = data and data.zg_detail_gunhp or inst.zg_num_ini
		if inst.zg_detail_gunhp then
			inst.net_zg_detail_gunhp:set(inst.zg_detail_gunhp)
		end
	end	
 
    return inst
end

STRINGS.NAMES.ZG_WEAPON_M4 = "M-4自动步枪(伤害25,射速快速)"
return  Prefab("common/inventory/zg_weapon_m4", fn, assets)