local assets =
{
    Asset("ANIM", "anim/zg_weapon_mordensword.zip"),
    Asset("ANIM", "anim/zg_weapon_swap_mordensword.zip"),
	Asset("ATLAS", "images/zg_weapon_mordensword.xml"),
}

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "zg_weapon_swap_mordensword", "zg_weapon_swap_mordensword")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end



local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("zg_weapon_mordensword")
    inst.AnimState:SetBuild("zg_weapon_mordensword")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("sharp")
	inst:AddTag("zg_heavy_weapon")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(113)
	inst.components.weapon:SetRange(1)					--攻击距离+1
	--inst.components.weapon:SetAttackCallback(OnAttack)

    -------

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(200)
    inst.components.finiteuses:SetUses(200)

    inst.components.finiteuses:SetOnFinished(inst.Remove)

    inst:AddComponent("inspectable")
	inst.components.inspectable:SetDescription("帅气, 可是火候还差些")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/zg_weapon_mordensword.xml"
	inst.components.inventoryitem.imagename = "zg_weapon_mordensword"
	inst.components.inventoryitem.nobounce = true
	inst.components.inventoryitem:SetOnDroppedFn( function(inst)
		inst.SoundEmitter:PlaySound("dontstarve/zg/sound_inv/sword")
	end)

    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    return inst
end

STRINGS.NAMES.ZG_WEAPON_MORDENSWORD = "摩登剑(伤害113)" 
return Prefab("zg_weapon_mordensword", fn, assets)