require("stategraphs/commonstates")

local actionhandlers = 
{
    ActionHandler(ACTIONS.GOHOME, "gohome"),
    ActionHandler(ACTIONS.EAT, "eat"),
}


local events=
{
    CommonHandlers.OnLocomote(true,true),
    CommonHandlers.OnSleep(),
    CommonHandlers.OnFreeze(),
    --CommonHandlers.OnAttack(),
	EventHandler("doattack", function (inst, data)
		if inst.components.health ~= nil and not inst.components.health:IsDead() and (not inst.sg:HasStateTag("busy") or inst.sg:HasStateTag("hit")) then
			local equip = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
			if equip and equip.zg_name == "sword" then
				inst.sg:GoToState("sword_attack", data.target)
			else	
				inst.sg:GoToState("attack", data.target)
			end
		end
	end),
	
	EventHandler("attacked", function (inst, data)
		if inst.components.health ~= nil and not inst.components.health:IsDead() and (not inst.sg:HasStateTag("busy") or inst.sg:HasStateTag("frozen")) then
			inst.sg:GoToState("hit")
		end
	end),
	
    --CommonHandlers.OnAttacked(),
    --CommonHandlers.OnDeath(),
	EventHandler("death", function (inst, data)
		inst.sg:GoToState("death", data)
	end),
}

local states=
{

	----奔跑
	State
    {
        name = "run_start",
        tags = { "moving", "running", "canrotate" },

        onenter = function(inst)
            inst.components.locomotor:RunForward()
			
			local anim_to_play = "run_pre"
			
			local equip = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
			if equip and equip.zg_name == "sword" then
				anim_to_play = "zg_swordrun_loop"
			end 
			
            inst.AnimState:PlayAnimation(anim_to_play)
        end,

        events =
        {
            EventHandler("animover", function(inst)
				inst.sg:GoToState("run")
			end),
        },
    },
	
	State
    {
        name = "run",
        tags = { "moving", "running", "canrotate" },

        onenter = function(inst)
            inst.components.locomotor:RunForward()
            --local anim_to_play = get_loco_anim(inst, anims ~= nil and anims.run or nil, "run_loop")
			local anim_to_play = "run_loop"
			
			local equip = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
			if equip and equip.zg_name == "sword" then
				anim_to_play = "zg_swordrun_loop"
			end  
			
            inst.AnimState:PlayAnimation(anim_to_play, true)
			
            inst.sg:SetTimeout(inst.AnimState:GetCurrentAnimationLength())
        end,

        timeline = 
		{
			TimeEvent(0*FRAMES, PlayFootstep ),
			TimeEvent(10*FRAMES, PlayFootstep ),
		},

        ontimeout = function(inst)
			inst.sg:GoToState("run")
		end,
    },
	
	State
    {
        name = "run_stop",
        tags = { "idle" },

        onenter = function(inst) 
            inst.components.locomotor:StopMoving()
            --if softstop == true or (type(softstop) == "function" and softstop(inst)) then
            --    inst.AnimState:PushAnimation(get_loco_anim(inst, anims ~= nil and anims.stoprun or nil, "run_pst"), false)
            --else
			
			local anim_to_play = "run_pst"
			
			local equip = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
			if equip and equip.zg_name == "sword" then
				anim_to_play = "zg_swordrun_loop"
			end  
			
            inst.AnimState:PlayAnimation(anim_to_play)
            --end
			
			inst.sg:SetTimeout(1*FRAMES)
        end,
		
		ontimeout = function(inst)
			inst.sg:GoToState("idle")
		end,

		--[[
        events =
        {
            EventHandler("animover", function(inst)
				inst.sg:GoToState("idle")
			end),
        },]]
    },

	----走路
	State
    {
        name = "walk_start",
        tags = { "moving", "canrotate" },

        onenter = function(inst)
            inst.components.locomotor:WalkForward()
			
			local anim_to_play = "walk_pre"
			
			local equip = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
			if equip and equip.zg_name == "sword" then
				anim_to_play = "zg_swordwalk_loop"
			end  
			
            inst.AnimState:PlayAnimation(anim_to_play)
        end,

        events =
        {
            EventHandler("animover", function(inst)
				inst.sg:GoToState("walk")
			end),
        },
    },
	
	State
    {
        name = "walk",
        tags = { "moving", "canrotate" },

        onenter = function(inst)
            inst.components.locomotor:WalkForward()
            --local anim_to_play = get_loco_anim(inst, anims ~= nil and anims.walk or nil, "walk_loop")
			
			local anim_to_play = "walk_loop"
			
			local equip = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
			if equip and equip.zg_name == "sword" then
				anim_to_play = "zg_swordwalk_loop"
			end 
			
            inst.AnimState:PlayAnimation(anim_to_play, true)
            inst.sg:SetTimeout(inst.AnimState:GetCurrentAnimationLength())
        end,

        timeline = 
		{
			TimeEvent(0*FRAMES, PlayFootstep ),
			TimeEvent(12*FRAMES, PlayFootstep ),
		},

        ontimeout = function(inst)
			inst.sg:GoToState("walk")
		end,
    },
	
	State
    {
        name = "walk_stop",
        tags = { "canrotate" },

        onenter = function(inst)
            inst.components.locomotor:StopMoving()
            --if softstop == true or (type(softstop) == "function" and softstop(inst)) then
            --    inst.AnimState:PushAnimation(get_loco_anim(inst, anims ~= nil and anims.stopwalk or nil, "walk_pst"), false)
            --else
			local anim_to_play = "walk_pst"
			
			local equip = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
			if equip and equip.zg_name == "sword" then
				anim_to_play = "zg_swordwalk_loop"
			end 
			
            inst.AnimState:PlayAnimation(anim_to_play)
            --end
			
			inst.sg:SetTimeout(1*FRAMES)
        end,
		
		ontimeout = function(inst)
			inst.sg:GoToState("idle")
		end,
		
		--[[
        events =
        {
            EventHandler("animover", function(inst)
				inst.sg:GoToState("idle")
			end),
        },]]
    },

	--近战武器攻击
	State
    {
        name = "sword_attack",
        tags = { "attack", "busy" },

        onenter = function(inst, target)
            if inst.components.locomotor ~= nil then
                inst.components.locomotor:StopMoving()
            end
            inst.AnimState:PlayAnimation("zg_swordatk")
            inst.components.combat:StartAttack()

            inst.sg.statemem.target = target
        end,

        timeline = 
		{
			--TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/merm/attack") end),
			--TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_whoosh") end),
			TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/tentacle/tentacle_attack") end),
			TimeEvent(10*FRAMES, function(inst) inst.components.combat:DoAttack(inst.sg.statemem.target) end),
		},

        events =
        {
            EventHandler("animover", function(inst)
				inst.sg:GoToState("idle")
			end),
        },
    },

	--空手攻击
	State
    {
        name = "attack",
        tags = { "attack", "busy" },

        onenter = function(inst, target)
            if inst.components.locomotor ~= nil then
                inst.components.locomotor:StopMoving()
            end
            inst.AnimState:PlayAnimation("atk")
            inst.components.combat:StartAttack()

            inst.sg.statemem.target = target
        end,

        timeline = 
		{
			--TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/merm/attack") end),
			--TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_whoosh") end),
			
			TimeEvent(17*FRAMES, function(inst) inst.components.combat:DoAttack(inst.sg.statemem.target) end),
		},

        events =
        {
            EventHandler("animover", function(inst)
				inst.sg:GoToState("idle")
			end),
        },
    },
	
	--被攻击
	State
    {
        name = "hit",
        tags = { "hit", "busy" },

        onenter = function(inst)
		
			--鱼人很滑的哟
            --if inst.components.locomotor ~= nil then
            --    inst.components.locomotor:StopMoving()
            --end

            inst.AnimState:PlayAnimation("hit")

        end,

        events =
        {
            EventHandler("animover", function(inst)
				inst.sg:GoToState("idle")
			end),
        },
    },
	
	--死亡
	State
    {
        name = "death",
        tags = { "busy" },

        onenter = function(inst)
            --if inst.components.locomotor ~= nil then
            --    inst.components.locomotor:StopMoving()
            --end
            inst.AnimState:PlayAnimation("death")
            RemovePhysicsColliders(inst)
			if inst.components.lootdropper then
				inst.components.lootdropper:DropLoot(inst:GetPosition())
			end
        end,

        timeline = 
		{
			TimeEvent(0*FRAMES, function(inst) 
				inst.SoundEmitter:PlaySound("zg_sfx_merm/zg_sfx_merm/die")			
			end),
		},
    },
	
	--静止
	State
    {
        name = "idle",
        tags = { "idle", "canrotate" },

        onenter = function(inst, pushanim)
            if inst.components.locomotor ~= nil then
                inst.components.locomotor:StopMoving()
            end

            --local anim =
            --    (anim_override == nil and "idle_loop") or
            --    (type(anim_override) ~= "function" and anim_override) or
            --    anim_override(inst)

            --pushanim could be bool or string?
            --if pushanim then
            --    if type(pushanim) == "string" then
            --        inst.AnimState:PlayAnimation(pushanim)
            --    end
            --    inst.AnimState:PushAnimation(anim, true)
            --elseif not inst.AnimState:IsCurrentAnimation(anim) then
			
			local anim = "idle_loop"
			
			local equip = inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
			if equip and equip.zg_name == "sword" then
				anim = "zg_sword_idle_loop"
			end 
			
            inst.AnimState:PlayAnimation(anim)
			
            --end
        end,

        events =
        {
            EventHandler("animover", function(inst)
                --if inst.AnimState:AnimDone() then
                    --inst.sg:GoToState(math.random() < .1 and funny_idle_state or "idle")
					inst.sg:GoToState("idle")
                --end
            end),
        },
    },

}

--[[
CommonStates.AddWalkStates(states,
{
	walktimeline = {
		TimeEvent(0*FRAMES, PlayFootstep ),
		TimeEvent(12*FRAMES, PlayFootstep ),
	},
})
CommonStates.AddRunStates(states,
{
	runtimeline = {
		TimeEvent(0*FRAMES, PlayFootstep ),
		TimeEvent(10*FRAMES, PlayFootstep ),
	},
})]]

CommonStates.AddSleepStates(states,
{
	sleeptimeline = 
	{
		TimeEvent(35*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/merm/sleep") end ),
	},
})

--[[
CommonStates.AddCombatStates(states,
{
    attacktimeline = 
    {
        TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/creatures/merm/attack") end),
        TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_whoosh") end),
        TimeEvent(18*FRAMES, function(inst) inst.components.combat:DoAttack() end),
    },
    hittimeline = 
    {
        TimeEvent(0*FRAMES, function(inst) 
			--inst.SoundEmitter:PlaySound("dontstarve/creatures/merm/hurt")
			--inst.SoundEmitter:PlaySound("zg_sfx_merm/zg_sfx_merm/hit")
		end),
    },
    deathtimeline = 
    {
        TimeEvent(0*FRAMES, function(inst) 
			--inst.SoundEmitter:PlaySound("dontstarve/creatures/merm/death")
			inst.SoundEmitter:PlaySound("zg_sfx_merm/zg_sfx_merm/die")			
		end),
    },
})]]

--CommonStates.AddIdle(states)
CommonStates.AddSimpleActionState(states, "gohome", "pig_pickup", 4*FRAMES, {"busy"})
CommonStates.AddSimpleActionState(states, "eat", "eat", 10*FRAMES, {"busy"})
CommonStates.AddFrozenStates(states)

    
return StateGraph("merm", states, events, "idle", actionhandlers)

