require("stategraphs/commonstates")

local actionhandlers = 
{
    ActionHandler(ACTIONS.GOHOME, "action"),
}

local events=
{
    CommonHandlers.OnSleep(),
    CommonHandlers.OnFreeze(),
    CommonHandlers.OnAttack(),
    CommonHandlers.OnAttacked(),
    CommonHandlers.OnDeath(),
    CommonHandlers.OnLocomote(true,false),
}

local function SpawnHound(inst)
	--[[
    local hounded = TheWorld.components.hounded
	if hounded ~= nil then
        local num = inst:NumHoundsToSpawn()
		local pt = inst:GetPosition()
		for i = 1, num do
			local hound = hounded:SummonSpawn(pt)
			if hound ~= nil then
				hound.components.follower:SetLeader(inst)
			end
		end
	end]]
	local pt = Vector3(inst.Transform:GetWorldPosition())
	inst:StartThread(function()
		for k = 1, 4 do
			local theta = math.random() * 2 * PI
			local radius = math.random(3, 8)
			local result_offset = FindValidPositionByFan(theta, radius, 12, function(offset)
				local pos = pt + offset
				local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, 1)
				return next(ents) == nil
			end)
			if result_offset ~= nil then
				local pos = pt + result_offset
				
				local perd = nil
				local therandom = math.random()
				if therandom < .33 then
					perd = SpawnPrefab("zg_mo_wolf")
				elseif therandom <.66 then
					perd = SpawnPrefab("zg_mo_snowwolf")
				else
					perd = SpawnPrefab("zg_mo_blackwolf")
				end
				if perd then
					perd.Transform:SetPosition(pos:Get())
					perd.components.follower:SetLeader(inst)
					SpawnPrefab("statue_transition_2").Transform:SetPosition(pos:Get())
				end
			end
			Sleep(.33)
		end
	end)
end

local states=
{
	State
	{
		name = "idle",
		tags = {"idle"},

		onenter = function(inst)
			inst.Physics:Stop()
			inst.AnimState:PlayAnimation("idle_loop")
			inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/vargr/idle")
			
		end,

		events = 
		{
			EventHandler("animover", function(inst) 
				inst.sg:GoToState("idle") 
			end)
		},
	},

	State
	{
		name = "howl",
		tags = {"busy"},

		onenter = function(inst)
			inst.Physics:Stop()
			inst.AnimState:PlayAnimation("howl")
			--inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/vargr/howl")
			inst.SoundEmitter:PlaySound("dontstarve/zg/mo_wolf/howl")
		end,

		timeline = 
		{
			TimeEvent(10*FRAMES, SpawnHound),
		},

		events = 
		{
			EventHandler("animover", function(inst) 
				inst.sg:GoToState("idle") 
			end)
		},
	},
}

CommonStates.AddCombatStates(states,
{
	hittimeline = 
	{
		TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/vargr/hit") end)
	},
	attacktimeline = 
	{
		TimeEvent(12*FRAMES, function(inst) inst.components.combat:DoAttack() end),
		TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/vargr/attack") end)
	},
	deathtimeline = 
	{
		TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/vargr/death") end)
	},
})
CommonStates.AddRunStates(states, 
{	
	starttimeline = {},
    runtimeline = 
    { 
        TimeEvent(5*FRAMES, 
        function(inst) 
        	PlayFootstep(inst)
        	inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/vargr/idle")
        end),
    },
	endtimeline = {},
})
CommonStates.AddSleepStates(states,
{
	starttimeline = {},
	sleeptimeline = 
	{
		TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/vargr/sleep") end)
	},
	endtimeline = {},
})
CommonStates.AddFrozenStates(states)
  
return StateGraph("warg", states, events, "idle", actionhandlers)