require("stategraphs/commonstates")

local events=
{

    --EventHandler("locomote", function(inst)
    --end),
	CommonHandlers.OnLocomote(true,false),

    EventHandler("doattack", function(inst, data)
        if inst.components.health and not inst.components.health:IsDead() then
            inst.sg:GoToState("charge_attack", data.target)
        end
    end),


    --CommonHandlers.OnStep(),
    --CommonHandlers.OnSleep(),
    --CommonHandlers.OnFreeze(),
    --CommonHandlers.OnAttacked(true),
	EventHandler("attacked", function(inst, data)
		--inst.SoundEmitter:PlaySound("dontstarve/zg/wx78/hit")
		inst.SoundEmitter:PlaySound("zg_cr_icepig/zg_cr_icepig/hit")
	end),
	
    --CommonHandlers.OnDeath(),
	EventHandler("death", function(inst)
        inst.sg:GoToState("death")
    end),
	
    --EventHandler("transformnormal", function(inst) if inst.components.health:GetPercent() > 0 then inst.sg:GoToState("transformNormal") end end),
}

local states=
{
    State{
        name= "idle",
        tags = {"idle"},
        
        onenter = function(inst)
			inst.Physics:Stop()
            --inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/wild_boar/oink")
			inst.AnimState:PlayAnimation("idle_angry") 
			inst.sg:SetTimeout( ( 20+math.random(10) ) * FRAMES)
		end,
        
        ontimeout = function(inst)
            inst.sg:GoToState("idle")
        end,        
    },
    
    State{
        name = "death",
        tags = {"busy"},
        
        onenter = function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/wild_boar/grunt")
			inst.SoundEmitter:PlaySound("zg_cr_icepig/zg_cr_icepig/die")
            inst.AnimState:PlayAnimation("death")
            inst.Physics:Stop()
            RemovePhysicsColliders(inst)            
            inst.components.lootdropper:DropLoot(Vector3(inst.Transform:GetWorldPosition())) 

			--[[
			if math.random() < .05 then
				inst.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/distant")
				TheWorld:PushEvent("ms_setseason", "winter")
				TheWorld:PushEvent("ms_advanceseason")
				TheWorld:PushEvent("ms_advanceseason")
				TheWorld:PushEvent("ms_forceprecipitation", true)
			end]]
			
        end,
        
    },
	
	--------------------------------------------------------------------------------------------------------------------------
	--[[
	State{
        name = "charge_antic_pre",
        tags = {"moving", "charging", "busy", "atk_pre", "canrotate"},

        onenter = function(inst)
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("paw_pre")
        end,

        events =
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("charge_antic_loop") end),
        },
    },

    State{
        name = "charge_antic_loop",
        tags = {"moving", "charging", "busy", "atk_pre", "canrotate"},

        onenter = function(inst)
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("paw_loop", true)
            inst.sg:SetTimeout(1.5)
        end,

        ontimeout= function(inst)
            inst.sg:GoToState("charge_pre")
            --inst:PushEvent("attackstart" )
			--inst.components.combat:DoAttack()
        end,
    },]]

	
    State{
        name = "run_start",
        tags = {"canrotate", "busy", "moving", "running"},

        onenter = function(inst)
            inst.components.locomotor:RunForward()
            inst.AnimState:PlayAnimation("charge_pre")
        end,

        events =
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("run") end),
        },
    },
	
	State{
        name = "run",
        tags = {"canrotate", "moving", "running"},

        onenter = function(inst)
            inst.components.locomotor:RunForward()
            inst.AnimState:PlayAnimation("charge_loop")
            --inst.components.locomotor.runspeed = inst.components.locomotor.runspeed + 5
        end,

        onexit = function(inst)
            --inst.components.locomotor.runspeed = inst.components.locomotor.runspeed - 5
        end,

        events =
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("run") end),
        },
    },
	
	State{
        name = "run_stop",
        tags = {"canrotate", "idle"},

        onenter = function(inst) 
            --inst.components.locomotor:Stop()
            --inst.AnimState:PlayAnimation(inst:HasTag("groggy") and "idle_walk_pst" or "run_pst")
			inst.sg:SetTimeout(1*FRAMES)
        end,

        ontimeout = function(inst)
            inst.sg:GoToState("idle")
        end,
    },

	-------------------------------------------------------------------------------------------------------------------------------
    State{
        name = "charge_attack",
        tags = {"attack", "busy", "notalking", "abouttoattack"},

        onenter = function(inst, target)
			inst.SoundEmitter:PlaySound("zg_cr_icepig/zg_cr_icepig/atk")
			
			----一记猛打
			inst.sg.statemem.target = target
            inst.components.combat:StartAttack()
			
            --inst.components.locomotor:StopMoving()
            inst.AnimState:PlayAnimation("charge_atk")
			--inst.AnimState:PushAnimation("atk")
            --inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/wild_boar/charge_attack")
			inst.sg:SetTimeout(12*FRAMES)
        end,

        timeline =
        {
            TimeEvent(8*FRAMES, function(inst)
				inst.sg:RemoveStateTag("abouttoattack")			
                inst.components.combat:DoAttack(inst.sg.statemem.target)
				inst.sg:RemoveStateTag("attack") 
				inst.sg:RemoveStateTag("busy")
                --inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_whoosh")
            end),
        },

        ontimeout = function(inst)
			inst.sg:GoToState("idle")
		end,
		
    },
	
	--[[
	State{
        name = "attack",
        tags = {"attack", "busy"},
        
        onenter = function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/wild_boar/attack")
            --inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_whoosh")
            inst.components.combat:StartAttack()
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("atk")
        end,
        
        timeline=
        {
            TimeEvent(13*FRAMES, function(inst) inst.components.combat:DoAttack() inst.sg:RemoveStateTag("attack") inst.sg:RemoveStateTag("busy") end),
        },
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },]]


}

--[[
CommonStates.AddRunStates(states,
{
	runtimeline = {
		TimeEvent(0*FRAMES, PlayFootstep ),
		TimeEvent(10*FRAMES, PlayFootstep ),
	},
})]]

--CommonStates.AddIdle(states,"funnyidle")
--CommonStates.AddSimpleState(states,"refuse", "pig_reject", {"busy"})
--CommonStates.AddFrozenStates(states)

--CommonStates.AddSimpleActionState(states,"pickup", "pig_pickup", 10*FRAMES, {"busy"})

--CommonStates.AddSimpleActionState(states, "gohome", "pig_pickup", 4*FRAMES, {"busy"})

    
return StateGraph("zg_cr_icebore", states, events, "idle")
