require("stategraphs/commonstates")

local events=
{
    CommonHandlers.OnStep(),
    CommonHandlers.OnLocomote(true,false),
    EventHandler("attacked", function(inst) 
	
	end),
    EventHandler("death", function(inst)
		inst.sg:GoToState("death") 
	end),
    EventHandler("doattack", function(inst) 
		if not inst.components.health:IsDead() then 
			inst.sg:GoToState("attack") 
		end 
	end),
}

local states=
{
    State{
        name= "gobble_idle",
        tags = {"idle"},
        
        onenter = function(inst)
			inst.Physics:Stop()
            inst.SoundEmitter:PlaySound("dontstarve/creatures/perd/gobble")
            inst.AnimState:PlayAnimation("idle_loop")
        end,
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end ),
        },        
    },
    
    
	State{
        name = "death",
        tags = {"busy"},
        
        onenter = function(inst)
			inst.SoundEmitter:PlaySound("dontstarve/zg/spell/summon02")
            --inst.SoundEmitter:PlaySound("dontstarve/creatures/perd/death")
            inst.AnimState:PlayAnimation("death")
            inst.components.locomotor:StopMoving()
            RemovePhysicsColliders(inst)            
        end,
        
    },

    
    State{
        name = "appear",
        tags = {"busy"},
        
        onenter = function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve/creatures/perd/scream")
			inst.SoundEmitter:PlaySound("dontstarve/creatures/perd/run")
            inst.Physics:Stop()	
            inst.AnimState:PlayAnimation("appear")
        end,
        
        events =
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },
    
    State{
        name = "attack",
        tags = {"attack"},
        
        onenter = function(inst)
            inst.SoundEmitter:PlaySound("dontstarve/creatures/perd/attack")
            inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_whoosh")
            inst.components.combat:StartAttack()
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("atk")
        end,
        
        timeline =
        {
            TimeEvent(18*FRAMES, function(inst) inst.components.combat:DoAttack() end),
        },
        
        events =
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },
    
}

CommonStates.AddRunStates(states,
{
    starttimeline = 
    {
		TimeEvent(0*FRAMES, function(inst) 
			--inst.SoundEmitter:PlaySound("dontstarve/creatures/perd/run") 
		end ),
    },
    
	runtimeline = {
		TimeEvent(0*FRAMES, PlayFootstep ),
		TimeEvent(5*FRAMES, function(inst) 
			--inst.SoundEmitter:PlaySound("dontstarve/creatures/perd/run") 
		end ),
		TimeEvent(10*FRAMES, PlayFootstep ),
	},
})

CommonStates.AddIdle(states,"gobble_idle")

    
return StateGraph("perd", states, events, "appear")

