require("stategraphs/commonstates")
   
local events=
{
	CommonHandlers.OnLocomote(true, false),
	
	CommonHandlers.OnFreeze(),

    EventHandler("attacked", function(inst, data)
		--冥河娃娃
		if inst.prefab == "zg_mo_stygiandoll" then
			inst.SoundEmitter:PlaySound("dontstarve/zg/mo_stygiandoll/hit")
		else	
			inst.SoundEmitter:PlaySound("dontstarve/zg/mo_skel/hit")
		end
		
	end),

    EventHandler("doattack", function(inst, data)
        if not inst.components.health:IsDead() then
            if inst.prefab == "zg_mo_skel3" then
				inst.sg:GoToState("attack_knight", data.target)
			elseif inst.prefab == "zg_mo_skelarcher" then
				inst.sg:GoToState("attack_bow", data.target)
			elseif inst.prefab == "zg_mo_stygiandoll" then	
				inst.sg:GoToState("attack_spear", data.target)
			else
				inst.sg:GoToState("attack", data.target)
			end
        end
    end),
    
    EventHandler("death", function(inst)
        inst.sg:GoToState("death")
    end),
}

local states= 
{

    State{
        name = "death",
        tags = {"busy"},
        
        onenter = function(inst)
		
			--冥河娃娃
			if inst.prefab == "zg_mo_stygiandoll" then
				inst.SoundEmitter:PlaySound("dontstarve/zg/mo_stygiandoll/die")
			
				--	尸体爆炸攻击
				local pt = inst:GetPosition()
				
				local fx = SpawnPrefab("sparks")
				fx.Transform:SetScale(5,5,5)
				fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
				
				local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, 5, { "_combat" }, {"shadowboss"})
				for k,v in pairs(ents) do
					if v and v.components.health and not v.components.health:IsDead() and v ~= inst and v.components.combat and not v:HasTag("zg_skel") then
						v.components.health:DoDelta(-100, nil, inst.prefab, nil, nil, true)
					end
				end
			else 
				inst.SoundEmitter:PlaySound("dontstarve/zg/mo_skel/die")
			end
		
            inst.components.locomotor:Stop()
            inst.AnimState:Hide("swap_arm_carry")
            inst.AnimState:PlayAnimation("death")
            inst.components.lootdropper:DropLoot(Vector3(inst.Transform:GetWorldPosition()))  

        end,
    },

    State{
        name = "idle",
        tags = {"idle", "canrotate"},
        onenter = function(inst, pushanim)     
            inst.components.locomotor:Stop()
            local anims = {"idle_loop"}          
            local anim = "idle_loop"                      
            if pushanim then
                for k,v in pairs (anims) do
					inst.AnimState:PushAnimation(v, k == #anims)
				end
            else
                inst.AnimState:PlayAnimation(anims[1], #anims == 1)
                for k,v in pairs (anims) do
					if k > 1 then
						inst.AnimState:PushAnimation(v, k == #anims)
					end
				end
            end 
			
			if math.random() < .075 then
				if inst.prefab == "zg_mo_stygiandoll" then
					inst.SoundEmitter:PlaySound("dontstarve/zg/mo_stygiandoll/call")
				else
					inst.SoundEmitter:PlaySound("dontstarve/zg/mo_skel/call")
				end
			end
            inst.sg:SetTimeout(math.random()*4+2)
        end,
    },
	
------------------------------------------------------------------------------------------------------------------------------------------------------
    State{
        name = "attack",
        tags = {"attack", "notalking", "abouttoattack", "busy"},
        
        onenter = function(inst, target)
            inst.sg.statemem.target = target
            inst.components.combat:StartAttack()
            
			inst.components.locomotor:Stop()
			
			inst.AnimState:PlayAnimation("atk")
			
        end,
        
        timeline=
        {	
			TimeEvent(4*FRAMES, function(inst) 
				inst.SoundEmitter:PlaySound("dontstarve/tentacle/tentacle_attack") 
			end),
            TimeEvent(8*FRAMES, function(inst) 
				inst.components.combat:DoAttack(inst.sg.statemem.target) 
				inst.sg:RemoveStateTag("abouttoattack")
				inst.sg:RemoveStateTag("busy")
				inst.sg:RemoveStateTag("attack")				
			end),  
        },
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end ),
        },
    }, 

	State{
        name = "attack_knight",
        tags = {"attack", "notalking", "abouttoattack", "busy"},
        
        onenter = function(inst, target)
            inst.sg.statemem.target = target
            inst.components.combat:StartAttack()
            
			inst.components.locomotor:Stop()
			
			inst.AnimState:PlayAnimation("pickaxe_loop")
			
        end,
        
        timeline=
        {	
			TimeEvent(6*FRAMES, function(inst) 
				inst.SoundEmitter:PlaySound("dontstarve/tentacle/tentacle_attack") 
			end),
            TimeEvent(10*FRAMES, function(inst) 
				inst.components.combat:DoAttack(inst.sg.statemem.target) 
				inst.sg:RemoveStateTag("abouttoattack")
				inst.sg:RemoveStateTag("busy")
				inst.sg:RemoveStateTag("attack")				
			end),  
        },
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end ),
        },
    },  

	State{
        name = "attack_spear",
        tags = {"attack", "notalking", "abouttoattack", "busy"},
        
        onenter = function(inst, target)
            inst.sg.statemem.target = target
            inst.components.combat:StartAttack()
            
			inst.components.locomotor:Stop()
			
			inst.AnimState:PlayAnimation("spearjab")
			
        end,
        
        timeline=
        {	
			TimeEvent(8*FRAMES, function(inst) 
				inst.SoundEmitter:PlaySound("dontstarve/tentacle/tentacle_attack") 
			end),
            TimeEvent(12*FRAMES, function(inst) 
				inst.components.combat:DoAttack(inst.sg.statemem.target) 
				inst.sg:RemoveStateTag("abouttoattack")
				inst.sg:RemoveStateTag("busy")
				inst.sg:RemoveStateTag("attack")				
			end),  
        },
        
        events=
        {
            EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end ),
        },
    },  
	
	State{
		name = "attack_bow",
		tags = { "attack", "notalking", "abouttoattack", "busy" },

		onenter = function(inst, target)
			inst.sg.statemem.target = target
			inst.components.combat:StartAttack()
			inst.components.locomotor:Stop()
			inst.AnimState:PlayAnimation("bow_attack")
		end,

		timeline =
		{		
			TimeEvent(4*FRAMES, function(inst) 
				--inst.SoundEmitter:PlaySound("dontstarve/tentacle/tentacle_attack")
				inst.SoundEmitter:PlaySound("dontstarve/zg/wicker/shoot")
			end),
            TimeEvent(8*FRAMES, function(inst) 
				inst.components.combat:DoAttack(inst.sg.statemem.target) 
				inst.sg:RemoveStateTag("abouttoattack") 
			end),  
			TimeEvent(10*FRAMES, function(inst) 
				inst.sg:RemoveStateTag("busy")
				inst.sg:RemoveStateTag("attack")
			end),			
		},

		events =
		{
			EventHandler("animover", function(inst)
                inst.sg:GoToState("idle")
            end ),
		},
	},
   
    State{
        name = "run_start",
        tags = {"moving", "running", "canrotate"},
        
        onenter = function(inst)
			inst.components.locomotor:RunForward()
            inst.AnimState:PlayAnimation("run_pre")
            inst.sg.mem.foosteps = 0
        end,

        onupdate = function(inst)
            inst.components.locomotor:RunForward()
        end,

        events=
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("run") end ),        
        },
        
        timeline=
        {
        
            TimeEvent(4*FRAMES, function(inst)
                PlayFootstep(inst)
                --DoFoleySounds(inst)
            end),
        },        
        
    },

    State{
        
        name = "run",
        tags = {"moving", "running", "canrotate"},
        
        onenter = function(inst) 
            inst.components.locomotor:RunForward()
            inst.AnimState:PlayAnimation("run_loop")
            
        end,
        
        onupdate = function(inst)
            inst.components.locomotor:RunForward()
        end,

        timeline=
        {
            TimeEvent(7*FRAMES, function(inst)
				inst.sg.mem.foosteps = inst.sg.mem.foosteps + 1
                PlayFootstep(inst, inst.sg.mem.foosteps < 5 and 1 or .6)
                --DoFoleySounds(inst)
            end),
            TimeEvent(15*FRAMES, function(inst)
				inst.sg.mem.foosteps = inst.sg.mem.foosteps + 1
                PlayFootstep(inst, inst.sg.mem.foosteps < 5 and 1 or .6)
                --DoFoleySounds(inst)
            end),
        },
        
        events=
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("run") end ),        
        },
        
        
    },
    
    State{
        name = "run_stop",
        tags = {"canrotate", "idle"},
        
        onenter = function(inst) 
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("run_pst")
        end,
        
        events=
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end ),        
        },       
    },    
	
	State {
		name = "frozen",
		tags = {"busy"},
		
        onenter = function(inst)
            inst.AnimState:PlayAnimation("frozen")
            inst.Physics:Stop()
        end,
    },
}
CommonStates.AddFrozenStates(states)
    
return StateGraph("zg_mo_skel", states, events, "idle")

