require("stategraphs/commonstates")

local actionhandlers = 
{
	ActionHandler(ACTIONS.EAT, "eat"),
}

local events=
{
    --CommonHandlers.OnAttack(),
	EventHandler("doattack", function(inst, data) 
		if not inst.components.health:IsDead() then
			inst.sg:GoToState("attack", data.target)
		end
	end),	
	
    EventHandler("attacked", function(inst, data)
		inst.SoundEmitter:PlaySound("dontstarve/zg/mo_wolf/hit")
		--不被中断
		
	end),
    --CommonHandlers.OnDeath(),
	EventHandler("death", function(inst) 
		inst.sg:GoToState("death") 
	end),
    CommonHandlers.OnLocomote(true,false),
}


local states=
{
	State
	{
		name = "idle",
		tags = {"idle"},

		onenter = function(inst)
			inst.Physics:Stop()
			inst.AnimState:PlayAnimation("idle_loop")
			if math.random() < .125 then
				inst.SoundEmitter:PlaySound("dontstarve/zg/mo_wolf/call")
			else
				inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/vargr/idle")
			end
		end,

		events = 
		{
			EventHandler("animover", function(inst) 
				inst.sg:GoToState("idle") 
			end)
		},
	},
	
	State{
        name = "attack",
        tags = { "attack", "busy" },

        onenter = function(inst, target)
            inst.sg.statemem.target = target
            inst.Physics:Stop()
            inst.components.combat:StartAttack()
            inst.AnimState:PlayAnimation("atk")
            --inst.AnimState:PushAnimation("atk", false)
        end,

        timeline =
        {
			TimeEvent(0*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve/zg/cr_hound/atk") end),
			TimeEvent(12*FRAMES, function(inst) inst.components.combat:DoAttack(inst.sg.statemem.target) end),
        },

        events =
        {
            EventHandler("animover", function(inst) 
				if math.random() < .2 then 
					inst.components.combat:SetTarget(nil) 
					inst.sg:GoToState("idle") 
				else 
					inst.sg:GoToState("idle") 
				end 
			end),
        },
    },
	
	State{
        name = "death",
        tags = { "busy" },

        onenter = function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve/creatures/hound/death")
			inst.SoundEmitter:PlaySound("dontstarve/zg/mo_wolf/die")
            inst.AnimState:PlayAnimation("death")
            inst.Physics:Stop()
            RemovePhysicsColliders(inst)            
            inst.components.lootdropper:DropLoot(Vector3(inst.Transform:GetWorldPosition()))            
        end,
    },
	
	State{
        name = "eat",
        tags ={"busy"},
        onenter = function(inst)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("atk")
			inst.SoundEmitter:PlaySound("dontstarve/zg/cr_hound/atk")
        end,

        timeline=
        {
            TimeEvent(12*FRAMES, function(inst) 
                inst:PerformBufferedAction() 
                inst.sg:RemoveStateTag("busy")
            end),
        },        
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
        
    },

}

CommonStates.AddRunStates(states, 
{	
	starttimeline = {},
    runtimeline = 
    { 
        TimeEvent(5*FRAMES, 
        function(inst) 
        	PlayFootstep(inst)
        	inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/vargr/idle")
        end),
    },
	endtimeline = {},
})
  
return StateGraph("zg_mo_wolf", states, events, "idle", actionhandlers)