require("stategraphs/commonstates")

--[[
local function startaura(inst)
    inst.SoundEmitter:PlaySound("dontstarve/ghost/ghost_girl_attack_LP", "angry")
    inst.AnimState:SetMultColour(207/255,92/255,92/255,1)
end

local function stopaura(inst)
    inst.SoundEmitter:KillSound("angry")
    inst.AnimState:SetMultColour(1,1,1,1)
end]]

local events =
{
    CommonHandlers.OnLocomote(true, false),
	
    --EventHandler("startaura", startaura),
    --EventHandler("stopaura", stopaura),
	
    EventHandler("attacked", function(inst, data)
		if zg_isalive(inst) and not inst.sg:HasStateTag("attack") then
			--被打声音
			inst.SoundEmitter:PlaySound(inst.zg_hurtsound)
			--
			if data.attacker and data.attacker:IsNear(inst,3) then
				inst.sg:GoToState("hit")
			end
		end
	end),
	
	EventHandler("death", function(inst) 
		inst.sg:GoToState("dissipate") 
	end),
}

local function getidleanim(inst)
    if inst.components.combat.target or inst.components.aura.applying then
        return "angry"
    elseif inst.components.health:GetPercent() < .25 then
        return "shy"
    else
        return "idle"
    end
end

local states =
{
    State
    {
        name = "idle",
        tags = {"idle", "canrotate", "canslide"},
        onenter = function(inst)
            inst.AnimState:PlayAnimation(getidleanim(inst), true)
        end,
    },
	
	State{
        name = "hit",
        tags = {"busy"},
        
        onenter = function(inst)
            if inst:HasTag("girl") then
                inst.SoundEmitter:PlaySound("dontstarve/ghost/ghost_girl_howl")
            else
                inst.SoundEmitter:PlaySound("dontstarve/ghost/ghost_howl")
            end

            inst.AnimState:PlayAnimation("hit")
            inst.Physics:Stop()            
        end,
        
        events =
        {
            EventHandler("animover", function(inst)
                if inst.AnimState:AnimDone() then
                    inst.sg:GoToState("idle")
                end
            end),
        },
    },
    
    State
    {
        name = "appear",
        onenter = function(inst)
            inst.AnimState:PlayAnimation("appear")
            if inst:HasTag("girl") then
                inst.SoundEmitter:PlaySound("dontstarve/ghost/ghost_girl_howl")
            else
                inst.SoundEmitter:PlaySound("dontstarve/ghost/ghost_howl")
            end
        end,

        events =
        {
            EventHandler("animover", function(inst)
                if inst.AnimState:AnimDone() then
                    inst.components.aura:Enable(true)
                    inst.sg:GoToState("idle")
                end
            end),
        },
    },    

    State
    {
        name = "dissipate",
        onenter = function(inst)
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("dissipate")          
            inst.SoundEmitter:PlaySound(inst.zg_deathsound)
        end,

        events =
        {
            EventHandler("animover", function(inst)
                if inst.AnimState:AnimDone() then
                    inst:Remove()
                end
            end)
        },
    },
}

CommonStates.AddSimpleRunStates(states, getidleanim)
    
return StateGraph("sg_ghost", states, events, "appear")