--智能敌对的函数库放在这里

--语言	例句： zg_ischs("你好","Hello")
function zg_ischs(a,b)
	if TUNING.ZG_LAN=="en" then
		return b
	else
		return a
	end
end

function c(str,num)
	c_give(str,num)
end

--增加组件
--[[别用
function zg_addcmp(inst,cmp)
	if not inst.components[cmp] then
		inst:AddComponent(cmp)
	end
	return inst.components[cmp]
end]]

--删除物品
function zg_remove(inst,time)
	if inst==nil then return end
	if inst.AnimState==nil then return inst.Remove end
	local time=time or 1
	local alpha=1
	inst:DoPeriodicTask(1/30, function()
		if alpha<=0 then
			inst:Remove()
		else
			alpha=alpha-1/30/time
			inst.AnimState:SetMultColour(1,1,1,alpha)
		end
	end)
end

--生成物品
function zg_spawn(inst, other, offset, mode, scale, phys, sound, fn_tar, fn_inst)

	if not inst then return end
	--local mode = mode or 0
	local tar
	
	if type(other) == "string" then
		tar = SpawnPrefab(other)
	elseif type(other) == "table" then
	
		--获取权重
		local weight = 0
		for k,v in pairs(other) do
			weight = weight + v
		end
		
		--选取物体
		local t = 0
		local ran = math.random()
		for k,v in pairs(other) do
			t = t + v
			if ran <= t/weight then
				tar = SpawnPrefab(k)
				break
			end
		end
	else
		return
	end
		
	--物体的父子位置关系
	if mode == 1 then
		
		tar.entity:SetParent(inst.entity)
		if type(offset) == "table" then
			tar.Transform:SetPosition(offset[1],offset[2],offset[3])
		else
			tar.Transform:SetPosition(0,0,0)
		end
	
	--Follow Symbol的关系
	elseif type(mode) == "string" then
		
		tar.entity:SetParent(inst.entity)
		tar.entity:AddFollower()
		if type(offset) == "table" then
			tar.Follower:FollowSymbol(inst.GUID, mode, offset[1],offset[2],offset[3])
		else
			tar.Follower:FollowSymbol(inst.GUID, mode, 0,0,0)
		end
	
	--普通生成模式
	else
		local x,y,z = inst.Transform:GetWorldPosition()
		local x1,y1,z1 = x,y,z
		if type(offset) == "table" then
			x1,y1,z1 = x+offset[1], y+offset[2], z+offset[3]
		end
		tar.Transform:SetPosition(x1,y1,z1)
	end
	
	--新事物的体积,多用于调试特效
	if scale then
		tar.Transform:SetScale(scale,scale,scale)
	end
	
	--新事物飞出的速度,多用于弹道类物体,也可用于掉落物
	if type(phys) == "table" and tar.Physics then

		--获取方向, 以自己为起点的方向
		if phys[1] then
			local angle = tar:GetAngleToPoint( phys[1]:Get() )	
			
			--偏离角度
			local angel_d = phys[2] or 0
			angle = angle + angel_d
			
			--获得最终面向角度
			while (angle < 0) do
				angle = angle + 360
			end
			while (angle >= 360) do
				angle = angle - 360
			end
			
			--设置最终面向
			tar.Transform:SetRotation(angle)
		end
		
		--获取速度, 如果速度小于0则倒退方向运行
		local vel = phys[3]
		if vel then
			tar.Physics:SetMotorVelOverride(vel[1],vel[2],vel[3])
		end
		
	end
	
	--新事物的音效,用于生成时的声音效果
	if type(sound) == "table" then
		if not tar.SoundEmitter then
			tar.entity:AddSoundEmitter()
		end
		tar:DoTaskInTime(sound[2] or 0, function()
			tar.SoundEmitter:PlaySound(sound[1])
		end)
	end
	
	-------------------------------------------一般情况是用不着的----------------
	--新事物的其他初始化
	if type(fn_tar) == "function" then
		fn_tar(tar)
	end
	
	--旧事物的操作
	if type(fn_inst) == "function" then
		fn_inst(inst)
	end

	return tar
end


--是否含有tag
function zg_checktag(inst, add, del, mult)
	if not inst then return false end
	local res	
	if type(add) == "table" then
		res = false
		for k,v in pairs(add) do
			res = res or inst:HasTag(v)
		end
	else
		res = true
	end
	if type(del) == "table" then
		for k,v in pairs(del) do
			res = res and not inst:HasTag(v)
		end
	end
	if type(mult) == "table" then
		for k,v in pairs(mult) do
			res = res and inst:HasTag(v)
		end
	end
	return res
end

--对方对 我或者指定标签 有敌意
function zg_isenemy(tar,inst,add,del,mult)
	local target=tar and tar.components.combat and tar.components.combat.target
	
	local leader=tar and tar.components.follower and tar.components.follower.leader
	local target2=leader and leader.components.combat and leader.components.combat.target
	
	return (target and (target==inst or zg_checktag(target,add,del,mult)))
		or (target2 and (target2==inst or zg_checktag(target2,add,del,mult)))
end

--是否活着
function zg_isalive(inst)
	return inst and inst.components.health and not inst.components.health:IsDead() and not inst:HasTag("playerghost") and inst.components.combat
end

--创建虚武器并装备
function zg_virtual_weapon(inst,damage,uses,attackrange,hitrange,projectile,build,bank,tag,slot,onattack,stimuli)
	if inst.components.inventory then
		local weapon = CreateEntity()
		weapon.entity:AddTransform()
		weapon.entity:AddSoundEmitter()
		weapon:AddComponent("weapon")
		weapon.components.weapon:SetDamage(damage or 10)
		
		--攻击特效
		if onattack then
			weapon.components.weapon:SetOnAttack(onattack)
		end
		
		--刺激物
		if stimuli then
			weapon.components.weapon.stimuli=stimuli
		end
		
		--耐久
		if uses then
			weapon:AddComponent("finiteuses")
			weapon.components.finiteuses:SetMaxUses(uses)
			weapon.components.finiteuses:SetUses(uses)
			weapon.components.finiteuses:SetOnFinished(function(weapon)
				inst:PushEvent("toolbroke", {tool = weapon})
				weapon:Remove()
			end)
		end
		
		--距离
		if attackrange then
			weapon.components.weapon:SetRange(attackrange, hitrange or attackrange)
		end
		
		--抛射物
		if projectile then
			weapon.components.weapon:SetProjectile(projectile)
		end
		
		weapon:AddComponent("inventoryitem")
		weapon.persists = false
		weapon.components.inventoryitem:SetOnDroppedFn(weapon.Remove)
		weapon:AddComponent("equippable")
		
		--样式
		if build and bank then
			weapon.components.equippable:SetOnEquip(function(weapon, owner)
				owner.AnimState:OverrideSymbol("swap_object", build, bank)
				owner.AnimState:Show("ARM_carry") 
				owner.AnimState:Hide("ARM_normal") 
			end)
			weapon.components.equippable:SetOnUnequip(function(weapon, owner) 
				owner.AnimState:Hide("ARM_carry") 
				owner.AnimState:Show("ARM_normal") 
			end)
		end
		
		--标签
		if type(tag) == "table" then
			for k,v in pairs(tag) do
				weapon:AddTag(v)
			end
		end
		
		inst.components.inventory:Equip(weapon)
		inst.zg_weapon_slot=slot
	end
end

--创建虚帽子并装备
function zg_virtual_hat(inst,condition,absorb,build,open,tag,slot)
	if inst.components.inventory then
		local hat = CreateEntity()
		hat.entity:AddTransform()
		
		--护甲
		if condition and absorb then
			hat:AddComponent("armor")
			hat.components.armor:InitCondition(condition,absorb)
		end
		
		hat:AddComponent("inventoryitem")
		hat.persists = false
		hat.components.inventoryitem:SetOnDroppedFn(hat.Remove)
		hat:AddComponent("equippable")
		hat.components.equippable.equipslot=EQUIPSLOTS.HEAD
		
		--样式
		if build then
			hat.components.equippable:SetOnEquip(function(hat, owner)
			
				owner.AnimState:OverrideSymbol("swap_hat", build, "swap_hat")
				if open then
					owner.AnimState:Show("HAT")
					owner.AnimState:Hide("HAT_HAIR")
					owner.AnimState:Show("HAIR_NOHAT")
					owner.AnimState:Show("HAIR")
					owner.AnimState:Show("HEAD")
					owner.AnimState:Hide("HEAD_HAT")
				else
					owner.AnimState:Show("HAT")
					owner.AnimState:Show("HAT_HAIR")
					owner.AnimState:Hide("HAIR_NOHAT")
					owner.AnimState:Hide("HAIR")
					owner.AnimState:Hide("HEAD")
					owner.AnimState:Show("HEAD_HAT")
				end
				
			end)
			hat.components.equippable:SetOnUnequip(function(hat, owner) 
				
				owner.AnimState:ClearOverrideSymbol("swap_hat")
				owner.AnimState:Hide("HAT")
				owner.AnimState:Hide("HAT_HAIR")
				owner.AnimState:Show("HAIR_NOHAT")
				owner.AnimState:Show("HAIR")
				owner.AnimState:Show("HEAD")
				owner.AnimState:Hide("HEAD_HAT")

			end)
		end
		
		--标签
		if type(tag) == "table" then
			for k,v in pairs(tag) do
				hat:AddTag(v)
			end
		end
		
		inst.components.inventory:Equip(hat)
		inst.zg_hat_slot=slot
	end
end

--创建虚护甲并装备
function zg_virtual_armor(inst,condition,absorb,build,tag,slot)
	if inst.components.inventory then
		local hat = CreateEntity()
		hat.entity:AddTransform()
		
		--护甲
		if condition and absorb then
			hat:AddComponent("armor")
			hat.components.armor:InitCondition(condition,absorb)
		end
		
		hat:AddComponent("inventoryitem")
		hat.persists = false
		hat.components.inventoryitem:SetOnDroppedFn(hat.Remove)
		hat:AddComponent("equippable")
		hat.components.equippable.equipslot=EQUIPSLOTS.BODY
		
		--样式
		if build then
			hat.components.equippable:SetOnEquip(function(hat, owner)
				owner.AnimState:OverrideSymbol("swap_body", build, "swap_body")
			end)
			hat.components.equippable:SetOnUnequip(function(hat, owner) 
				owner.AnimState:ClearOverrideSymbol("swap_body")
			end)
		end
		
		--标签
		if type(tag) == "table" then
			for k,v in pairs(tag) do
				hat:AddTag(v)
			end
		end
		
		inst.components.inventory:Equip(hat)
		inst.zg_hat_slot=slot
	end
end

--获得循环数组的下一个数值,就是那种首位相连的结构,类似圆环的
function zg_loop_next(tab,key,step)
	local step=step or 1
	local maxn=#tab
	local getn=key+step
	while (getn>maxn) do
		getn=getn-maxn
	end
	return getn
end

--可攻击到 目标否
function zg_canattacktarget(inst)
	local target=inst and inst.components.combat and inst.components.combat.target
	if target then
		return inst.components.combat:CanAttack(target)
	else
		return false
	end
end

--可被 自己目标 攻击到否
function zg_canbeattacked(inst)
	local target=inst and inst.components.combat and inst.components.combat.target
	if target and target.components.combat then
		return target.components.combat:CanAttack(inst)
	else
		return false
	end
end

--[[
--开始 走位距离
function zg_startdogedist(inst,add)
	local target=inst and inst.components.combat and inst.components.combat.target
	if target and target.components.combat and not target:HasTag("wall") then
		--local range = inst.Physics ~= nil and inst.Physics:GetRadius() + inst.components.combat:GetAttackRange() or inst.components.combat:GetAttackRange()
		local range=target.components.combat:GetAttackRange()+( inst.Physics and inst.Physics:GetRadius() or 0 )
		return range+(add or 0)
	else
		return 0	--+(add or 0)
	end
end

--结束 走位距离
function zg_stopdogedist(inst,add)
	local target=inst and inst.components.combat and inst.components.combat.target
	if target and target.components.combat and not target:HasTag("wall") then
		local range=target.components.combat:GetAttackRange()+( inst.Physics and inst.Physics:GetRadius() or 0 )
		return range+(add or 0)
	else
		return 0	--+(add or 0)
	end
end]]

--目标是否 无 比自己长些的攻击距离
function zg_target_noexweapon(inst,add)
	--目标攻击距离
	local target=inst and inst.components.combat and inst.components.combat.target
	if target and target.components.combat then
		local distsq=target.components.combat:CalcHitRangeSq(inst)
		local distsq2=inst.components.combat:CalcHitRangeSq(target)
		return distsq<(distsq2+(add or 0))
	else
		return true	--安全
	end
end

--可以乘着 目标攻击间隔 袭击否
function zg_cansneak(inst,a,b)
	local target=inst and inst.components.combat and inst.components.combat.target
	if target and target:HasTag("wall") then return true end
	if target and target.components.combat then
		local lastattacktime=target.components.combat.lastdoattacktime or 0
		local timedelta=GetTime()-lastattacktime
		local attackperiod=target.components.combat.min_attack_period
		if timedelta>(a or .75)*attackperiod and timedelta<(b or 1.25)*attackperiod then
			return false
		else
			return true
		end
	else
		return true
	end
end

--[[
--目标 表面上 正在逃跑否
function zg_target_isescaping(inst)
	local target=inst and inst.components.combat and inst.components.combat.target
	if target then
		
	end
end]]

-------------------------------------------------------------------------------------------------------