local TheWorld = GLOBAL.TheWorld
local GetTime = GLOBAL.GetTime
local ACTIONS = GLOBAL.ACTIONS
local TUNING = GLOBAL.TUNING
local STRINGS = GLOBAL.STRINGS
local FRAMES = GLOBAL.FRAMES
local GetValidRecipe = GLOBAL.GetValidRecipe
local SpawnPrefab = GLOBAL.SpawnPrefab
local ProfileStatsAdd = GLOBAL.ProfileStatsAdd
local require = GLOBAL.require

local easing = require("easing") 

----拾取不是立刻装备上
ACTIONS.PICKUP.fn = function(act)
    if act.doer.components.inventory ~= nil and
        act.target ~= nil and
        act.target.components.inventoryitem ~= nil and
        (act.target.components.inventoryitem.canbepickedup or
        (act.target.components.inventoryitem.canbepickedupalive and not act.doer:HasTag("player"))) and
        not (act.target:IsInLimbo() or
            (act.target.components.burnable ~= nil and act.target.components.burnable:IsBurning()) or
            (act.target.components.projectile ~= nil and act.target.components.projectile:IsThrown())) then

        act.doer:PushEvent("onpickupitem", { item = act.target })

        --special case for trying to carry two backpacks
        if not act.target.components.inventoryitem.cangoincontainer and act.target.components.equippable and act.doer.components.inventory:GetEquippedItem(act.target.components.equippable.equipslot) then
            local item = act.doer.components.inventory:GetEquippedItem(act.target.components.equippable.equipslot)
            if item.components.inventoryitem and item.components.inventoryitem.cangoincontainer then
                
                --act.doer.components.inventory:SelectActiveItemFromEquipSlot(act.target.components.equippable.equipslot)
                act.doer.components.inventory:GiveItem(act.doer.components.inventory:Unequip(act.target.components.equippable.equipslot))
            else
                act.doer.components.inventory:DropItem(act.doer.components.inventory:GetEquippedItem(act.target.components.equippable.equipslot))
            end
            act.doer.components.inventory:Equip(act.target)
            return true
        end

        if act.doer:HasTag("player") and act.target.components.equippable and not act.doer.components.inventory:GetEquippedItem(act.target.components.equippable.equipslot) 
			and act.target.components.container 
		then
            act.doer.components.inventory:Equip(act.target)
        else
            act.doer.components.inventory:GiveItem(act.target, nil, act.target:GetPosition())
        end
        return true
    end
end

----制作出来不是立刻装备上
AddComponentPostInit("builder", function(cmp)

	function cmp:DoBuild(recname, pt, rotation, skin)
	
		local recipe = GetValidRecipe(recname)
		if recipe ~= nil and (self:IsBuildBuffered(recname) or self:CanBuild(recname)) then
			if recipe.placer ~= nil and
				self.inst.components.rider ~= nil and
				self.inst.components.rider:IsRiding() then
				return false, "MOUNTED"
			end

			local wetlevel = self.buffered_builds[recname]
			if wetlevel ~= nil then
				self.buffered_builds[recname] = nil
				self.inst.replica.builder:SetIsBuildBuffered(recname, false)
			else
				local materials = self:GetIngredients(recname)
				wetlevel = self:GetIngredientWetness(materials)
				self:RemoveIngredients(materials, recname)
			end
			self.inst:PushEvent("refreshcrafting")

			local prod = SpawnPrefab(recipe.product, skin, nil, self.inst.userid)
			if prod ~= nil then
				
				pt = pt or self.inst:GetPosition()

				if wetlevel > 0 and prod.components.inventoryitem ~= nil then
					prod.components.inventoryitem:InheritMoisture(wetlevel, self.inst:GetIsWet())
				end

				if prod.components.inventoryitem ~= nil then
					if self.inst.components.inventory ~= nil then
						--self.inst.components.inventory:GiveItem(prod)
						self.inst:PushEvent("builditem", { item = prod, recipe = recipe, skin = skin })
						ProfileStatsAdd("build_"..prod.prefab)

						--[[
						if prod.components.equippable ~= nil and self.inst.components.inventory:GetEquippedItem(prod.components.equippable.equipslot) == nil then
							if recipe.numtogive <= 1 then
								--The item is equippable. Equip it.
								self.inst.components.inventory:Equip(prod)
								
								
							elseif prod.components.stackable ~= nil then
								--The item is stackable. Just increase the stack size of the original item.
								prod.components.stackable:SetStackSize(recipe.numtogive)
								self.inst.components.inventory:Equip(prod)
								
								
							else
								--We still need to equip the original product that was spawned, so do that.
								self.inst.components.inventory:Equip(prod)
								
								
								--Now spawn in the rest of the items and give them to the player.
								for i = 2, recipe.numtogive do
									local addt_prod = SpawnPrefab(recipe.product)
									self.inst.components.inventory:GiveItem(addt_prod, nil, pt)
								end
							end]]
							
						if recipe.numtogive <= 1 then
							--Only the original item is being received.
							self.inst.components.inventory:GiveItem(prod, nil, pt)
						elseif prod.components.stackable ~= nil then
							--The item is stackable. Just increase the stack size of the original item.
							prod.components.stackable:SetStackSize(recipe.numtogive)
							self.inst.components.inventory:GiveItem(prod, nil, pt)
						else
							--We still need to give the player the original product that was spawned, so do that.
							self.inst.components.inventory:GiveItem(prod, nil, pt)
							--Now spawn in the rest of the items and give them to the player.
							for i = 2, recipe.numtogive do
								local addt_prod = SpawnPrefab(recipe.product)
								self.inst.components.inventory:GiveItem(addt_prod, nil, pt)
							end
						end

						if self.onBuild ~= nil then
							self.onBuild(self.inst, prod)
						end
						prod:OnBuilt(self.inst)

						return true
					end
				else
					prod.Transform:SetPosition(pt:Get())
					--V2C: or 0 check added for backward compatibility with mods that
					--     have not been updated to support placement rotation yet
					prod.Transform:SetRotation(rotation or 0)
					self.inst:PushEvent("buildstructure", { item = prod, recipe = recipe, skin = skin })
					prod:PushEvent("onbuilt", { builder = self.inst })
					ProfileStatsAdd("build_"..prod.prefab)

					if self.onBuild ~= nil then
						self.onBuild(self.inst, prod)
					end

					prod:OnBuilt(self.inst)

					return true
				end
			end
		end
	end

end)















