----全局变量声明
local _G = GLOBAL
local TimeEvent = _G.TimeEvent
local FRAMES = _G.FRAMES
local EQUIPSLOTS = _G.EQUIPSLOTS
local EventHandler = _G.EventHandler
local GetWorld = _G.GetWorld
local SpawnPrefab = _G.SpawnPrefab
local State = _G.State
local DEGREES = _G.DEGREES
local Vector3 = _G.Vector3
local STRINGS = _G.STRINGS
local ACTIONS = _G.ACTIONS
local FOODTYPE = _G.FOODTYPE

local TUNING = _G.TUNING
local PLAYERSTUNLOCK = _G.PLAYERSTUNLOCK
local GetTime = _G.GetTime

--lightning---------------------------------------------------------------------------------------------
AddStategraphState("wilson_client", State{
	name = "zg_weapon_lightninggun",
	tags = { "attack", "notalking", "abouttoattack", --"autopredict"
	},
	onenter = function(inst)
		local buffaction = inst:GetBufferedAction()
		if buffaction ~= nil then
			inst:PerformPreviewBufferedAction()
			if buffaction.target ~= nil and buffaction.target:IsValid() then
				inst:FacePoint(buffaction.target:GetPosition())
				inst.sg.statemem.attacktarget = buffaction.target
			end
		end
		if inst.replica.combat ~= nil then
			inst.replica.combat:StartAttack()
		end
		inst.components.locomotor:Stop()
		
		inst.AnimState:PlayAnimation("dart")
		
		--inst.sg.statemem.weapon = inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
		
	end,
	
	timeline=
	{	
	
		TimeEvent(8*FRAMES, function(inst)
			inst.sg:RemoveStateTag("abouttoattack")
			inst.sg:RemoveStateTag("busy")
			inst.sg:RemoveStateTag("attack")
		end),   
	},
	
	events=
	{
		EventHandler("animover", function(inst)
			inst.sg:GoToState("idle")
		end ),
	},			
})

--zhzh--------------------------------------------------------------------------------------------------
AddStategraphState("wilson_client", State{
	name = "zg_shotgun",
	tags = { "attack", "notalking", "abouttoattack", --"autopredict"
	},
	onenter = function(inst)
		local buffaction = inst:GetBufferedAction()
		if buffaction ~= nil then
			inst:PerformPreviewBufferedAction()
			if buffaction.target ~= nil and buffaction.target:IsValid() then
				inst:FacePoint(buffaction.target:GetPosition())
				inst.sg.statemem.attacktarget = buffaction.target
			end
		end
		if inst.replica.combat ~= nil then
			inst.replica.combat:StartAttack()
		end
		inst.components.locomotor:Stop()
		
		inst.AnimState:PlayAnimation("dart")
		
		--inst.sg.statemem.weapon = inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
		
	end,
	
	timeline=
	{	
	
		TimeEvent(8*FRAMES, function(inst)
			inst.sg:RemoveStateTag("abouttoattack")
			inst.sg:RemoveStateTag("busy")
			inst.sg:RemoveStateTag("attack")
		end),   
	},
	
	events=
	{
		EventHandler("animover", function(inst)
			inst.sg:GoToState("idle")
		end ),
	},			
})

--m3----------------------------------------------------------------------------------------------------
AddStategraphState("wilson_client", State{
	name = "zg_minigun",
	tags = { "attack", "notalking", "abouttoattack", --"autopredict"
	},
	onenter = function(inst)
		local buffaction = inst:GetBufferedAction()
		if buffaction ~= nil then
			inst:PerformPreviewBufferedAction()
			if buffaction.target ~= nil and buffaction.target:IsValid() then
				inst:FacePoint(buffaction.target:GetPosition())
				inst.sg.statemem.attacktarget = buffaction.target
			end
		end
		if inst.replica.combat ~= nil then
			inst.replica.combat:StartAttack()
		end
		inst.components.locomotor:Stop()
		
		inst.AnimState:PlayAnimation("dart")
		
		--inst.sg.statemem.weapon = inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
		inst.sg:SetTimeout(3*FRAMES)
	end,
	
	timeline=
	{	
		
		TimeEvent(2*FRAMES, function(inst)
			inst.sg:RemoveStateTag("abouttoattack")
			inst.sg:RemoveStateTag("busy")
			inst.sg:RemoveStateTag("attack")
		end),  
	},
	
	ontimeout = function(inst)
		inst.sg:GoToState("idle")
	end,
})

--ak47--------------------------------------------------------------------------------------------------
AddStategraphState("wilson_client", State{
	name = "zg_ak47",
	tags = { "attack", "notalking", "abouttoattack", --"autopredict"
	},
	onenter = function(inst)
		local buffaction = inst:GetBufferedAction()
		if buffaction ~= nil then
			inst:PerformPreviewBufferedAction()
			if buffaction.target ~= nil and buffaction.target:IsValid() then
				inst:FacePoint(buffaction.target:GetPosition())
				inst.sg.statemem.attacktarget = buffaction.target
			end
		end
		if inst.replica.combat ~= nil then
			inst.replica.combat:StartAttack()
		end
		inst.components.locomotor:Stop()
		
		inst.AnimState:PlayAnimation("dart")
		
		--inst.sg.statemem.weapon = inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
		inst.sg:SetTimeout(5*FRAMES)
	end,
	
	timeline=
	{	
		
		TimeEvent(3*FRAMES, function(inst)
			inst.sg:RemoveStateTag("abouttoattack")
			inst.sg:RemoveStateTag("busy")
			inst.sg:RemoveStateTag("attack")
		end),  
	},
	
	ontimeout = function(inst)
		inst.sg:GoToState("idle")
	end,
})

--m4----------------------------------------------------------------------------------------------------
AddStategraphState("wilson_client", State{
	name = "zg_m4",
	tags = { "attack", "notalking", "abouttoattack",-- "autopredict"
	},
	onenter = function(inst)
		local buffaction = inst:GetBufferedAction()
		if buffaction ~= nil then
			inst:PerformPreviewBufferedAction()
			if buffaction.target ~= nil and buffaction.target:IsValid() then
				inst:FacePoint(buffaction.target:GetPosition())
				inst.sg.statemem.attacktarget = buffaction.target
			end
		end
		if inst.replica.combat ~= nil then
			inst.replica.combat:StartAttack()
		end
		inst.components.locomotor:Stop()
		
		inst.AnimState:PlayAnimation("dart")
		
		inst.sg:SetTimeout(4*FRAMES)
	end,
	
	timeline=
	{	
		
		TimeEvent(3*FRAMES, function(inst)
			inst.sg:RemoveStateTag("abouttoattack")
			inst.sg:RemoveStateTag("busy")
			inst.sg:RemoveStateTag("attack")
		end),  
	},
	
	ontimeout = function(inst)
		inst.sg:GoToState("idle")
	end,
})

-------------------------------------------------------------------------------------------------------
AddStategraphState("wilson_client", State{
	name = "zg_bow",
	tags = { "attack", "notalking", "abouttoattack", },
	onenter = function(inst)
		local buffaction = inst:GetBufferedAction()
		if buffaction ~= nil then
			inst:PerformPreviewBufferedAction()
			if buffaction.target ~= nil and buffaction.target:IsValid() then
				inst:FacePoint(buffaction.target:GetPosition())
				inst.sg.statemem.attacktarget = buffaction.target
			end
		end
		if inst.replica.combat ~= nil then
			inst.replica.combat:StartAttack()
		end
		inst.components.locomotor:Stop()
		inst.AnimState:PlayAnimation("bow_attack")
		--inst.sg:SetTimeout(15*FRAMES)
	end,
	timeline=
	{	
		TimeEvent(12*FRAMES, function(inst)
			inst.sg:RemoveStateTag("abouttoattack")
			inst.sg:RemoveStateTag("attack")
		end),   
	},
	--ontimeout = function(inst)
	--	inst.sg:GoToState("idle")
	--end,
	--
	events=
	{
		EventHandler("animover", function(inst)
			inst.sg:GoToState("idle")
		end ),
	},		
})

AddStategraphState("wilson_client", State{
	name = "zg_gun_fire",
	tags = { "attack", "notalking", "abouttoattack", },
	onenter = function(inst)
		local buffaction = inst:GetBufferedAction()
		if buffaction ~= nil then
			inst:PerformPreviewBufferedAction()
			if buffaction.target ~= nil and buffaction.target:IsValid() then
				inst:FacePoint(buffaction.target:GetPosition())
				inst.sg.statemem.attacktarget = buffaction.target
			end
		end
		if inst.replica.combat ~= nil then
			inst.replica.combat:StartAttack()
		end
		inst.components.locomotor:Stop()
		--动画
		inst.AnimState:PlayAnimation("fishing_idle")
		--inst.sg:SetTimeout(6*FRAMES)
	end,
	timeline=
	{	
		TimeEvent(4*FRAMES, function(inst)
			inst.sg:RemoveStateTag("abouttoattack")
			inst.sg:RemoveStateTag("attack")
		end),   
	},
	--ontimeout = function(inst)
	--	inst.sg:GoToState("idle")
	--end,
	--
	events=
	{
		EventHandler("animover", function(inst)
			inst.sg:GoToState("idle")
		end ),
	},	
})

----状态图优化
AddStategraphPostInit("wilson_client", function(sg)

	--攻击
	local action_attack_fn=sg.actionhandlers[ACTIONS.ATTACK].deststate
	sg.actionhandlers[ACTIONS.ATTACK].deststate=function(inst, action)
		if not (inst.replica.health:IsDead() or inst.sg:HasStateTag("attack")) then
			local weapon = inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
			
			if weapon and weapon:HasTag("zg_bow") then
				return "zg_bow"
			elseif weapon and weapon:HasTag("zg_gun_fire") then
				return "zg_gun_fire"	
				
			elseif weapon and weapon:HasTag("zg_m4") then
				return "zg_m4"	
			elseif weapon and weapon:HasTag("zg_ak47") then
				return "zg_ak47"
			elseif weapon and weapon:HasTag("zg_minigun") then
				return "zg_minigun"	
			elseif weapon and weapon:HasTag("zg_shotgun") then
				return "zg_shotgun"	
			elseif weapon and weapon:HasTag("zg_weapon_lightninggun") then
				return "zg_weapon_lightninggun"		
			else
				return action_attack_fn(inst, action)
			end
			
		end
	end
	
	local state_attack = sg.states["attack"]
	state_attack.onenter = function(inst)
		local cooldown = 0
		if inst.replica.combat ~= nil then
			inst.replica.combat:StartAttack()
			cooldown = inst.replica.combat:MinAttackPeriod() + .5 * FRAMES
		end
		inst.components.locomotor:Stop()
		local equip = inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
		local rider = inst.replica.rider
		
		----检测盾牌
		local shield = inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.ZGHAND2)
		local hasshield = shield and shield:HasTag("zg_shield") or nil 
		
		if rider ~= nil and rider:IsRiding() then
			inst.AnimState:PlayAnimation("atk_pre")
			inst.AnimState:PushAnimation("atk", false)
			--DoMountSound(inst, rider:GetMount(), "angry")
			if cooldown > 0 then
				cooldown = math.max(cooldown, 16 * FRAMES)
			end
			
		--[[
		elseif equip ~= nil and equip:HasTag("whip") then
			inst.AnimState:PlayAnimation("whip_pre")
			inst.AnimState:PushAnimation("whip", false)
			inst.sg.statemem.iswhip = true
			inst.SoundEmitter:PlaySound("dontstarve/common/whip_pre", nil, nil, true)
			if cooldown > 0 then
				cooldown = math.max(cooldown, 17 * FRAMES)
			end]]
			
		----双手武器
		elseif equip ~= nil and equip:HasTag("zg_doublehand") then
			
			----劈的动作
			inst.AnimState:PlayAnimation("pickaxe_loop")
			--inst.AnimState:PushAnimation("zg_atk", false)
			
			inst.SoundEmitter:PlaySound(
				(equip:HasTag("icestaff") and "dontstarve/wilson/attack_icestaff") or
				(equip:HasTag("shadow") and "dontstarve/wilson/attack_nightsword") or
				(equip:HasTag("firestaff") and "dontstarve/wilson/attack_firestaff") or
				"dontstarve/wilson/attack_weapon",
				nil, nil, true
			)
			cooldown = math.max(cooldown, 13 * FRAMES)
			
			
		elseif equip ~= nil and
			equip.replica.inventoryitem ~= nil and
			equip.replica.inventoryitem:IsWeapon() and
			not equip:HasTag("punch") then
			
			if hasshield then
				inst.AnimState:PlayAnimation("zg_atk_pre")
				inst.AnimState:PushAnimation("zg_atk", false)
			else
				inst.AnimState:PlayAnimation("atk_pre")
				inst.AnimState:PushAnimation("atk", false)
			end
			
			inst.SoundEmitter:PlaySound(
				(equip:HasTag("icestaff") and "dontstarve/wilson/attack_icestaff") or
				(equip:HasTag("shadow") and "dontstarve/wilson/attack_nightsword") or
				(equip:HasTag("firestaff") and "dontstarve/wilson/attack_firestaff") or
				"dontstarve/wilson/attack_weapon",
				nil, nil, true
			)
			if cooldown > 0 then
				cooldown = math.max(cooldown, 13 * FRAMES)
			end	
		elseif equip ~= nil and
			(equip:HasTag("light") or
			equip:HasTag("nopunch")) then
			
			if hasshield then
				inst.AnimState:PlayAnimation("zg_atk_pre")
				inst.AnimState:PushAnimation("zg_atk", false)
			else
				inst.AnimState:PlayAnimation("atk_pre")
				inst.AnimState:PushAnimation("atk", false)
			end
			
			inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon", nil, nil, true)
			if cooldown > 0 then
				cooldown = math.max(cooldown, 13 * FRAMES)
			end
			
		----海獭
		elseif inst:HasTag("beaver") then
			inst.sg.statemem.isbeaver = true
			inst.AnimState:PlayAnimation("atk_pre")
			inst.AnimState:PushAnimation("atk", false)
			inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_whoosh", nil, nil, true)
			if cooldown > 0 then
				cooldown = math.max(cooldown, 8 * FRAMES)
			end
			
		----空手
		else
		
			if hasshield then
				inst.AnimState:ClearOverrideSymbol("swap_object")
				inst.AnimState:PlayAnimation("zg_atk_pre")
				inst.AnimState:PushAnimation("zg_atk", false)
			else
				inst.AnimState:PlayAnimation("punch")
			end
			
			inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_whoosh", nil, nil, true)
			if cooldown > 0 then
				cooldown = math.max(cooldown, 24 * FRAMES)
			end
		end

		local buffaction = inst:GetBufferedAction()
		if buffaction ~= nil then
			inst:PerformPreviewBufferedAction()

			if buffaction.target ~= nil and buffaction.target:IsValid() then
				inst:FacePoint(buffaction.target:GetPosition())
				inst.sg.statemem.attacktarget = buffaction.target
			end
		end

		if cooldown > 0 then
			inst.sg:SetTimeout(cooldown)
		end
	end
	
	----跑步
	local state_run_start = sg.states["run_start"]
	state_run_start.onenter = function(inst)
		inst.components.locomotor:RunForward()
		
		----检测盾牌
		local shield = inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.ZGHAND2)
		local hasshield = shield and shield:HasTag("zg_shield") or nil 
		
		if hasshield then
		
			----检查手1
			local handitem = inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
			if handitem then
				inst.AnimState:PlayAnimation(inst:HasTag("groggy") and "idle_walk_pre" or "zg_run_pre")
			else
				inst.AnimState:ClearOverrideSymbol("swap_object")
				inst.AnimState:PlayAnimation(inst:HasTag("groggy") and "idle_walk_pre" or "zgfy_run_pre")
			end
			
			
		
			--inst.AnimState:PlayAnimation(inst:HasTag("groggy") and "idle_walk_pre" or "zg_run_pre")
		else
			inst.AnimState:PlayAnimation(inst:HasTag("groggy") and "idle_walk_pre" or "run_pre")
		end
			
		inst.sg.mem.footsteps = 0
		inst.sg.statemem.riding = inst.replica.rider ~= nil and inst.replica.rider:IsRiding()
	end
	
	local state_run = sg.states["run"]
	state_run.onenter = function(inst)
		inst.components.locomotor:RunForward()
		
		----检测盾牌
		local shield = inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.ZGHAND2)
		local hasshield = shield and shield:HasTag("zg_shield") or nil 
		local anim = inst:HasTag("groggy") and "idle_walk" or "run_loop"
		
		if hasshield then
		
			----检查手1
			local handitem = inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
			if handitem then
				anim = inst:HasTag("groggy") and "idle_walk" or "zg_run_loop"
			else
				inst.AnimState:ClearOverrideSymbol("swap_object")
				anim = inst:HasTag("groggy") and "idle_walk" or "zgfy_run_loop"
			end
			
			
		
			--anim = inst:HasTag("groggy") and "idle_walk" or "zg_run_loop"
		else
			anim = inst:HasTag("groggy") and "idle_walk" or "run_loop"
		end
		
		if not inst.AnimState:IsCurrentAnimation(anim) then
			inst.AnimState:PlayAnimation(anim, true)
		end
		inst.sg:SetTimeout(inst.AnimState:GetCurrentAnimationLength())
		inst.sg.statemem.riding = inst.replica.rider ~= nil and inst.replica.rider:IsRiding()
	end
	
	local state_run_stop = sg.states["run_stop"]
	state_run_stop.onenter = function(inst)
		inst.components.locomotor:Stop()
		
		----检测盾牌
		local shield = inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.ZGHAND2)
		local hasshield = shield and shield:HasTag("zg_shield") or nil 
		
		if hasshield then
		
			----检查手1
			local handitem = inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
			if handitem then
				inst.AnimState:PlayAnimation(inst:HasTag("groggy") and "idle_walk_pst" or "zg_run_pst")
			else
				inst.AnimState:ClearOverrideSymbol("swap_object")
				inst.AnimState:PlayAnimation(inst:HasTag("groggy") and "idle_walk_pst" or "zgfy_run_pst")
			end
			
			
		
			--inst.AnimState:PlayAnimation(inst:HasTag("groggy") and "idle_walk_pst" or "zg_run_pst")
		else
			inst.AnimState:PlayAnimation(inst:HasTag("groggy") and "idle_walk_pst" or "run_pst")
		end
		
	end

--------------------------------------------------------------------------------------------------------------------------------
	--静止
	local state_idle = sg.states["idle"]
	state_idle.onenter = function(inst, pushanim)
		inst.entity:SetIsPredictingMovement(false)
		inst.components.locomotor:Stop()
		inst.components.locomotor:Clear()

		if pushanim == "cancel" then
			return
		elseif inst:HasTag("nopredict") or inst:HasTag("pausepredict") then
			inst:ClearBufferedAction()
			return
		elseif pushanim == "noanim" then
			inst.sg:SetTimeout(2)
			return
		end

		local anims = {}

		if inst.replica.rider ~= nil and inst.replica.rider:IsRiding() then
			table.insert(anims, "idle_loop")
		elseif inst:HasTag("beaver") then
			if inst:HasTag("groggy") then
				table.insert(anims, "idle_groggy_pre")
				table.insert(anims, "idle_groggy")
			else
				table.insert(anims, "idle_loop")
			end
		else
		
			----刚进入游戏, 客机组件还没来得及加载, 所以一定要逐级判断
			local shield = nil
			if inst.replica.inventory then
				shield = inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.ZGHAND2)
			end
			
			local hasshield = shield and shield:HasTag("zg_shield") or nil 
			
			if hasshield then
			
				----检查手1
				local handitem = inst.replica.inventory and inst.replica.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
				if handitem then
					table.insert(anims, "zg_idle_loop")
				else
					table.insert(anims, "zgfy_idle_loop")
				end
				
			else
				table.insert(anims, "idle_loop")
			end
			
		end

		if pushanim then
			for i, v in ipairs(anims) do
				inst.AnimState:PushAnimation(v, i == #anims)
			end
		else
			inst.AnimState:PlayAnimation(anims[1], #anims == 1)
			for i, v in ipairs(anims) do
				if i > 1 then
					inst.AnimState:PushAnimation(v, i == #anims)
				end
			end
		end
	end
	
-----------------------------------------------------------------------------------------------------------------------------------------------------
	
	----顺畅的动作-------------------------------------------------------------------------------------------------------
	--长动作变短动作
	--if fast_do then
	--[[
		--长动作改进
		local state_dolongaction = sg.states["dolongaction"]
		state_dolongaction.onenter = function(inst)
            inst.components.locomotor:Stop()
            --inst.AnimState:PlayAnimation("pickup")

            inst:PerformPreviewBufferedAction()
			inst.sg:RemoveStateTag("busy")
            inst.sg:SetTimeout(2 * FRAMES)
        end
		state_dolongaction.timeline =
        {
           
        }
		state_dolongaction.ontimeout = function(inst)
			inst:ClearBufferedAction()
            inst.sg:GoToState("idle", true)
        end
		
		state_dolongaction.onexit = function(inst)
		
		end
		
		state_dolongaction.onupdate = function(inst)
		
		end
		
		state_dolongaction.events =
		{
			
		}
		
		--短动作改进
		local state_doshortaction = sg.states["doshortaction"]
		state_doshortaction.onenter = function(inst)
            inst.components.locomotor:Stop()
            --inst.AnimState:PlayAnimation("pickup")

            inst:PerformPreviewBufferedAction()
			inst.sg:RemoveStateTag("busy")
            inst.sg:SetTimeout(2 * FRAMES)
        end
		state_doshortaction.timeline =
        {
           
        }
		state_doshortaction.ontimeout = function(inst)
			inst:ClearBufferedAction()
            inst.sg:GoToState("idle", true)
        end
		
		state_doshortaction.onexit = function(inst)
		
		end
		
		state_doshortaction.onupdate = function(inst)
		
		end
		
		state_doshortaction.events =
		{
			
		}
		]]
	--end
	
	--吃变快吃
	--if fast_eat then
	--[[
		local state_eat = sg.states["eat"]
		state_eat.onenter = function(inst)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("quick_eat_pre")
            inst.AnimState:PushAnimation("quick_eat_lag", false)
 
            inst:PerformPreviewBufferedAction()
            inst.sg:SetTimeout(10 * FRAMES)
        end
		state_eat.onupdate = function(inst)
            
        end
		
		state_eat.ontimeout = function(inst)
            inst.sg:GoToState("idle")
        end
		
		state_eat.onexit = function(inst)
		
		end
		
		state_eat.timeline =
		{
			
		}
		
		state_eat.events =
		{
			
		}
		]]
	--end
	
	----砍树,挖矿,砸, 铲,捕捉等的延迟消除
	--[[
	local state_chop_start = sg.states["chop_start"]
	state_chop_start.onenter = function(inst)
		inst.components.locomotor:Stop()
		inst:PerformPreviewBufferedAction()
		inst.sg:SetTimeout(2*FRAMES)
	end
	state_chop_start.onupdate = function(inst)         
	end
	state_chop_start.ontimeout = function(inst)
		inst:ClearBufferedAction()
		inst.sg:GoToState("idle")
	end
	
	local state_mine_start = sg.states["mine_start"]
	state_mine_start.onenter = function(inst)
		inst.components.locomotor:Stop()
		inst:PerformPreviewBufferedAction()
		inst.sg:SetTimeout(2*FRAMES)
	end
	state_mine_start.onupdate = function(inst)         
	end
	state_mine_start.ontimeout = function(inst)
		inst:ClearBufferedAction()
		inst.sg:GoToState("idle")
	end
	
	local state_hammer_start = sg.states["hammer_start"]
	state_hammer_start.onenter = function(inst)
		inst.components.locomotor:Stop()
		inst:PerformPreviewBufferedAction()
		inst.sg:SetTimeout(2*FRAMES)
	end
	state_hammer_start.onupdate = function(inst)         
	end
	state_hammer_start.ontimeout = function(inst)
		inst:ClearBufferedAction()
		inst.sg:GoToState("idle")
	end
	
	local state_dig_start = sg.states["dig_start"]
	state_dig_start.onenter = function(inst)
		inst.components.locomotor:Stop()
		inst:PerformPreviewBufferedAction()
		inst.sg:SetTimeout(2*FRAMES)
	end
	state_dig_start.onupdate = function(inst)         
	end
	state_dig_start.ontimeout = function(inst)
		inst:ClearBufferedAction()
		inst.sg:GoToState("idle")
	end
	
	local state_give = sg.states["give"]
	state_give.onenter = function(inst)
		inst.components.locomotor:Stop()
		inst.AnimState:PlayAnimation("give")
		inst:PerformPreviewBufferedAction()
		inst.sg:SetTimeout(5*FRAMES)
	end
	state_give.onupdate = function(inst)
	end
	state_give.ontimeout = function(inst)
		inst:ClearBufferedAction()
		inst.sg:GoToState("idle")
	end]]
	
	--[[
	local action_net = sg.actionhandlers[ACTIONS.NET]
	action_net.deststate = function(inst)
		return "bugnet" or nil
	end]]
	
	--叉地皮延迟消除
	--[[
	local state_terraform = sg.states["terraform"]
	state_terraform.onenter = function(inst)
		inst.components.locomotor:Stop()
		inst.AnimState:PlayAnimation("shovel_loop", false)
		inst:PerformPreviewBufferedAction()
		inst.sg:SetTimeout(10*FRAMES)
	end
	state_terraform.onupdate = function(inst)
	end
	state_terraform.ontimeout = function(inst)
		inst:ClearBufferedAction()
		inst.sg:GoToState("idle", true)
	end]]

end)